unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  ExtCtrls, SoGraph, ComCtrls, StdCtrls, SoCtrls, SoChkBox;

type
  TMainForm = class(TForm)
    SourceIm: TImage;
    DestIm: TImage;
    Pages: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    sohoLabel1: TsohoLabel;
    sohoLabel2: TsohoLabel;
    HorScr: TTrackBar;
    VertScr: TTrackBar;
    sohoLabel3: TsohoLabel;
    CenterX: TTrackBar;
    sohoLabel4: TsohoLabel;
    CenterY: TTrackBar;
    sohoLabel5: TsohoLabel;
    Angle: TTrackBar;
    TabSheet3: TTabSheet;
    sohoLabel6: TsohoLabel;
    HorSize: TTrackBar;
    sohoLabel7: TsohoLabel;
    VertSize: TTrackBar;
    TabSheet4: TTabSheet;
    GrayC: TsohoCheckBox;
    sohoLabel8: TsohoLabel;
    sohoLabel9: TsohoLabel;
    sohoLabel10: TsohoLabel;
    Blue: TTrackBar;
    Green: TTrackBar;
    Red: TTrackBar;
    sohoLabel11: TsohoLabel;
    sohoLabel12: TsohoLabel;
    sohoLabel13: TsohoLabel;
    procedure ApplyChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GrayCChange(Sender: TObject);
    procedure PagesChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure PrepareGraphic;
    procedure UpdateGraphic;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.ApplyChange(Sender: TObject);
var Source, Dest: TsohoBitmapArray;
begin
  PrepareGraphic;

  Source := TsohoBitmapGraphic(SourceIm.Picture.Graphic).CurrentArea;
  Dest := TsohoBitmapGraphic(DestIm.Picture.Graphic).CurrentArea;

  case Pages.ActivePageIndex of
    0: ShiftImage(Source, Dest, HorScr.Position, VertScr.Position, nil);
    1: RotateImage(Source, Dest,
                CenterX.Position, CenterY.Position,
                Angle.Position * 2 * 3.14 / 360, nil);
    2: ResizeImage(Source, Dest, HorSize.Position, VertSize.Position, nil);
    3: if GrayC.Checked then
         ConvertToGrayScale(Source, Dest)
       else
         ChangeRGB(Source, Dest, Red.Position, Green.Position, Blue.Position);
    else ;
  end;

  UpdateGraphic;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  DestIm.Picture.Assign(SourceIm.Picture);
  with DestIm, TsohoBitmapGraphic(Picture.Graphic) do
    SetCurrentArea(0, 0, Width, Height);
end;

procedure TMainForm.PrepareGraphic;
begin
  with SourceIm, TsohoBitmapGraphic(Picture.Graphic) do begin
    SetCurrentArea(0, 0, Width, Height);
    UpdateArea;
  end;
end;

procedure TMainForm.UpdateGraphic;
begin
  with DestIm, TsohoBitmapGraphic(Picture.Graphic) do begin
    UpdateBitmap;
    Repaint;
  end;
end;

procedure TMainForm.GrayCChange(Sender: TObject);
begin
  Blue.Enabled := not GrayC.Checked;
  Green.Enabled := Blue.Enabled;
  Red.Enabled := Blue.Enabled;

  ApplyChange(Sender);
end;

procedure TMainForm.PagesChange(Sender: TObject);
begin
  ApplyChange(Sender);
end;

end.
