unit Main;

interface

uses Windows, Classes, Controls, ComCtrls, SoEnhTreeView, SoPrcUtils,
     Forms, SoMemTree, StdCtrls, SohoBtns;

type

  TMainForm = class(TForm)
    PrL: TsohoEnhTreeView;
    sohoBitBtn1: TsohoBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RefreshClick(Sender: TObject);
  private
    { Private declarations }
  public
    PrcTree: TsohoMemoryTree;
    Processes: TProcessList;
    Found: TsohoMTreeItem;
  end;

var MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  PrcTree := TsohoMemoryTree.Create;
  Processes := TProcessList.Create;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  PrcTree.Free;
  Processes.Free;
end;

procedure FindNode (Item: TsohoMTreeItem; Index: integer;
    var ContinueIterate: boolean; IterateData: pointer);
begin
  MainForm.Found := nil;
  if (TProcess(Item.Data).ProcessID <> 0) and (
     TProcess(Item.Data).ProcessID = dword(IterateData)) then begin
    MainForm.Found := Item;
    ContinueIterate := false;
  end;
end;

procedure TMainForm.RefreshClick(Sender: TObject);
var Index: LongInt;

    procedure CopyItem(ParentNode: TTreeNode; aItem: TsohoMTreeItem);
    var Node: TTreeNode;
        aIndex: LongInt;
    begin
      Node := PrL.Items.AddChild(ParentNode, TProcess(aItem.Data).ProcessName);
      for aIndex := 0 to pred(aItem.List.Count) do
        CopyItem(Node, TsohoMTreeItem(aItem.List[aIndex]));
    end;

begin
  Processes.Refresh;
  PrcTree.Clear;
  for Index := 0 to pred(Processes.Count) do begin
    Found := nil;
    PrcTree.AddItem(PrcTree.Root, Processes.Process[Index]);
  end;

  //   
  Index := 0;
  while Index <= pred(PrcTree.Root.List.Count) do begin
    Found := nil;
    PrcTree.Iterate(FindNode,
      pointer(TProcess(
        TsohoMTreeItem(PrcTree.Root.List[Index]).Data).ParentProcessID));
    if Found <> nil then
      PrcTree.MoveTo(
        TsohoMTreeItem(PrcTree.Root.List[Index]), Found)
    else inc(Index);
  end;

  PrL.Items.Clear;
  for Index := 0 to pred(PrcTree.Root.List.Count) do
    CopyItem(nil, TsohoMTreeItem(PrcTree.Root.List[Index]));
end;

end.
