unit FacRepF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SohoBtns, SohoComb, SoCtrls, SohoRgst, Menus, 
  SoCtmRgs, Db, DBTables, SoFrmStorage, SoCtmFld, SoFolder, Grids, DBGrids,
  SoDBGrid, SoCtmCmb, SoClass;

type
  TFactoryRepForm = class(TForm)
    sohoLabel6: TsohoLabel;
    sohoLabel1: TsohoLabel;
    FactoryC: TsohoDBComboBox;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    Grid: TsohoDBGrid;
    Folder: TsohoFolder;
    DataSource: TDataSource;
    Ini: TsohoFormStorage;
    KnoT: TTable;
    Reg: TsohoSubRegister;
    SelectMenu: TPopupMenu;
    MarkAllM: TMenuItem;
    UnmarkM: TMenuItem;
    procedure GridKeyPress(Sender: TObject; var Key: Char);
    procedure MarkAllMClick(Sender: TObject);
    procedure GridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    function Execute (var IdFactory : LongInt; IdKno : TsohoIntegerList;
     FactoryEnabled : boolean) : boolean;
  public
    { Public declarations }
  end;

var FactoryRepForm: TFactoryRepForm;

function FactoryReportData (var IdFactory : LongInt; IdKno : TsohoIntegerList;
  FactoryEnabled : boolean) : boolean;

implementation
uses SoDbRtn;

{$R *.DFM}

function FactoryReportData (var IdFactory : LongInt; IdKno : TsohoIntegerList;
  FactoryEnabled : boolean) : boolean;
begin
  try
    if FactoryRepForm = nil then FactoryRepForm := TFactoryRepForm.Create(Application);
    Result := FactoryRepForm.Execute(IdFactory, IdKNO, FactoryEnabled);
  except
    FactoryRepForm.Free;
    FactoryRepForm := nil;
  end;
end;

function TFactoryRepForm.Execute (var IdFactory : LongInt; IdKno : TsohoIntegerList;
  FactoryEnabled : boolean) : boolean;
var Index : integer;
begin
  Grid.Results.Clear;
  if FactoryC.Active then FactoryC.DeActivate;
  if not KnoT.Active then KnoT.Open
  else RefreshFolderWithId(Folder, 'Id');

  if FactoryEnabled then begin
    FactoryC.Activate;
    FactoryC.Enabled := true;
  end
  else FactoryC.Enabled := false;

  FactoryC.AddItem(-1, 'All factories');
  IdKno.Clear;
  Result := ShowModal = mrOk;
  if not Result then exit;
  IdFactory := FactoryC.ItemId;
  if Grid.Results.Count > 0 then
    for Index := 0 to pred(Grid.Results.Count) do
      IdKno.Add(Grid.Results.Items[Index])
  else IdKno.Add(KnoT.FieldByName('Id').AsInteger);
end;

procedure TFactoryRepForm.GridKeyPress(Sender: TObject; var Key: Char);
var Id : LongInt;
begin
  if Key<>#32 then exit;
  Id := KnoT.FieldByName('Id').AsInteger;
  if Grid.Results.IndexOf(Id)=-1 then Grid.Results.Add(Id)
  else Grid.Results.Remove(Id);
end;

procedure TFactoryRepForm.MarkAllMClick(Sender: TObject);
begin
  if (Sender as TMenuItem).Tag = 2 then Grid.Results.Clear
  else
    with KnoT do begin
      DisableControls;
      try
        First;
        while not Eof do begin
          Grid.Results.Add(FieldByName('Id').AsInteger);
          Next;
        end;
      finally
        EnableControls;
      end;
    end;
end;

procedure TFactoryRepForm.GridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var Id : LongInt;
begin
  if (Key in [VK_UP, VK_DOWN])
     and (ssShift in Shift) then begin
    Id := KnoT.FieldByName('Id').AsInteger;
    if Grid.Results.IndexOf(Id)=-1 then Grid.Results.Add(Id)
    else Grid.Results.Remove(Id);
  end;
end;

initialization
  FactoryRepForm := nil;
end.
