unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, SoStatus, ComCtrls, ActnList, ToolWin, SoMenuBar,
  Db, DBTables, SoCtmDBGuide, SoDBGuide, SoCtmTVCont, SoTVCont,
  Menus, SoCtmRgs, SohoRgst, SoFrmStorage, SoDBGrid, SoClass,
  SoStatusBar, SoGauges, SoAbout, StdCtrls, ImgList;

type
  TMainForm = class(TForm)
    MainIni: TsohoFormStorage;
    Register: TsohoRegister;
    MainMenu: TMainMenu;
    CommonM: TMenuItem;
    OptionsM: TMenuItem;
    S1: TMenuItem;
    ExitM: TMenuItem;
    GuidesM: TMenuItem;
    DocumentsM: TMenuItem;
    HelpM: TMenuItem;
    ContentsM: TMenuItem;
    S2: TMenuItem;
    AboutM: TMenuItem;
    FactoryM: TMenuItem;
    GoodsM: TMenuItem;
    CompanyM: TMenuItem;
    OrderM: TMenuItem;
    KnoM: TMenuItem;
    FactoryTV: TsohoTVContainer;
    CompanyTV: TsohoTVContainer;
    GoodsTV: TsohoTVContainer;
    KnoGuide: TsohoDBGuide;
    OrdersGuide: TsohoDBGuide;
    Database: TDatabase;
    ControlBar1: TControlBar;
    sohoMenuBar1: TsohoMenuBar;
    ToolBar1: TToolBar;
    ActionList1: TActionList;
    CloseA: TAction;
    FactoryA: TAction;
    GoodsA: TAction;
    CompanyA: TAction;
    KnoA: TAction;
    OrderA: TAction;
    KnoReportA: TAction;
    FactoryReportA: TAction;
    AboutA: TAction;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    StatusBar: TsohoStatusBar;
    Gauge: TsohoGauge;
    AboutBox: TsohoAboutBox;
    ImageList1: TImageList;
    procedure RegisterActivate(Sender: TObject);
    procedure AboutMClick(Sender: TObject);
    procedure FactoryMClick(Sender: TObject);
    procedure GoodsMClick(Sender: TObject);
    procedure CompanyMClick(Sender: TObject);
    procedure ExitMClick(Sender: TObject);
    procedure GoodsTVItemEdit(Sender: TObject; GroupId, ItemID: Integer;
      var Allow: Boolean);
    procedure GoodsTVNewItem(Sender: TObject; GroupId: Integer; var ItemID,
      ItemHash: Integer; var Allow: Boolean);
    procedure OrderMClick(Sender: TObject);
    procedure KnoMClick(Sender: TObject);
    function KnoGuideOperation(Sender: TObject;
      Operation: TsohoGridOperation): Boolean;
    function OrdersGuideOperation(Sender: TObject;
      Operation: TsohoGridOperation): Boolean;
    procedure BackPaint(Sender: TObject; Canvas: TCanvas);
    procedure ToolButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function GetGoods : LongInt;
    procedure CopyProgress (Sender : TObject; Stage : TProgressStage;
          PercentDone : byte; const Msg : string);
    function GetCompany : LongInt;
    function GetFactory (var Ids : TsohoIntegerList) : boolean;
  end;

var
  MainForm: TMainForm;

function GetFactoryName (IdFactory : LongInt) : string;

implementation
uses Global, SoUtils, GoodsF, KnoF, SoDBRtn, OrderF, FacRepF, SoVrsInf,
     FileUtil, SoCtrls, SoBDERtn, SoVCLUtils, SoStrUtils;

{$R *.DFM}

function GetFactoryName (IdFactory : LongInt) : string;
begin
  Result := GetSQLResult(MainForm.Register.PathToSQL+
    'Get_Factory_name_by_Id.sql', BaseDir, [IntToStr(IdFactory)]);
end;

function TMainForm.GetCompany : LongInt;
begin
  Result := -1;
  if not CompanyTV.Execute(false, true, true) then exit;
  if CompanyTV.Results.Count>0 then Result := CompanyTV.Results.Items[0]
  else Result := CompanyTV.ItemId;
end;

function TMainForm.GetFactory (var Ids : TsohoIntegerList) : boolean;
begin
  //FactoryTV.OnFormCreate := FactoryGuideFormCreate;
  Result := FactoryTV.Execute(false, true, true);
  FactoryTV.Results.SaveToFile(Register.PathToProgram+'Lists\Kno\CurFactories.ids');
  Ids.LoadFromFile(Register.PathToProgram+'Lists\Kno\CurFactories.ids');
  FactoryTV.Results.Clear;
end;

procedure TMainForm.CopyProgress (Sender : TObject; Stage : TProgressStage;
          PercentDone : byte; const Msg : string);
begin
  if Stage = psStarting then Gauge.MaxValue := 100;
  Gauge.Progress := PercentDone;
  Gauge.Caption  := Msg;
end;

function TMainForm.GetGoods   : LongInt;
begin
  Result := -1;
  if not GoodsTV.Execute(false, true, true) then exit;
  if GoodsTV.Results.Count>0 then Result := GoodsTV.Results.Items[0]
  else Result := GoodsTV.ItemId;
end;

procedure TMainForm.RegisterActivate(Sender: TObject);
begin
  try
    DataBase.AliasName := Register.PathToData;
    DataBase.Connected := true;
    BaseDir := 'IBKno_DataBase';
  except
    on E:Exception do begin
      ErrorMsg('Error during connecting to a database: '+E.Message);
      Halt(200);
    end;
  end;
end;

procedure TMainForm.AboutMClick(Sender: TObject);
begin
  AboutBox.Execute;
end;

procedure TMainForm.FactoryMClick(Sender: TObject);
begin
  FactoryTV.Execute(false, true, false);
end;

procedure TMainForm.GoodsMClick(Sender: TObject);
begin
  GoodsTV.Execute(false, true, false);
end;

procedure TMainForm.CompanyMClick(Sender: TObject);
begin
  CompanyTV.Execute(false, true, false);
end;

procedure TMainForm.ExitMClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.GoodsTVItemEdit(Sender: TObject; GroupId,
  ItemID: Integer; var Allow: Boolean);
begin
  Allow := EditGoods(ItemId);
end;

procedure TMainForm.GoodsTVNewItem(Sender: TObject; GroupId: Integer;
  var ItemID, ItemHash: Integer; var Allow: Boolean);
begin
  Allow := NewGoods(ItemId, GroupId, ItemHash);
end;

procedure TMainForm.OrderMClick(Sender: TObject);
begin
  OrdersGuide.Execute(false, true, false);
end;

procedure TMainForm.KnoMClick(Sender: TObject);
begin
  KnoGuide.Execute(false, true, false);
end;

function TMainForm.KnoGuideOperation(Sender: TObject;
  Operation: TsohoGridOperation): Boolean;
var DoRefresh : boolean;
begin
  case Operation of
    soNewRecord    : DoRefresh := NewKNO;
    soEditRecord   : DoRefresh := EditKNO(KnoGuide.ItemsQuery.FieldByName('Id').AsInteger);
    soDeleteRecord : begin
      DoRefresh := YesNoMsg('Are you sure you want to delete this exemption?');
      if DoRefresh then
        DoRefresh := ExecuteSQL(Register.PathToSQL+'Delete_exem_by_id.sql',
          BaseDir, [KnoGuide.ItemsQuery.FieldByName('Id').AsString]);
    end;
  end;
  if DoRefresh then begin
    RefreshFolder(KnoGuide.GuideForm.Folder);
    if OrdersGuide.GuideForm <> nil then
      RefreshFolder(OrdersGuide.GuideForm.Folder);
  end;
end;

function TMainForm.OrdersGuideOperation(Sender: TObject;
  Operation: TsohoGridOperation): Boolean;
var DoRefresh : boolean;
begin
  case Operation of
    soNewRecord    : DoRefresh := NewOrder;
    soEditRecord   : DoRefresh := EditOrder(OrdersGuide.ItemsQuery.FieldByName('Id').AsInteger);
    soDeleteRecord : begin
      DoRefresh := YesNoMsg('Are you sure you want to delete this order?');
      if DoRefresh then
        DoRefresh := ExecuteSQL(Register.PathToSQL+'Delete_order_by_Id.sql',
          BaseDir, [OrdersGuide.ItemsQuery.FieldByName('Id').AsString]);
    end;
  end;
  if DoRefresh then RefreshFolder(OrdersGuide.GuideForm.Folder);
end;

procedure TMainForm.BackPaint(Sender: TObject; Canvas: TCanvas);
var Tmp : string;
    Rect : TRect;
begin
  Tmp := 'SohoLib Pro Examples. Build #'+GetFileVersion+' '+ DateTimeToStr(
    FileDateTime(Application.ExeName));
  with Canvas do begin
    Font := Self.Font;
    Font.Size := 10;
    Font.Color := clAqua;
    Font.Style := [fsBold];
    Brush.Style := bsClear;
    with Rect do begin
      Left := ClientWidth - TextWidth(Tmp)-15;
      Top := ClientHeight - TextHeight(Tmp)-10-StatusBar.Height;
      Right := Left + TextWidth(Tmp) + 15;
      Bottom := Top + TextHeight(Tmp)+5;
    end;
    Draw3DText(Tmp, Rect, Canvas, lpLeftTop, clBtnFace, clWhite, clBlack, 1,
               taLeftJustify, tlCenter, false, false, false);
  end;
end;

procedure TMainForm.ToolButton1Click(Sender: TObject);
begin
  Close;
end;

initialization
  StringBooleanFields.Add('Assessment');
  StringBooleanFields.Add('Column6');
end.
