@echo off
@echo {*******************************************************}
@echo {                                                       }
@echo {           Delphi Visual Component Library             }
@echo {                                                       }
@echo {           Copyright (c) 2000-2001 Devrace             }
@echo {            Devrace SohoLib Pro Components             }
@echo {                                                       }
@echo {*******************************************************}
@echo .
@echo .
@echo            SohoLib Pro for Delphi 3 Installation 
@echo .
@echo .
@echo {*******************************************************}
@echo {         Phase 1 - Special variables setting           }
@echo {*******************************************************}

rem   *******************************************************
rem   * At first, you must set the special variables:       *
rem   * 1. DELPHIBIN - path to your Delphi bin directory    *
rem   * 2. DPLDIR    - path to directory for DPL files      *
rem   *    (Windows system directory is recommended)        *
rem   *******************************************************

@set DELPHIBIN=F:\Delphi\Delphi3\BIN
@set DPLDIR=%SYSTEMROOT%\System32

@echo .
@echo .
@echo {*******************************************************}
@echo {        Phase 2 - Superfluous files deleting           }
@echo {*******************************************************}

rem   *******************************************************
rem   * Now, we delete superfluous files from SohoLib       *
rem   * directory                                           *
rem   *******************************************************

@if exist *.~?? del *.~?? >nul
@if exist *.dpl del *.dpl >nul
@if exist *.dpl del *.bpl >nul
@if exist *.dcp del *.dcp >nul
@if exist *.dcu del *.dcu >nul
@if exist .\Delphi3\*.dcu copy .\Delphi3\*.dcu *.dcu >nul

@echo .
@echo .
@echo {*******************************************************}
@echo {       Phase 3 - Run-time packages compilation         }
@echo {*******************************************************}

rem   *******************************************************
rem   * Results of compilation will be stored into the      *
rem   * ErrorLog.log file                                   *
rem   *******************************************************

@%DELPHIBIN%\dcc32.exe RsoCmn3.dpk -B >ErrorLog.log
@if ErrorLevel=1 goto RTCommonError
@echo RsoCmn3.dpk was compiled successfully
@if exist %DPLDIR%\RsoCmn3.dpl del %DPLDIR%\RsoCmn3.dpl >nul
@move RsoCmn3.dpl %DPLDIR% >nul
@%DELPHIBIN%\dcc32.exe RsoDB3.dpk -B >>ErrorLog.Log
@if ErrorLevel=1 goto RTDBError
@echo RsoDB3.dpk was compiled successfully
@if exist %DPLDIR%\RsoDB3.dpl del %DPLDIR%\RsoDB3.dpl >nul
@move RsoDB3.dpl %DPLDIR% >nul

@echo .
@echo .
@echo {*******************************************************}
@echo {     Phase 4 - Design-time packages compilation        }
@echo {*******************************************************}

@%DELPHIBIN%\dcc32.exe DsoCmn3.dpk -B >>ErrorLog.Log
@if ErrorLevel=1 goto DTCommonError
@echo DsoCmn3.dpk was compiled successfully
@%DELPHIBIN%\dcc32.exe DsoDB3.dpk -B >>ErrorLog.Log
@if ErrorLevel=1 goto DTDBError
@echo DsoDB3.dpk was compiled successfully
goto End

:RTCommonError
@echo RsoCmn3.dpk was compiled with errors!
@pause
goto End 
:RTDBError
@echo RsoDB3.dpk was compiled with errors!
@pause
goto End 
:DTCommonError
@echo DsoCmn3.dpk was compiled with errors!
@pause
goto End 
:DTDBError
@echo DsoDB3.dpk was compiled with errors!
@pause
:End