@echo off
@echo {*******************************************************}
@echo {                                                       }
@echo {           Delphi Visual Component Library             }
@echo {                                                       }
@echo {           Copyright (c) 2000-2001 Devrace             }
@echo {            Devrace SohoLib Pro Components             }
@echo {                                                       }
@echo {*******************************************************}
@echo .
@echo .
@echo            SohoLib Pro for Delphi 4 Installation 
@echo .
@echo .
@echo {*******************************************************}
@echo {         Phase 1 - Special variables setting           }
@echo {*******************************************************}

rem   *******************************************************
rem   * At first, you must set the special variables:       *
rem   * 1. DELPHIBIN - path to your Delphi bin directory    *
rem   * 2. RBPLDIR   - path to directory for run-time BPL   *
rem   *    files (Windows system directory is recommended)  *
rem   * 3. RBPLDIR   - path to directory for design-time    *
rem   *    BPL (Default value is recommended)               *
rem   *******************************************************

@set DELPHIROOT=F:\Delphi\Delphi4
@set DELPHIBIN=%DELPHIROOT%\BIN
@set RBPLDIR=%SYSTEMROOT%\System32
@set DBPLDIR=%DELPHIROOT%\Projects\Bpl

@echo .
@echo .
@echo {*******************************************************}
@echo {        Phase 2 - Superfluous files deleting           }
@echo {*******************************************************}

rem   *******************************************************
rem   * Now, we delete superfluous files from the SohoLib   *
rem   * directory and from design-time packages directory   *
rem   *******************************************************

@if exist *.~?? del *.~?? >nul
@if exist *.dpl del *.dpl >nul
@if exist *.bpl del *.bpl >nul
@if exist *.dcp del *.dcp >nul
@if exist *.dcu del *.dcu >nul
@if exist %DBPLDIR%\DsoCmn4.bpl del %DBPLDIR%\DsoCmn4.bpl >nul
@if exist %DBPLDIR%\DsoDB4.bpl del %DBPLDIR%\DsoDB4.bpl >nul
@if exist %DBPLDIR%\DsoCmn4.dcp del %DBPLDIR%\DsoCmn4.dcp >nul
@if exist %DBPLDIR%\DsoDB4.dcp del %DBPLDIR%\DsoDB4.dcp >nul
@if exist %DBPLDIR%\RsoCmn4.dcp del %DBPLDIR%\RsoCmn4.dcp >nul
@if exist %DBPLDIR%\RsoDB4.dcp del %DBPLDIR%\RsoDB4.dcp >nul
@if exist .\Delphi4\*.dcu copy .\Delphi4\*.dcu *.dcu >nul

@echo .
@echo .
@echo {*******************************************************}
@echo {       Phase 3 - Run-time packages compilation         }
@echo {*******************************************************}

rem   *******************************************************
rem   * Results of compilation will be stored into the      *
rem   * ErrorLog.log file                                   *
rem   *******************************************************

@%DELPHIBIN%\dcc32.exe RsoCmn4.dpk -B -U%DBPLDIR% >ErrorLog.log
@if ErrorLevel=1 goto RTCommonError
@echo RsoCmn4.dpk was compiled successfully
@if exist %DBPLDIR%\RsoCmn4.bpl del %DBPLDIR%\RsoCmn4.bpl >nul

@%DELPHIBIN%\dcc32.exe RsoDB4.dpk -B -U%DBPLDIR% >>ErrorLog.Log
@if ErrorLevel=1 goto RTDBError
@echo RsoDB4.dpk was compiled successfully
@if exist %DBPLDIR%\RsoCmn4.bpl del %DBPLDIR%\RsoCmn4.bpl >nul
@if exist %DBPLDIR%\RsoDB4.bpl del %DBPLDIR%\RsoDB4.bpl >nul

@echo .
@echo .
@echo {*******************************************************}
@echo {     Phase 4 - Design-time packages compilation        }
@echo {*******************************************************}

@%DELPHIBIN%\dcc32.exe DsoCmn4.dpk -B -U%DBPLDIR% >>ErrorLog.Log
@if ErrorLevel=1 goto DTCommonError
@echo DsoCmn4.dpk was compiled successfully
@if exist %DBPLDIR%\RsoCmn4.bpl del %DBPLDIR%\RsoCmn4.bpl >nul
@if exist %DBPLDIR%\RsoDB4.bpl del %DBPLDIR%\RsoDB4.bpl >nul

@%DELPHIBIN%\dcc32.exe DsoDB4.dpk -B -U%DBPLDIR% >>ErrorLog.Log
@if ErrorLevel=1 goto DTDBError
@echo DsoDB4.dpk was compiled successfully
@if exist %DBPLDIR%\RsoCmn4.bpl del %DBPLDIR%\RsoCmn4.bpl >nul
@if exist %DBPLDIR%\RsoDB4.bpl del %DBPLDIR%\RsoDB4.bpl >nul
@if exist %RBPLDIR%\RsoCmn4.bpl del %RBPLDIR%\RsoCmn4.bpl >nul
@if exist %RBPLDIR%\RsoDB4.bpl del %RBPLDIR%\RsoDB4.bpl >nul
@if exist RsoCmn4.bpl move RsoCmn4.bpl %RBPLDIR% >nul
@if exist RsoDB4.bpl move RsoDB4.bpl %RBPLDIR% >nul
@if exist *.bpl move *.bpl %DBPLDIR% >nul
@if exist *.dcp move *.dcp %DBPLDIR% >nul
goto End

:RTCommonError
@echo RsoCmn4.dpk was compiled with errors!
@pause
goto End 
:RTDBError
@echo RsoDB4.dpk was compiled with errors!
@pause
goto End 
:DTCommonError
@echo DsoCmn4.dpk was compiled with errors!
@pause
goto End 
:DTDBError
@echo DsoDB4.dpk was compiled with errors!
@pause
:End