@echo off
@echo {*******************************************************}
@echo {                                                       }
@echo {           Delphi Visual Component Library             }
@echo {                                                       }
@echo {           Copyright (c) 2000-2001 Devrace             }
@echo {            Devrace SohoLib Pro Components             }
@echo {                                                       }
@echo {*******************************************************}
@echo .
@echo .
@echo            SohoLib Pro for Delphi 6 Installation 
@echo .
@echo .
@echo {*******************************************************}
@echo {         Phase 1 - Special variables setting           }
@echo {*******************************************************}

rem   *******************************************************
rem   * At first, you must set the special variables:       *
rem   * 1. DELPHIBIN - path to your Delphi bin directory    *
rem   * 2. RBPLDIR   - path to directory for run-time BPL   *
rem   *    files (Windows system directory is recommended)  *
rem   * 3. RBPLDIR   - path to directory for design-time    *
rem   *    BPL (Default value is recommended)               *
rem   *******************************************************

@set DELPHIROOT=F:\Delphi\Delphi6
@set DELPHIBIN=%DELPHIROOT%\BIN
@set RBPLDIR=D:\winnt\System32
@set DBPLDIR=%DELPHIROOT%\Projects\BPL

rem @set DELPHIROOT=D:\Borland\Delphi5
rem @set DELPHIBIN=%DELPHIROOT%\BIN
rem @set RBPLDIR=D:\winnt\System32
rem @set DBPLDIR=%DELPHIROOT%\Projects\BPL

@echo .
@echo .
@echo {*******************************************************}
@echo {        Phase 2 - Superfluous files deleting           }
@echo {*******************************************************}

rem   *******************************************************
rem   * Now, we delete superfluous files from the SohoLib   *
rem   * directory and from design-time packages directory   *
rem   *******************************************************

@if exist *.~?? del *.~?? >nul
@if exist *.dpl del *.dpl >nul
@if exist *.bpl del *.bpl >nul
@if exist *.dcp del *.dcp >nul
@if exist *.dcu del *.dcu >nul
@if exist %DBPLDIR%\DsoCmn6.bpl del %DBPLDIR%\DsoCmn6.bpl >nul
@if exist %DBPLDIR%\DsoDB6.bpl del %DBPLDIR%\DsoDB6.bpl >nul
@if exist %DBPLDIR%\DsoCmn6.dcp del %DBPLDIR%\DsoCmn6.dcp >nul
@if exist %DBPLDIR%\DsoDB6.dcp del %DBPLDIR%\DsoDB6.dcp >nul
@if exist %DBPLDIR%\RsoCmn6.dcp del %DBPLDIR%\RsoCmn6.dcp >nul
@if exist %DBPLDIR%\RsoDB6.dcp del %DBPLDIR%\RsoDB6.dcp >nul
@if exist .\Delphi6\*.dcu copy .\Delphi5\*.dcu *.dcu >nul

@echo .
@echo .
@echo {*******************************************************}
@echo {       Phase 3 - Run-time packages compilation         }
@echo {*******************************************************}

rem   *******************************************************
rem   * Results of compilation will be stored into the      *
rem   * ErrorLog.log file                                   *
rem   *******************************************************

@%DELPHIBIN%\dcc32.exe RsoCmn6.dpk -B -UDBPLDIR >ErrorLog.log
@if ErrorLevel=1 goto RTCommonError
@echo RsoCmn6.dpk was compiled successfully
@if exist %DBPLDIR%\RsoCmn6.bpl del %DBPLDIR%\RsoCmn6.bpl >nul

@%DELPHIBIN%\dcc32.exe RsoDB6.dpk -B -UDBPLDIR >>ErrorLog.Log
@if ErrorLevel=1 goto RTDBError
@echo RsoDB6.dpk was compiled successfully
@if exist %DBPLDIR%\RsoCmn6.bpl del %DBPLDIR%\RsoCmn6.bpl >nul
@if exist %DBPLDIR%\RsoDB6.bpl del %DBPLDIR%\RsoDB6.bpl >nul

@echo .
@echo .
@echo {*******************************************************}
@echo {     Phase 4 - Design-time packages compilation        }
@echo {*******************************************************}

@%DELPHIBIN%\dcc32.exe DsoCmn6.dpk -B -UDBPLDIR >>ErrorLog.Log
@if ErrorLevel=1 goto DTCommonError
@echo DsoCmn6.dpk was compiled successfully
@if exist %DBPLDIR%\RsoCmn6.bpl del %DBPLDIR%\RsoCmn6.bpl >nul
@if exist %DBPLDIR%\RsoDB6.bpl del %DBPLDIR%\RsoDB6.bpl >nul

@%DELPHIBIN%\dcc32.exe DsoDB6.dpk -B -UDBPLDIR >>ErrorLog.Log
@if ErrorLevel=1 goto DTDBError
@echo DsoDB6.dpk was compiled successfully

@if exist %DBPLDIR%\RsoCmn6.bpl del %DBPLDIR%\RsoCmn6.bpl >nul
@if exist %DBPLDIR%\RsoDB6.bpl del %DBPLDIR%\RsoDB6.bpl >nul
@if exist %RBPLDIR%\RsoCmn6.bpl del %RBPLDIR%\RsoCmn6.bpl >nul
@if exist %RBPLDIR%\RsoDB6.bpl del %RBPLDIR%\RsoDB6.bpl >nul
@if exist RsoCmn6.bpl move RsoCmn6.bpl %RBPLDIR% >nul
@if exist RsoDB6.bpl move RsoDB6.bpl %RBPLDIR% >nul
@if exist *.bpl move *.bpl %DBPLDIR% >nul
@if exist *.dcp move *.dcp %DBPLDIR% >nul
goto End

:RTCommonError
@echo RsoCmn6.dpk was compiled with errors!
@pause
goto End 
:RTDBError
@echo RsoDB6.dpk was compiled with errors!
@pause
goto End 
:DTCommonError
@echo DsoCmn6.dpk was compiled with errors!
@pause
goto End 
:DTDBError
@echo DsoDB6.dpk was compiled with errors!
@pause
:End