@echo off
@echo {*******************************************************}
@echo {                                                       }
@echo {           Delphi Visual Component Library             }
@echo {                                                       }
@echo {           Copyright (c) 2000-2001 Devrace             }
@echo {            Devrace SohoLib Pro Components             }
@echo {                                                       }
@echo {*******************************************************}
@echo .
@echo .
@echo            SohoLib for CBuilder 4 Installation 
@echo .
@echo .
@echo {*******************************************************}
@echo {         Phase 1 - Special variables setting           }
@echo {*******************************************************}

rem   *******************************************************
rem   * At first, you must set the special variables:       *
rem   * 1. CBBIN - path to your Delphi bin directory        *
rem   * 2. RBPLDIR   - path to directory for run-time BPL   *
rem   *    files (Windows system directory is recommended)  *
rem   * 3. RBPLDIR   - path to directory for design-time    *
rem   *    BPL (Default value is recommended)               *
rem   * 4. LIBDIR   - path to directory for projects lib    *
rem   *    *.lib & *.bpi (Default value is recommended)     *
rem   *******************************************************

@set CBROOT=C:\Progra~1\Borland\CBuild~1
@set CBBIN=%CBROOT%\BIN
@rem @set RBPLDIR=%SYSTEMROOT%\System32
@set RBPLDIR=%CBROOT%\Projects\BPL
@set DBPLDIR=%CBROOT%\Projects\BPL
@set LIBDIR=%CBROOT%\Projects\Lib

@echo .
@echo .
@echo {*******************************************************}
@echo {        Phase 2 - Superfluous files deleting           }
@echo {*******************************************************}

rem   *******************************************************
rem   * Now, we delete superfluous files from the SohoLib   *
rem   * directory and from design-time packages directory   *
rem   *******************************************************

@if exist *.~?? del *.~?? >nul
@if exist *.bpi del *.bpi >nul
@if exist *.lib del *.lib >nul
@if exist *.bpl del *.bpl >nul
@if exist %DBPLDIR%\DsoCmn4.bpl del %DBPLDIR%\DsoCmn4.bpl >nul
@if exist %DBPLDIR%\DsoDB4.bpl del %DBPLDIR%\DsoDB4.bpl >nul
@if exist %LIBDIR%\RsoCmn4.bpi del %DBPLDIR%\RsoCmn4.bpi >nul
@if exist %LIBDIR%\DsoCmn4.bpi del %DBPLDIR%\DsoCmn4.bpi >nul
@if exist %LIBDIR%\RsoDB4.bpi del %DBPLDIR%\RsoDB4.bpi >nul
@if exist %LIBDIR%\DsoDB4.bpi del %DBPLDIR%\DsoDB4.bpi >nul
@if exist %LIBDIR%\RsoCmn4.lib del %DBPLDIR%\RsoCmn4.lib >nul
@if exist %LIBDIR%\DsoCmn4.lib del %DBPLDIR%\DsoCmn4.lib >nul
@if exist %LIBDIR%\RsoDB4.lib del %DBPLDIR%\RsoDB4.lib >nul
@if exist %LIBDIR%\DsoDB4.lib del %DBPLDIR%\DsoDB4.lib >nul
@if exist .\CBuilder4\*.obj copy .\CBuilder4\*.obj *.obj >nul

@echo .
@echo .
@echo {*******************************************************}
@echo {       Phase 3 - Run-time packages compilation         }
@echo {*******************************************************}

rem   *******************************************************
rem   * Results of compilation will be stored into the      *
rem   * ErrorLog.log file                                   *
rem   *******************************************************

@%CBBIN%\make.exe -fRsoCmn4.bpk >>ErrorLog.log

@%CBBIN%\make.exe -fRsoDB4.bpk >>ErrorLog.Log

@echo .
@echo .
@echo {*******************************************************}
@echo {     Phase 4 - Design-time packages compilation        }
@echo {*******************************************************}

@%CBBIN%\make.exe -fDsoCmn4.bpk >>ErrorLog.Log

@%CBBIN%\make.exe -fDsoDB4.bpk >>ErrorLog.Log
@if exist %DBPLDIR%\RsoCmn4.bpl del %DBPLDIR%\RsoCmn4.bpl >nul
@if exist %DBPLDIR%\RsoDB4.bpl del %DBPLDIR%\RsoDB4.bpl >nul
@if exist %RBPLDIR%\RsoCmn4.bpl del %RBPLDIR%\RsoCmn4.bpl >nul
@if exist %RBPLDIR%\RsoDB4.bpl del %RBPLDIR%\RsoDB4.bpl >nul
@if exist RsoCmn4.bpl move RsoCmn4.bpl %RBPLDIR% >nul
@if exist RsoDB4.bpl move RsoDB4.bpl %RBPLDIR% >nul
@if exist *.bpl move *.bpl %DBPLDIR% >nul
@if exist *.bpi move *.bpi %LIBDIR% >nul
@if exist *.lib move *.lib %LIBDIR% >nul
