{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoAlignF;

{$I SOHOLIB.INC}

interface

uses
  SysUtils, Windows, Messages, Classes, SoRadGrp, Controls,
  StdCtrls, SohoBtns, Forms;

type
  TsohoAlignmentForm = class(TForm)
    sohoBitBtn1: TsohoBitBtn;
    sohoBitBtn2: TsohoBitBtn;
    HorGr: TsohoRadioGroup;
    VertGr: TsohoRadioGroup;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    function GetAlign (var aHorAlign, aVertAlign : integer) : boolean;
  public
    { Public declarations }
  end;

var AlignmentForm: TsohoAlignmentForm;

function GetControlsAlign (var aHorAlign,aVertAlign : integer) : boolean;

implementation
uses SoCmnCns;

{$R *.DFM}

function GetControlsAlign (var aHorAlign, aVertAlign : integer) : boolean;
begin
  try
    AlignmentForm := TsohoAlignmentForm.Create(Application);
    Result := AlignmentForm.GetAlign(aHorAlign,aVertAlign);
  finally
    AlignmentForm.Free;
  end;
end;

function TsohoAlignmentForm.GetAlign (var aHorAlign,aVertAlign : integer) : boolean;
begin
  Result := ShowModal = mrOk;
  aHorAlign  := HorGr.ItemIndex;
  aVertAlign := VertGr.ItemIndex;
end;

procedure TsohoAlignmentForm.FormShow(Sender: TObject);
begin
  HorGr.ItemIndex := 0;
  VertGr.ItemIndex := 0;
end;

procedure TsohoAlignmentForm.FormCreate(Sender: TObject);
begin
  // Text
  Caption := sohoAlignFormTitle;
  with HorGr, Items do begin
    Add(sohoAlignFormNoChanges);
    Add(sohoAlignFormLefts);
    Add(sohoAlignFormCenter);
    Add(sohoAlignFormRights);
    Add(sohoAlignFormWindowCenter);
  end;
  with VertGr, Items do begin
    Add(sohoAlignFormNoChanges);
    Add(sohoAlignFormTops);
    Add(sohoAlignFormCenter);
    Add(sohoAlignFormBottoms);
    Add(sohoAlignFormWindowCenter);
  end;
end;

end.
