{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoAnimate;

{$I SOHOLIB.INC }

interface
uses ComCtrls, Classes, Controls, Forms;

function CreateAnimate(aOwner: TComponent; aParent: TWinControl; AviType: TCommonAVI): TAnimate;
{   TAnimate,    aParent  
    AviType }
procedure RunAnimate(Value: TAnimate; aParent: TWinControl; AviType: TCommonAVI);
{   Value  aParent  
    AviType }
procedure StopAnimate(Value: TAnimate);
{   Value.    RunAnimate }
function CreateCopyForm(const aCaption: string; StayOnTop: boolean): TForm;
{       }

implementation
uses SoGraph;

procedure RunAnimate(Value: TAnimate; aParent: TWinControl; AviType: TCommonAVI);
begin
  with Value do begin
    Parent := aParent;
    AutoSize := true;
    CommonAVI := AviType;
    Left := HorCenter(aParent.ClientRect, Width);
    Top := VertCenter(aParent.ClientRect, Height);
    Active := true;
  end;
end;

function CreateAnimate(aOwner: TComponent; aParent: TWinControl; AviType: TCommonAVI): TAnimate;
begin
  Result := TAnimate.Create(aOwner);
  RunAnimate(Result, aParent, AviType);
end;

procedure StopAnimate(Value: TAnimate);
begin
  Value.Active := false;
  Value.Visible := false;
end;

function CreateCopyForm(const aCaption: string; StayOnTop: boolean): TForm;
var Animate: TAnimate;
begin
  Result := TForm.Create(Application);
  with Result do begin
    BorderStyle := bsToolWindow;
    Animate := CreateAnimate(Result, Result, aviCopyFiles);
    ClientWidth := Animate.Width + 10;
    ClientHeight := Animate.Height + 30;
    Animate.Left := HorCenter(ClientRect, Animate.Width);
    Animate.Top := VertCenter(ClientRect, Animate.Height);
    Caption := aCaption;
    Position := poScreenCenter;
    if StayOnTop then FormStyle := fsStayOnTop;
    Show;
    Update;
  end;
end;

end.
