{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{           Partial copyright (c) AllexSoft             }
{              Written by Serg Vostrikov,               }
{                 Alexander Govyadinov,                 }
{                   Igor Chernyshov                     }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoAppUtils;

{$I SOHOLIB.INC}

interface
uses Windows, Classes, Forms, Controls;

const

  crHourGlass = -11;
  crDefault = 0;

function AllFilesFound(PathTo: string; Files: array of string): Boolean;
{         ? }
procedure FilesToStrings(List: TStringList; const Path: string; Attr: Integer);
{      Path  List. Attr -  ,
      .  ,    
   ,  Attr     faDirectory }
function CopyFiles(FromName, ToName: string; Erase: Boolean): Boolean;
{ / //,  true   .
   !     ,    - "\"
  ,    - "\*.*". Erase  True,    ,
     }
function MakeDirectory(Dir: string): Boolean;
{    MkDir.    , 
     ,         }
function ClearDir(const Path: string; Delete: Boolean): Boolean;
{        . 
   Delete    true,   
      }
function Exec(const ProgramName, Params: string; ShowCode: Integer; Wait : boolean): string;
{     ,  ,  . 
     ,   .    
   ProgramName    ,    - ,
  ,    Ms Word: 'c:\temp\test.doc' }
function ExecError(ErrorNum: Longint): string;
{       }
function WindowsVerStr: string;
{    /  Windows }
procedure WindowsVer(var FirstNumb, SecondNumb: DWORD);
{    Windows }
function GetEnvVar(Pattern: string): string;
{    }
function ExtractFileNameOnly(Filename: string): string;
{      }
function DefaultName: string;
{     ( ) }
function DefaultIniName: string;
{   ini-   }
function GetRunDir: string;
{  ,    .   
      "\" }
procedure HideApplication;
{   }
function IDERunning: boolean;
{ ,    -  IDE Delphi? }
function GetPathToTemp: string;
{      }
function GetPathToLocalTemp: string;
{       }
procedure StandartAboutBox(const ProductName, Comments: string);
{   " ..."}
function NormalDir (const DirName : string) : string;
{   '/'   ,   }
function TextFileToStr (const FileName : string) : string;
{       }
function StrToTextFile (const FileName, Text : string) : boolean;
{       }
procedure PushCursor (aCursor : TCursor);
{     .    ,
   , , ,    ,  
  ResoreCursor }
procedure RestoreCursor;
{  ,   PushCursor }
procedure SwitchToRussian;
{     }
procedure SwitchToEnglish;
{     }
procedure RestoreLayout;
{     }
function RegisterTTF (const FileName: string): boolean;
{  TTF    }
function RemoveTTF (const FileName: string): boolean;
{  TTF,     }
function FileExists (const Name: string): boolean;
{  ,   .     
          }
function DirectoryExists (const Name: string): boolean;
{  ,    }
function GetShortFileName(FileName: string): string;
{       }
function RegisterFileExt (const ApplicationPath, ExtensionSubst,
  Description, Extension: string; IconIndex: LongInt;
  Force: boolean): boolean;
{   ,    
  .    ,  
   (Force = true),     (Force = false) }
procedure AddToRecentDocs(const DocName: string);
{       ""  "" }
procedure RefreshCursor;
{   "".  ,  Screen.Cursor = crDefault,
      crDefault .  
        crDefault }
function SystemSmallFonts: boolean;
{     ""  }

function GetScreenFormByName(const FormName : string) : TComponent;
{     Screen.Forms  .     ,
    nil }

implementation
uses SoCmnCns, SoClass, SysUtils, ShellAPI, SoStrUtils, SoVCLUtils,
     Registry, ShlObj;

function FileExists (const Name: string): boolean;
var SR: TSearchRec;
begin
  Result := FindFirst(Name, faAnyFile - faDirectory, SR) = 0;
  FindClose(SR);
end;

function AllFilesFound(PathTo: string; Files: array of string): Boolean;
var index: Integer;
begin
  Result := False;
  if PathTo[Length(PathTo)] <> '\' then PathTo := PathTo + '\';
  for index := Low(Files) to High(Files) do
    if not FileExists(PathTo + Files[index]) then exit;
  Result := True;
end;

function ExecError(ErrorNum: Longint): string;
begin
  case ErrorNum of
    0: Result := sohoUtilsFileError0;
    2: Result := sohoUtilsFileError2;
    3: Result := sohoUtilsFileError3;
    4: Result := sohoUtilsFileError4;
    5: Result := sohoUtilsFileError5;
    6: Result := sohoUtilsFileError6;
    8: Result := sohoUtilsFileError8;
    10: Result := sohoUtilsFileError10;
    11: Result := sohoUtilsFileError11;
    12: Result := sohoUtilsFileError12;
    13: Result := sohoUtilsFileError13;
    14: Result := sohoUtilsFileError14;
    15: Result := sohoUtilsFileError15;
    16: Result := sohoUtilsFileError16;
    19: Result := sohoUtilsFileError19;
    20: Result := sohoUtilsFileError20;
    21: Result := sohoUtilsFileError21;
  else Result := sohoUtilsFileErrorUnknown
    {See help topic WinExec 3.0 , Windows unit}
  end;
end;

function Exec(const ProgramName, Params: string; ShowCode: Integer; Wait : boolean): string;
{$IFNDEF WIN32}
var Tmp: string;
    TaskHandle: THandle;
    ExecUsage: Word;
    // Prog, Parm : PChar;
begin
  Tmp := Command + Space + Params + #0;
  TaskHandle := WinExec(@Tmp[1], ShowCode);
  if TaskHandle < 32 then begin
    Result := ExecError(TaskHandle);
    exit;
  end;
  if Wait then
   with Application do begin
     ExecUsage := GetModuleUsage(ExecHandle);
     MainForm.Visible := False;
     repeat
       ProcessMessages;
     until GetModuleUsage(TaskHandle) <> ExecUsage;
     MainForm.Visible := True;
   end;
end;
{$ELSE}
var ExecInfo: TShellExecuteInfo;
    {ExitCode: LongInt;}
    ExitCode : DWORD; {D4}
begin
  FillChar(ExecInfo, SizeOf(ExecInfo), 0);
  ExecInfo.cbSize := SizeOf(TShellExecuteInfo);
  with ExecInfo do begin
    fMask := SEE_MASK_NOCLOSEPROCESS;
    Wnd := Application.Handle;
    GetMem(lpFile, length(ProgramName)+1);
    GetMem(lpParameters, length(Params)+1);
    StrPCopy(lpFile, ProgramName);
    StrPCopy(lpParameters, Params);
    {lpFile := PChar(ProgramName);
    lpParameters := PChar(Params);}
    nShow := ShowCode;
  end;
  if ShellExecuteEx(@ExecInfo) then begin
    if Wait then
      repeat
        Application.ProcessMessages;
        GetExitCodeProcess(ExecInfo.hProcess, ExitCode);
      until (ExitCode <> STILL_ACTIVE) or Application.Terminated;
    Result := '';
  end
  else Result := ExecError(GetLastError);
end;
{$ENDIF}

function WindowsVerStr: string;
var
    Info : TOSVERSIONINFO;
begin
  Info.dwOSVersionInfoSize := SizeOf(TOSVERSIONINFO);
  GetVersionEx(Info);
  case Info.dwPlatformId of
    VER_PLATFORM_WIN32_WINDOWS: Result := 'Windows 95/98 '+StrPas(Info.szCSDVersion);
    VER_PLATFORM_WIN32_NT     : begin
      if Info.dwMajorVersion = 5 then
        Result := 'Windows 2000 (build ' + IntToStr(Info.dwBuildNumber) + ')'
      else
        Result := 'Windows NT ' + StrPas(Info.szCSDVersion);
    end;
  end;
end;

{$IFNDEF WIN32}
procedure WindowsVer(var FirstNumb, SecondNumb: Byte);
{$ELSE}
procedure WindowsVer(var FirstNumb, SecondNumb: DWORD);
{$ENDIF}
var
    {$IFNDEF WIN32}
    LVerW: Word;
    HVer, LVer: Byte;
    {$ELSE}
    Info : TOSVERSIONINFO;
    {$ENDIF}
begin
  {$IFNDEF WIN32}
  LVerW := GetVersion and $FFFF; HVer := Hi(LVerW); LVer := Lo(LVerW);
  FirstNumb := LVer; SecondNumb := HVer;
  {$ELSE}
  Info.dwOSVersionInfoSize := SizeOf(TOSVERSIONINFO);
  GetVersionEx(Info);
  FirstNumb := Info.dwMajorVersion;
  SecondNumb := Info.dwMinorVersion;
  {$ENDIF}
end;

function ExtractFileNameOnly(FileName: string): string;
var P: Longint;
begin
  Result := ExtractFileName(FileName); //
  P := Pos('.', Result);
  if P = 0 then exit; //  -   
  P := Length(Result);
  while Result[P] <> '.' do Dec(P);
  Delete(Result, P, Length(Result));
end;

function DefaultName: string;
begin
  Result := ExtractFileNameOnly(ParamStr(0)){+'.'};
end;

function DefaultIniName: string;
begin
  Result := GetRunDir + DefaultName + '.ini';
end;

function GetEnvVar(Pattern: string): string;
var TPC: PChar;
  I: Longint;
  {$IFDEF WIN32}
  lpBuffer  : array [0..255] of char;
  VarResult : LongInt;
  {$ELSE}
  S: string;
  {$ENDIF}
  function NextEnvVar: string;
  begin
    Result := EmptyStr;
    repeat Result := Result + TPC[I]; inc(I); until TPC[I] = #0;
    Result := AnsiUpperCase(Result); inc(I);
  end;
   begin
  Pattern := AnsiUpperCase(Pattern);
  {$IFNDEF Win32}
  TPC := GetDosEnvironment;
  I := 0;
  repeat
    S := NextEnvVar;
  until (TPC[I] = #0) or (Copy(S, 1, Pos('=', S) - 1) = Pattern);
  Result := Copy(S, Pos('=', S) + 1, 254);
  {$ELSE}
  Pattern := AnsiUpperCase(Pattern) + #0;
  VarResult := GetEnvironmentVariable(@Pattern[1], lpBuffer, 255);
  if VarResult > 0 then Result := StrPas(lpBuffer);
  {$ENDIF}
end;

procedure FilesToStrings(List: TStringList; const Path: string; Attr: Integer);
var F: TSearchRec;
  ErrorCode: Integer;
begin
  with List do begin
    ErrorCode := FindFirst(Path, Attr, F);
    if ErrorCode <> 0 then begin
      FindClose(F);
      exit;
    end;
    Clear;
    repeat
      if (F.name <> '.') and (F.name <> '..') then Add(F.name);
      ErrorCode := FindNext(F);
    until ErrorCode <> 0;
    FindClose(F);
  end;
end;

function MakeDirectory(Dir: string): Boolean;
var SubDir: string;
begin
  {$i-}
  if Dir[Length(Dir)] = '\' then Dir := Copy(Dir, 1, Length(Dir) - 1);
  MkDir(Dir); {  ?}
  case IOResult of
    0: Result := True; {-, !!!}
    3: begin {,       }
       SubDir := Dir;
       {For Delphi 2,3 use Subdir:=Copy(Subdir ...) or other cases}
       while (SubDir <> EmptyStr) and (SubDir[Length(SubDir)] <> '\') do
         SubDir := DecLength(SubDir, 1);
       Result := MakeDirectory(SubDir);
       if Result then MkDir(Dir); { -  !}
       Result := (IOResult = 0)
    end;
    5, 183: Result := True; { ,   }
    else begin
    {   -  }
    InfoMsg(Format(sohoUtilsUnableCreateDir, [Dir]));
    Result := False;
    end;
  end;
end;

function CopyFiles(FromName, ToName: string; Erase: Boolean): Boolean;
type TBuffer = array[1..1024 * 4] of Byte;
var Buffer:^TBuffer;
  DirFrom, FileFrom, DirTo, FileTo: string[128];
  {Exist                          :Boolean;     }
  SR                              : TSearchRec;
  FF, FT                          : file;
  {$IFDEF WIN32}
  Size                            : Integer;
  {$ELSE}
  Size                            : Word;
  {$ENDIF}
  Error                           : string[80];
  label Finish;

begin
  Result := False; Error := EmptyStr; Buffer := nil;
  DirFrom := ExtractFilePath(FromName);
  DirTo := ExtractFilePath(ToName);
  FileFrom := ExtractFileName(FromName);
  if FileFrom = '' then FileFrom := '*.*';
  FileTo := ExtractFileName(ToName);
  if FileTo = '' then FileTo := '*.*';

  { }
  if FindFirst(DirFrom + FileFrom, faAnyFile, SR) <> 0 then begin
    Error := sohoUtilsNotFound + DirFrom + FileFrom;
    goto Finish;
  end;
  {$i-}
  {  }
  if not MakeDirectory(DirTo) then begin
    Error := sohoUtilsNotCreated + DirTo;
    goto Finish;
  end;
  {$IFDEF Delphi3}
  InOutRes := 0;
  {$ELSE}
  SetInOutRes(0); {D4, D5 -   }
  {$ENDIF}

  { }
  if DirFrom + FileFrom = DirTo + FileTo then begin
    Error := sohoUtilsCopyToSelf + DirFrom + FileFrom;
    goto Finish; {   }
  end;
  if FileFrom = '*.*' then
    if (DirFrom <> EmptyStr) and (Pos(DirFrom, DirTo) <> 0) then begin
      Result := False;
      Error := DirFrom + FileFrom + sohoUtilsRecourceCopy;
      goto Finish;
    end;

  if (Pos('*', FileFrom) <> 0) and (Pos('*', FileTo) = 0) then begin
    Error := sohoUtilsCopyManyToOne + DirFrom + FileFrom + '=>' + DirTo + FileTo;
    goto Finish; { 
        }
  end;
  { }
  {   -  ,  }
  Result := True; {,  }
  if Pos('*', FileFrom) = 0 then begin
    AssignFile(FF, DirFrom + FileFrom);
    FileMode := $40; {Shared and Read Only!}
    Reset(FF, 1);
    FileMode := 2; {Monopolize and Full Access}
    Result := Result and (IOResult = 0);
    if not Result then begin
      Error := sohoUtilsOpenError + DirFrom + FileFrom;
      goto Finish; {     }
    end;
    if Pos('*', FileTo) = 0
      then AssignFile(FT, DirTo + FileTo)
    else AssignFile(FT, DirTo + FileFrom);
    Rewrite(FT, 1);
    Result := Result and (IOResult = 0);
    if not Result then begin
      Error := sohoUtilsOpenError + DirTo + FileTo;
      goto Finish; {     }
    end;
    {  }
    New(Buffer);
    repeat
      System.BlockRead(FF, Buffer^, SizeOf(TBuffer), Size);
      Result := Result and (IOResult = 0);
      if not Result then begin
        Error := sohoUtilsReadError + DirFrom + FileFrom;
        goto Finish; {     }
      end;
      BlockWrite(FT, Buffer^, Size);
      Result := Result and (IOResult = 0);
      if not Result then begin
        Error := sohoUtilsWriteError + DirTo + FileTo;
        goto Finish; {     }
      end;
    until Size <> SizeOf(TBuffer);
    FileSetDate(TFileRec(FT).Handle, FileGetDate(TFileRec(FF).Handle));
    CloseFile(FF);
    CloseFile(FT);
    {  }
    if Erase then SysUtils.DeleteFile(DirFrom + FileFrom);
  end {if * then}
  else begin {      ,
        }
    FindFirst(DirFrom + FileFrom, faAnyFile, SR);
    repeat
      if (SR.name[1] <> '.') then
        if (SR.Attr and faDirectory <> 0)
          then Result := Result and CopyFiles(DirFrom + SR.name + '\' + FileFrom, DirTo + SR.name + '\*', Erase)
        else Result := Result and CopyFiles(DirFrom + SR.name, DirTo + SR.name, Erase);
      if not Result then goto Finish;
    until FindNext(SR) <> 0;
  end {if * else};
Finish:
  {$IFDEF Delphi3}
  InOutRes := 0;
  {$ELSE}
  SetInOutRes(0); {D4, D5 -   }
  {$ENDIF}
  if Buffer <> nil then Dispose(Buffer);
  if not Result then if Error <> '' then InfoMsg(Error);
end;

function GetRunDir: string;
begin
  Result := ExtractFilePath(ParamStr(0));
  if Result = EmptyStr then GetDir(0, Result);
  if Result[Length(Result)] <> '\' then Result := Result + '\';
end;

procedure HideApplication;
begin
  Application.Minimize;
  ShowWindow(Application.Handle, SW_HIDE);
end;

function GetPathToTemp: string;
{$IFDEF Win32}
var Buffer: array[0..255] of Char;
begin
  GetTempPath(255, Buffer);
  Result := StrPas(Buffer);
  if Result[Length(Result)] <> '\' then Result := Result + '\';
end;
{$ELSE}
begin
  Result := GetEnvVar('TMP');
  if Result = '' then Result := GetEnvVar('TEMP');
end;
{$ENDIF}

function DirectoryExists (const Name: string): boolean;
var SR: TSearchRec;
    Tmp: string;
begin
  Result := false;
  if Name = EmptyStr then exit;
  Tmp := Name;
  if Tmp[Length(Tmp)] = '\' then Tmp := Copy(Tmp, 1, Length(Tmp) - 1);
  Result := FindFirst(Tmp + '\*.*', faAnyFile, SR) = 0;
  FindClose(SR);
end;

function GetShortFileName(FileName: string): string;
var Tmp: PChar;
begin
  GetMem(Tmp, 256);
  GetShortPathName(PChar(FileName), Tmp, 256);
  Result := StrPas(Tmp);
  FreeMem(Tmp);
end;

function RegisterFileExt (const ApplicationPath, ExtensionSubst,
  Description, Extension: string; IconIndex: LongInt;
  Force: boolean): boolean;
var Reg: TRegistry;
begin
  Result := false;
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_CLASSES_ROOT;
  if Reg.KeyExists('.' + Extension) and (not Force) then begin
    Reg.Free;
    exit;
  end;

  //       HKEY_CLASSES_ROOT
  // ,     :
  // HKEY_CLASSES_ROOT\ExtensionSubst = Description\DefaultIcon =
  //   "GetShortName(ApplicationPath), IconIndex"
  // HKEY_CLASSES_ROOT\ExtensionSubst\shell=open
  // HKEY_CLASSES_ROOT\ExtensionSubst\shell\Open\Command="ApplicationPath"
  with Reg do begin
    OpenKey(ExtensionSubst, true);
    WriteString(EmptyStr, Description);
    CloseKey;

    OpenKey(ExtensionSubst + '\DefaultIcon\', true);
    WriteString(EmptyStr, GetShortFileName(ApplicationPath) + ',' +
      IntToStr(IconIndex));
    CloseKey;

    OpenKey(ExtensionSubst + '\shell\', true);
    WriteString(EmptyStr, 'open');
    CloseKey;

    OpenKey(ExtensionSubst + '\shell\Open\Command\', true);
    WriteString(EmptyStr, GetShortFileName(ApplicationPath) + ' %1');
    CloseKey;

    //   
    // HKEY_CLASSES_ROOT\.Extension = ExtensionSubst
    OpenKey('.' + Extension, true);
    WriteString(EmptyStr, ExtensionSubst);
    CloseKey;

    Free;
  end;

  Result := true;
end;

procedure AddToRecentDocs(const DocName: string);
begin
  SHAddToRecentDocs(SHARD_PATH, PChar(DocName));
end;

function GetPathToLocalTemp: string;
begin
  Result := ExtractFileNameOnly(ParamStr(0));
  Result := GetPathToTemp+Result+'\';

  if not DirectoryExists(Result) then MakeDirectory(Result);
end;

procedure StandartAboutBox(const ProductName, Comments: string);
var Wnd: HWnd;
    AppIcon: HIcon;
    Prod, Comm : PChar;
begin
  Wnd := 0;
  if Application.MainForm <> nil then Wnd := Application.MainForm.Handle;
  AppIcon := Application.Icon.Handle;
  if AppIcon = 0 then AppIcon := LoadIcon(0, IDI_APPLICATION);
  GetMem(Prod, length(ProductName)+1);
  GetMem(Comm, length(Comments)+1);
  ShellAbout(Wnd, Prod, Comm, AppIcon);
  FreeMem(Prod, length(ProductName)+1);
  FreeMem(Comm, length(Comments)+1);
end;

function NormalDir (const DirName : string) : string;
begin
  Result := DirName;
  if Result = EmptyStr then exit;
  if Result[length(Result)]<>'\' then Result := Result + '\';
end;

function ClearDir(const Path: string; Delete: Boolean): Boolean;
const
  FileNotFound = 18;
var
  FileInfo: TSearchRec;
  DosCode: Integer;
begin
  Result := DirectoryExists(Path);
  if not Result then Exit;
  DosCode := FindFirst(NormalDir(Path) + '*.*', faAnyFile, FileInfo);
  try
    while DosCode = 0 do begin
      if (FileInfo.Name[1] <> '.') and
         (FileInfo.Attr <> faVolumeID) then begin
        if (FileInfo.Attr and faDirectory = faDirectory) then
          Result := ClearDir(NormalDir(Path) + FileInfo.Name, Delete)
                    and Result
        else if (FileInfo.Attr and faVolumeID <> faVolumeID) then begin
          if (FileInfo.Attr and faReadOnly = faReadOnly) then
            FileSetAttr(NormalDir(Path) + FileInfo.Name, faArchive);
          Result := DeleteFile(NormalDir(Path) + FileInfo.Name) and Result;
        end;
      end;
      DosCode := FindNext(FileInfo);
    end;
  finally
    FindClose(FileInfo);
  end;
  if Delete and Result and (DosCode = FileNotFound) and
    not ((Length(Path) = 2) and (Path[2] = ':')) then begin
    RmDir(Path);
    Result := (IOResult = 0) and Result;
  end;
end;

function TextFileToStr (const FileName : string) : string;
var FileText : TStringList;
begin
  Result := EmptyStr;
  if not FileExists(FileName) then exit;
  FileText := TStringList.Create;
  FileText.LoadFromFile(FileName);
  Result := FileText.Text;
  FileText.Free;
end;

function StrToTextFile (const FileName, Text : string) : boolean;
var FileText : TStringList;
begin
  Result := false;
  if not DirectoryExists(ExtractFilePath(FileName)) then exit;
  FileText := TStringList.Create;
  FileText.Text := Text;
  try
    FileText.SaveToFile(FileName);
    Result := true;
  except
    on E: Exception do ErrorMsg(E.Message);
  end;
  FileText.Free;
end;

var CursorsList : TsohoIntegerList;

procedure RestoreCursor;
begin
  if CursorsList.Count > 0 then begin
    Screen.Cursor := TCursor(CursorsList[CursorsList.Count-1]);
    CursorsList.Delete(CursorsList.Count-1);
  end
  else Screen.Cursor := crDefault;
end;

procedure PushCursor (aCursor : TCursor);
begin
  CursorsList.Add(Screen.Cursor);
  Screen.Cursor := aCursor;
end;

var PrevLayout, NewLayout : HKL;
    LayoutRestored : boolean;

procedure RestoreLayout;
begin
  LayoutRestored := true;
  ActivateKeyboardLayout(PrevLayout, HKL_NEXT);
end;

procedure SwitchToRussian;
begin
  if not LayoutRestored then RestoreLayout;
  PrevLayout := GetKeyboardLayout(0);
  NewLayout  := LoadKeyboardLayout('00000419', KLF_ACTIVATE);
end;

procedure SwitchToEnglish;
begin
  if not LayoutRestored then RestoreLayout;
  PrevLayout := GetKeyboardLayout(0);
  NewLayout  := LoadKeyboardLayout('00000409', KLF_ACTIVATE);
end;

function RegisterTTF (const FileName: string): boolean;
var pFont : array [0..255] of char;
begin
  if FileExists(FileName) then begin
    StrPCopy(pFont, FileName);
    Result := AddFontResource(pFont) <> 0;
  end
  else Result := false;
end;

function RemoveTTF (const FileName: string): boolean;
var pFont : array [0..255] of char;
begin
  if FileExists(FileName) then begin
    StrPCopy(pFont, FileName);
    Result := RemoveFontResource(pFont);
  end
  else Result := false;
end;

function IDERunning: boolean;
begin
 Result :=  FindWindow('TAppBuilder', nil) <> 0;
end;

procedure RefreshCursor;
begin
  with Screen do begin
    Cursor := crHourGlass;
    Cursor := crDefault;
  end;
end;

function SystemSmallFonts: boolean;
var DC: HDC;
begin
  DC := GetDC(0);
  Result := (GetDeviceCaps(DC, LOGPIXELSX) = 96);
  { LOGPIXELSX will = 120 if large fonts are in use }
  ReleaseDC(0, DC);
end;

function GetScreenFormByName(const FormName : string)  : TComponent;
var
  i : Integer;
begin
  Result := nil;
  for i := 0 to pred(Screen.FormCount) do
    if CompareText(Screen.Forms[i].Name,FormName) = 0
      then Result := Screen.Forms[i];
end;

initialization
  CursorsList := TsohoIntegerList.Create;
  LayoutRestored := true;
finalization
  CursorsList.Free;
end.
