{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoCmnReg;

interface

{$I SOHOLIB.INC}

procedure Register;

implementation

uses SysUtils, Classes, SoCtrls, SohoBtns, SohoTabs, SoSplit, SoVLbl,
     SoGrids,  SoCtlPrp, {$IFDEF Delphi6}DesignEditors, DesignIntf{$ELSE}DsgnIntf{$ENDIF},
     Grids, SoStatus, SoGauges, SoTools,  SoMRU, SohoLog, SoMultimedia,
     SohoHntC, SoMenuEd, SoTlsPrp, SoFrmAct, SoAbout, SoCmplFm, SoDesCns,
     SoRadGrp, SoStatusBar, SoFrmStorage, SohoApp, SoFrmProps, SohoCalc,
     SoBckgrd, SoEnhTreeView, SoGraph, SoChkBox, SohoSpin, SoListView,
     SoSpecEdit, SoBrsFld, SoExpertTree,  SoScaleForm, SoCombos, SoMDINotifier

     {$IFDEF Delphi4_or_5},SohoMultiLng, SohoMultiLng_Editor, SoMenuBar, ImgList {$ENDIF}
     {$IFDEF Delphi5}, Stdreg{$ENDIF}
     {$IFDEF Delphi3}, CalCtrls{$ENDIF};

{$R SOCMNREG.D32}

procedure Register;
begin
  RegisterComponents ('SOHO-Controls', [
                      TsohoLabel,
                      TsohoBitBtn,
                      TsohoSpeedButton,
                      TsohoEdit,
                      TsohoComboBox,
                      TsohoCheckBox,
                      TsohoSpinEdit,
                      TsohoStatusBar,
                      TsohoGauge,
                      TsohoRadioGroup,
                      TsohoEnhTreeView,
                      TsohoListView,
                      TsohoStringGrid,
                      TsohoPanel,
                      TsohoFilenameEdit,
                      TsohoDirectoryEdit,
                      TsohoTransButton,
                      TsohoSplitter,
                      TsohoVertLabel,
                      TsohoStatus,
                      TsohoTabSet,
                      TsohoVertTabSet,
                      TsohoExpertTree,
                      TsohoColorComboBox,
                      TsohoImageComboBox,
                      TsohoFontComboBox
                      {$IFDEF Delphi4_or_5}, TsohoMenuBar{$ENDIF}
                      ]);

  RegisterComponents ('SOHO-Tools', [
                      TsohoSound,
                      TsohoEnterTab,
                      TsohoHintsCollector,
                      TsohoMenuCaptionEditor,
                      TsohoFormActive,
                      TsohoFormStorage,
                      TsohoApplication,
                      TsohoRegionForm,
                      TsohoBackground,
                      TsohoCalculator,
                      TsohoScaleForm,
                      TsohoMDINotifier,
                      TsohoMRUManager,
                      TsohoLog
{$IFDEF Delphi4_or_5}
, TsohoMultiLng
{$ENDIF}
                      ]);

  RegisterComponents ('SOHO-Dialogs', [TsohoAboutBox, TsohoBrowseFolder]);

  {$IFDEF Delphi3}
  RegisterComponents ('Win32', [TMonthCalendar]);
  {$ENDIF}

  RegisterComponentEditor (TsohoStringGrid    , TsohoStringGridEditor);
  RegisterComponentEditor (TsohoFormStorage   , TsohoFormStorageEditor);
  RegisterComponentEditor (TsohoEnterTab      , TsohoEnterTabEditor);
  RegisterComponentEditor (TsohoHintsCollector, TsohoHintsCollectorEditor);
  RegisterComponentEditor (TsohoRegionForm    , TsohoRegionFormEditor);
  RegisterComponentEditor (TsohoStatusBar     , TsohoStatusBarEditor);
{$IFDEF Delphi4_or_5}
  RegisterComponentEditor (TsohoMultiLNG      , TsohoMultiLngEditor);
{$ENDIF}

  RegisterPropertyEditor  (TypeInfo(TFileName)    , nil, '', TFileNameProperty);
  RegisterPropertyEditor  (TypeInfo(TWaveFileName), nil, '', TWavFileNameProperty);
  RegisterPropertyEditor  (TypeInfo(TIniFileName) , nil, '', TIniFileNameProperty);
  RegisterPropertyEditor  (TypeInfo(THintFileName), nil, '', TsohoHintsFileNameProperty);
  RegisterPropertyEditor  (TypeInfo(TStrings)     , TsohoFormStorage, 'StoredProps', TsohoStoredPropsProperty);
{$IFDEF Delphi4_or_5}
  RegisterPropertyEditor  (TypeInfo(String)       , TsohoMultiLNG, 'LangName', TsohoMultiLNGNameProperty);
{$ENDIF}

  {$IFNDEF Delphi5}
  RegisterPropertyEditor  (TypeInfo(LongInt)      , TComponent, 'ImageIndex', TsohoImageIndexEditor);
  {$ELSE}
  RegisterPropertyEditor  (TypeInfo(LongInt)      , TsohoBitBtn, 'ImageIndex', TsohoImageIndexEditor);
  RegisterPropertyEditor  (TypeInfo(LongInt)      , TsohoEdit, 'ImageIndex', TsohoImageIndexEditor);
  (*
  RegisterPropertyEditor  (TypeInfo(TImageIndex)  , TsohoBitBtn, 'ImageIndex', TComponentImageIndexPropertyEditor);
  RegisterPropertyEditor  (TypeInfo(TImageIndex)  , TsohoEdit, 'ImageIndex', TComponentImageIndexPropertyEditor);
  *)
  {$ENDIF}
end;

end.