{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoCrFldF;

{$I SOHOLIB.INC}

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, StdCtrls, SoCtrls, SoTools, SohoBtns, SohoSpin;

type

  TCreateFieldForm = class(TForm)
    NameL: TsohoLabel;
    TypeL: TsohoLabel;
    LenL: TsohoLabel;
    SQLL: TsohoLabel;
    NameE: TsohoEdit;
    TypeC: TsohoComboBox;
    LengthE: TsohoSpinEdit;
    SQLE: TsohoEdit;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    sohoEnterTab1: TsohoEnterTab;
    procedure NameEChange(Sender: TObject);
    procedure NameECanExit(Sender: TObject; var AllowExit: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    RealTypes: TStringList;
  end;
  
var CreateFieldForm: TCreateFieldForm;
  
function CreateNewField(var SQLCommand: string): boolean;

implementation
uses SoCmnCns;

{$R *.DFM}

function CreateNewField(var SQLCommand: string): boolean;
begin
  try
    CreateFieldForm := TCreateFieldForm.Create(Application);
    CreateFieldForm.TypeC.ItemIndex := 0;
    Result := CreateFieldForm.ShowModal = mrOk;
    if Result then SQLCommand := CreateFieldForm.SQLE.AsString;
  finally
    CreateFieldForm.Free;
  end;
end;

procedure TCreateFieldForm.NameEChange(Sender: TObject);
begin
  LengthE.Enabled := TypeC.Text = '';
  SQLE.AsString := NameE.AsString + ' ' + RealTypes[TypeC.ItemIndex];
  if LengthE.Enabled then SQLE.AsString := SQLE.AsString + ' (' + LengthE.Text + ')';
end;

procedure TCreateFieldForm.NameECanExit(Sender: TObject; var AllowExit: boolean);
begin
  AllowExit := (NameE.AsString <> '') or (ActiveControl = CancelB);
end;

procedure TCreateFieldForm.FormCreate(Sender: TObject);
begin
  RealTypes := TStringList.Create;
  RealTypes.Add('integer');
  RealTypes.Add('numeric');
  RealTypes.Add('char');
  RealTypes.Add('date');
  RealTypes.Add('time');
  RealTypes.Add('boolean');
  RealTypes.Add('memo');

  Caption := sohoCreateFieldFormTitle;
  NameL.Caption := sohoCreateFieldFormFieldName;
  TypeL.Caption := sohoCreateFieldFormFieldType;
  LenL.Caption := sohoCreateFieldFormFieldLen;
  SQLL.Caption := sohoCreateFieldFormSQLText;

  OkB.Caption := SOKButton;
  CancelB.Caption := SCancelButton;
end;

procedure TCreateFieldForm.FormDestroy(Sender: TObject);
begin
  RealTypes.Free;
end;

end.

