{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoCtlPrp;

{$I SOHOLIB.INC}

interface
uses {$IFDEF Delphi6}DesignEditors, DesignIntf{$ELSE}DsgnIntf{$ENDIF};

type

  TsohoStringGridEditor = class (TComponentEditor)
    function  GetVerbCount : integer; override;
    function  GetVerb (Index : integer) : string; override;
    procedure ExecuteVerb (Index : integer);override;
  end;

  TsohoStatusBarEditor = class (TComponentEditor)
    function  GetVerbCount : integer; override;
    function  GetVerb (Index : integer) : string; override;
    procedure ExecuteVerb (Index : integer);override;
  end;

implementation
uses SysUtils, Controls, Forms, Classes, SoGrdEd,
     Grids, SoGrids, SoUtils, SoCtrls, SoDesCns, SoStatusBar,
     SoStsCtrlEditor, ColnEdit;

{ TsohoStringGridEditor }
function TsohoStringGridEditor.GetVerbCount : integer;
begin
     Result := 1;
end;

function TsohoStringGridEditor.GetVerb (Index : integer) : string;
begin
     case Index of
       0 : Result := sohoGridEditor;
     end;
end;

procedure TsohoStringGridEditor.ExecuteVerb (Index : integer);
var GridEditorForm: TGridEditorForm;
begin
     GridEditorForm := TGridEditorForm.Create(Application);
     try
        GridEditorForm.Prepare(TsohoStringGrid(Component).ColCount,
                               TsohoStringGrid(Component).RowCount);
        GridEditorForm.CopyFrom(TsohoStringGrid(Component));
        if Component is TsohoStringGrid then GridEditorForm.vGrid.PopupMenu :=
             GridEditorForm.AlignMenu
        else GridEditorForm.vGrid.PopupMenu := nil;
        if GridEditorForm.ShowModal = mrOk then begin
           GridEditorForm.CopyTo(TsohoStringGrid(Component));
           Designer.Modified;
        end;
     finally
        GridEditorForm.Free;
     end;
end;

{ TsohoStatusBarEditor }

function  TsohoStatusBarEditor.GetVerbCount : integer;
begin
  // inherited;
  Result := 2;
end;

function  TsohoStatusBarEditor.GetVerb (Index : integer) : string;
begin
  case Index of
    0: Result := sohoStatusControlEditor;
    1: Result := sohoStatusPanelsEditor;
    else Result := inherited GetVerb(Index);
  end;
end;

procedure TsohoStatusBarEditor.ExecuteVerb (Index : integer);
begin
  case Index of
    0: if EditStatusControls(Component as TsohoStatusBar) then begin
          TsohoStatusBar(Component).Refresh;
       Designer.Modified;
    end;
    1: ShowCollectionEditor(Designer, Component,
        (Component as TsohoStatusBar).Panels, 'Panels');
    else inherited ExecuteVerb(Index);
  end;
end;

end.
