{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{ 12.11.2000   ButtonPanelVisible }
unit SoCtmDBGuide;

{$I SOHOLIB.INC}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Forms, Grids,
  DBGrids, SoDBGrid, StdCtrls, SohoBtns, ExtCtrls, SoFrmStorage, Db,
  Dialogs, Controls, SoCtmRec, SoCtmFld, SoCtmDBGridAddon,
  SoGauges, SoTools, SoUnit, Menus, SoChkBox;

type

  TButtonsLayout = (blLeft, blCenter, blRight);
  {    Ok  Cancel: ,     }
  TPanelLayout   = (plLeft, plRight);
  {      "//"}
  TsohoCustomDBGuide = class;

  TsohoCtmDBGuideForm = class(TForm)
    BtnsPanel: TPanel;
    Panel1: TPanel;
    Panel3: TPanel;
    AddB: TsohoBitBtn;
    EditB: TsohoBitBtn;
    DeleteB: TsohoBitBtn;
    GuideGrid: TsohoDBGrid;
    SaveD: TSaveDialog;
    OpenD: TOpenDialog;
    GuideSource: TDataSource;
    GuideStorage: TsohoFormStorage;
    SortC: TsohoCheckBox;
    GuidePopupMenu: TPopupMenu;
    CheckM: TMenuItem;
    UnCheckM: TMenuItem;
    N1: TMenuItem;
    SaveIdsM: TMenuItem;
    LoadIdsM: TMenuItem;
    ClearMarkedM: TMenuItem;
    N2: TMenuItem;
    OkM: TMenuItem;
    CancelM: TMenuItem;
    procedure ButtonClick(Sender: TObject);
    procedure SortCChange(Sender: TObject);
    procedure CheckMClick(Sender: TObject);
    procedure OkMClick(Sender: TObject);
    procedure CancelMClick(Sender: TObject);
    procedure SaveIdsMClick(Sender: TObject);
    procedure LoadIdsMClick(Sender: TObject);
    procedure ClearMarkedMClick(Sender: TObject);
    procedure GuideGridKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure GuideGridDblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    FContainer: TsohoCustomDBGuide;
    ModalMode: boolean;
    DataSetHooked: boolean;
    FDBGuide       : TsohoCustomDBGuide; //   
    FButtonsLayout : TButtonsLayout;     //   
  protected
    FRecordForm: TsohoCustomRecordForm;
    FFolder: TsohoCustomFolder;
    FGuideDS: TDataSet;
    FDBAddon: TsohoCustomDBGridAddon;

    procedure SetButtonsLayout(Value : TButtonsLayout);
    procedure DBAddonBeforeOperation(Sender: TObject);
    procedure DBAddonAfterOperation(Sender: TObject);
    procedure UpdateButtons;
  public
    { Public declarations }
    OkBtn,
    CancelBtn: TsohoBitBtn;
    {$IFDEF Delphi5}
    procedure DoDestroy; override;
    {$ENDIF}
    {$IFDEF Delphi4}
    procedure BeforeDestruction; override;
    {$ENDIF}
    {$IFDEF Delphi3}
    destructor Destroy; override;
    {$ENDIF}


    constructor CreateGuide(aOwner: TComponent; DBGuide : TsohoCustomDBGuide); virtual;

    property RecordForm: TsohoCustomRecordForm read FRecordForm;
    property Folder: TsohoCustomFolder read FFolder;
    property GuideDS: TDataSet read FGuideDS;
    property DBAddon: TsohoCustomDBGridAddon read FDBAddon;
    property ButtonsLayout : TButtonsLayout read FButtonsLayout write SetButtonsLayout default blLeft;
    {      cancel   :
      blLeft   - ,
      blCenter -  
      blRight  -  }
  end;

  TsohoGuideOption = (goDeleteItem, goAddItem, goEditItem);
  TsohoGuideOptions = set of TsohoGuideOption;

  TsohoCustomDBGuide = class(TComponent)
  {        
    ,    .     
         -    
    . ,      
    .         
      MDIChild.        
      - TsohoDBGrid, TsohoCustomRecordForm  TsohoCustomFolder. 
      TsohoCustomDBGuide -      
     .   ,      
        , , TsohoDBGuide
  }
  private
    { Private declarations }
    FOnProgress   : TsohoProgressEvent; {04/10/98}
    FGauge        : TsohoGauge; {04/10/98}
    FFolderName: TFileName;
    FFolderDir: TDirName;
    FEnabledMenus: SetOfByte;
    FKeyField: string;
    FResSaveFile: TFileName;
    FMarkedColor: TColor;
    FMarkedFont: tFont;
    FFolderTable: String;
    FItemId: Longint;
    FItemsPreffix  : string; {01/10/98}
    FGuideMenu   : TPopupMenu;
    FOptions: TsohoGuideOptions;
    FEditOnDblClick : boolean;

    FCaption: TCaption;
    FSQLFile: TSQLFileName;
    FOnOperation: TsohoOnGridOperation;
    FOnFilter: TFilterRecordEvent;
    FOnOldFilter: TFilterRecordEvent;
    FOnGetCellsProps: TGetCellPropsEvent;
    FOnDrawCells: TDrawDataCellEvent;

    FHideFields: TStringList;
    FComplexFields: TStringList;
    FComplexLabels: TStringList;
    FSQLHideFields: TStringList;

    FBeforeSQLGen,
      FAfterSQLGen: TsohoOnSQLGenerate;
    FOnAddField: TsohoOnAddField;
    FOnAddFieldToSQL: TsohoOnAddFieldToSQL;
    FOnGetValue: TsohoOnGetValue;
    FOnGetTextForField: TsohoOnGetTextForField;
    FOnGetComplexValue: TsohoOnGetComplexValue;
    FOnCardCreate,
      FOnCardDestroy,
      FOnFormCreate,
      FOnFormDestroy,
      FOnCardSave,
      FOnCardLoad: TNotifyEvent;
    FAfterExec: TNotifyEvent;

    FBeforeQueryOpen: TDataSetNotifyEvent;
    FOnOldBeforeOpen: TDataSetNotifyEvent;
    FGuideForm: TsohoCtmDBGuideForm;
    FButtonPanelVisible : boolean;   // -    --
    FButtonsLayout : TButtonsLayout; //   
    FPanelLayout   : TPanelLayout;   //     
  protected
    { Protected declarations }
    procedure SetOptions(const Value: TsohoGuideOptions);
    procedure RecordCardGetValue(Sender: TObject;
      FieldName: String; var Value: String);
    function  CreateGuideForm: TsohoCtmDBGuideForm; virtual; abstract;
    procedure AddMenuItems;
    procedure DoFormCreate   (Reopen, Modal, WithCancel : boolean); virtual;
    procedure DoFormDestroy  (DoFree: boolean); virtual;
    procedure DoFilter       (DataSet: TDataSet; var Accept: boolean);
    procedure SetMarkedFont  (Value: tFont);
    function GetResults: TsohoDBGridResults;
    procedure SetHideFields  (Value: TStringList);
    procedure SetSQLHideFields(Value: TStringList);
    procedure SetComplexFields(Value: TStringList);
    procedure SetComplexLabels(Value: TStringList);
    function GetItemId: Longint;
    procedure SetItemId(Value: Longint);
    procedure SetEnabledMenus(Value: string);
    function GetEnabledMenus: string;

    procedure SetFolderProperties; virtual;
    procedure SetRecordProperties; virtual;
    procedure SetQueryProperties; virtual;
    procedure SetDBGridAddonProperties; virtual;
    procedure SetEvents; virtual;
    procedure DoBeforeOpen(DataSet: TDataSet); virtual;
    function DoDeleteRecord : boolean; virtual; abstract;
    procedure AfterEditRecord; virtual; abstract;

    procedure PrepareButtons(Modal: boolean; WithCancel: boolean);
    procedure RestoreSelection;
    procedure GuideRecordGetValue(Sender: TObject; FieldName: string;
      var Value: string);
    function GuideDoOperation(Sender: TObject; Operation: TsohoGridOperation): boolean;
    procedure DoProgress (Stage : TProgressStage; PercentDone : byte;
              const Msg : string); virtual;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure SetButtonPanelVisible(Value : boolean);
    procedure SetButtonsLayout(Value : TButtonsLayout);
    procedure SetPanelLayout(Value : TPanelLayout);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    function GetPublicArea : TPoint;
    {    ,       
           OnFormCreate }
    procedure RefreshGuide;
    {   .       }
    function ReCreateExecute(Modal, WithCancel : boolean): boolean;
    {        Ok, Cancel.    }
    function Execute(Reopen, Modal, WithCancel : boolean): boolean;
    {     Ok, Cancel.    }
    function MDIExecute: boolean;
    {     MDI-Child  }
    function ItemsQuery : TDataSet;
    {      }

    property Results: TsohoDBGridResults read GetResults;
    {   .  TsohoDBGrid }
    property ItemID: Longint read GetItemId write SetItemId default - 1;
    {   .  ,   
              }
    procedure CloseGuideForm;
    {   }
    property GuideForm: TsohoCtmDBGuideForm read FGuideForm;
    {     }
  published
    property Options: TsohoGuideOptions read FOptions write SetOptions
      default [goDeleteItem, goAddItem, goEditItem];
    {  ,     
      ,   :  ,
           }
    property FolderName: TFileName read FFolderName write FFolderName;
    {  TsohoCustomDBFolder }
    property FolderDir: TDirName read FFolderDir write FFolderDir;
    {  TsohoCustomDBFolder }
    property EnabledMenus: string read GetEnabledMenus write SetEnabledMenus;
    {  TsohoCustomDBFolder }
    property FolderTable: String read FFolderTable write FFolderTable;
    {     }
    property SQLFile: TSQLFileName read FSQLFile write FSQLFile;
    {     SQL-      }
    property ItemsPreffix : string read FItemsPreffix write FItemsPreffix; {01/10/98}
    {  TsohoCustomTreeView }
    property Caption: TCaption read FCaption write FCaption;
    {   }
    property MarkedColor: TColor read FMarkedColor write FMarkedColor;
    {  TsohoDBGrid }
    property MarkedFont: tFont read FMarkedFont write SetMarkedFont;
    {  TsohoDBGrid }
    property KeyField: string read FKeyField write FKeyField;
    { ,     -  'Id' }
    property HideFields: TStringList read FHideFields write SetHideFields;
    {  TsohoCustomDBRecordForm }
    property SQLHideFields: TStringList read FSQLHideFields write SetSQLHideFields;
    {  TsohoCustomDBRecordForm }
    property ComplexFields: TStringList read FComplexFields write SetComplexFields;
    {  TsohoCustomDBRecordForm }
    property ComplexLabels: TStringList read FComplexLabels write SetComplexLabels;
    {  TsohoCustomDBRecordForm }
    property ButtonPanelVisible : boolean read FButtonPanelVisible write SetButtonPanelVisible default True;
    {  -    ""-""-"" }
    property ButtonsLayout : TButtonsLayout read FButtonsLayout write SetButtonsLayout default blLeft;
    {      cancel   :
      blLeft   - ,
      blCenter -  
      blRight  -  }
    property PanelLayout : TPanelLayout read FPanelLayout write SetPanelLayout default plLeft;
    {         :
      plLeft   - ,
      plRight  -  }
    property EditOnDblClick : boolean read FEditOnDblClick write FEditOnDblClick default true;
    {  true,          ,
             ModalResult = mrOk }

    property Gauge         : TsohoGauge read FGauge write FGauge; {04/10/98}
    {    TsohoGauge,     
       .  ""    
       OnProgress }
    property GuideMenu     : TPopupMenu  read FGuideMenu write FGuideMenu;
    {   PopupMenu,      }

    property OnGetTextForField: TsohoOnGetTextForField read FOnGetTextForField write FOnGetTextForField;
    {  TsohoCustomDBRecordForm }
    property OnGetComplexValue: TsohoOnGetComplexValue read FOnGetComplexValue write FOnGetComplexValue;
    {  TsohoCustomDBRecordForm }
    property BeforeSQL: TsohoOnSQLGenerate read FBeforeSQLGen write FBeforeSQLGen;
    {  TsohoCustomDBRecordForm }
    property AfterSQL: TsohoOnSQLGenerate read FAfterSQLGen write FAfterSQLGen;
    {  TsohoCustomDBRecordForm }
    property OnAddField: TsohoOnAddField read FOnAddField write FOnAddField;
    {  TsohoCustomDBRecordForm }
    property OnAddFieldToSQL: TsohoOnAddFieldToSQL read FOnAddFieldToSQL write FOnAddFieldToSQL;
    {  TsohoCustomDBRecordForm }
    property OnGetValue: TsohoOnGetValue read FOnGetValue write FOnGetValue;
    {  TsohoCustomDBRecordForm }
    property AfterSQLExecute: TNotifyEvent read FAfterExec write FAfterExec;
    {  TsohoCustomDBRecordForm }
    property OnCardCreate: TNotifyEvent read FOnCardCreate write FOnCardCreate;
    {  TsohoCustomDBRecordForm }
    property OnCardDestroy: TNotifyEvent read FOnCardDestroy write FOnCardDestroy;
    {  TsohoCustomDBRecordForm }
    property OnCardSave: TNotifyEvent read FOnCardSave write FOnCardSave;
    {  TsohoCustomDBRecordForm }
    property OnCardLoad: TNotifyEvent read FOnCardLoad write FOnCardLoad;
    {  TsohoCustomDBRecordForm }
    property OnFilter: TFilterRecordEvent read FOnFilter write FOnFilter;
    {      .  TsohoCustomDBTreeView }
    property OnGetCellProps: TGetCellPropsEvent read FOnGetCellsProps write FOnGetCellsProps;
    {  OnGetCellProps  TsohoDBGrid }
    property OnDrawDataCell: TDrawDataCellEvent read FOnDrawCells write FOnDrawCells;
    {  OnDrawDataCell  TsohoDBGrid }
    property BeforeQueryOpen: TDataSetNotifyEvent read FBeforeQueryOpen write FBeforeQueryOpen;
    {       -      }
    property OnOperation: TsohoOnGridOperation read FOnOperation write FOnOperation;
    {  OnOperation  TsohoDBGrid }
    property OnFormCreate: TNotifyEvent read FOnFormCreate write FOnFormCreate;
    {     - }
    property OnFormDestroy: TNotifyEvent read FOnFormDestroy write FOnFormDestroy;
    {     - }
    property OnProgress     : TsohoProgressEvent read FOnProgress write FOnProgress; {04/10/98}
    {        }
  end;

implementation
uses SoStrUtils, SoDBRtn, SoCtmRgs, SoVCLUtils, SoAppUtils, SoDBCns
     {$IFDEF Delphi4_or_5}, ImgList{$ENDIF};

{$R *.DFM}

{ TsohoCtmDBGuideForm }
//    -    Ok  Cancel
procedure TsohoCtmDBGuideForm.FormResize(Sender: TObject);
Var
  i : integer;
begin
  case FButtonsLayout of
   blLeft   : begin
                OkBtn.Left     := 3;
                CancelBtn.Left := OkBtn.Left + OkBtn.Width + 3;
              end; {--- blLeft ---}
   blCenter : begin
                i := BtnsPanel.Width div 2;
                if CancelBtn.Visible then begin
                  OkBtn.Left     := i - OkBtn.Width - 2;
                  CancelBtn.Left := i + 2;
                end else begin
                  OkBtn.Left     := (i - OkBtn.Width) div 2;
                end; {--- if ---}
              end; {--- blCenter ---}
   blRight  : begin
                if CancelBtn.Visible then begin
                  CancelBtn.Left := BtnsPanel.Width - CancelBtn.Width - 3;
                  OkBtn.Left     := CancelBtn.Left - 3 - OkBtn.Width;
                end else begin
                  OkBtn.Left     := BtnsPanel.Width - OkBtn.Width - 3;
                end; {--- if ---}
              end; {--- blRight ---}
  end; {--- case ---}
end;

procedure TsohoCtmDBGuideForm.FormShow(Sender: TObject);
begin
  GuideGrid.SetFocus;
  FContainer.DoProgress(psEnding, 100, EmptyStr);
  UpdateButtons;
end;

procedure TsohoCtmDBGuideForm.SortCChange(Sender: TObject);
begin
  FDBAddon.Active := SortC.Checked;
end;

procedure TsohoCtmDBGuideForm.GuideGridKeyPress(Sender: TObject;
  var Key: Char);
var ItemID: Longint;
begin
  with GuideGrid do begin
    if (KEY = #32) and (not EditorMode) then begin
      ItemID := GuideDS.FieldByName(FContainer.KeyField).AsInteger;
      if Results.IndexOf(ItemID) = -1 then Results.Add(ItemID)
      else Results.Remove(ItemID);
    end;
    if (Key = #27) and (FormStyle <> fsMDIChild) then Close;
  end;
end;

procedure TsohoCtmDBGuideForm.SaveIdsMClick(Sender: TObject);
begin
  if not SaveD.Execute then exit;
  try
    GuideGrid.Results.SaveToFile(SaveD.Filename);
  except
  end;
end;

procedure TsohoCtmDBGuideForm.LoadIdsMClick(Sender: TObject);
begin
  if not OpenD.Execute then exit;
  try
    GuideGrid.Results.LoadFromFile(OpenD.Filename);
  except
  end;
end;

procedure TsohoCtmDBGuideForm.ClearMarkedMClick(Sender: TObject);
begin
  GuideGrid.Results.Clear;
end;

procedure TsohoCtmDBGuideForm.CheckMClick(Sender: TObject);
begin
  with FGuideDS do begin
    case (Sender as TMenuItem).Tag of
      1: GuideGrid.Results.Add(FieldByName(FContainer.KeyField).AsInteger);
      2: GuideGrid.Results.Remove(FieldByName(FContainer.KeyField).AsInteger);
    end;
  end;
end;

procedure TsohoCtmDBGuideForm.ButtonClick(Sender: TObject);
begin
  GuideGrid.DoOperation(TsohoGridOperation((Sender as TsohoBitBtn).Tag));
end;

procedure TsohoCtmDBGuideForm.GuideGridDblClick(Sender: TObject);
begin
  if not FDBGuide.EditOnDblClick then OkMClick(OkBtn);
end;

procedure TsohoCtmDBGuideForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TsohoCtmDBGuideForm.CancelMClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

constructor TsohoCtmDBGuideForm.CreateGuide(aOwner: TComponent; DBGuide : TsohoCustomDBGuide);
begin
  inherited Create(aOwner);
  FDBGuide := DBGuide;
  Icon.Handle          := LoadIcon(HInstance, 'MAINICON');
  OkM.Caption          := sohoTVContSelectItem;
  CancelM.Caption      := sohoTVContCancelItem;
  SaveIdsM.Caption     := sohoTVContSaveMarkedItem;
  LoadIdsM.Caption     := sohoTVContLoadMarkedItem;
  ClearMarkedM.Caption := sohoTVContClearItem;
  CheckM.Caption       := sohoTVContMarkItem;
  UncheckM.Caption     := sohoTVContUnMarkItem;
  AddB.Caption         := sohoDBGuideAddRecord;
  EditB.Caption        := sohoDBGuideEditRecord;
  DeleteB.Caption      := sohoDBGuideDeleteRecord;
  SortC.Caption        := sohoTVContSortBtnCaption;
  SortC.Hint           := sohoTVContSortBtnHint;
  SortC.Cursor         := crHandPoint;
  DataSetHooked        := false;
  FButtonsLayout       := blLeft;
  {$IFDEF Delphi4_or_5}
  with GuideGrid.PopupMenu do begin
    Images              := TVImages;
    Items[3].ImageIndex := 2;
    Items[4].ImageIndex := 3;
    Items[7].ImageIndex := 4;
    Items[8].ImageIndex := 5;
  end;
  {$ENDIF}
  ButtonsLayout  := FDBGuide.FButtonsLayout;
  Panel3.Visible := FDBGuide.ButtonPanelVisible;
  case FDBGuide.FPanelLayout of
    plLeft  : Panel3.Align := alLeft;
    plRight : Panel3.Align := alRight;
  end; {--- case ---}
end;

//  
procedure TsohoCtmDBGuideForm.FormCreate(Sender: TObject);
begin
  OkBtn := TsohoBitBtn.Create(Self);
  with OkBtn do begin
    Parent := BtnsPanel;
    Top := 4;
    OnClick := OkMClick;
  end;
  CancelBtn := TsohoBitBtn.Create(Self);
  with CancelBtn do begin
    Parent := BtnsPanel;
    Top := 4;
    OnClick := CancelMClick;
  end;
  FormResize(Self);
end;

//   
procedure TsohoCtmDBGuideForm.SetButtonsLayout(Value : TButtonsLayout);
begin
  if Value <> FButtonsLayout then begin
    FButtonsLayout := Value;
  end; {--- if ---}
end;

procedure TsohoCtmDBGuideForm.UpdateButtons;
begin
  AddB.Enabled := goAddItem in FContainer.Options;
  DeleteB.Enabled := goDeleteItem in FContainer.Options;
  EditB.Enabled := goEditItem in FContainer.Options;
end;

procedure TsohoCtmDBGuideForm.DBAddonAfterOperation(Sender: TObject);
begin
  FFolder.LoadDBGridColumns;
end;

procedure TsohoCtmDBGuideForm.DBAddonBeforeOperation(Sender: TObject);
begin
  FFolder.SaveDBGridColumns;
end;

{$IFDEF Delphi5}
procedure TsohoCtmDBGuideForm.DoDestroy;
{$ENDIF}
{$IFDEF Delphi4}
procedure TsohoCtmDBGuideForm.BeforeDestruction;
{$ENDIF}
{$IFDEF Delphi3}	
destructor TsohoCtmDBGuideForm.Destroy;
{$ENDIF}
begin
  GuideStorage.SaveFormPlacement;
  FDBAddon.SaveStatement(GuideStorage);
  FDBAddon.Free;
  if FContainer <> nil then FContainer.FGuideForm := nil;
  DataSetHooked := false;
  OkBtn.Free;
  CancelBtn.Free;
  inherited;
end;

procedure TsohoCtmDBGuideForm.OkMClick(Sender: TObject);
begin
  if not ModalMode then Close
  else ModalResult := mrOk;
end;

{ TsohoCustomDBGuide }
procedure TsohoCustomDBGuide.RecordCardGetValue(Sender: TObject;
  FieldName: String; var Value: String);
begin
  if FieldName = 'MDFDATE' then Value := DateToStr(Date); {01/10/98}
  if FieldName = 'MDFTIME' then Value := TimeToStr(Time); {01/10/98}
  if FieldName = 'IDMDFDAUTH' then begin {01/10/98}
    Value := '0';
    if SingleRegister <> nil then Value := IntToStr(SingleRegister.UserID);
  end;
  if FGuideForm.FRecordForm.Mode <> rmInsert then exit;
  if FieldName = AnsiUpperCase(FKeyField) then begin
    if FItemsPreffix = EmptyStr then
      FItemsPreffix := Owner.ClassName + '.' + ClassName + '.' + Name + '.NewItem'; {01/10/98}
    Value := IntToStr(GetNewId(FItemsPreffix));
  end;
  if Assigned(FOnGetValue) then FOnGetValue(Sender, FieldName, Value);
end;

procedure TsohoCustomDBGuide.DoProgress (Stage : TProgressStage; PercentDone : byte;
          const Msg : string);
begin
  if Assigned(FGauge) then begin
    case Stage of
      psStarting : begin
        FGauge.MinValue := 0;
        FGauge.MaxValue := 100;
        FGauge.Progress := PercentDone;
        FGauge.Caption  := Msg;
      end;
      psRunning  : begin
        FGauge.Progress := PercentDone;
        FGauge.Caption  := Msg;
      end;
      psEnding   : begin
        FGauge.Progress := 0;
        FGauge.Caption  := Msg;
      end;
    end;
  end;
  if Assigned(FOnProgress) then FOnProgress(Self, Stage, PercentDone, Msg);
end;

procedure TsohoCustomDBGuide.Notification(AComponent: TComponent; Operation: TOperation);
begin
  if (aComponent=FGauge) and (Operation=opRemove) then FGauge := nil;
  inherited Notification(aComponent, Operation);
end;

function TsohoCustomDBGuide.ItemsQuery : TDataSet;
begin
  Result := nil;
  if FGuideForm <> nil then Result := FGuideForm.FGuideDS;
end;

procedure TsohoCustomDBGuide.RefreshGuide;
begin
  if FGuideForm = nil then exit;
  try
    // statements to try
    RefreshFolderWithId(FGuideForm.FFolder, FKeyField);
  except
    on e: Exception do begin
      Application.HandleException(Self);
      ErrorMsg(E.Message);
    end;
  end;    // try/except
end;

procedure TsohoCustomDBGuide.SetMarkedFont(Value: tFont);
begin
  FMarkedFont.Assign(Value);
end;

procedure TsohoCustomDBGuide.GuideRecordGetValue(Sender: TObject; FieldName: string;
    var Value: string);
begin
  if FieldName = 'MDFDATE' then Value := DateToStr(Date); {01/10/98}
  if FieldName = 'MDFTIME' then Value := TimeToStr(Time); {01/10/98}
  if FieldName = 'IDMDFDAUTH' then begin {01/10/98}
    Value := '0';
    if SingleRegister <> nil then Value := IntToStr(SingleRegister.UserID);
  end;
  if FGuideForm.FRecordForm.Mode = rmInsert then begin   // Garik 04.04.2000
    if (FGuideForm.FRecordForm.GetIdentifier(FieldName) =
        FGuideForm.FRecordForm.GetIdentifier(FKeyField)) and
       (FGuideForm.FRecordForm.HideFields.IndexOf(FKeyField) <> -1) then begin
       if FItemsPreffix <> EmptyStr then
          Value := IntToStr(GetNewId(FItemsPreffix)); // Garik
    end;
  end; {--- if ---}
  if Assigned(FOnGetValue) then FOnGetValue(Sender, FieldName, Value);
end;

function TsohoCustomDBGuide.GuideDoOperation(Sender: TObject; Operation: TsohoGridOperation): boolean;
var BkMark: TBookmark;
begin
  Result := false;
  BkMark := FGuideForm.FGuideDS.GetBookmark;
  if Assigned(FOnOperation) then Result := FOnOperation(Sender, Operation)
  else begin
    case Operation of
      soNewRecord: begin
         if goAddItem in Options then begin
           Result := FGuideForm.FRecordForm.Insert;
           FGuideForm.FRecordForm.Close; {07/10/98}
         end;
      end;
      soEditRecord: begin
        if goEditItem in Options then begin
          if FGuideForm.FGuideDS.FieldByName(FKeyField).IsNull then
            Result := FGuideForm.FRecordForm.Insert
          else Result := FGuideForm.FRecordForm.Edit;
          FGuideForm.FRecordForm.Close; {07/10/98}
        end;
      end;
      else begin
         if goDeleteItem in Options then begin
           if not (FGuideForm.FGuideDS.FieldByName(FKeyField).IsNull) and
                        (YesNoMsg(sohoTVContDeleteQuestion)) then
             Result := DoDeleteRecord;
         end;
      end;
    end;
  end;
  if Result then begin
    AfterEditRecord;
    RefreshGuide;
    if Operation = soEditRecord then
       FGuideForm.FGuideDS.GotoBookmark(BkMark);
  end;
  if Assigned(BkMark) then
    FGuideForm.FGuideDS.FreeBookmark(BkMark);
end;

procedure TsohoCustomDBGuide.DoBeforeOpen(DataSet: TDataSet);
begin
  if Assigned(FBeforeQueryOpen) then FBeforeQueryOpen(DataSet);
  if Assigned(FOnOldBeforeOpen) then FOnOldBeforeOpen(DataSet);
end;

procedure TsohoCustomDBGuide.AddMenuItems;
var InsIndex, Index : LongInt;
    MnuItem : TMenuItem;
begin
  if FGuideMenu = nil then exit;
  with FGuideForm.GuideGrid.PopupMenu do begin
     InsIndex := Items.Count-1;
     {    -       
        }
     while (InsIndex>=0)and (Items[InsIndex].Caption <> '-') do Dec(InsIndex);
     if InsIndex<0 then InsIndex := 0;
     Items.Insert(InsIndex, NewItem('-', 0, false, true, nil, 0, EmptyStr));
     inc(InsIndex);
     for Index := 0 to pred(FGuideMenu.Items.Count) do begin
       MnuItem := CopyMenuItem(Self, FGuideMenu.Items[Index]);
       Items.Insert(InsIndex, MnuItem);
       inc(InsIndex);
     end;
  end;
end;

procedure TsohoCustomDBGuide.SetEvents;
begin
  if FGuideForm = nil then exit;
  with FGuideForm do begin
    Tag := Self.Tag;
    KeyField := FKeyField; {07/10/98}
    GuideGrid.KeyField := FKeyField;
    SetFolderProperties;
    SetQueryProperties;
    SetRecordProperties;
    SetDBGridAddonProperties;
    with GuideGrid do begin
      OnGetCellProps := FOnGetCellsProps;
      OnDrawDataCell := FOnDrawCells;
      OnOperation := GuideDoOperation;
      AddMenuItems;
    end;
    GuideGrid.EditOnDblClick := FEditOnDblClick;
    Caption := FCaption;
    GuideStorage.IniSection := Owner.name + '.' + ClassName +
      '.' + Name;
  end;
end;

procedure TsohoCustomDBGuide.DoFilter(DataSet: TDataSet; var Accept: boolean);
begin
  if Assigned(FOnOldFilter) then FOnOldFilter(DataSet, Accept);
  if Assigned(FOnFilter) then FOnFilter(DataSet, Accept);
end;

function TsohoCustomDBGuide.GetResults: TsohoDBGridResults;
begin
  Result := nil;
  if FGuideForm = nil then exit;
  Result := FGuideForm.GuideGrid.Results;
end;

procedure TsohoCustomDBGuide.SetHideFields(Value: TStringList);
begin
  FHideFields.Assign(Value);
end;

procedure TsohoCustomDBGuide.SetSQLHideFields(Value: TStringList);
begin
  FSQLHideFields.Assign(Value);
end;

procedure TsohoCustomDBGuide.SetComplexFields(Value: TStringList);
begin
  FComplexFields.Assign(Value);
end;

procedure TsohoCustomDBGuide.SetComplexLabels(Value: TStringList);
begin
  FComplexLabels.Assign(Value);
end;

function TsohoCustomDBGuide.GetItemId: Longint;
begin
  if FGuideForm = nil then Result := FItemId
  else Result := FGuideForm.GuideDS.FieldByName(FKeyField).AsInteger;
end;

procedure TsohoCustomDBGuide.SetItemId(Value: Longint);
begin
  if FGuideForm <> nil then
    if LocaleByID(FGuideForm.GuideDS, FKeyField, Value) then FItemId := Value;
end;

procedure TsohoCustomDBGuide.SetEnabledMenus(Value: string);
begin
  FEnabledMenus := StrToSet(Value);
end;

function TsohoCustomDBGuide.GetEnabledMenus: string;
begin
  Result := SetToStr(FEnabledMenus);
end;

constructor TsohoCustomDBGuide.Create(AOwner: TComponent);
var Form: TForm;
begin
  inherited Create(AOwner);
  FEnabledMenus := StrToSet('0-9,11-12,14-15,17-18,20-21,');
  FOptions := [goDeleteItem, goAddItem, goEditItem];
  // FEditOnDblClick := true;
  FKeyField := 'Id';
  FItemId := -1;
  FMarkedFont := tFont.Create;
  with FMarkedFont do begin
    Form := GetOwnerForm(Self);
    if Form <> nil then Assign(Form.Font);
    Style := [];
  end;
  FMarkedColor := clAqua;
  FGuideForm := nil;
  FHideFields := TStringList.Create;
  with FHideFields do begin
    Clear;
    Add('ID');
    Add('MDFDATE');
    Add('MDFTIME');
    Add('IDMDFAUTH');
    Add('PROTECT');
  end;
  FSQLHideFields      := TStringList.Create;
  FComplexFields      := TStringList.Create;
  FComplexLabels      := TStringList.Create;
  EditOnDblClick      := True;
  FButtonPanelVisible := True;
  FButtonsLayout      := blLeft;
  FPanelLayout        := plLeft;
end;

destructor TsohoCustomDBGuide.Destroy;
begin
  FHideFields.Free;
  FSQLHideFields.Free;
  FComplexFields.Free;
  FComplexLabels.Free;
  FMarkedFont.Free;
  inherited Destroy;
end;


procedure TsohoCustomDBGuide.PrepareButtons(MODAL: boolean; WithCancel: boolean);
begin
  if Modal
    then FGuideForm.OkBtn.Caption := 'OK'
    else FGuideForm.OkBtn.Caption := sohoTVContBtnClose;
  FGuideForm.CancelBtn.Caption    := sohoExlRepCancelBtnCaption;
  FGuideForm.CancelM.Visible      := WithCancel;
  FGuideForm.CancelBtn.Visible    := WithCancel;
end;

function TsohoCustomDBGuide.GetPublicArea : TPoint;
begin
  Result.X := 0;
  if FGuideForm.OkBtn     <> nil then Result.X := FGuideForm.OkBtn.Left+FGuideForm.OkBtn.Width + 2;
  if FGuideForm.CancelBtn <> nil then Result.X := FGuideForm.CancelBtn.Left+FGuideForm.CancelBtn.Width + 2;
  Result.Y := 1;
end;


procedure TsohoCustomDBGuide.RestoreSelection;
begin
  FGuideForm.GuideStorage.RestoreFormPlacement;
  FGuideForm.Folder.LoadDataSet;
  if FItemId > 0 then
    LocaleByID(FGuideForm.GuideDS, FKeyField, FItemId);
  if FResSaveFile <> EmptyStr then
    FGuideForm.GuideGrid.Results.LoadFromFile(FResSaveFile);
end;

procedure TsohoCustomDBGuide.DoFormCreate(Reopen, Modal, WithCancel : boolean);
begin
  try
    PushCursor(crHourGlass);
    DoProgress (psRunning, 45, gdSetEvents);
    SetEvents;
    FGuideForm.Folder.LoadDataSet;
    DoProgress (psRunning, 60, gdPrepareButtons);
    PrepareButtons(Modal, WithCancel);
    DoProgress (psRunning, 90, gdQueryActivate);
    FGuideForm.SortC.Checked :=
      FGuideForm.GuideStorage.ReadBool('Options', 'Sort', false);
    if Reopen then begin
      FGuideForm.GuideDS.Close;
      FGuideForm.GuideDS.Open;
      FGuideForm.DBAddon.LoadStatement(FGuideForm.GuideStorage);
    end;
    PushCursor(crHourGlass);
    DoProgress (psRunning, 99, gdRestoring);
    RestoreSelection;
    FGuideForm.ModalMode := Modal;
    if Assigned(FOnFormCreate) then FOnFormCreate(Self);
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TsohoCustomDBGuide.DoFormDestroy(DoFree: boolean);
begin
  try
    PushCursor(crHourGlass);
    FGuideForm.GuideStorage.WriteBool('Options', 'Sort', FGuideForm.SortC.Checked);
    FGuideForm.FFolder.SaveDataSet;
    if Assigned(FOnFormDestroy) then FOnFormDestroy(Self);
    if DoFree then FGuideForm.Free
    else FGuideForm.Hide;
  finally
    Screen.Cursor := crDefault;
  end;
end;

function TsohoCustomDBGuide.ReCreateExecute(Modal: boolean; WithCancel: boolean): boolean;
begin
  Result := false;
  DoProgress (psStarting, 0, gdPreparing);
  if FGuideForm <> nil then begin
    ErrorMsg(Format(sohoTVContFormAlreadyExists, [name]));
    exit;
  end;
  try
    Result := true;
    DoProgress (psRunning, 33, gdFormCreate);
    FGuideForm := CreateGuideForm;
    with FGuideForm do begin
      FContainer := Self;
      Result := not Modal;
      DoFormCreate(true, Modal, WithCancel);
      DoProgress (psRunning, 100, gdFormShow);
      if Modal then Result := ShowModal = mrOk
      else Show;
      if Result then begin
        FItemId := FGuideDS.FieldByName(FKeyField).AsInteger;
        if FResSaveFile <> EmptyStr then GuideGrid.Results.SaveToFile(FResSaveFile);
      end;
    end;
  finally
    if Modal then DoFormDestroy(True);
  end;
end;

function TsohoCustomDBGuide.Execute(Reopen, Modal, WithCancel: boolean): boolean;
begin
  Result := true;
  DoProgress (psStarting, 0, gdPreparing);
  if FGuideForm <> nil then begin
    if not Reopen then begin
      DoFormCreate(false, Modal, WithCancel);
      DoProgress (psRunning, 100, gdFormShow);
      if Modal then begin
        DoProgress (psEnding, 100, EmptyStr);
        RestoreCursor;
        Result := FGuideForm.ShowModal = mrOk;
        if Result then begin
          FItemId := FGuideForm.GuideDS.FieldByName(FKeyField).AsInteger;
          if FResSaveFile <> EmptyStr then
            FGuideForm.GuideGrid.Results.SaveToFile(FResSaveFile);
        end;
        DoFormDestroy(false);
      end
      else begin
        RestoreCursor;
        Result := true;
        FGuideForm.Show;
        DoProgress (psEnding, 100, EmptyStr);
      end;
      DoProgress (psStarting, 0, EmptyStr);
      exit;
    end
    else FGuideForm.Free;
  end;
  try
    DoProgress (psRunning, 33, gdFormCreate);
    FGuideForm := CreateGuideForm;
    with FGuideForm do begin
      FContainer     := Self;
      DoFormCreate(true, Modal, WithCancel);
      DoProgress (psRunning, 100, gdFormShow);
      Result := not Modal;
      if Modal then Result := ShowModal = mrOk
      else Show;
      if Result then begin
        FItemId := FGuideDS.FieldByName(FKeyField).AsInteger;
        if FResSaveFile <> EmptyStr then GuideGrid.Results.SaveToFile(FResSaveFile);
      end;
      if Modal then DoFormDestroy(False);
    end;
  except ErrorMsg(Format(sohoTVContFormCreateError, [Self.name]));
  end;
  DoProgress (psStarting, 0, EmptyStr);
end;

function TsohoCustomDBGuide.MDIExecute: boolean;
var Form: TForm;
begin
  Result := false;
  DoProgress (psStarting, 0, gdPreparing);
  if FGuideForm <> nil then begin
    ErrorMsg(Format(sohoTVContFormAlreadyExists, [name]));
    exit;
  end;
  try
    Result := true;
    Form := GetOwnerForm(Self);
    if Form = nil then exit;
    if Form.FormStyle <> fsMDIForm then exit;
    DoProgress (psRunning, 33, gdFormCreate);
    FGuideForm := CreateGuideForm;
    FGuideForm.CancelBtn.Visible := False;
    with FGuideForm do begin
      FContainer := Self;
      FormStyle := fsMDIChild;
      DoProgress (psRunning, 60, gdSetEvents);
      SetEvents;
      FGuideForm.Caption := FCaption;
      DoProgress (psRunning, 90, gdQueryActivate);
      GuideDS.Open;
      DoProgress (psRunning, 99, gdRestoring);
      RestoreSelection;
      if Assigned(FOnFormCreate) then FOnFormCreate(Self);
      ModalMode := False;
      DoProgress (psRunning, 100, gdFormShow);
      PrepareButtons(false, false);
      Show;
      Result := True;
    end;
  except ErrorMsg(Format(sohoTVContFormCreateError, [Self.Name]));
  end;
  DoProgress (psStarting, 0, EmptyStr);
end;

procedure TsohoCustomDBGuide.CloseGuideForm;
begin
  if FGuideForm = nil then exit;
  DoFormDestroy(True);
end;

procedure TsohoCustomDBGuide.SetDBGridAddonProperties;
begin
  with FGuideForm, FDBAddon do begin
    Grid := GuideGrid;
    TurnOffFilter := false;
    SetEvents;
    SetDataSet;
    BeforeOperation := DBAddonBeforeOperation;
    AfterOperation := DBAddonAfterOperation;
  end;
end;

procedure TsohoCustomDBGuide.SetFolderProperties;
begin
  with FGuideForm, FFolder do begin
    if FFolderDir <> EmptyStr then FolderDir := FFolderDir;
    FolderName := FFolderName;
    TableName := FFolderTable;
    KeyField := FKeyField;
    EnabledMenus := SetToStr(FEnabledMenus);
  end;
end;

procedure TsohoCustomDBGuide.SetQueryProperties;
var FSQL: string;
begin
  if FGuideForm.DataSetHooked then exit;
  FSQL := FSQLFile;
  if SingleRegister<>nil then
    FSQL := SingleRegister.PathToSQL + FSQLFile;
  if not FileExists(FSQL) then begin
    ErrorMsg(Format(sohoTVContFileNotFound, [FSQL]));
    Abort;
  end;

  with FGuideForm, FGuideDS do begin
    FOnOldBeforeOpen := BeforeOpen;
    BeforeOpen := DoBeforeOpen;
    FOnOldFilter := OnFilter;
    OnFilterRecord := DoFilter;
  end;
  FGuideForm.DataSetHooked := true;
end;

procedure TsohoCustomDBGuide.SetRecordProperties;
begin
  with FGuideForm, FRecordForm do begin
    Caption := FCaption;
    KeyField := FKeyField;
    TableName := FFolderTable;
    HideFields.Assign(FHideFields);
    SQLHideFields.Assign(FSQLHideFields);
    ComplexFields.Assign(FComplexFields);
    ComplexLabels.Assign(FComplexLabels);
    OnGetTextForField := FOnGetTextForField;
    OnGetComplexValue := FOnGetComplexValue;
    BeforeSQL := FBeforeSQLGen;
    AfterSQL := FAfterSQLGen;
    OnAddField := FOnAddField;
    OnAddFieldToSQL := FOnAddFieldToSQL;
    OnGetValue := GuideRecordGetValue;
    AfterSQLExecute := FAfterExec;
    OnCardCreate := FOnCardCreate;
    OnCardDestroy := FOnCardDestroy;
    OnCardSave := FOnCardSave;
    OnCardLoad := FOnCardLoad;
  end;
end;

procedure TsohoCustomDBGuide.SetOptions(const Value: TsohoGuideOptions);
begin
  if FOptions = Value then exit;
  FOptions := Value;
  if FGuideForm <> nil then FGuideForm.UpdateButtons;
end;

procedure TsohoCustomDBGuide.SetButtonPanelVisible(Value : boolean);
begin
  if value <> FButtonPanelVisible then begin
    FButtonPanelVisible := value;
    if FGuideForm <> nil then FGuideForm.Panel3.Visible := value;
  end; {--- if ---}
end;

procedure TsohoCustomDBGuide.SetButtonsLayout(Value : TButtonsLayout);
begin
  if Value <> FButtonsLayout then begin
    FButtonsLayout := Value;
    if FGuideForm <> nil then FGuideForm.ButtonsLayout := Value;
  end; {--- if ---}
end;

procedure TsohoCustomDBGuide.SetPanelLayout(Value : TPanelLayout);
begin
  if Value <> FPanelLayout then begin
    FPanelLayout := Value;
    if FGuideForm <> nil then
      case FPanelLayout of
       plLeft  : FGuideForm.Panel3.Align := alLeft;
       plRight : FGuideForm.Panel3.Align := alRight;
      end; {--- case ---}
  end; {--- if ---}
end;

end.
