{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{           Partial copyright (c) AllexSoft             }
{              Written by Serg Vostrikov,               }
{                Alexander Govyadinov,                  }
{                   Victor Mylcin                       }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
     TsohoCustomFolder
}
unit SoCtmFld;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Menus, SoTools, SoDBGrid, DB, IniFiles, SoUnit, Grids,
  DbGrids{$IFDEF Delphi4_or_5}, ImgList{$ENDIF};

type


  EFolderError = class(Exception);

  TsohoOnLoadEvent = procedure (Sender: TObject; DataSet: TDataSet) of object;
  {    TsohoOnLoadEvent  TsohoCustomFolder. DataSet - 
      }
  TsohoOnSaveEvent = procedure (Sender: TObject; DataSet: TDataSet) of object;
  {    TsohoOnSaveEvent  TsohoCustomFolder. DataSet - 
      }

  TsohoCustomFolder = class(TComponent)
  private
    { Private declarations }
    FMenuAppend: Boolean;
    FSubMenu: Boolean;
    FActivated: Boolean;
    FEventsOur: Boolean;
    FAuto: Boolean;
    FMenu: TPopupMenu;
    FHiddenFields: TMenuItem;
    FItem: TMenuItem;
    FFolderDir: TDirName;
    FFolderName: TFileName;
    FGrid: TsohoDBGrid;
    FDataSet: TDataSet;
    FBeforeOpen: TDataSetNotifyEvent;
    FAfterOpen: TDataSetNotifyEvent;
    FBeforeClose: TDataSetNotifyEvent;
    FBeforePost: TDataSetNotifyEvent; {Allex}
    FOnFilter: TFilterRecordEvent; {Wizard}
    FOnFormActive: TNotifyEvent;
    FCalcFields: TDataSetNotifyEvent;
    FOldPopup: TNotifyEvent;
    FOldBeforeColMoved : TNotifyEvent;
    FOldAfterColMoved  : TMovedEvent;
    FEnabledMenus: SetOfByte;
    FOnColResize: TNotifyEvent;
    FOnLoad: TsohoOnLoadEvent;
    FOnSave: TsohoOnSaveEvent;
    FTablePath: String;
    FCanResize: Boolean;
    FOnChange: TNotifyEvent;
    FProtectView : boolean;
    FKeyField : string;
    { For setting properties and events }
    procedure DoBeforeColMoved(Sender: TObject);
    procedure DoAfterColMoved(Sender: TObject; FromIndex, ToIndex: Longint);
    procedure DoColResize(Sender: TObject);
    procedure SetGrid(Value: TsohoDBGrid);
    procedure SetFolderName(Value: TFileName);
    procedure SetFolderDir(Value: TDirName);
    procedure SetActivated(Value: Boolean);
    procedure SetEnabledMenus(Value: string);
    function GetEnabledMenus: string;
    procedure SetProtect (Value : boolean);
    procedure SetDataSet;
    { Methods are running on popup-menu click }
    procedure SetColumnSettings(Operation: LongInt);
    procedure CreateMenu;
    procedure DestroyMenu;
    procedure HideField(index: Longint);
  protected
    FIni: TIniFile;
    procedure CreateRealField; virtual; abstract;
    procedure DeleteRealField; virtual; abstract;
    procedure ChangeVisible; virtual; abstract;

    function MenuCount: Integer; virtual;
    procedure SetMenuItem(index: Integer; Item: TMenuItem); virtual;
   {$IFDEF Delphi4_or_5}
   procedure SetMenuImages;
   {$ENDIF}
    {    ini- }
    procedure DoBeforeClose(DataSet: TDataSet); virtual;
    {    ini- }
    procedure DoAfterOpen(DataSet: TDataSet); virtual;
    {      -   }
    procedure DoBeforePost(DataSet: TDataSet); {Allex, all procedure}
    {      ,    
          }
    procedure DoFormActivate(Sender: TObject); virtual;
    {      ,  ,
        calculated-  ini- }
    procedure DoBeforeOpen(DataSet: TDataSet); virtual;
    {   }
    procedure DoOnFilter(DataSet: TDataSet; var Accept: Boolean); { Wizard }
    procedure MenuClick(Sender: TObject); virtual;
    procedure Notification(AComponent: TComponent; aOperation: TOperation); override;
    procedure BeforeMenuPopup(Sender: TObject); virtual;
    procedure GetRights;
    function GetDisplayLabel(FieldName: string): string;
    procedure SaveColumn(index: Longint);
    procedure LoadColumn(index: Longint);
    procedure Changed; virtual;

    procedure Loaded; override;
  public
    ActionRights    : SetOfByte;
    {    ,   .. . TsohoCustomRegister}
    DataReadRights  : SetOfByte;
    {       . . TsohoCustomRegister }
    DataWriteRights : SetOfByte;
    {       . . TsohoCustomRegister }
    UserId          : Longint;
    {  . . TsohoCustomRegister }
    DataLevel: Longint;
    { . TsohoCustomRegister }

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure ApplyDataSetDescription;
    {     }
    procedure SaveDataSetDescription;
    {     }
    procedure ApplyDataRights(DataRead, DataWrite: SetOfByte);
    {    /   .   
       TsohoCustomRegister }
    procedure SaveDBGridColumns; virtual;
    {   ini-   }
    procedure LoadDBGridColumns; virtual;
    {   ini-   }
    procedure ReOpen; virtual;
    {  DataSet,   Grid }
    procedure ReActivate;
    {   ,     - }
    procedure SetEvents; virtual;
    {        DataSet,
       Grid }
    procedure RestoreEvents; virtual;
    {        DataSet,
        Grid }
    procedure SaveDataSet; virtual;
    {   }
    procedure LoadDataSet; virtual;
    {   }
    function Activate: Boolean;
    {  :  ,   }
    function Deactivate: Boolean;
    {     }
    function FullFolderName: TFileName;
    {    -: FolderDir+FolderName }
    property DataSetHooked: boolean read FEventsOur;
    { ,     DataSet  }
    property Activated: Boolean read FActivated write SetActivated;
    {    }
    property ProtectView : boolean read FProtectView write SetProtect;
    {   ""   DataSet.   true
      TsohoFolder      
              "Protect".
        ,     false  
        }
    property Auto: Boolean read FAuto write FAuto;
    {      DataSet',  
      Grid  DataSource }
    property FolderName: TFileName read FFolderName write SetFolderName;
    {   - }
    property FolderDir: TDirName read FFolderDir write SetFolderDir;
    { ,      }
    property TableName: String read FTablePath write FTablePath;
    {    .   ,    
          }
    property EnabledMenus: string read GetEnabledMenus write SetEnabledMenus;
    {     }
    property KeyField : string read FKeyField write FKeyField;
{  ,    .      'Id' }
    property Ini: TIniFile read FIni;
    {   ini-,      }
    property DataSet: TDataSet read FDataSet;
    {   DataSet }
    property Grid: TsohoDBGrid read FGrid write SetGrid;
    {   ,      }
    property OnSaveDataSet: TsohoOnSaveEvent read FOnSave write FOnSave;
    {      DataSet }
    property OnLoadDataSet: TsohoOnLoadEvent read FOnLoad write FOnLoad;
    {      DataSet }
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    {       Grid }
  end;

const

  {      }
  mDisplaylabel    = 0;
  mDisplayWidth    = 1;
  mDisplayFormat   = 2;
  mFieldAlign      = 3;
  mHideField       = 4;
  mChangeVisible   = 5;
  mSeparator1      = 6;
  mSaveFolder      = 7;
  mLoadFolder      = 8;
  mSeparator2      = 9;
  mTitleLines      = 10;
  mTitleAlign      = 11;
  mSeparator3      = 12;
  mCreateRField    = 13;
  mDeleteRField    = 14;

  {     }
  MenuOptionsCount = mDeleteRField + 1;

  {        }
function GetMenuCaption(MenuIndex: Integer): string;

procedure DoSaveDataSetDescription(DataSet: TDataSet; IniFile: TIniFile);
procedure DoApplyDataSetDescription(DataSet: TDataSet; IniFile: TIniFile);

{$IFDEF Delphi4_or_5}
var TVImages, FldImages: TImageList;
{$ENDIF}

implementation
uses SoVCLUtils, SoCtmRgs, SoCrFldF, SoFldFrm, SoRghtsF, SoDBRtn,
     SoDBCns, SoRTTI, SoAppUtils, Dialogs, SoStrUtils;

{$R SOCTMFLD.R32}

type

  EsohoFolderException = class(Exception);

function GetMenuCaption(MenuIndex: Integer): string;
begin
  case MenuIndex of
    mDisplaylabel  : Result := sohoFoldermDisplaylabel;
    mDisplayWidth  : Result := sohoFoldermDisplayWidth;
    mDisplayFormat : Result := sohoFoldermDisplayFormat;
    mFieldAlign    : Result := sohoFoldermFieldAlign;
    mHideField     : Result := sohoFoldermHideField;
    mChangeVisible : Result := sohoFoldermChangeVisible;
    mSaveFolder    : Result := sohoFoldermSaveFolder;
    mLoadFolder    : Result := sohoFoldermLoadFolder;
    mSeparator1,
    mSeparator2,
    mSeparator3    : Result := '-';
    mTitleLines    : Result := sohoFoldermTitleLines;
    mTitleAlign    : Result := sohoFoldermTitleAlign;
    mCreateRField  : Result := sohoFoldermCreateRField;
    mDeleteRField  : Result := sohoFoldermDeleteRField;
 end;
end;

{ TsohoCustomFolder }
procedure TsohoCustomFolder.SetProtect (Value : boolean);
begin
  if FProtectView = Value then exit;
  FProtectView := Value;
end;

procedure TsohoCustomFolder.ApplyDataRights;
var Index: Longint;
  I: Longint; { Added by Allex.  ? }
  { Added by Wizard.  ...   ... ,
                            :) }
begin
  {     .
         }
  if not Assigned(FDataSet) then exit; {    - }
  { C    "" ALLEX, april 1998 }
  with FDataSet do begin
    for Index := 0 to pred(FieldCount) do { ,    }
      if not (LOWORD(Fields[Index].Tag) in DataRead) then
        for I := 0 to pred(FGrid.FieldCount) do
          if FGrid.Fields[I].FieldName = FDataSet.Fields[index].FieldName then begin
            FGrid.ColWidths[I] := 5;
            Break; {  }
          end;
    for Index := 0 to pred(FieldCount) do
      Fields[index].Readonly := not (LOWORD(Fields[index].Tag) in DataWrite)
      or Fields[index].Readonly;
  end;
end;

procedure DoApplyDataSetDescription(DataSet: TDataSet; IniFile: TIniFile);
var FldList: TStringList;
  I           : Longint;
  CurrentField: TField;
begin
  FldList := TStringList.Create;
  if not DataSet.Active then exit; { Can't apply to closed dataset }
  IniFile.ReadSection('Fields', FldList);
  with IniFile, DataSet do begin
    for I := 0 to pred(FldList.Count) do begin
      CurrentField := FindField(FldList[I]);
      if CurrentField = nil then Continue;
      with CurrentField do begin
        DisplayLabel := ReadString(FldList[I], 'DisplayLabel', DisplayLabel);
        index := ReadInteger(FldList[I], 'Index', index);
        Visible := ReadBool(FldList[I], 'Visible', Visible);
        Tag := ReadInteger(FldList[I], 'Tag', Tag);
        Alignment := TAlignment(ReadInteger(FldList[I], 'Alignment', Integer(Alignment)));
        if DataType in [ftSmallint, ftInteger, ftWord, ftFloat, ftCurrency,
          ftDate, ftDateTime, ftBCD] then
          if IsProperty(CurrentField, 'DisplayFormat') then
            SetStringProperty(CurrentField, 'DisplayFormat', ReadString(FldList[I], 'DisplayFormat', EmptyStr));
        if DataType in [ftBoolean] then
          if IsProperty(CurrentField, 'DisplayValues') then
            SetStringProperty(CurrentField, 'DisplayValues', ReadString(FldList[I], 'DisplayValues', EmptyStr));
      end;
    end;
  end;
  FldList.Free;
end;

procedure DoSaveDataSetDescription(DataSet: TDataSet; IniFile: TIniFile);
var I: Longint;
begin
  if not DataSet.Active then exit; {Can't save status of closed dataset}
  with IniFile, DataSet do begin
    EraseSection('Fields');
    for I := 0 to pred(FieldCount) do
      with Fields[I] do begin
        if Fields[I].Calculated then WriteString('Fields', FieldName, 'Calculated')
        else WriteString('Fields', FieldName, 'Stored');
        WriteString(FieldName, 'DisplayLabel', DisplayLabel);
        WriteInteger(FieldName, 'DisplayWidth', DisplayWidth);
        WriteInteger(FieldName, 'Index', index);
        WriteInteger(FieldName, 'Tag', Tag);
        WriteBool(FieldName, 'Visible', Visible);
        WriteInteger(FieldName, 'Alignment', Integer(Alignment));
        if DataType in [ftSmallint, ftInteger, ftWord, ftFloat, ftCurrency,
          ftDate, ftDateTime, ftBCD] then
          if IsProperty(Fields[I], 'DisplayFormat') then
            WriteString(FieldName, 'DisplayFormat', GetStringProperty(Fields[I], 'DisplayFormat'));
        if DataType in [ftBoolean] then
          if IsProperty(Fields[I], 'DisplayValues') then
            WriteString(FieldName, 'DisplayValues', GetStringProperty(Fields[I], 'DisplayValues'));
      end;
  end;
end;

procedure TsohoCustomFolder.ApplyDataSetDescription;
begin
  DoApplyDataSetDescription(FDataSet, FIni);
end;

procedure TsohoCustomFolder.SaveDataSetDescription;
begin
  DoSaveDataSetDescription(FDataSet, FIni);
end;

procedure TsohoCustomFolder.ReOpen;
begin
  with FDataSet do begin
    DisableControls;
    Close;
    try
      try
        {    ,   
                }
        RemoveAllFields(FDataSet);
        Open;
      except {   !  DataSet-  ! }
        ErrorMsg(Format(sohoFolderDataSetOpenError, [Self.name]));
      end;
    finally
      EnableControls;
    end;
  end;
end;

procedure TsohoCustomFolder.DoFormActivate(Sender: TObject);
begin
  LoadDBGridColumns;
  if Assigned(FOnFormActive) then FOnFormActive(Self);
end;

procedure TsohoCustomFolder.Changed;
begin
  if Assigned(FOnChange) then FOnChange(Self);
end;

procedure TsohoCustomFolder.DoBeforeColMoved(Sender: TObject);
begin
  SaveDBGridColumns;
  if Assigned(FOldBeforeColMoved) then FOldBeforeColMoved(Self);
end;

procedure TsohoCustomFolder.DoAfterColMoved(Sender: TObject; FromIndex, ToIndex: Longint);
begin
  LoadDBGridColumns;
  if Assigned(FOldAfterColMoved) then FOldAfterColMoved(Self, FromIndex, ToIndex);
end;

procedure TsohoCustomFolder.SetEvents;
var FActive: Boolean;
  Form: TForm;
begin
  if csDesigning in ComponentState then exit;
  if FDataSet = nil then raise
    EsohoFolderException.Create(Format(sohoFolderDataSetNotDefined, [name]));
  Form := GetOwnerForm(Self);
  if Form <> nil then begin
    FOnFormActive := Form.OnActivate;
    Form.OnActivate := DoFormActivate;
  end;
  FActive := FDataSet.Active;
  FDataSet.Close;
  with FDataSet do begin
    FAfterOpen := AfterOpen;
    FBeforeClose := BeforeClose;
    FBeforeOpen := BeforeOpen;
    AfterOpen := DoAfterOpen;
    BeforeClose := DoBeforeClose;
    BeforeOpen := DoBeforeOpen;
    FCalcFields := OnCalcFields;
    FBeforePost := BeforePost; {Allex}
    BeforePost := DoBeforePost; {Allex ...}

    FOnFilter := FDataSet.OnFilterRecord;
    if FProtectView then FDataSet.OnFilterRecord := DoOnFilter;
  end;
  if Assigned(FGrid) then begin
    FOnColResize := FGrid.OnColResize;
    FOldBeforeColMoved := FGrid.OnBeforeColumnMoved;
    FOldAfterColMoved := FGrid.OnColumnMoved;
    FGrid.OnColResize := DoColResize;
    FGrid.OnColumnMoved := DoAfterColMoved;
    FGrid.OnBeforeColumnMoved := DoBeforeColMoved;
  end;

  if FActive then FDataSet.Open;
  FEventsOur := True;
end;

procedure TsohoCustomFolder.RestoreEvents;
var FActive: Boolean;
  Form: TForm;
begin
  if csDesigning in ComponentState then exit;
  if FDataSet = nil then begin
    FEventsOur := False;
    exit;
  end;
  Form := GetOwnerForm(Self);
  if Form <> nil then Form.OnActivate := FOnFormActive;
  FActive := FDataSet.Active;
  if not (csDestroying in ComponentState) then FDataSet.Close;
  with FDataSet do begin
    AfterOpen := FAfterOpen;
    BeforeClose := FBeforeClose;
    BeforeOpen := FBeforeOpen;
    OnCalcFields := FCalcFields;
  end;
  {  -   }
  if not (csDestroying in ComponentState) and Assigned(FGrid) then begin
    FGrid.OnColResize := FOnColResize;
    FGrid.OnColumnMoved := FOldAfterColMoved;
    FGrid.OnBeforeColumnMoved := FOldBeforeColMoved;
  end;
  if not (csDestroying in ComponentState) then begin
    if FActive then FDataSet.Open
    else FDataSet.Close;
  end;
  FEventsOur := False;
end;

procedure TsohoCustomFolder.SetEnabledMenus(Value: string);
begin
  FEnabledMenus := StrToSet(Value);
end;

function TsohoCustomFolder.GetEnabledMenus: string;
begin
  Result := SetToStr(FEnabledMenus);
end;

function TsohoCustomFolder.GetDisplayLabel(FieldName: string): string;
begin
  {    }
  if FIni = nil then FIni := TIniFile.Create(FullFolderName);
  Result := FIni.ReadString(FieldName, 'DisplayLabel', FieldName);
end;

procedure TsohoCustomFolder.HideField(index: Longint);
begin
  SaveDBGridColumns;
  FGrid.Fields[index].Visible := False;
  LoadDBGridColumns;
end;

procedure TsohoCustomFolder.DoColResize;
var index: Longint;
  OldOnResize: TNotifyEvent;
begin
  if (not FCanResize) or (csDestroying in ComponentState) then exit;
  if mHideField in FEnabledMenus then
    with FGrid do begin
      OldOnResize := OnColResize;
      OnColResize := nil;
      for index := 0 to pred(FieldCount) do
        if ColWidths[index + 1] <= 8 then begin
          ColWidths[index + 1] := 100;
          HideField(index);
        end;
      OnColResize := OldOnResize;
    end;
  if Assigned(FOnColResize) then FOnColResize(FGrid);
end;

procedure TsohoCustomFolder.GetRights;
var Reg: TsohoCustomRegister;
begin
  {       TsohoRegister     DataReadRights
      DataRightRights.     }
  ActionRights := [0..255];
  DataReadRights := [0..255];
  DataWriteRights := [0..255];
  UserId := 666;
  DataLevel := 0;
  Reg := FindSohoRegister;
  if Reg <> nil then begin
    ActionRights := Reg.ActionRights;
    DataReadRights := Reg.DataReadRights;
    DataWriteRights := Reg.DataWriteRights;
    UserId := Reg.UserId;
    DataLevel := Reg.DataLevel;
    if FolderDir = EmptyStr then FolderDir := Reg.PathToHome;
  end;
end;

procedure TsohoCustomFolder.SetActivated(Value: Boolean);
begin
  if csDesigning in ComponentState then exit;
  if FActivated = Value then begin
    //  , -,      DataSet?
    if FEventsOur then RestoreEvents;
    exit; 
  end;
  if not Value then begin
    SaveDataSet;
    FGrid.PopupMenu.OnPopup := FOldPopup;
    DestroyMenu;
  end;
  if Value then begin
    SetDataSet;
    if not FEventsOur then SetEvents;
    LoadDataSet;
    CreateMenu;
  end;
  FActivated := Value;
end;

procedure TsohoCustomFolder.SetDataSet;
begin
  //      DataSet
  if Assigned(FDataSet) and FEventsOur then RestoreEvents;
  if (FGrid <> nil) and (FGrid.DataSource <> nil) then
    FDataSet := FGrid.DataSource.DataSet
  else FDataSet := nil;  
end;

procedure TsohoCustomFolder.SetGrid(Value: TsohoDBGrid);
begin
  if (FGrid <> nil) and (FAuto) then Activated := False;
  FGrid := Value;
  SetDataSet;
end;

function TsohoCustomFolder.FullFolderName: TFileName;
begin
  Result := FFolderDir + FFolderName;
end;

procedure TsohoCustomFolder.SetFolderName;
var FPath: string;
begin
  if FFolderDir + FFolderName = Value then exit;
  if (FIni <> nil) and not (csDesigning in ComponentState) then begin
    FIni.Free;
    FIni := nil;
  end;
  FPath := ExtractFilePath(Value);
  FFolderName := ExtractFileName(Value);
  if FPath <> EmptyStr then FolderDir := FPath;
  if not (csDesigning in ComponentState) and (FIni = nil) then
    FIni := TIniFile.Create(FullFolderName);
end;

procedure TsohoCustomFolder.SetFolderDir;
begin
  if FFolderDir = Value then exit;
  if (FIni <> nil) and not (csDesigning in ComponentState) then begin
    FIni.Free;
    FIni := nil;
  end;
  FFolderDir := Value;
  if FFolderDir <> EmptyStr then {Added by ALLEX}
    FFolderDir := NormalDir(FFolderDir);
  if not (csDesigning in ComponentState) and (FIni = nil) then
    FIni := TIniFile.Create(FullFolderName);
end;

{$IFDEF Delphi4_or_5}
procedure TsohoCustomFolder.SetMenuImages;

  procedure SetMenuImage(ItemIndex, ImageIndex: LongInt);
  begin
    {$IFDEF Delphi5}
    if not FSubMenu then FMenu.Items[ItemIndex].ImageIndex := ImageIndex
    else FItem.Items[ItemIndex].ImageIndex := ImageIndex;
    {$ELSE}
    if not FSubMenu then FMenu.Items[ItemIndex].ImageIndex := ImageIndex;
    {$ENDIF}
  end;

begin
  {$IFDEF Delphi5}
  if FSubMenu then FItem.SubMenuImages := FldImages
  else FMenu.Images := FldImages;
  {$ELSE}
  if not FSubMenu then FMenu.Images := FldImages;
  {$ENDIF}
  SetMenuImage(mDisplaylabel, 0);
  SetMenuImage(mDisplayWidth, 1);
  SetMenuImage(mDisplayFormat, 2);
  SetMenuImage(mFieldAlign, 3);
  SetMenuImage(mHideField, 12);

  SetMenuImage(mSaveFolder, 5);
  SetMenuImage(mLoadFolder, 6);

  SetMenuImage(mTitleLines, 7);
  SetMenuImage(mCreateRField, 8);
  SetMenuImage(mDeleteRField, 9);
end;
{$ENDIF}

procedure TsohoCustomFolder.DestroyMenu;
begin
  if FSubMenu then begin
    {    }
    if not Assigned(FItem) then exit;
    FItem.Parent.Remove(FItem);
    FItem.Free;
    FItem := nil;
  end
  else begin
    if Assigned(FMenu) and
       (not (csDestroying in FMenu.ComponentState)) then FMenu.Free;
    FMenu := nil;
  end;
end;

procedure TsohoCustomFolder.CreateMenu;
var MenuItem: TMenuItem;
  index: Integer;
  
  procedure AddMenuItem(CAPTION: string; OnClick: TNotifyEvent);
  begin
    MenuItem := NewItem(CAPTION, 0, False, True, OnClick, 0, EmptyStr);
    if not FSubMenu then FMenu.Items.Add(MenuItem)
    else FItem.Add(MenuItem);
    SetMenuItem(index, MenuItem);
  end;

begin
  FSubMenu := False;
  FHiddenFields := NewItem(sohoFolderShowColumn, 0, False, True, nil, 0, EmptyStr);
  DestroyMenu;
  if FGrid.PopupMenu <> nil then begin
    FItem := NewItem(sohoFolderService, 0, False, True, nil, 0, EmptyStr);
    FGrid.PopupMenu.Items.Insert(0, FItem);
    FSubMenu := True;
    FOldPopup := FGrid.PopupMenu.OnPopup;
    {$IFDEF Delphi5}
    FItem.AutoHotkeys := maManual;
    {$ENDIF}
  end
  else begin
    FMenu := TPopupMenu.Create(Owner);
    FGrid.PopupMenu := FMenu;
    {$IFDEF Delphi5}
    FMenu.AutoHotkeys := maManual;
    {$ENDIF}
  end;
  FGrid.PopupMenu.OnPopup := BeforeMenuPopup;
  for index := 0 to MenuCount do AddMenuItem(EmptyStr, MenuClick);
  MenuItem.Caption := '-';
  if not FSubMenu then FMenu.Items.Add(FHiddenFields)
  else FItem.Add(FHiddenFields);
  {$IFDEF Delphi4_or_5}
  SetMenuImages;
  FHiddenFields.ImageIndex := 11;
  {$ENDIF}
end;

procedure TsohoCustomFolder.BeforeMenuPopup;
var index: Integer;
  Field      : TField;
  TmpMenuItem: TMenuItem;
  FieldName : string;
begin
  {   ,      ,
           }
  for index := mDisplaylabel to MenuOptionsCount - 1 do
    if FSubMenu then FItem.Items[index].Visible := True
    else FMenu.Items[index].Visible := True;

  for index := mDisplaylabel to pred(MenuOptionsCount) do
    if not (index in [mSeparator1, mSeparator2, mSeparator3]) then
      if FSubMenu then begin
        if not ((index + 1 in FEnabledMenus) and (index + 1 in ActionRights)) then FItem.Items[index].Visible := False;
      end
      else if not ((index + 1 in FEnabledMenus) and (index + 1 in ActionRights)) then FMenu.Items[index].Visible := False;

  Field := FGrid.SelectedField;
  if not Assigned(Field) then exit;
  FieldName := AnsiUpperCase(Field.FieldName);
  if FSubMenu then begin
    FItem.Items[mDisplayFormat].Visible := FItem.Items[mDisplayFormat].Visible and
                                           IsProperty(Field,'DisplayFormat');
    FItem.Items[mDeleteRField].Visible := FItem.Items[mDeleteRField].Visible and
     (not Field.Calculated) and (FTablePath <> EmptyStr);
    FItem.Items[mCreateRField].Visible := FItem.Items[mCreateRField].Visible and
                                          (FTablePath <> EmptyStr);

    FItem.Items[mChangeVisible].Caption := sohoFolderVisibility;

    { Allex }
    FItem.Items[mSeparator1].Visible := FItem.Items[mSaveFolder].Visible or FItem.Items[mLoadFolder].Visible;
    FItem.Items[mSeparator2].Visible := FItem.Items[mTitleLines].Visible or FItem.Items[mTitleAlign].Visible;
    FItem.Items[mSeparator3].Visible := FItem.Items[mCreateRField].Visible or FItem.Items[mDeleteRField].Visible;
  end
  else begin
    FMenu.Items[mDisplayFormat].Visible := FMenu.Items[mDisplayFormat].Visible and
       IsProperty(Field, 'DisplayFormat');

    FMenu.Items[mDeleteRField].Visible := FMenu.Items[mDeleteRField].Visible and
      (not Field.Calculated) and (FTablePath <> EmptyStr);
    FMenu.Items[mCreateRField].Visible := FMenu.Items[mCreateRField].Visible and
      (FTablePath <> EmptyStr);

    FMenu.Items[mSeparator1].Visible := FMenu.Items[mSaveFolder].Visible or FMenu.Items[mLoadFolder].Visible;
    FMenu.Items[mSeparator2].Visible := FMenu.Items[mTitleLines].Visible or FMenu.Items[mTitleAlign].Visible;
    FMenu.Items[mSeparator3].Visible := FMenu.Items[mCreateRField].Visible or FMenu.Items[mDeleteRField].Visible;
  end;

  for index := pred(FHiddenFields.Count) downto 0 do
    FHiddenFields.Delete(index);
  for index := 0 to pred(FDataSet.FieldCount) do
    if (not FDataSet.Fields[index].Visible)
      then begin
      TmpMenuItem := NewItem(FDataSet.Fields[index].DisplayLabel, 0,
        False, True, MenuClick, 0, EmptyStr);

      TmpMenuItem.Enabled := ((255 in ActionRights) or not SohoNames(FDataSet.Fields[index].FieldName))
        {  -   -        
          "    ,  " }
        and (LOWORD(FDataSet.Fields[index].Tag) in DataReadRights);

      {  20-    }
      if (FHiddenFields.Count mod 20 = 0) and
        (FHiddenFields.Count <> 0) then TmpMenuItem.Break :=
        mbBarBreak;
      FHiddenFields.Add(TmpMenuItem);
    end;
  FHiddenFields.Visible := FHiddenFields.Count > 0;
  if Assigned(FOldPopup) then FOldPopup(Sender);
end;

procedure TsohoCustomFolder.ReActivate;
begin
  Activated := False;
  Activated := True;
end;

procedure TsohoCustomFolder.SetColumnSettings(Operation: LongInt);
var Tmp: LongInt;
begin
  FCanResize := False;
  SaveDBGridColumns;
  Tmp := FGrid.ColWidthsByFieldIndex[FGrid.SelectedIndex];
  if SetField(FGrid.SelectedField, FEnabledMenus, FGrid, 0, Operation) then begin
    if Operation <> mDisplayWidth then begin
      LoadDBGridColumns;
      FGrid.ColWidthsByFieldIndex[FGrid.SelectedIndex] := Tmp;
    end;
    SaveDBGridColumns;
    Changed;
  end;
  FCanResize := True;
end;

function TsohoCustomFolder.MenuCount: Integer;
begin
  Result := MenuOptionsCount;
end;

procedure TsohoCustomFolder.SetMenuItem(index: Integer; Item: TMenuItem);
begin
  if index <= MenuCount then Item.CAPTION := GetMenuCaption(index);
end;

procedure TsohoCustomFolder.DoBeforeClose(DataSet: TDataSet);
begin
  {    }
  SaveDataSet;
  if Assigned(FBeforeClose) then FBeforeClose(DataSet);
  FActivated := False;
end;

procedure TsohoCustomFolder.DoOnFilter;
var CheckField: TField;
begin
  if FDataSet = nil then exit;
  if FDataSet.State = dsInactive then exit;
  if Assigned(FOnFilter) then FOnFilter(FDataSet, Accept);
  CheckField := FDataSet.FindField('PROTECT');
  if CheckField <> nil then
    Accept := Accept and (CheckField.AsInteger in DataReadRights);
end;

{ Allex, all procedure }
procedure TsohoCustomFolder.DoBeforePost(DataSet: TDataSet);
var Field: TField;
begin
  Field := DataSet.FindField('MdfDate');
  if Assigned(Field) then Field.AsDateTime := Date;
  Field := DataSet.FindField('MdfTime');
  if Assigned(Field) then Field.AsDateTime := Time;
  Field := DataSet.FindField('IDMdfAuth');
  if Assigned(Field) then Field.AsInteger := UserId;
  Field := DataSet.FindField('PROTECT');
  if Assigned(Field) then Field.AsInteger := DataLevel;
  if Assigned(FBeforePost) then FBeforePost(DataSet);
end;

procedure TsohoCustomFolder.DoBeforeOpen(DataSet: TDataSet);
var index: Longint;
begin
  GetRights;
  if FIni = nil then FIni := TIniFile.Create(FullFolderName);
  {    }
  with DataSet, FieldDefs do begin
    {     DataSet}
    Update;
    {  ,    , 
              TFields}
    for index := 0 to Count - 1 do
      if FindField(Items[index].name) = nil then
        Items[index].CreateField(DataSet);
  end;
  if Assigned(FBeforeOpen) then FBeforeOpen(DataSet);
end;

procedure TsohoCustomFolder.DoAfterOpen(DataSet: TDataSet);
begin
  LoadDataSet;
  if Assigned(FAfterOpen) then FAfterOpen(DataSet);
  Changed;
  FActivated := True;
end;

procedure TsohoCustomFolder.MenuClick(Sender: TObject);
var index: Integer;
  Field: TField;
  
  function FindHiddenField(index: Longint): TField;
  var HdIndex: Longint;
    HdCount: Longint;
  begin
    HdIndex := 0;
    HdCount := 0;
    Result := nil;
    while (HdIndex <= pred(FDataSet.FieldCount)) and (HdCount <= index) do begin
      if not FDataSet.Fields[HdIndex].Visible then inc(HdCount);
      if HdCount > index then Break;
      inc(HdIndex);
    end;
    if HdIndex <= pred(FDataSet.FieldCount) then Result := FDataSet.Fields[HdIndex];
  end;
   begin
  if FSubMenu then index := FItem.IndexOf(TMenuItem(Sender))
  else index := FMenu.Items.IndexOf(TMenuItem(Sender));
  {      , ,   ,
         }
  if index = -1 then begin
    SaveDBGridColumns;
    index := FHiddenFields.IndexOf(TMenuItem(Sender));
    Field := FindHiddenField(index);
    if Field <> nil then Field.Visible := True;
    LoadDBGridColumns;
  end
  else begin
    if index = mLoadFolder then begin
      LoadDataSet;
      exit;
    end;
    SaveDBGridColumns;
    case index of
      mDisplaylabel,
      mDisplayWidth,
      mDisplayFormat,
      mFieldAlign,
      mTitleLines,
      mTitleAlign: SetColumnSettings(Index);
      mHideField: begin
        HideField(FGrid.SelectedIndex);
        exit;
      end;
      mChangeVisible: ChangeVisible;
      mSaveFolder: SaveDataSet;
      mCreateRField: CreateRealField;
      mDeleteRField: DeleteRealField;
    end;
    LoadDBGridColumns;
  end;
end;

procedure TsohoCustomFolder.SaveColumn(index: Longint);
var Field: TField;
  Offset: Integer;
begin
  try
    Field := FGrid.Fields[index];
  except exit;
  end;
  if (dgIndicator in FGrid.Options) then Offset := 1
  else Offset := 0;
  if (Field.Visible) and (index + Offset < FGrid.ColCount) then
    FIni.WriteInteger(Field.FieldName, 'GridWidth', FGrid.ColWidths[index + Offset]);
end;

procedure TsohoCustomFolder.LoadColumn(index: Longint);
var Field: TField;
  Offset: Integer;
begin
  try
    Field := FGrid.Fields[index];
  except exit;
  end;
  if (dgIndicator in FGrid.Options) then Offset := 1
  else Offset := 0;
  if Field <> nil then
    if Field.Visible and (index + Offset < FGrid.ColCount) then
      FGrid.ColWidths[index + Offset] := FIni.ReadInteger(Field.FieldName,
      'GridWidth', FGrid.ColWidths[index + Offset]);
end;

procedure TsohoCustomFolder.SaveDBGridColumns;
var index: Longint;
begin
  FCanResize := False;
  for index := 0 to pred(FGrid.FieldCount) do SaveColumn(index);
  FCanResize := True;
end;

procedure TsohoCustomFolder.LoadDBGridColumns;
var index: Longint;
begin
  FCanResize := False;
  for index := 0 to pred(FGrid.FieldCount) do
    try
      LoadColumn(index);
    except
    end;
  FCanResize := True;
end;

procedure TsohoCustomFolder.SaveDataSet;
begin
  if (FGrid = nil) or (csDestroying in FGrid.ComponentState) then exit;
  if FDataSet = nil then SetDataSet;
  if FDataSet = nil then
    raise EsohoFolderException.Create(Format(sohoFolderDataSetUndefined,
      [name]));
  if FullFolderName = EmptyStr then
    raise EsohoFolderException.Create(Format(sohoFolderNameUndefined, [name]));
  if not FDataSet.Active then exit;
  SaveDataSetDescription;
  SaveDBGridColumns;
  with FIni do begin
    WriteInteger('Main', 'TitleLines', FGrid.TitleLines);
    WriteInteger('Main', 'TitleAlign', Integer(FGrid.TitleAlignment));
  end;
  if Assigned(FOnSave) then FOnSave(Self, FDataSet);
end;

procedure TsohoCustomFolder.LoadDataSet;                
begin
  if FGrid = nil then
    raise EsohoFolderException.Create(Format(sohoFolderLoadDataSetError, [name]));
  if FDataSet = nil then SetDataSet;
  if FDataSet = nil then
    raise EsohoFolderException.Create(Format(sohoFolderDataSetUndefined, [Name]));
  if FullFolderName = EmptyStr then
    raise EsohoFolderException.Create(Format(sohoFolderNameUndefined, [Name]));
  if FDataSet.Active then begin
    ApplyDataSetDescription;
    with FIni do begin
      FGrid.TitleLines := ReadInteger('Main', 'TitleLines', FGrid.TitleLines);
      FGrid.TitleAlignment := TAlignment(ReadInteger('Main', 'TitleAlign', Integer(FGrid.TitleAlignment)));
    end;
    LoadDBGridColumns;
    ApplyDataRights(DataReadRights, DataWriteRights);
  end;
  if Assigned(FOnLoad) then FOnLoad(Self, FDataSet);
end;

procedure TsohoCustomFolder.Notification(AComponent: TComponent; aOperation: TOperation);
begin
  if (AComponent = FGrid) and (aOperation = opRemove) then begin
    Activated := False;
    Grid := nil;
  end;
  if (AComponent = FDataSet) and (aOperation = opRemove) then begin
    Activated := False;
    if Assigned(FDataSet) and FEventsOur then RestoreEvents;
    FDataSet := nil;
  end;
  inherited Notification(AComponent, aOperation);
end;

function TsohoCustomFolder.Activate: Boolean;
begin
  Result := False;
  Activated := not Result;
  Result := Activated;
end;

function TsohoCustomFolder.Deactivate: Boolean;
begin
  Result := True;
  Activated := not Result;
  Result := not Activated;
end;

procedure TsohoCustomFolder.Loaded;
begin
  inherited Loaded;
  if FAuto and not (csDesigning in ComponentState) then begin
    SetDataSet;
    SetEvents;
    CreateMenu;
    FActivated := True;
  end;
end;

constructor TsohoCustomFolder.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FEventsOur := False;
  FMenuAppend := False;
  FActivated := False;
  FSubMenu := False;
  FAuto := True;
  FFolderDir := EmptyStr;
  FFolderName := EmptyStr;
  FMenu := nil;
  FItem := nil;
  FIni := nil;
  FCanResize := False;
  FEnabledMenus := StrToSet('0-9,11-12,14-15,17-18,20-22');
  FProtectView := true;
  FKeyField := 'Id';
end;

destructor TsohoCustomFolder.Destroy;
begin
  if FAuto then Deactivate;
  if (FEventsOur) and (FDataSet <> nil) then RestoreEvents;
  if FIni <> nil then FIni.Free;
  inherited Destroy;
end;

{$IFDEF Delphi4_or_5}
initialization
  TVImages := TImageList.Create(nil);
  with TVImages do begin
    Width := 16;
    Height := 16;
    ResourceLoad(rtBitmap, 'SOHOTVCONTIMAGES', clAqua);
  end;

  FldImages := TImageList.Create(nil);
  with FldImages do begin
    Width := 16;
    Height := 16;
    ResourceLoad(rtBitmap, 'SOHOFOLDERIMAGES', clAqua);
  end;
finalization
  TVImages.Free;
  FldImages.Free;
{$ENDIF}
end.

