{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{           Partial copyright (c) AllexSoft             }
{           Written by Alexander Govyadinov,            }
{                   Serg Vostrikov                      }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
     TsohoCustomRegister  TsohoSubRegister
}
unit SoCtmRgs;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Graphics, Controls,
     ExtCtrls, Menus, SoUnit, StdCtrls, Forms;

type

  TsohoNewUserBoxCreated = procedure (Sender: TObject; BoxName: string) of object;
  {    OnNewUserBox. BoxName -      }

  TsohoRegisterActivate = (raFormShow, raFormCreate);
  {   TsohoCustomRegister:        
     }

  TsohoCustomRegister = class(TComponent)
  private
    { Private declarations }
    FPassword: boolean;
    FApplyRights: boolean;
    FHideSecret: boolean;
    FOnFormShow: TNotifyEvent;
    FOnActivate: TNotifyEvent;
    FOnBeforeActivate: TNotifyEvent;
    FOnNewUserBox: TsohoNewUserBoxCreated;
    FWindowHandle: HWND;
    FActivateOn: TsohoRegisterActivate;
    FOnUserNameRequired: TNotifyEvent;
    {        
            }
    function GetActionRightsAsString: string;
    function GetDataReadRightsAsString: string;
    function GetDataWriteRightsAsString: string;
    procedure SetActionRightsAsString(aValue: string);
    procedure SetDataReadRightsAsString(aValue: string);
    procedure SetDataWriteRightsAsString(aValue: string);

    procedure SetPasswordRequired(aValue: boolean);

    { -   }
    procedure FormShow(Sender: TObject);
    procedure WNDPROC(var message: TMessage);
  protected

    {   }
    procedure DefineProgramPath;
    procedure DefineDataPath;virtual;
    procedure DefineTempPath;
    procedure DefineHomePath;
    procedure DefineSQLPath;
    procedure DefineReportsPath;
    procedure DefineImagesPath;
    procedure DefineScriptsPath;

    procedure BeforeActivate; virtual;
    procedure DoActivate; virtual;
    procedure DoNewUserBox; virtual;
    {     }
    procedure ShowUserList; virtual; abstract;
    {         }
    function ShowPasswordDialog: boolean; virtual; abstract;
    {    }
    procedure ChangePassword; virtual; abstract;
    {    }
    procedure GetUserRights; virtual; abstract;
    procedure DoUserNameRequired; virtual;

    {    ,   TsohoCustomRegister    }
    property WindowHandle: HWND read FWindowHandle;

  public
    PathToData: string;
    {     ,    }
    DataName: string;
    {     .    }
    PathToProgram: string;
    { ,     }
    ProgramName: string;
    PathToTemp: string;
    {      }
    PathToLocalTemp: string;
    {        }
    PathToHome: string;
    {   -    -    
       .  TsohoCustomFolder }
    PathToSQL: string;
    {      }
    PathToReports: string;
    {     .     XLS }
    PathToImages: string;
    {          .. }
    PathToScripts: string;
    {    .   }
    PathToUsers: string;
    {   .    , 
       PathToUsers = PathToHome.       
        }

    IniFileName: string;
    {   -  }
    UserName: string;
    {    }
    ShortName: string;
    {    }
    UserID: Longint;
    {   -   TsohoFolder    }
    DataLevel: Longint;
    {      .    }
    ActionRights: SetOfByte;
    {    -  ,   TAG    }
    DataReadRights: SetOfByte;
    {    .  TAG    TDataSet }
    DataWriteRights: SetOfByte;
    {   (.. ) .  TAG    TDataSet
           TsohoFolder,  
         TsohoCustomRegister.     
         " "       
        .    ,     }

    procedure Loaded; override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure Activate; virtual;
    {  TsohoCustomRegister -  ,     }
    property ApplyRights: boolean read FApplyRights write FApplyRights;
    {        }
    property UserActionRights: string read GetActionRightsAsString write SetActionRightsAsString;
    {       }
    property UserDataReadRights: string read GetDataReadRightsAsString write SetDataReadRightsAsString;
    {         }
    property UserDataWriteRights: string read GetDataWriteRightsAsString write SetDataWriteRightsAsString;
    {         }
    property HideSecret: boolean read FHideSecret write FHideSecret;
    {    AppplyRights,     
              
         .      
        ,    . 
      HideSecret       ""
      :  Visible = false,  Enabled = false }
    property PasswordRequired: boolean read FPassword write SetPasswordRequired default False;
    {         ? }
    property ActivateOn: TsohoRegisterActivate read FActivateOn write FActivateOn default raFormCreate;
    {  :   ,     }
    property OnActivate: TNotifyEvent read FOnActivate write FOnActivate;
    {     TsohoCustomRegister }
    property OnBeforeActivate: TNotifyEvent read FOnBeforeActivate write FOnBeforeActivate;
    {     TsohoCustomRegister }
    property OnNewUserBox: TsohoNewUserBoxCreated read FOnNewUserBox write FOnNewUserBox;
    {         }
    property OnUserNameRequired: TNotifyEvent read FOnUserNameRequired write FOnUserNameRequired;
    {  ,  TsohoCustomRegister   
         .    
      UserName       
      (PasswordRequired),   OnUserNameRequired   }
  end;

  TsohoSubRegister = class(TComponent)
  { -      
    TsohoCustomRegister }
  private
    FActivateOn: TsohoRegisterActivate;
    FOnActivate: TNotifyEvent;
    FOnFormShow: TNotifyEvent;
  protected
    procedure FormShow(Sender: TObject);
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;

    procedure Activate; virtual;
    {   }
    function PathToData: string;
    {  TsohoCustomRegister }
    function DataName: string;
    {  TsohoCustomRegister }
    function PathToProgram: string;
    {  TsohoCustomRegister }
    function ProgramName: string;
    {  TsohoCustomRegister }
    function PathToTemp: string;
    {  TsohoCustomRegister }
    function PathToLocalTemp: string;
    {  TsohoCustomRegister }
    function PathToHome: string;
    {  TsohoCustomRegister }
    function PathToSQL: string;
    {  TsohoCustomRegister }
    function PathToReports: string;
    {  TsohoCustomRegister }
    function PathToImages: string;
    {  TsohoCustomRegister }
    function PathToUsers: string;
    {  TsohoCustomRegister }
    function IniFileName: string;
    {  TsohoCustomRegister }
    function UserName: string;
    {  TsohoCustomRegister }
    function ShortName: string;
    {  TsohoCustomRegister }
    function UserID: Longint;
    {  TsohoCustomRegister }
    function DataLevel: Longint;
    {  TsohoCustomRegister }
    function ActionRights: SetOfByte;
    {  TsohoCustomRegister }
    function DataReadRights: SetOfByte;
    {  TsohoCustomRegister }
    function DataWriteRights: SetOfByte;
    {  TsohoCustomRegister }
  published
    property ActivateOn: TsohoRegisterActivate read FActivateOn write FActivateOn default raFormCreate;
    {  TsohoCustomRegister }
    property OnActivate: TNotifyEvent read FOnActivate write FOnActivate;
    {  TsohoCustomRegister }
  end;

{      TsohoCustomRegister }
function FindSohoRegister: TsohoCustomRegister;

var
   {     TsohoCustomRegister   }
   SingleRegister: TsohoCustomRegister;

implementation
uses SoVCLUtils, FileCtrl, SoDBCns, SoAppUtils, SoStrUtils;

procedure TsohoCustomRegister.DoActivate;
begin
  if Assigned(FOnActivate) then FOnActivate(Self);
end;

procedure TsohoCustomRegister.DoNewUserBox;
begin
 if Assigned(FOnNewUserBox) then FOnNewUserBox(Self, PathToHome + '\');
end;

function FindSohoRegister: TsohoCustomRegister;
begin
  Result := SingleRegister;
end;

procedure TsohoCustomRegister.SetPasswordRequired(aValue: boolean);
begin
  FPassword := aValue;
end;

procedure TsohoCustomRegister.Loaded;
var Form: TForm;
begin
  inherited Loaded;
  if not (csDesigning in ComponentState) then begin
    Form := GetOwnerForm(Self);
    if Form <> nil then begin
      if FActivateOn = raFormShow then begin
        FOnFormShow := Form.OnShow;
        Form.OnShow := FormShow;
      end
      else begin
        FOnFormShow := Form.OnCreate;
        Form.OnCreate := FormShow;
      end;
    end;
  end;
end;

constructor TsohoCustomRegister.Create;
begin
  if SingleRegister <> nil then raise
    Exception.Create(sohoRegisterOnlySingleRegister);
  inherited Create(AOwner);
  FPassword := False;
  FActivateOn := raFormCreate;
  {        ! }
  SingleRegister := Self;
  ActionRights := [0..255];
  DataReadRights := [0..255];
  DataWriteRights := [0..255];
  FHideSecret := true;

  if not (csDesigning in ComponentState) then begin
    FWindowHandle := AllocateHWnd(WNDPROC);
    DefineProgramPath; {,   }
    DefineDataPath; {,   }
    DefineTempPath; {  }
    DefineSQLPath; {     }
    DefineReportsPath;
    DefineImagesPath;
    DefineScriptsPath;
  end;
end;

procedure TsohoCustomRegister.WNDPROC(var message: TMessage);
begin
  with message do
    //   -     
    Result := DefWindowProc(FWindowHandle, Msg, WPARAM, LPARAM);
end;

destructor TsohoCustomRegister.Destroy;
begin
  if not (csDesigning in ComponentState) then DeallocateHWnd(FWindowHandle);
  SingleRegister := nil;
  inherited Destroy;
end;

procedure TsohoCustomRegister.Activate; {  ,    }
var Form  : TForm;
  TmpDir: string;
  Valid : boolean;
begin
  Valid := True;
  if PasswordRequired then begin
    GetDir(0, TmpDir);
    Valid := ShowPasswordDialog;
    ChDir(TmpDir);
  end
  else DoUserNameRequired;

  if Valid then begin
    DefineHomePath; {    }

    Form := GetOwnerForm(Self);
    if (Form <> nil) and ApplyRights then begin
      ActionRights := [0..0];
      GetUserRights; //   
      ApplyActionRights(Form, ActionRights, FHideSecret);
    end;
    BeforeActivate;
    DoActivate;
  end
  else Application.Terminate;
end;

procedure TsohoCustomRegister.DefineScriptsPath;
begin
  PathToScripts := PathToProgram + 'Scripts\' + DefaultName+'\';
end;

procedure TsohoCustomRegister.DefineImagesPath;
begin
  PathToImages := PathToProgram + 'Images\' + DefaultName+'\';
end;

procedure TsohoCustomRegister.DefineReportsPath;
begin
  PathToReports := PathToProgram + 'Reports\' + DefaultName+'\';
end;

procedure TsohoCustomRegister.DefineSQLPath;
begin
  PathToSQL := PathToProgram + 'SQL\' + DefaultName+'\';
end;

procedure TsohoCustomRegister.DefineDataPath;
begin
  { Paramstr(1)     }
  PathToData := ParamStr(1); {ExtractFile ...}
end;


procedure TsohoCustomRegister.DefineProgramPath;
begin
  PathToProgram := ParamStr(0);
  PathToProgram := ExtractFilePath(PathToProgram);
  IniFileName := DefaultName + '.ini';
end;

procedure TsohoCustomRegister.DefineTempPath;
begin
  PathToTemp := GetEnvVar('temp');
  PathToTemp := NormalDir(PathToTemp);
  PathToLocalTemp := GetPathToLocalTemp;
  PathToTemp := ExtractFilePath(PathToTemp); { -   }
end;

procedure TsohoCustomRegister.DefineHomePath;
var FindFile: TSearchRec;
begin
  GetDir(0, PathToHome);
  PathToHome := NormalDir(PathToHome);
  PathToUsers := PathToHome;
  if ShortName <> EmptyStr then PathToHome := PathToHome + ShortName + '\';
  PathToHome := PathToHome+DefaultName + '\';
  {      .    ... }
  if FindFirst(PathToHome, faDirectory, FindFile) <> 0 then begin
    MakeDirectory(PathToHome); { Allex }
    DoNewUserBox;
  end;
end;

{$i-}

function TsohoCustomRegister.GetActionRightsAsString: string;
begin
  Result := SetToStr(ActionRights);
end;

procedure TsohoCustomRegister.SetActionRightsAsString(aValue: string);
begin
  ActionRights := StrToSet(aValue);
end;

function TsohoCustomRegister.GetDataReadRightsAsString: string;
begin
  Result := SetToStr(DataReadRights);
end;

procedure TsohoCustomRegister.SetDataReadRightsAsString(aValue: string);
begin
  DataReadRights := StrToSet(aValue);
end;

function TsohoCustomRegister.GetDataWriteRightsAsString: string;
begin
  Result := SetToStr(DataWriteRights);
end;

procedure TsohoCustomRegister.SetDataWriteRightsAsString(aValue: string);
begin
  DataWriteRights := StrToSet(aValue);
end;

procedure TsohoCustomRegister.FormShow(Sender: TObject);
var Form: TForm;
begin
  Activate;
  if (csDesigning in ComponentState) then exit;
  Form := GetOwnerForm(Self);
  {       ,  
         }
  if Form <> nil then begin
    if FActivateOn = raFormShow then Form.OnShow := FOnFormShow
    else Form.OnCreate := FOnFormShow;
    if Assigned(FOnFormShow) then FOnFormShow(Sender);
  end;
end;

{ TsohoSubRegister }
procedure TsohoSubRegister.FormShow(Sender: TObject);
var Form: TForm;
begin
  if SingleRegister = nil then exit;
  Activate;
  Form := GetOwnerForm(Self);
  {       ,  
         }
  if Form <> nil then begin
    if FActivateOn = raFormShow then Form.OnShow := FOnFormShow
    else Form.OnCreate := FOnFormShow;
    if Assigned(FOnFormShow) then FOnFormShow(Sender);
  end;
end;

procedure TsohoSubRegister.Activate;
var Form: TForm;
begin
  Form := GetOwnerForm(Self);
  if Assigned(Form) and Assigned(SingleRegister) and
     SingleRegister.ApplyRights then ApplyActionRights(Form,
       ActionRights, SingleRegister.HideSecret);
  if Assigned(FOnActivate) then FOnActivate(Self);
end;

procedure TsohoSubRegister.Loaded;
var Form: TForm;
begin
  inherited Loaded;
  if not (csDesigning in ComponentState) then begin
    Form := GetOwnerForm(Self);
    if Form <> nil then begin
      if FActivateOn = raFormShow then begin
        FOnFormShow := Form.OnShow;
        Form.OnShow := FormShow;
      end
      else begin
        FOnFormShow := Form.OnCreate;
        Form.OnCreate := FormShow;
      end;
    end;
  end;
end;

constructor TsohoSubRegister.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FActivateOn := raFormCreate;
end;

function TsohoSubRegister.PathToData: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.PathToData;
end;

function TsohoSubRegister.DataName: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.DataName;
end;

function TsohoSubRegister.PathToProgram: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.PathToProgram;
end;

function TsohoSubRegister.ProgramName: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.ProgramName;
end;

function TsohoSubRegister.PathToTemp: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.PathToTemp;
end;

function TsohoSubRegister.PathToLocalTemp: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.PathToLocalTemp;
end;

function TsohoSubRegister.PathToHome: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.PathToHome;
end;

function TsohoSubRegister.IniFileName: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.IniFileName;
end;

function TsohoSubRegister.UserName: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.UserName;
end;

function TsohoSubRegister.ShortName: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.ShortName;
end;

function TsohoSubRegister.UserID: Longint;
begin
  Result := -1;
  if SingleRegister = nil then exit;
  Result := SingleRegister.UserID;
end;

function TsohoSubRegister.DataLevel: Longint;
begin
  Result := -1;
  if SingleRegister = nil then exit;
  Result := SingleRegister.DataLevel;
end;


function TsohoSubRegister.ActionRights: SetOfByte;
begin
  Result := [0..255];
  if SingleRegister = nil then exit;
  Result := SingleRegister.ActionRights;
end;

function TsohoSubRegister.DataReadRights: SetOfByte;
begin
  Result := [0..255];
  if SingleRegister = nil then exit;
  Result := SingleRegister.DataReadRights;
end;

function TsohoSubRegister.DataWriteRights: SetOfByte;
begin
  Result := [0..255];
  if SingleRegister = nil then exit;
  Result := SingleRegister.DataWriteRights;
end;

function TsohoSubRegister.PathToSQL: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.PathToSQL;
end;

function TsohoSubRegister.PathToReports: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.PathToReports;
end;

function TsohoSubRegister.PathToImages: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.PathToImages;
end;

function TsohoSubRegister.PathToUsers: string;
begin
  Result := EmptyStr;
  if SingleRegister = nil then exit;
  Result := SingleRegister.PathToUsers;
end;

procedure TsohoCustomRegister.BeforeActivate;
begin
  if Assigned(FOnBeforeActivate) then FOnBeforeActivate(Self);
end;

procedure TsohoCustomRegister.DoUserNameRequired;
begin
  if ShortName <> EmptyStr then exit;
  if Assigned(FOnUserNameRequired) then FOnUserNameRequired(Self);
end;

initialization
  SingleRegister := nil;
end.

