{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov,              }
{                  Alexander Govyadinov,                }
{                    Victor Mylcin,                     }
{                   Igor Chernyshov                     }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
    TsohoCustomTreeView -    
 SohoLib        
}
unit SoCtmTre;
//  07.07.2000.  
//  FieldsList  ValuesList  TsohoTreeOnNewGroup
{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, DB,
     ExtCtrls, SoSplit, Menus, Grids, StdCtrls, SoCtrls, SoTools,
     SoCtmFld, DBGrids, SoClass, SoChkBox, SohoBtns, SoDBGrid,
     SoEnhTreeView, ComCtrls;

type

  TsohoTreeNode = record
  {    . GroupName -  , GroupId - 
     .   }
    GroupName: string;
    GroupId: Longint;
  end;

  TsohoTreeOption = (trDeleteGroup, trAddGroup, trEditGroup, trDeleteItem,
    trAddItem, trEditItem, trRefresh, trReNumber,
    trMoveItem, trMoveGroup);
  {   TsohoCustomTreeView:
    trDeleteGroup -  ,
    trAddGroup    -  ,
    trEditGroup   -   ,
    trDeleteItem  -   ,
    trAddItem     -   ,
    trEditItem    -   ,
    trRefresh     -  ,
    trReNumber    -  ,
    trMoveItem    -   ,
    trMoveGroup   -   
  }

  TsohoTreeOptions = set of TsohoTreeOption;
  {     TsohoCustomTreeView }

  TsohoTreeSaveOption = (trSaveTreeView, trSaveSplitter, trSaveViewChild);
  { trSaveTreeView   -   TreeView,
    trSaveSplitter  -     TreeView  DBGrid,
    trSaveViewChild -   CheckBox' }

  TsohoTreeSaveOptions = set of TsohoTreeSaveOption;
  {     TreeView }

  TsohoTreeOnFilter = procedure (Sender: TObject; DataSet: TDataSet;
    var Visible: boolean) of object;
  {    OnFilter. DataSet -   
     .  Visible     }

  TsohoTreeOnDeleteItem = procedure (Sender: TObject; ItemID: Longint;
    var Allow: boolean) of object;
  {    OnItemDelete.    ItemId,
     "" . Allow   ,  
     }
  TsohoTreeOnDeleteGroup = procedure (Sender: TObject; GrpId: Longint;
    var Allow: boolean) of object;
  {    OnGrpDelete.    GrpId.
    Allow   ,    }
  TsohoTreeOnNewItem = procedure (Sender: TObject; GroupId: Longint;
    var ItemID, ItemHash: Longint; var Allow: boolean) of object;
  {    OnGrpDelete.    GrpId.
    Allow   ,    }
  TsohoTreeOnNewGroup = procedure (Sender: TObject; NewGroup: TsohoTreeNode;
    var FieldsList : TStringList; var ValuesList : TStringList; var Allow: boolean) of object;
  {    OnNewGrp.    NewGroup.
    Allow   ,   .
    FieldsList -  ,      
      
    ValueList -  ,     FieldsList }
  TsohoTreeOnEditItem = procedure (Sender: TObject; GroupId, ItemID: Longint;
    var Allow: boolean) of object;
  {    OnItemEdit.    GroupId 
      itemId. Allow   ,    }
  TsohoTreeOnEditGroup = procedure (Sender: TObject; Group: TsohoTreeNode;
    var Allow: boolean) of object;
  {    OnGrpEdit.    Group.
    Allow   ,    }
  TsohoTreeCustomGroup = procedure (Sender: TObject; GroupId, GroupHash, ParentId: Longint;
    var GroupName: string; var Allow: boolean) of object;
  {     OnCustomEditGrp  OnCustomNewGrp.   
   GroupId,   GroupHash,    ParentId 
     GroupName. Allow       }
  TsohoTreeOnMoveItem = procedure (Sender: TObject; OldGroupId, NewGroupId: Longint;
    ItemID, NewItemHash: Longint; var Allow: boolean) of object;
  {     OnItemMove.   ,  
     OldGroupId,  ,     NewGroupId,
     ItemId,      NewItemHash. Allow
         }
  TsohoTreeOnGetItems = procedure (Sender: TObject; GroupId : LongInt) of object;
  {    OnGetItems.   ,  
      .     
     ,       
      SelectedGroups }

  TsohoTreeOnPopupCreate = procedure (Sender: TObject; PopupMenu: TPopupMenu) of object;
  {    OnPopupMenuCreate  OnBtnPopupMenuCreate. 
       ""  }

  TsohoTreeOnException = function (Sender: TObject; E: Exception): boolean of object;
  {    OnException.    
    .   ,   Result 
     true.   , TsohoCustomTreeView    
  }

  PTreeLeaf = ^TTreeLeaf;
  TTreeLeaf = record
  {    TreeView. ItemId -  , ItemsHash -  
     , ParentId -    }
    ItemID: Longint;
    ItemHash: Longint;
    ParentId: Longint;
  end;

  TsohoMoveItem = record
  {     }
    ID: Longint;
    OldGrpId, NewGrpId: Longint;
    NewHash: Longint;
    ItemDragBegin: boolean;
    DragOverId: Longint;
    GridDrag: boolean;
    GridRow: Longint;
  end;

  TsohoMoveGroup = record
  {     }
    GrpDragSourceRow: TTreeNode;
  end;

  TsohoSpecEnhTreeView = class(TsohoEnhTreeView)
  {   }
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure NodeSelected(Node: TTreeNode); override;
  end;

  TsohoCustomTreeView = class(TCustomControl)
{        .   
    -     .     ,
    . ,         ,
    .       . 
  , ,     TsohoCustomTreeView   .  
,         OnNewItem, OnItemDelete,
OnItemEdit }
  private
    { Private declarations }
    FFolder: TsohoCustomFolder;
    FFixedGrpName: string;
    FFixedGrpId: Longint;
    FRootName: string;
    FActive: boolean;
    FByFilter: boolean;
    FCloseGroups: boolean;
    FEditOnDblClick: boolean;

    FGroupsDS,
      FItemsDS: TDataSet;

    FIdGrpField: string;
    FParentIdField: string;
       FGroupNameField: string;
    FHashField: string;
    FOrderField: string;
    FKeyField: string;

    FItemsName: string;
    FGroupsName: string;
    FItemsGenderIndex,
    FGroupsGenderIndex: LongInt;

    FGroupPreffix,
      FItemsPreffix: string;
    FSaveFile: TIniFileName;
    fOptions: TsohoTreeOptions;
    FSaveOptions: TsohoTreeSaveOptions;

    FFilterGroups : TsohoIntegerList;

    { Events }
    FOnActivate: TNotifyEvent;
    FOnFilter: TsohoTreeOnFilter;
    FOnItemDelete: TsohoTreeOnDeleteItem;
    FOnGrpDelete: TsohoTreeOnDeleteGroup;
    FOnNewItem: TsohoTreeOnNewItem;
    FOnMoveItem: TsohoTreeOnMoveItem;
    FOnNewGrp: TsohoTreeOnNewGroup;
    FOnItemEdit: TsohoTreeOnEditItem;
    FOnGrpEdit: TsohoTreeOnEditGroup;
    FOnGetItems: TsohoTreeOnGetItems;

    FOnCustomEditGrp: TsohoTreeCustomGroup;
    FOnCustomNewGrp: TsohoTreeCustomGroup;

    FOnGetCellsProps: TGetCellPropsEvent;
    FOnDrawCells: TDrawDataCellEvent;
    FOnSaveFolder: TsohoOnSaveEvent;
    FOnLoadFolder: TsohoOnLoadEvent;
    FOnPopup: TNotifyEvent;
    FAfterGrpDelete: TNotifyEvent;
    FOnChange: TNotifyEvent;
    FOnGroupSelect: TNotifyEvent;
    FOnPopupMenuCreate: TsohoTreeOnPopupCreate;
    FOnBtnPopupMenuCreate: TsohoTreeOnPopupCreate;

    FOnGridDblClick: TNotifyEvent;
    FOnGridKeyDown: TKeyEvent;
    FOnGroupsKeyDown: TKeyEvent;
    FOnGroupsMouseDown: TMouseEvent;
    FOnGroupsMouseMove: TMouseMoveEvent;
    FOnGroupsDragOver: TDragOverEvent;
    FOnGroupsDragDrop: TDragDropEvent;
    FOnGridDragDrop: TDragDropEvent;
    FOnGridMouseMove: TMouseMoveEvent;
    FOnGridDragOver: TDragOverEvent;
    FOnGridMouseDown: TMouseEvent;
    FOnException: TsohoTreeOnException;

    { Visible controls }
    FBtnsPanel,
      FComPanel,
      FTreeViewPanel,
      FGridPanel: TPanel;
    FGroups: TsohoEnhTreeView;
    FGrid: TsohoDBGrid;
    FSplitter: TsohoSplitter;
    FViewChild: TsohoCheckBox;
    FReport: TLabel;
    FMenuBtn: TsohoBitBtn;
    FBtnMenu: TPopupMenu;

    { Data Access }
    FSource: TDataSource;
    FOldGrp,
      FOldItm: boolean;
    FOnDSFilter: TFilterRecordEvent;
    FGroupsTable: String;
    FItemsTable: String;

    FPopMenu: TPopupMenu;
    FGroupMenu: TPopupMenu;
    FGrpSelItem,
      FGrpDeselItem: TMenuItem;
    FEnabledItem,
      FDisabledItem: TMenuItem;
    FParSet: boolean;

    procedure GroupsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GroupsMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure GroupsDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: boolean);
    procedure GroupsDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ItemsGridDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ItemsGridMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure ItemsGridDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: boolean);
    procedure ItemsGridMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    { Design and Run-Time routines }
    procedure WriteGrid(Stream: TStream);
    procedure WriteTreeView(Stream: TStream);
    procedure ReadGrid(Stream: TStream);
    procedure ReadTreeView(Stream: TStream);
    function GetGroupsVisible: boolean;
    function GetItemsVisible: boolean;
    procedure SetGroupsVisible(Show: boolean);
    procedure SetItemsVisible(Show: boolean);
    procedure SetIncludeSubTree(Value: boolean);
    function GetIncludeSubTree: boolean;
    procedure SetGroupsTable(Value: String);
    procedure ButtonMenuClick(Sender: TObject);
    procedure CheckFilter(DataSet: TDataSet; var Accept: boolean);
    procedure GroupSelected(Sender: TObject);
    procedure SetItemsName(Value: string);
    procedure SetGroupsName(Value: string);
    procedure UpdateBtnMenus;
    procedure SetGroupsDataSet(Value: TDataSet);
    procedure SetItemsDataSet(Value: TDataSet);
    procedure SetNameGrID(Value: string);
    procedure SetOrderField(Value: string);
    procedure SetNameParentID(Value: string);
    procedure SetHashField(Value: string);
    procedure SetOptions(Value: TsohoTreeOptions);
    function GetItemId: Longint;
    procedure SetItemId(Value: Longint);
    procedure SetActive(Value: boolean);
    procedure SetRootName(Value: string);
    function GetResults: TsohoDBGridResults;
    procedure SetKeyField (Value : string);

    { Events handlers }
    procedure GridDblClick(Sender: TObject);

    procedure GridGetCellProps (Sender: TObject; Field: TField;
              AFont: TFont; var Background: TColor);

    procedure GridDataCell(Sender: TObject; const Rect: TRect; Field: TField;
      State: TGridDrawState);

    procedure GridKeyDown(Sender: TObject; var KEY: Word; Shift: TShiftState);
    procedure FolderSave(Sender: TObject; DataSet: TDataSet);
    procedure FolderLoad(Sender: TObject; DataSet: TDataSet);

    procedure MenuItemClick(Sender: TObject);
    procedure OnMenuPopup(Sender: TObject);

    procedure OnBtnMenuPopup (Sender : TObject);
    procedure ViewChildClick(Sender: TObject);
    procedure SetSaveFile(Value: TIniFileName);
    function InGroup(Node: TTreeNode; FilterGroup: Longint): boolean;
    procedure SetFolder(Value: TsohoCustomFolder);
    procedure CreateBtnMenus;
    procedure GetTreeViewImageIndex (Sender: TObject; Node: TTreeNode);
    procedure AllowEditNode(Sender: TObject; Node: TTreeNode;
              var AllowEdit: Boolean);
    procedure DoEditNode(Sender: TObject; Node: TTreeNode;
              var S: string);
  protected
    { Protected declarations }
    { For drag and drop }
    FMoveItem: TsohoMoveItem;
    FMoveGroup: TsohoMoveGroup;
    LeftHash, RightHash: Longint;

    procedure DefineProperties(Filer: TFiler); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure InternalRefreshFilter; virtual;
    procedure BeforeActivate; virtual;
    function CreateGroupsTree: boolean;virtual;
    function AddTreeItem(Node: TTreeNode; ItemID, ParentId, ItemHash: Longint;
      ItemName: string): boolean;
    procedure ClearTreeView;
    procedure Loaded; override;
    procedure Changed; virtual;
    function  RenumberRecords: boolean;virtual; abstract;
    function  DeleteOneRecord(ItemID: Longint): boolean;virtual; abstract;
    procedure MoveGroup (NewParentId, NewHash, Id : LongInt);virtual; abstract;
    function  TreeViewGetGroupsIds(const aFixedGrpName, aGroupTable: string;
              var Ids: TsohoDBGridResults): boolean;virtual; abstract;
    procedure GetFilterGroups;
    procedure CreateWnd; override;
    {     }
    function  HandleExceptions(E: Exception): boolean; virtual;
  public

    procedure CreateMenu;
    {        DBGrid }
    function GetSelectedGroupId : LongInt;
    {     }
    function GetSelectedGroupName : string;
    {     }

    function QuietAddGroup(var NewName: string): boolean; virtual; abstract;
    {          }
    function AddGroup: boolean; virtual;
    {   }
    function QuietEditGroup(var NewName: string): boolean; virtual; abstract;
    {          }
    function EditGroup: boolean; virtual;
    {    }
    function DeleteGroup: boolean; virtual; abstract;
    {   }
    function AddItem: boolean; virtual;
    {   }
    function EditItem: boolean; virtual;
    {   }
    function MoveItem: boolean; virtual; abstract;
    {   }
    function DeleteItem: boolean; virtual; abstract;
    {   }
    function LocateOnGroup: boolean;
    {      GroupsDataSet  , 
          GroupTreeView.     CloseGroups = false }
    function GetNewGroupIdPreffix: string;
    {  ,       TreeView, 
      -  -      
      GetNewId    SoUnit }
    function GetNewItemIdPreffix: string;
    {  ,       TreeView, 
      -  -      
      GetNewId    SoUnit }
    procedure ReDrawTreeView;
    {  TreeView }
    procedure SetTreeViewWidth(Value: Integer);
    {   GroupTreeView }
    function GetNodeByName(const Name: string): TTreeNode;
    {       }
    function GetNewItemHash(GrpId: Longint): Longint; virtual; abstract;
    {     Hash    }
    function GetHash(Left, Right: Longint): Longint;
    {    Hash       }
    function GetLeafRecord(Node: TTreeNode): PTreeLeaf;
    {      }
    function GetIdByNode(Node: TTreeNode): LongInt;
    {        }
    function GetNodeByID(ItemID: Longint): TTreeNode;
    {      }
    procedure TreeViewButtonsClick(ButtonIndex: Longint); virtual;
    {    -   TsohoCustomTreeView.    
        actDelGroup   }
    procedure RefreshGroup;
    {     }
    procedure RefreshItems;
    {   }
    procedure RefreshTreeView; virtual;
    {    }
    procedure LoadTreeViewState; virtual;
    {   ini-  TreeView }
    procedure SaveTreeViewState; virtual;
    {   ini-  TreeView }
    function AddNewItem(GrpId, ItemID, ItemHash: Longint): boolean;virtual; abstract;
    {     .   
      Id, IdGrp, Hash }
    function MoveItemById(Id, NewGrpId : Integer) : boolean;
    {     Id   NewGrpId }

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    property Active: boolean read FActive write SetActive;
    {    TreeView }
    property Results: TsohoDBGridResults read GetResults;
    {      TsohoDBGrid }
    property ItemID: Longint read GetItemId write SetItemId default - 1;
    {    }
    property FixedGrpName: string read FFixedGrpName write FFixedGrpName;
    {    .  ,   TreeView   
       }
    property FixedGrpId: Longint read FFixedGrpId write FFixedGrpId;
    {    .  ,   TreeView   
       }
    property BtnsPanel: TPanel read FBtnsPanel;
    {       CheckBox'  TreeView }
    property ChildCheckBox: TsohoCheckBox read FViewChild;
    {   IncludeSubTree CheckBox' }
    property SelectedGroups : TsohoIntegerList read FFilterGroups;
    {   ,    
       }

  published
{$IFDEF Delphi4_or_5}
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
    property ImeMode;
    property ImeName;
{$ENDIF}
    property Align;
    property Font;
    property Color;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property DragCursor;
    property DragMode;
    property Ctl3D;
    property ParentCtl3D;

    property ByFilter : boolean read FByFilter write FByFilter default true;
    {          }
    property EditOnDblClick: boolean read FEditOnDblClick write FEditOnDblClick default True;
    {  true,     DBGrid    }
    property GroupPreffix: string read FGroupPreffix write FGroupPreffix;
    {      .    
       GetNewId }
    property ItemsPreffix: string read FItemsPreffix write FItemsPreffix;
    {      .    
       GetNewId }
    property Folder: TsohoCustomFolder read FFolder write SetFolder;
    {   TsohoCustomFolder  DBGrid.   Auto  Folder 
        false }
    property IncludeSubTree: boolean read GetIncludeSubTree write SetIncludeSubTree;
    {               }
    property RootName: string read FRootName write SetRootName;
    {     TreeView }
    property GroupsDataSet: TDataSet read FGroupsDS write SetGroupsDataSet;
    { DataSet   }
    property GroupsTable: String read FGroupsTable write SetGroupsTable;
    {      }
    property ItemsTable: String read FItemsTable write FItemsTable;
    {      }
    property ItemsDataSet: TDataSet read FItemsDS write SetItemsDataSet;
    { DataSet   }
    property NameGroupID: string read FIdGrpField write SetNameGrID;
    {  ,   ItemsDataSet      .
         - 'IdGrp'}
    property NameParentID: string read FParentIdField write SetNameParentID;
    {  ,   GroupsDataSet     
         - 'IdParent'}
       property NameGroup: string read FGroupNameField write FGroupNameField;
{ ,       }
    property KeyField: string read FKeyField write SetKeyField;
{     .   = 'Id' }
    property OrderField: string read FOrderField write SetOrderField;
    {  ,          
       }
    property HashField: string read FHashField write SetHashField;
    {  ,      
       .    - "Hash" }
    property Options: TsohoTreeOptions read fOptions write SetOptions;
    {    : , ,     }
    property SaveOptions: TsohoTreeSaveOptions read FSaveOptions write FSaveOptions default[trSaveSplitter];
    {    TreeView    }
    property ItemsName: string read FItemsName write SetItemsName;
    {    -   .     
      :  ,    .      ,
          ,     }
    property GroupsName: string read FGroupsName write SetGroupsName;
    {    -   .     
      :  ,    .      ,
          ,     }
    property ItemsGenderIndex : LongInt read FItemsGenderIndex write FItemsGenderIndex default 1;
    {  ItemsName    ,     , 
           . ,  ItemsName =
      " ",  ItemsGenderIndex    1 }
    property GroupsGenderIndex: LongInt read FGroupsGenderIndex write FGroupsGenderIndex default 1;
    {  GroupsName    ,     , 
           . ,  GroupsName =
      " ",  GroupsGenderIndex    1 }
    property CloseGroups: boolean read FCloseGroups write FCloseGroups default True;
    {     ,       ?
            -   ,  
        ,  CloseGroups    false,  
               GroupsDataSet }
    property DBGrid: TsohoDBGrid read FGrid;
    {   }
    property GroupTreeView: TsohoEnhTreeView read FGroups;
    {   }
    property GroupsVisible: boolean read GetGroupsVisible write SetGroupsVisible;
    {     }
    property ItemsVisible: boolean read GetItemsVisible write SetItemsVisible;
    {      }
    property SaveFile: TIniFileName read FSaveFile write SetSaveFile;
    {  ini-    TreeView.    Folder,
           -folder }

    property OnFilter: TsohoTreeOnFilter read FOnFilter write FOnFilter;
    {      }
    property OnItemDelete: TsohoTreeOnDeleteItem read FOnItemDelete write FOnItemDelete;
    {      }
    property OnGrpDelete: TsohoTreeOnDeleteGroup read FOnGrpDelete write FOnGrpDelete;
    {      }
    property OnNewItem: TsohoTreeOnNewItem read FOnNewItem write FOnNewItem;
    {      }
    property OnNewGrp: TsohoTreeOnNewGroup read FOnNewGrp write FOnNewGrp;
    {     .
        Garik :         
        - ,      OnNewGroup
         FieldsList,ValuesList : TStringList -     
            }
    property OnItemEdit: TsohoTreeOnEditItem read FOnItemEdit write FOnItemEdit;
    {      }
    property OnItemMove: TsohoTreeOnMoveItem read FOnMoveItem write FOnMoveItem;
    {      }
    property OnGrpEdit: TsohoTreeOnEditGroup read FOnGrpEdit write FOnGrpEdit;
    {      }
    property OnCustomEditGrp: TsohoTreeCustomGroup read FOnCustomEditGrp write FOnCustomEditGrp;
    {      ""  ,   ,
           ,     .
         ,  OnGrpEdit   -  
              OnCustomEditGrp }
    property OnCustomNewGrp: TsohoTreeCustomGroup read FOnCustomNewGrp write FOnCustomNewGrp;
    {      ""  ,   ,
           ,     .
         ,  OnNewGrp   -  
              OnCustomEditGrp
        Garik :         
        - ,      OnNewGroup
         FieldsList,ValuesList : TStringList -     
            }
    property AfterGrpDelete: TNotifyEvent read FAfterGrpDelete write FAfterGrpDelete;
    {      }
    property OnGridDblClick: TNotifyEvent read FOnGridDblClick write FOnGridDblClick;
    property OnGridKeyDown: TKeyEvent read FOnGridKeyDown write FOnGridKeyDown;
    property OnGridDragDrop: TDragDropEvent read FOnGridDragDrop write FOnGridDragDrop;
    property OnGridMouseMove: TMouseMoveEvent read FOnGridMouseMove write FOnGridMouseMove;
    property OnGridMouseDown: TMouseEvent read FOnGridMouseDown write FOnGridMouseDown;
    property OnGridDragOver: TDragOverEvent read FOnGridDragOver write FOnGridDragOver;

    property OnGroupsKeyDown: TKeyEvent read FOnGroupsKeyDown write FOnGroupsKeyDown;
    property OnGroupsMouseDown: TMouseEvent read FOnGroupsMouseDown write FOnGroupsMouseDown;
    property OnGroupsMouseMove: TMouseMoveEvent read FOnGroupsMouseMove write FOnGroupsMouseMove;
    property OnGroupsDragOver: TDragOverEvent read FOnGroupsDragOver write FOnGroupsDragOver;
    property OnGroupsDragDrop: TDragDropEvent read FOnGroupsDragDrop write FOnGroupsDragDrop;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;

    property OnGroupSelect: TNotifyEvent read FOnGroupSelect write FOnGroupSelect;
    {       }

    property OnGetCellProps: TGetCellPropsEvent read FOnGetCellsProps write FOnGetCellsProps;
    {    TsohoDBGrid }
    property OnDrawDataCell: TDrawDataCellEvent read FOnDrawCells write FOnDrawCells;
    {    TsohoDBGrid }

    property OnPopupMenuCreate: TsohoTreeOnPopupCreate read FOnPopupMenuCreate write FOnPopupMenuCreate;
    {     PopupMenu   }
    property OnBtnPopupMenuCreate: TsohoTreeOnPopupCreate read FOnBtnPopupMenuCreate write FOnBtnPopupMenuCreate;
    {             }
    property OnActivate : TNotifyEvent read FOnActivate write FOnActivate;
    {      }
    property OnGetItems: TsohoTreeOnGetItems read FOnGetItems write FOnGetItems;
    {       .   
      -      ,  
         .      ByFilter = false }
    property OnException: TsohoTreeOnException read FOnException write FOnException;
    {      .  ,
            TsohoCustomTreeView, 
         }
{$IFDEF Delphi5}
    property OnContextPopup;
{$ENDIF}
{$IFDEF Delphi4_or_5}
    property OnEndDock;
    property OnStartDock;
{$ENDIF}
  end;

function SohoTreeNode(GroupName: string; GroupId: Longint): TsohoTreeNode;
{    }

const

  actDelGroup       = 0;
  {  .    TreeViewButtonsClick  TsohoCustomTreeView }
  actNewGroup       = 1;
  {  .    TreeViewButtonsClick  TsohoCustomTreeView }
  actEditGroup      = 2;
  {  .    TreeViewButtonsClick  TsohoCustomTreeView }
  actDelItem        = 3;
  {  .    TreeViewButtonsClick  TsohoCustomTreeView }
  actNewItem        = 4;
  {  .    TreeViewButtonsClick  TsohoCustomTreeView }
  actEditItem       = 5;
  {  .    TreeViewButtonsClick  TsohoCustomTreeView }
  actRefresh        = 6;
  {  .    TreeViewButtonsClick  TsohoCustomTreeView }
  actReNumber       = 7;
  {  .    TreeViewButtonsClick  TsohoCustomTreeView }

  ButtonsPanelWidth = 60;
  {       }

implementation
uses IniFiles, SoDBRtn, SoUnit, SoVCLUtils, SohoWrds, SoCtmRgs,
     SoDBCns, Dialogs, SoStrUtils, SoAppUtils
     {$IFDEF Delphi4_or_5}, ImgList{$ENDIF};

{$R SOHOTREE.R32}

const sohoTreeViewBtnsCaptions: array[actDelGroup..actReNumber] of TCaption = (
    sohoTreeBtnDeleteGroup, sohoTreeBtnCreateGroup, sohoTreeBtnEditGroup,
    sohoTreeBtnDeleteItem, sohoTreeBtnCreateItem, sohoTreeBtnEditItem,
    sohoTreeBtnRefresh, sohoTreeBtnRenumber);

var
  TVImages: TImageList;

function SohoTreeNode(GroupName: string; GroupId: Longint): TsohoTreeNode;
begin
  Result.GroupName := GroupName;
  Result.GroupId := GroupId;
end;

{ TsohoCustomTreeView }
function  TsohoCustomTreeView.HandleExceptions(E: Exception): boolean;
begin
  Result := false;
  if Assigned(FOnException) then Result := FOnException(Self, E);
end;

procedure TsohoCustomTreeView.BeforeActivate;
begin
  // Nothing to do;
end;

procedure TsohoCustomTreeView.InternalRefreshFilter;
begin
  if Assigned(FFolder) then RefreshFolderWithId(FFolder, FKeyField)
  else RefreshDataSet(FItemsDS);
end;

procedure TsohoCustomTreeView.SetKeyField (Value : string);
begin
  if FKeyField = Value then exit;
  FKeyField := Value;
  FGrid.KeyField := Value;
  FGrid.Update;
end;

function TsohoCustomTreeView.LocateOnGroup: boolean;
begin
  Result := False;
  if not FGroupsDS.Active then exit;
  Result := LocaleById(FGroupsDS, FKeyField,
    GetIdByNode(FGroups.Selected));
end;

function TsohoCustomTreeView.GetResults: TsohoDBGridResults;
begin
  if FGrid = nil then Result := nil
  else Result := FGrid.Results;
end;

procedure TsohoCustomTreeView.RefreshItems;
begin
  InternalRefreshFilter;
end;

procedure TsohoCustomTreeView.Changed;
begin
  if Assigned(FOnChange) then FOnChange(Self);
end;

procedure TsohoCustomTreeView.WriteGrid(Stream: TStream);
begin
  Stream.WriteComponent(FGrid);
end;

procedure TsohoCustomTreeView.WriteTreeView;
begin
  Stream.WriteComponent(FGroups);
end;

procedure TsohoCustomTreeView.ReadGrid(Stream: TStream);
begin
  Stream.ReadComponent(FGrid);
end;

procedure TsohoCustomTreeView.ReadTreeView(Stream: TStream);
begin
  FGroups.Parent := FTreeViewPanel;
  FParSet := True;
  Stream.ReadComponent(FGroups);
end;

procedure TsohoCustomTreeView.SetSaveFile;
begin
  if FSaveFile = Value then exit;
  FSaveFile := Value;
end;

procedure TsohoCustomTreeView.RefreshTreeView;
begin
  TreeViewButtonsClick(actRefresh);
end;

procedure TsohoCustomTreeView.CreateWnd;
begin
  inherited;
  if Assigned(Parent) then begin
    //      ?
    FGroups.Parent := FTreeViewPanel;
    FGrid.Parent := FGridPanel;
  end;
end;

procedure TsohoCustomTreeView.CreateMenu;
var Index: LongInt;
    MnuItem: TMenuItem;
begin
  if PopupMenu <> nil then begin
    if Assigned(FOnPopupMenuCreate) then FOnPopupMenuCreate(Self, FPopMenu);
    FPopMenu.Items.Add(NewItem('-', 0, False, True, nil, 0, ''));
    for index := 0 to pred(PopupMenu.Items.Count) do begin
      MnuItem := PopupMenu.Items[0];
      PopupMenu.Items.Delete(0);
      FPopMenu.Items.Add(MnuItem);
    end;
    FOnPopup := PopupMenu.OnPopup;
  end;
end;

procedure TsohoCustomTreeView.Loaded;
begin
  inherited Loaded;
  if not (csDesigning in ComponentState) then CreateMenu;
  if (FFolder <> nil) and not (csDesigning in ComponentState) then begin
    FOnSaveFolder := FFolder.OnSaveDataSet;
    FOnLoadFolder := FFolder.OnLoadDataSet;
    FFolder.OnSaveDataSet := FolderSave;
    FFolder.OnLoadDataSet := FolderLoad;
  end;
end;

procedure TsohoCustomTreeView.FolderSave(Sender: TObject; DataSet: TDataSet);
begin
  SaveTreeViewState;
  if Assigned(FOnSaveFolder) then FOnSaveFolder(FFolder, FItemsDS);
end;

procedure TsohoCustomTreeView.FolderLoad(Sender: TObject; DataSet: TDataSet);
begin
  LoadTreeViewState;
  if Assigned(FOnLoadFolder) then FOnLoadFolder(FFolder, FItemsDS);
end;

procedure TsohoCustomTreeView.SetFolder(Value: TsohoCustomFolder);
begin
  if FFolder = Value then exit;
  {    , ,     }
  if (FFolder <> nil) and not (csDesigning in ComponentState) then begin
    FFolder.OnSaveDataSet := FOnSaveFolder;
    FFolder.OnLoadDataSet := FOnLoadFolder;
  end;
  FFolder := Value;
end;

procedure TsohoCustomTreeView.DefineProperties(Filer: TFiler);
begin
  inherited DefineProperties(Filer);
  Filer.DefineBinaryProperty('FGrid', ReadGrid, WriteGrid, FGrid <> nil);
  Filer.DefineBinaryProperty('FGroups', ReadTreeView, WriteTreeView, FGroups <> nil);
end;

procedure TsohoCustomTreeView.SetGroupsVisible(Show: boolean);
begin
  FTreeViewPanel.Visible := Show;
  if not Show then
    fOptions := fOptions - [trEditItem, trAddItem, trDeleteItem];
  UpdateBtnMenus;
end;

procedure TsohoCustomTreeView.SetItemsVisible(Show: boolean);
begin
  FGridPanel.Visible := Show;
  if not Show then
    fOptions := fOptions - [trEditGroup, trAddGroup, trDeleteGroup];
  UpdateBtnMenus;
end;

function TsohoCustomTreeView.GetGroupsVisible;
begin
  Result := FTreeViewPanel.Visible;
end;

function TsohoCustomTreeView.GetItemsVisible;
begin
  Result := FGridPanel.Visible;
end;

function TsohoCustomTreeView.GetIncludeSubTree: boolean;
begin
  Result := FViewChild.Checked;
end;

procedure TsohoCustomTreeView.SetIncludeSubTree(Value: boolean);
begin
  if FViewChild.Checked = Value then exit;
  FViewChild.Checked := Value;
end;

function TsohoCustomTreeView.GetNodeByName(const Name: string): TTreeNode;
begin
  Result := nil;
  if FGroups.Items[0].Count = 0 then exit;
  Result := FGroups.Items[0];
  while Result <> nil do begin
    if Result.Text = Name then exit;
    Result := Result.GetNext;
  end;
end;

function TsohoCustomTreeView.GetHash(Left, Right: Longint): Longint;
begin
  Result := Left div 2 + Right div 2;
end;

function TsohoCustomTreeView.GetIdByNode(Node: TTreeNode): LongInt;
var Leaf: PTreeLeaf;
begin
  Leaf := GetLeafRecord(Node);
  if not Assigned(Leaf) then Result := 0
  else Result := Leaf^.ItemID;
end;

function TsohoCustomTreeView.GetLeafRecord(Node: TTreeNode): PTreeLeaf;
begin
  Result := nil;
  if Node = nil then exit;
  if Node = FGroups.Items[0] then exit
  else Result := PTreeLeaf(Node.Data);
end;

function TsohoCustomTreeView.GetNodeByID(ItemID: Longint): TTreeNode;
begin
  Result := nil;
  if FGroups.Items[0].Count = 0 then exit;
  Result := FGroups.Items[0];
  while Result <> nil do begin
    if PTreeLeaf(Result.Data)^.ItemId = ItemId then exit;
    Result := Result.GetNext;
  end;
end;

function TsohoCustomTreeView.AddTreeItem(Node: TTreeNode;
  ItemID, ParentId, ItemHash: Longint; ItemName: string): boolean;
var NewLeaf: PTreeLeaf;
    NewNode: TTreeNode;
begin
  Result := False;
  try
    New(NewLeaf);
  except
    on E: Exception do begin
      HandleExceptions(E);
      exit;
    end;
  end;
  NewLeaf^.ItemID := ItemID;
  NewLeaf^.ParentId := ParentId;
  NewLeaf^.ItemHash := ItemHash;
  try
    NewNode := FGroups.Items.AddChildObject(Node, ItemName, NewLeaf);
    NewNode.ImageIndex := 0;
    NewNode.SelectedIndex := 1;
  except
    on E: Exception do begin
      if HandleExceptions(E) then exit;
      ErrorMsg(Format(sohoTreeNotMemory, [Name]));
      exit;
    end;
  end;
  Result := True;
end;


function TsohoCustomTreeView.AddGroup: boolean;
var NewName: string;
  F1, F2, F3, NewC: string;
begin
  {         }
  Result := False;
  if not (trAddGroup in fOptions) then exit;
  NewName := '';
  {   ,  -      ,
            }
  if not Assigned(FOnCustomNewGrp) then begin
    WordToWordForm(FGroupsName, F1, F2, F3, FGroupsGenderIndex);
    if WordGender(F1, FGroupsGenderIndex) = gnFemale then NewC := sohoTreeNewFeMaleGroup
    else NewC := sohoTreeNewMaleGroup;
    repeat
      if not InputQuery(NewC + F1, sohoTreeGroupName + F3, NewName) then exit;
      if NewName = '' then exit;
      NewName := ChangeChars(NewName, '"', '''');
    until GetNodeByName(NewName) = nil;
    {         }
  end;
  Result := QuietAddGroup(NewName);
end;

function TsohoCustomTreeView.EditGroup: boolean;
var NewName: string;
  F1, F2, F3        : string;
  CurNode, NowNode: TTreeNode;
begin
  {   }
  Result := False;
  if not (trEditGroup in fOptions) then exit;
  with FGroups do begin
    CurNode := Selected;
    NewName := CurNode.Text;
  end;
  if CurNode = FGroups.Items[0] then exit;
  if not Assigned(FOnCustomEditGrp) then begin
    WordToWordForm(FGroupsName, F1, F2, F3, FGroupsGenderIndex);
    repeat
      if not InputQuery(sohoTreeGroupNameChange + F3, sohoTreeGroupName + F3, NewName) then exit;
      if NewName = '' then exit;
      NewName := ChangeChars(NewName, '"', '''');
      NowNode := GetNodeByName(NewName);
      if CurNode = NowNode then exit;
    until NowNode = nil;
  end;
  Result := QuietEditGroup(NewName);
end;


function TsohoCustomTreeView.GetNewGroupIdPreffix: string;
begin
  if FGroupPreffix <> '' then Result := FGroupPreffix
  else Result := Owner.name + '.' + name + '.Group';
end;

function TsohoCustomTreeView.GetNewItemIdPreffix: string;
begin
  if FItemsPreffix <> '' then Result := FItemsPreffix
  else Result := Owner.name + '.' + name + '.Items';
end;

function TsohoCustomTreeView.AddItem: boolean;
var NewId, GrpId: Longint;
  NewHash: Longint;
begin
  Result := False;
  if not (trAddItem in fOptions) then exit;
  {         }
  NewId := SoUnit.GetNewId(GetNewItemIdPreffix);
  GrpId := GetIdByNode(FGroups.Selected);
  {    }
  NewHash := GetNewItemHash(GrpId);
  if Assigned(FOnNewItem) then FOnNewItem(Self, GrpId, NewId, NewHash, Result);
  {      AddNewItem(IDGrp,IDItem, ItemHash) }
  if Result then begin
    RefreshItems;
    Changed;
  end;
end;

function TsohoCustomTreeView.EditItem: boolean;
var BkMark: TBookmark;
begin
  Result := False;
  BkMark := FItemsDS.GetBookmark;
  if not (trEditItem in fOptions) then exit;
  if FItemsDS.FieldByName(FKeyField).IsNull then Result := AddItem
  else
    if Assigned(FOnItemEdit) then
      FOnItemEdit(Self, GetIdByNode(FGroups.Selected),
      FItemsDS.FieldByName(FKeyField).AsInteger, Result);
  if Result then begin
    RefreshItems;
    FItemsDS.GotoBookmark(BkMark);
    Changed;
  end;
  FItemsDS.FreeBookmark(BkMark);
end;

function TsohoCustomTreeView.CreateGroupsTree: boolean;

  function GetParentNode(ParentId: Longint): TTreeNode;
  begin
    Result := FGroups.Items[0];
    while Result <> nil do begin
      if PTreeLeaf(Result.Data)^.ItemID = ParentId then exit;
      Result := Result.GetNext;
    end;
  end;

var
  ItemID, ParentId, ItemHash  : Longint;
  ItemName                    : string;
  DoAddItem                   : boolean;
  Ids                         : TsohoDBGridResults;
  Leaf                        : PTreeLeaf;
  LastNode, Node: TTreeNode;

begin
  Result := False;
  if FGroups = nil then begin
    ErrorMsg(Format(sohoTreeGetNilInsteadOutLine, [name]));
    exit;
  end;

  FGroups.Items.BeginUpdate;
  ClearTreeView;

  with FGroupsDS do begin
    if not Active then
      try
        Open;
      except
        on E: Exception do begin
          if HandleExceptions(E) then exit;
          ErrorMsg(Format(sohoTreeCantOpenGroupsTable, [Name]));
          FGroups.Items.EndUpdate;
          exit;
        end;
      end;
    {  }
    if not AddTreeItem(nil, 0, 0, 0, FRootName) then exit;
    {      }
    Ids := TsohoDBGridResults.Create;

    if FFixedGrpName <> '' then
      TreeViewGetGroupsIds(FFixedGrpName, FGroupsTable, Ids);

    First;
    while not EOF do begin
      ItemID    := FieldByName(FKeyField).AsInteger;
      ParentId  := FieldByName(FParentIdField).AsInteger;
      ItemHash  := FieldByName(FHashField).AsInteger;
      ItemName  := FieldByName('Name').AsString;
      DoAddItem := (ItemID <> 0) and
                   ((ItemID = FFixedGrpId) or (FFixedGrpId = -1)) and
                   ((Ids.IndexOf(ItemID) <> -1) or (FFixedGrpName = ''));

      if DoAddItem then
        AddTreeItem(FGroups.Items[0], ItemID, ParentId, ItemHash, ItemName);
      Next;
    end;
    Ids.Free;
    if FCloseGroups then Close;
  end;
  //    
  LastNode := FGroups.Items[0];
  while LastNode.GetNext <> nil do LastNode := LastNode.GetNext;

  Node := FGroups.Items[0];
  while Node <> nil do begin
    Node := Node.GetNext;
    Leaf := GetLeafRecord(Node);
    if not Assigned(Leaf) then Continue;
    if Leaf^.ParentId = Leaf^.ItemId then Leaf^.ParentId := 0;
    if Node.Level = 1 then begin
      Node.MoveTo(
      GetParentNode(Leaf^.ParentId), naAddChild);
      if Node = LastNode then break;
      Node := FGroups.Items[0];
    end;
  end;
  FGroups.Items.EndUpdate;
  FGroups.Selected := FGroups.Items[0];
  FGroups.Selected.Expand(true);
  GroupSelected(FGroups);
  Result := True;
end;


procedure TsohoCustomTreeView.Notification(AComponent: TComponent; Operation: TOperation);
begin
  if (AComponent = FGroupsDS) and (Operation = opRemove) then begin
    Active := False;
    FGroupsDS := nil;
  end;
  if (AComponent = FItemsDS) and (Operation = opRemove) then begin
    Active := False;
    FItemsDS := nil;
  end;
  if (AComponent = FFolder) and (Operation = opRemove) then
    FFolder := nil;
end;

procedure TsohoCustomTreeView.SetGroupsTable;
begin
  FGroupsTable := Value;
end;

procedure TsohoCustomTreeView.SetTreeViewWidth(Value: Integer);
begin
  FTreeViewPanel.Width := Value;
end;

procedure TsohoCustomTreeView.LoadTreeViewState;
var FIniFile: TFileName;
begin
  if csDesigning in ComponentState then exit;
  FIniFile := FSaveFile;
  if (FIniFile = '') and (FFolder <> nil) then FIniFile := FFolder.FullFolderName;
  if FIniFile = '' then exit;
  with TIniFile.Create(FIniFile) do begin
    if trSaveSplitter in FSaveOptions then begin
      FTreeViewPanel.Width := ReadInteger(Owner.ClassName + name + 'Splitter',
      'Width', FTreeViewPanel.Width);
      FSplitter.IsPacked := ReadBool(Owner.ClassName + name + 'Splitter',
          'IsPacked', FSplitter.IsPacked);
      FSplitter.UnPackWidth := ReadInteger(Owner.ClassName + name + 'Splitter',
          'UnpackedWidth', FSplitter.UnPackWidth);
    end;
    if trSaveViewChild in FSaveOptions then
      FViewChild.Checked := ReadBool(Owner.ClassName + name + 'ViewChild',
      'View', False);
    Free;
  end;
  (*
  try
    if trSaveTreeView in FSaveOptions then
      ApplyTreeViewDescription(FGroups, FIniFile);
  except {     }
  end; *)
end;

procedure TsohoCustomTreeView.SaveTreeViewState;
var FIniFile: TFileName;
begin
  if csDesigning in ComponentState then exit;
  FIniFile := FSaveFile;
  if (FIniFile = '') and (FFolder <> nil) then FIniFile := FFolder.FullFolderName;
  if FIniFile = '' then exit;
  with TIniFile.Create(FIniFile) do begin
    if trSaveSplitter in FSaveOptions then begin
      WriteInteger(Owner.ClassName + name + 'Splitter', 'Width', FTreeViewPanel.Width);
      WriteBool(Owner.ClassName + name + 'Splitter',
          'IsPacked', FSplitter.IsPacked);
      WriteInteger(Owner.ClassName + name + 'Splitter',
          'UnpackedWidth', FSplitter.UnPackWidth);
    end;
    if trSaveViewChild in FSaveOptions then
      WriteBool(Owner.ClassName + name + 'ViewChild', 'View', FViewChild.Checked);
    Free;
    (*
    if trSaveTreeView in FSaveOptions then
      SaveTreeViewDescription(FGroups, FIniFile);
    *)  
  end;
end;

procedure TsohoCustomTreeView.SetActive(Value: boolean);

  procedure RestoreDataSets;
  begin
    if FOldGrp then FGroupsDS.Open
    else FGroupsDS.Close;
    if FOldItm then FItemsDS.Open
    else FItemsDS.Close;
  end;

begin
  if (FActive = Value) then exit;
  if (FGroupsDS = nil) or (FItemsDS = nil) or
    (FIdGrpField = '') or (FGroupsTable = '') then begin
    ErrorMsg(Format(sohoTreeCantActivateTreeView, [name]));
    exit;
  end;
  if not Value then begin
    if FFolder <> nil then begin
      FFolder.SaveDataSet;
      FFolder.SaveDBGridColumns;
      FFolder.Deactivate;
      FFolder.RestoreEvents;
      FFolder.Grid := nil;
    end;
    {      Popup}
    FGrid.PopupMenu.OnPopup := OnMenuPopup;
    RestoreDataSets;
    FActive := Value;
    if FGroups <> nil then FGroups.Items.Clear;
    FItemsDS.OnFilterRecord := FOnDSFilter;
    exit;
  end;
  BeforeActivate;
  PushCursor(crHourGlass);
  FOldGrp := FGroupsDS.Active;
  FOldItm := FItemsDS.Active;
  try
    if not FGroupsDS.Active then FGroupsDS.Open;
    Screen.Cursor := crHourGlass;
    if not FItemsDS.Active then begin
      if not FByFilter then
         if Assigned(FOnGetItems) then FOnGetItems(Self, 0)
         else raise Exception.Create(Format(sohoCtmTreNoOnGetItems, [Name]))
      else FItemsDS.Open;
    end;
    Screen.Cursor := crHourGlass;
    {Check fields}
    with FGroupsDS do
      if (FindField(FKeyField) = nil) or
        (FindField(FParentIdField) = nil) or
        (FindField('Name') = nil) or
        (FindField(FHashField) = nil)
        then begin
        ErrorMsg(Format(sohoTreeMustExistGrpFields, [Name, KeyField, FParentIdField, FHashField]));
        RestoreDataSets;
        exit;
      end;

    with FItemsDS do begin
      if (FindField(FKeyField) = nil) or
        (FindField(FIdGrpField) = nil) or
        (FindField(FHashField) = nil) then begin
        ErrorMsg(Format(sohoTreeMustExistItmFields, [Name, KeyField, FIdGrpField, FHashField]));
        RestoreDataSets;
        exit;
      end;
    end;

    with FGroups do begin
      Align := alClient;
      PopupMenu := FGroupMenu;
    end;

    with FGrid do Parent := FGridPanel;


    CreateGroupsTree;

    FOnDSFilter := FItemsDS.OnFilterRecord;
    FItemsDS.OnFilterRecord := CheckFilter;

    FGrid.DataSource := FSource;
    FSource.DataSet := FItemsDS;
    FActive := Value;
    if FFolder <> nil then begin
      FFolder.KeyField := FKeyField;
      FFolder.Grid := FGrid;
      FFolder.Activate;
      FFolder.LoadDBGridColumns;
    end;
    FGrid.PopupMenu := FPopMenu;
    if Assigned(FOnActivate) then FOnActivate(Self);
    RestoreCursor;
  except
    on E: Exception do begin
      if not HandleExceptions(E) then
        ErrorMsg(Format(sohoTreeDataSetsActivateError, [name]));
    end
  end;
end;

procedure TsohoCustomTreeView.SetGroupsDataSet(Value: TDataSet);
begin
  if FGroupsDS = Value then exit;
  Active := False;
  FGroupsDS := Value;
end;

procedure TsohoCustomTreeView.SetItemsDataSet(Value: TDataSet);
begin
  if FItemsDS = Value then exit;
  Active := False;
  FItemsDS := Value;
end;

procedure TsohoCustomTreeView.SetOrderField(Value: string);
begin
  if FOrderField = Value then exit;
  Active := False;
  FOrderField := Value;
end;

procedure TsohoCustomTreeView.SetHashField(Value: string);
begin
  if FHashField = Value then exit;
  Active := False;
  FHashField := Value;
end;

procedure TsohoCustomTreeView.SetNameGrID(Value: string);
begin
  if FIdGrpField = Value then exit;
  Active := False;
  FIdGrpField := Value;
end;

procedure TsohoCustomTreeView.SetNameParentID(Value: string);
begin
  if FParentIdField = Value then exit;
  Active := False;
  FParentIdField := Value;
end;

procedure TsohoCustomTreeView.SetOptions(Value: TsohoTreeOptions);
begin
  if fOptions = Value then exit;
  fOptions := Value;
  FGroups.ReadOnly := trEditGroup in fOptions;
  UpdateBtnMenus;
end;

procedure TsohoCustomTreeView.SetGroupsName(Value: string);
begin
  if FGroupsName = Value then exit;
  FGroupsName := Value;
  UpdateBtnMenus;
end;

procedure TsohoCustomTreeView.SetItemsName(Value: string);
begin
  if FItemsName = Value then exit;
  FItemsName := Value;
  UpdateBtnMenus;
end;

procedure TsohoCustomTreeView.UpdateBtnMenus;
var index: Integer;
    F1, F2, F3: string;
    GroupsActive, ItemsActive : boolean;
begin
  if csDestroying in ComponentState then exit;
  GroupsActive := FGroups.Items.Count > 0;
  ItemsActive := (FItemsDS<>nil) and (FItemsDS.Active);
  for Index := actDelGroup to actReNumber do
    with FBtnMenu.Items[index] do begin
      Caption := sohoTreeViewBtnsCaptions[index];
      if (Index < 3) then WordToWordForm(FGroupsName, F1, F2, F3, FGroupsGenderIndex)
      else WordToWordForm(FItemsName, F1, F2, F3, FItemsGenderIndex);
      if Index <= actEditItem then Caption := Caption + ' ' + F2;
      if Index <= actReNumber then Enabled := TsohoTreeOption(index) in fOptions;
      if Index < 3 then Enabled := Enabled and GroupsActive
      else
        if Index < actReNumber then Enabled := Enabled and ItemsActive;
    end;
  //     ""
  FBtnMenu.Items[actReNumber].Enabled := FBtnMenu.Items[actReNumber].Enabled
    and ItemsActive and (FOrderField<>'')
    and (FItemsDS.FindField(FOrderField) <> nil);
  if Assigned(FOnBtnPopupMenuCreate) then FOnBtnPopupMenuCreate(Self, FBtnMenu);
end;

function TsohoCustomTreeView.GetItemId: Longint;
begin
  Result := -1;
  if (FItemsDS = nil) or (not FItemsDS.Active) then exit;
  Result := FItemsDS.FieldByName(FKeyField).AsInteger;
end;

procedure TsohoCustomTreeView.SetItemId(Value: Longint);
var CurItem: Longint;
  ID: Longint;
  CurNode: TTreeNode;
begin
  if (FItemsDS = nil) or (not FItemsDS.Active) then begin
    ErrorMsg(Format(sohoTreeCantSetItemId, [name]));
    exit;
  end;
  if Value < 0 then exit;
  {     ! }
  CurNode := FGroups.Selected;
  with FItemsDS do begin
    CurItem := FieldByName(FKeyField).AsInteger;
    DisableControls;
    PushCursor(crHourGlass);
    while CurNode <> nil do begin
      FGroups.Selected := CurNode;
      First;
      while not EOF do begin
        ID := FieldByName(FKeyField).AsInteger;
        if ID = Value then begin
          FGroups.Selected :=
            GetNodeByID(FieldByName(FIdGrpField).AsInteger);
          EnableControls;
          RestoreCursor;
          exit;
        end;
        Next;
      end;
    end;
    FGroups.Selected := CurNode;
    First;
    while not EOF and not (CurItem = FieldByName(FKeyField).AsInteger) do Next;
    EnableControls;
    RestoreCursor;
  end;
end;

procedure TsohoCustomTreeView.ViewChildClick(Sender: TObject);
begin
  if FActive then GroupSelected(Sender);
end;

procedure TsohoCustomTreeView.CreateBtnMenus;
var index: Longint;
  Item: TMenuItem;
begin
  for index := actDelGroup to actReNumber do begin
    Item := NewItem(sohoTreeViewBtnsCaptions[index], 0, False, True, ButtonMenuClick, 0, '');
    Item.Tag := index;
    FBtnMenu.Items.Add(Item);
  end;
end;

constructor TsohoCustomTreeView.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ShowHint := true;
  fOptions := [trDeleteGroup, trAddGroup, trEditGroup, trDeleteItem,
    trAddItem, trEditItem, trRefresh, trReNumber,
    trMoveItem, trMoveGroup];
  FSaveOptions := [trSaveSplitter];
  FEditOnDblClick := True;
  FGroupsDS := nil;
  FItemsDS := nil;
  FFolder := nil;
  FActive := False;
  FIdGrpField := 'IDGrp';
  FOrderField := 'NumOrder';
  FHashField := 'Hash';
  FParentIdField := 'IdParent';
  FGroupNameField := 'Name';
  FKeyField := 'Id';
  FItemsName := sohoTreeDefItemName;
  FGroupsName := sohoTreeDefGroupName;
  FGroupsGenderIndex := 1;
  FItemsGenderIndex := 1;
  Font.name := 'Ms Sans Serif';
  Font.Size := 8;
  FFixedGrpId := -1;
  FFixedGrpName := '';
  FItemsPreffix := '';
  FGroupPreffix := '';
  FCloseGroups := True;
  FByFilter := true;
  FFilterGroups := TsohoIntegerList.Create;

  { Create visible controls }
  Width := 400;
  Height := 200;

  FBtnsPanel := TPanel.Create(Self);
  with FBtnsPanel do begin
    Parent := Self;
    Width := ButtonsPanelWidth;
    Align := alLeft;
    BevelOuter := bvNone;
    BevelInner := bvNone;
    ParentColor := True;
    ParentFont := True;
  end;

  FComPanel := TPanel.Create(Self);
  with FComPanel do begin
    Parent := Self;
    Align := alClient;
    BevelOuter := bvNone;
    BevelInner := bvNone;
    ParentColor := True;
    ParentFont := True;
    ParentShowHint := true;
  end;

  FTreeViewPanel := TPanel.Create(Self);
  with FTreeViewPanel do begin
    Parent := FComPanel;
    Width := 100;
    Align := alLeft;
    BevelOuter := bvNone;
    BevelInner := bvNone;
    ParentColor := True;
    ParentFont := True;
    ParentShowHint := true;
  end;

  FSplitter := TsohoSplitter.Create(Self);
  with FSplitter do begin
    Parent := FComPanel;
    Left := FTreeViewPanel.Left + FTreeViewPanel.Width + 2;
    Align := alLeft;
  end;
  SetComponentState(FSplitter, []); 

  FGridPanel := TPanel.Create(Self);
  with FGridPanel do begin
    Parent := FComPanel;
    Align := alClient;
    BevelOuter := bvNone;
    BevelInner := bvNone;
    Caption := sohoTreeNoRecords;
    ParentColor := True;
    ParentFont := True;
    ParentShowHint := true;
  end;

  FGrid := TsohoDBGrid.Create(Self);
  with FGrid do begin
    Align := alClient;
    Options := [dgTitles, dgIndicator, dgColumnResize, dgColLines,
      dgRowLines, dgTabs, dgAlwaysShowSelection, dgCancelOnExit];
    ReadOnly := true;
    SmashColumn := true;
    OnGetCellProps := GridGetCellProps;
    OnDrawDataCell := GridDataCell;
    OnDblClick := GridDblClick;
    OnKeyDown := GridKeyDown;
    OnDragDrop := ItemsGridDragDrop;
    OnMouseMove := ItemsGridMouseMove;
    OnMouseDown := ItemsGridMouseDown;
    OnDragOver := ItemsGridDragOver;
    ParentFont := True;
    ParentShowHint := true;
  end;

  FBtnMenu := TPopupMenu.Create(Self);
  FBtnMenu.OnPopup := OnBtnMenuPopup;
  CreateBtnMenus;

  FMenuBtn := TsohoBitBtn.Create(Self);
  with FMenuBtn do begin
    Parent := FBtnsPanel;
    DropDownMenu := FBtnMenu;
    Width := ButtonsPanelWidth - 4;
    Left := 2;
    Top := 2;
    Hint := sohoTreeItemsOperations;
    Glyph.Handle := ResBitmap('SOHOTVMENUBTN');
    Cursor := crHandPoint;
  end;

  FViewChild := TsohoCheckBox.Create(Self);
  with FViewChild do begin
    Parent := FBtnsPanel;
    Hint := sohoTreeShowChilds;
    Checked := False;
    OnClick := ViewChildClick;
    Top := FMenuBtn.Top + FMenuBtn.Height + 4;
    Left := 2;
    Caption := sohoTreeChildsCaption;
    Cursor := crHandPoint;
  end;

  FEnabledItem := NewItem(sohoTreeSelectItem, 0, False, True, MenuItemClick, 0, '');
  FEnabledItem.Tag := -1;
  FDisabledItem := NewItem(sohoTreeUnselectItem, 0, False, True, MenuItemClick, 0, '');
  FDisabledItem.Tag := -1;
  FPopMenu := NewPopupMenu(Self, '', paLeft, True,[FEnabledItem, FDisabledItem]);
  FPopMenu.OnPopup := OnMenuPopup;

  FGrpSelItem := NewItem(sohoTreeSelectItem, 0, False, True, MenuItemClick, 0, '');
  FGrpDeselItem := NewItem(sohoTreeUnselectItem, 0, False, True, MenuItemClick, 0, '');
  FGroupMenu := NewPopupMenu(Self, '', paLeft, True,[FGrpSelItem, FGrpDeselItem]);
  FGroupMenu.OnPopup := OnMenuPopup;

  FGroups := TsohoSpecEnhTreeView.Create(Self);
  with FGroups do begin
    Name := Self.name + 'TreeView';
    Align := alClient;
    PopupMenu := FGroupMenu;
    Images := TVImages;
    HideSelection := false;
    OnGetImageIndex := GetTreeViewImageIndex;
    OnEditing := AllowEditNode;
    OnEdited := DoEditNode;
    OnMouseDown := GroupsMouseDown;
    OnMouseMove := GroupsMouseMove;
    OnDragOver := GroupsDragOver;
    OnDragDrop := GroupsDragDrop;
    ParentShowHint := true;
  end;

  FParSet := False;

  FGrid.PopupMenu := FPopMenu;

  FSource := TDataSource.Create(Self);
  FRootName := '';
  FGrid.DataSource := FSource;

  with FMoveItem do begin
    ID := -1;
    OldGrpId := -1;
    NewGrpId := -1;
    NewHash := -1;
    {Fields for drag&drop}
    ItemDragBegin := False;
    DragOverId := -1;
    GridDrag := False;
    GridRow := -1;
  end;
  with FMoveGroup do begin
    GrpDragSourceRow := nil;
  end;

end;

procedure TsohoCustomTreeView.SetRootName;
begin
  FRootName := Value;
  if (csLoading in ComponentState) or
     (FGroups.Parent = nil) then exit;
  if FGroups.Items.Count <> 0 then FGroups.Items[0].Text := Value
  else AddTreeItem(nil, 0, 0, 0, Value);
end;


procedure TsohoCustomTreeView.TreeViewButtonsClick(ButtonIndex: Longint);
var Res: boolean;
  FIniFile: TFileName;
begin
  Res := False;
  case ButtonIndex of
    actDelGroup: Res := DeleteGroup; { }
    actNewGroup: Res := AddGroup; { }
    actEditGroup: EditGroup; { }
    actDelItem: Res := DeleteItem; { item}
    actNewItem: Res := AddItem; { item}
    actEditItem: Res := EditItem; { item}
    actRefresh: begin Res := True; {}
      if trSaveTreeView in FSaveOptions then begin
        FIniFile := FSaveFile;
        if (FIniFile = '') and (FFolder <> nil) then
          FIniFile := FFolder.FullFolderName;
        // SaveTreeViewDescription(FGroups, FIniFile);
      end;
      Active := False;
      Active := True;
      {
      try
        if trSaveTreeView in FSaveOptions then
          ApplyTreeViewDescription(FGroups, FIniFile);
      except
      end;}
    end;
    actReNumber: Res := RenumberRecords; {}
  end;
  if Res then GroupSelected(FGroups);
end;

procedure TsohoCustomTreeView.ButtonMenuClick(Sender: TObject);
var index: Integer;
begin
  index := (Sender as TMenuItem).Tag;
  if (index >= actDelGroup) and (index <= actReNumber) then TreeViewButtonsClick(index);
end;

procedure TsohoCustomTreeView.GetFilterGroups;
var
    GrpId : LongInt;
    Node: TTreeNode;
begin
  FFilterGroups.Clear;
  Node := FGroups.Items[0];
  while Node <> nil do begin
    GrpId := GetIdByNode(Node);
    if InGroup(Node, GrpId) then FFilterGroups.Add(GrpId);
    Node := Node.GetNext;
  end;
end;

function TsohoCustomTreeView.InGroup(Node: TTreeNode;
  FilterGroup: Longint): boolean;
var Index: LongInt;
begin
  Result := GetIdByNode(Node) = FilterGroup;
  if Result then exit;
  if Node.GetLastChild = nil then exit;

  for Index := 0 to pred(Node.Count) do begin
    Result := InGroup(Node.Item[Index], FilterGroup);
    if Result then exit;
  end;
end;

function TsohoCustomTreeView.GetSelectedGroupId : LongInt;
begin
  if Active and (FGroups.Selected <> nil) then
    Result := GetIdByNode(FGroups.Selected)
  else Result := -1;
end;

function TsohoCustomTreeView.GetSelectedGroupName : string;
begin
  if FGroups.Selected <> nil then
    Result := FGroups.Selected.Text
  else Result := '';
end;

procedure TsohoCustomTreeView.CheckFilter(DataSet: TDataSet; var Accept: boolean);
var GrpId, CurId: Longint;
  Allow: boolean;
begin
  if (csDestroying in ComponentState) then exit;
  if not FByFilter then begin
    if Assigned(FOnDSFilter) then FOnDSFilter(DataSet, Accept);
    exit;
  end;
  GrpId := GetIdByNode(FGroups.Selected);
  CurId := DataSet.FieldByName(FIdGrpField).AsInteger;
  if not FViewChild.Checked then Allow := CurId = GrpId
  else Allow := (GrpId = 0) or (CurId = GrpId) or
    InGroup(FGroups.Selected, CurId);
  if Assigned(FOnFilter) then FOnFilter(Self, DataSet, Allow);
  Accept := Allow;
  if Assigned(FOnDSFilter) then FOnDSFilter(DataSet, Accept);
end;

procedure TsohoCustomTreeView.RefreshGroup;
begin
  GroupSelected(FGroups);
end;

procedure TsohoCustomTreeView.GroupSelected(Sender: TObject);
var GrpId : LongInt;
begin
  { Update filter texts }
  if not FByFilter then begin
     GetFilterGroups;
     if FGroups.Selected <> nil then
       GrpId := GetIdByNode(FGroups.Selected)
     else GrpId := 0;
     if Assigned(FOnGetItems) then FOnGetItems(Self, GrpId);
  end
  else RefreshDataSetFilter(FItemsDS);
  FGrid.Visible := FItemsDS.RecordCount > 0;
  if Assigned(FOnGroupSelect) then FOnGroupSelect(Self);
end;

procedure TsohoCustomTreeView.GridDblClick(Sender: TObject);
begin
  if FEditOnDblClick then EditItem;
  if Assigned(FOnGridDblClick) then FOnGridDblClick(Sender);
end;

procedure TsohoCustomTreeView.GridDataCell(Sender: TObject; const Rect: TRect; Field: TField;
    State: TGridDrawState);
begin
  if Assigned(FOnDrawCells) then FOnDrawCells(Sender, Rect, Field, State);
end;

procedure TsohoCustomTreeView.GridGetCellProps(Sender : TObject; Field: TField; AFont: TFont;
              var Background: TColor);
begin
  if Assigned(FOnGetCellsProps) then FOnGetCellsProps(Sender, Field, aFont,
     Background);
end;

procedure TsohoCustomTreeView.GridKeyDown(Sender: TObject; var KEY: Word; Shift: TShiftState);
begin
  if Assigned(FOnGridKeyDown) then FOnGridKeyDown(Sender, KEY, Shift);
  case KEY of
    VK_INSERT: begin
      if Shift = [] then begin
        TreeViewButtonsClick(actNewItem);
        KEY := 0;
      end;
      if (Shift = [ssCtrl]) and (not FMoveItem.ItemDragBegin) then begin
        KEY := 0;
        if not (trMoveItem in fOptions) then exit;
        FMoveItem.ItemDragBegin := True;
        FMoveItem.ID := FItemsDS.FieldByName(FKeyField).AsInteger;
        SetCaptureControl(FGrid);
        PushCursor(crCross);
      end;
      if (Shift = [ssShift]) and FMoveItem.ItemDragBegin then begin
        KEY := 0;
        SetCaptureControl(nil);
        if not (trMoveItem in fOptions) then exit;
        FMoveItem.ItemDragBegin := False;
        with FItemsDS do begin
          FMoveItem.DragOverId := FieldByName(FKeyField).AsInteger;
          FMoveItem.NewGrpId := FieldByName(FIdGrpField).AsInteger;
          RightHash := FieldByName(FHashField).AsInteger;
          Prior;
          if FieldByName(FKeyField).AsInteger = FMoveItem.DragOverId then
            LeftHash := - MaxLongint
          else LeftHash := FieldByName(FHashField).AsInteger;
          FMoveItem.NewHash := GetHash(LeftHash, RightHash);
        end;
        {       Hash,    ID }
        MoveItem;
        {  Resfresh   }
        RefreshItems;
        RestoreCursor;
      end;
    end;
    VK_ESCAPE: if FMoveItem.ItemDragBegin then begin
      SetCaptureControl(nil);
      FMoveItem.ItemDragBegin := False;
      RestoreCursor;
      KEY := $00;
    end;
    VK_RETURN: if Shift = [ssAlt] then TreeViewButtonsClick(actEditItem);
    VK_DELETE: DeleteItem;
  end;
end;

procedure TsohoCustomTreeView.OnBtnMenuPopup (Sender : TObject);
begin
  UpdateBtnMenus;
end;

procedure TsohoCustomTreeView.OnMenuPopup(Sender: TObject);
var index: Longint;

begin
  if (Sender = FEnabledItem) or (Sender = FDisabledItem) then begin
    index := Results.IndexOf(FItemsDS.FieldByName(FKeyField).AsInteger);
    with FPopMenu do begin
      FEnabledItem.Enabled := index = -1;
      FDisabledItem.Enabled := index <> -1;
    end;
  end;
  if (Sender <> FGroupMenu) and Assigned(FOnPopup) then FOnPopup(Sender);
end;

procedure TsohoCustomTreeView.MenuItemClick(Sender: TObject);

  procedure SelectGroup(DoSelect: boolean);
  var OldCheck: boolean;
  begin
    OldCheck := FViewChild.Checked;
    try
      with FItemsDS do begin
        DisableControls;
        FViewChild.Checked := True;
        First;
        while not EOF do begin
          if DoSelect then Results.Add(FItemsDS.FieldByName(FKeyField).AsInteger)
          else Results.Remove(FItemsDS.FieldByName(FKeyField).AsInteger);
          Next;
        end;
      end;
    finally
      FViewChild.Checked := OldCheck;
      FItemsDS.EnableControls;
    end;
  end;
begin
  with Sender as TMenuItem do begin
    if (Sender = FEnabledItem) or (Sender = FDisabledItem) then begin
      if Sender = FEnabledItem then Results.Add(FItemsDS.FieldByName(FKeyField).AsInteger)
      else Results.Remove(FItemsDS.FieldByName(FKeyField).AsInteger);
    end
    else begin
      if (Sender = FGrpSelItem) then { } SelectGroup(True)
      else {   } SelectGroup(False);
    end;
  end;
end;

procedure TsohoCustomTreeView.ClearTreeView;
var Node: TTreeNode;
begin
  if FGroups.Items.Count = 0 then exit;
  Node := FGroups.Items[0];
  while Node <> nil do begin
    if Node.Data <> nil then Dispose(PTreeLeaf(Node.Data));
    Node := Node.GetNext;
  end;
  FGroups.Items.Clear;
end;

destructor TsohoCustomTreeView.Destroy;
begin
  {     }
  if Assigned(FFolder) then FFolder.DeActivate;
  FBtnMenu.Free;
  FMenuBtn.Free;
  FViewChild.Free;
  FBtnsPanel.Free;
  ClearTreeView;
  FGroups.Free;
  FTreeViewPanel.Free;
  FGrid.Free;
  FGridPanel.Free;
  FSplitter.Free;
  FComPanel.Free;
  FPopMenu.Free;
  FGroupMenu.Free;
  FSource.Free;
  FFilterGroups.Free;
  inherited Destroy;
end;

procedure TsohoCustomTreeView.GroupsMouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
begin
  if (Shift = [ssRight]) then begin
    FGroups.Selected := FGroups.GetNodeAt(X, Y);
    InternalRefreshFilter;
  end;
  if Assigned(FOnGroupsMouseDown) then FOnGroupsMouseDown(Sender, Button, Shift, X, Y);
end;

procedure TsohoCustomTreeView.GroupsMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var NowNode: TTreeNode;
begin
  NowNode := FGroups.GetNodeAt(X, Y);
  { Drag&Drop   Ctrl }
  if (Shift = [ssLeft, ssCtrl]) and (FGroups.Dragging = False) then begin
    FGroups.BeginDrag(False); //ICM was true
    FMoveGroup.GrpDragSourceRow := NowNode;
  end;
  if Assigned(FOnGroupsMouseMove) then FOnGroupsMouseMove(Sender, Shift, X, Y);
end;

procedure TsohoCustomTreeView.GroupsDragOver(Sender, Source: TObject; X,
    Y: Integer; State: TDragState; var Accept: boolean);
var NowNode: TTreeNode;
begin
  Accept := (trMoveItem in Options) or (trMoveGroup in Options);
  if not Accept then exit;
  NowNode := FGroups.GetNodeAt(X, Y);
  Accept := ((FMoveGroup.GrpDragSourceRow <> FGroups.Items[0]) and
    (FMoveGroup.GrpDragSourceRow <> NowNode))
    or FMoveItem.GridDrag;
  FGroups.Selected := NowNode;
  if Assigned(FOnGroupsDragOver) then FOnGroupsDragOver(Sender, Source, X, Y, State, Accept);
end;

procedure TsohoCustomTreeView.GroupsDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  GroupName: string;
  Buttons: TMsgDlgButtons;
  NewHash, RLeft, RRight: Longint;
  ParentId: Longint;
  Res: TModalResult;
  TmpLeaf: PTreeLeaf;
  ParNode, AfterChild, BeforeChild,
  SelNode, LastChild: TTreeNode;
begin
  SelNode := FGroups.Selected;
  if Source = FGrid then begin // ICM was TsohoDBGrid
    FMoveItem.GridDrag := False;
    {     items.db}
    if FItemsTable = '' then begin
      ErrorMsg(Format(sohoTreeCantMoveItem, [Name]));
      exit;
    end;
    ParentId := GetIdByNode(SelNode);
    RightHash := MaxLongint;
    with FMoveItem do begin
      NewHash := GetNewItemHash(ParentId);
      NewGrpId := GetIdByNode(SelNode);
    end;
    MoveItem;
    exit;
  end;

  if Source = FGroups then begin
    GroupName := SelNode.Text;
    if SelNode = FGroups.Items[0] then Buttons := [mbYes, mbCancel]
    else Buttons := [mbYes, mbNo, mbCancel];
    Res := YesNoCancel(Format(sohoTreeIncludeGroupInto,
      [GroupName, SelNode.Text]));
    BeforeChild := nil;
    AfterChild := nil;
    ParNode := nil;
    case Res of
      mrCancel: exit; {  }
      mrYes: begin {  }
        ParNode := SelNode;
        BeforeChild := nil;
        AfterChild := ParNode.GetLastChild;
      end;
      mrNo: begin { }
        ParNode := SelNode.Parent;
        BeforeChild := SelNode;
        AfterChild := ParNode.GetPrevChild(BeforeChild);
      end;
    end;

    with FGroups do begin
     ParentId := GetIdByNode(ParNode);

     if AfterChild = nil then RLeft := - MaxLongint
     else begin
       TmpLeaf := GetLeafRecord(AfterChild);
       if not Assigned(TmpLeaf) then RLeft := 0
       else RLeft := TmpLeaf^.ItemHash;
     end;

     if BeforeChild = nil then RRight := MaxLongint
     else begin
       TmpLeaf := GetLeafRecord(AfterChild);
       if not Assigned(TmpLeaf) then RRight := 0
       else RRight := TmpLeaf^.ItemHash;
     end;
     NewHash := GetHash(RLeft, RRight);

     if (AfterChild = BeforeChild) or (BeforeChild = nil) then
       FMoveGroup.GrpDragSourceRow.MoveTo(
         ParNode, naAddChild
       )
     else
       FMoveGroup.GrpDragSourceRow.MoveTo(
         BeforeChild, naInsert
       );

     Update;
     Items[0].Expand(true);
     {      }
     LastChild := FMoveGroup.GrpDragSourceRow;
     PTreeLeaf(LastChild.Data)^.ItemHash := NewHash;
     PTreeLeaf(LastChild.Data)^.ParentId := ParentId;
    end;
    MoveGroup(ParentId, NewHash, GetIdByNode(LastChild));
  end; // ICM
  if Assigned(FOnGroupsDragDrop) then FOnGroupsDragDrop(Sender, Source, X, Y);
end;


procedure TsohoCustomTreeView.ItemsGridDragDrop(Sender, Source: TObject; X, Y: Integer);
var Coord: TGridCoord;
  Insert: Word;
begin
  Coord := (Sender as TsohoDBGrid).MouseCoord(X, Y);
  Insert := VK_INSERT;
  GridKeyDown(Sender, Insert,[ssCtrl]);
  FItemsDS.MoveBy(Coord.Y - FMoveItem.GridRow);
  Insert := VK_INSERT;
  GridKeyDown(Sender, Insert,[ssShift]);
  if Assigned(FOnGridDragDrop) then FOnGridDragDrop(Sender, Source, X, Y);
end;

procedure TsohoCustomTreeView.ItemsGridMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if Shift = [ssLeft, ssCtrl] then begin
    FGrid.BeginDrag(False);
    if not FMoveItem.GridDrag then begin
      FMoveItem.GridDrag := True;
      FMoveItem.GridRow := 1 + (Sender as TsohoDBGrid).GetActiveRow;
      FMoveItem.ID := FItemsDS.FieldByName(FKeyField).AsInteger;
      FReport.Caption := IntToStr(FMoveItem.ID);
    end;
  end;
  if Assigned(FOnGridMouseMove) then FOnGridMouseMove(Sender, Shift, X, Y);
end;

procedure TsohoCustomTreeView.ItemsGridDragOver(Sender, Source: TObject; X, Y: Integer;
    State: TDragState; var Accept: boolean);
var Coord: TGridCoord;
begin
  Coord := (Sender as TsohoDBGrid).MouseCoord(X, Y);
  Accept := (Source is TsohoDBGrid) and (FMoveItem.GridRow <> Coord.Y);
  if Assigned(FOnGridDragOver) then
    FOnGridDragOver(Sender, Source, X, Y, State, Accept);
end;

procedure TsohoCustomTreeView.ItemsGridMouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
begin
  if Assigned(FOnGridMouseDown) then
    FOnGridMouseDown(Sender, Button, Shift, X, Y);
end;

procedure TsohoCustomTreeView.ReDrawTreeView;
begin
  FGroups.Height := Height;
  FGroups.Width := FTreeViewPanel.Width;
end;

function TsohoCustomTreeView.MoveItemById(Id, NewGrpId : Integer) : boolean;
begin
  FMoveItem.ID := Id;
  FMoveItem.NewGrpId := NewGrpId;
  FMoveItem.NewHash := GetNewItemHash(NewGrpId);
  Result := MoveItem;
end;

procedure TsohoCustomTreeView.GetTreeViewImageIndex (Sender: TObject; Node: TTreeNode);
begin
  if Node.Expanded then Node.ImageIndex := 1
  else Node.ImageIndex := 0;
end;

procedure TsohoCustomTreeView.AllowEditNode(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
  AllowEdit := Node.Parent <> nil;
end;

procedure TsohoCustomTreeView.DoEditNode(Sender: TObject; Node: TTreeNode;
  var S: string);
var NowNode: TTreeNode;  
begin
  NowNode := GetNodeByName(S);
  if (Node <> NowNode) and
     (NowNode <> nil) then begin
    S := Node.Text;
    exit;
  end;
  if not QuietEditGroup(S) then S := Node.Text;
end;

{ TsohoSpecEnhTreeView }

procedure TsohoSpecEnhTreeView.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited;
  case KEY of
    VK_INSERT: begin
      TsohoCustomTreeView(Owner).TreeViewButtonsClick(actNewGroup);
    end;
    VK_RETURN: begin
      if Shift = [ssAlt] then begin
        TsohoCustomTreeView(Owner).TreeViewButtonsClick(actEditGroup);
      end;
      if Shift = [] then begin
        TsohoCustomTreeView(Owner).InternalRefreshFilter;
      end;
    end;
    vk_Delete: begin
      if not IsEditing then
        TsohoCustomTreeView(Owner).TreeViewButtonsClick(actDelGroup);
    end;
  end;
  if Assigned(TsohoCustomTreeView(Owner).FOnGroupsKeyDown) then
    TsohoCustomTreeView(Owner).FOnGroupsKeyDown(Self, KEY, Shift);
end;

procedure TsohoSpecEnhTreeView.NodeSelected(Node: TTreeNode);
begin
  inherited;
  TsohoCustomTreeView(Owner).GroupSelected(Self);
end;

initialization
  TVImages := TImageList.Create(nil);
  TVImages.ResourceLoad(rtBitmap, 'SOHOTREEFOLDERS', clAqua);
finalization
  TVImages.Free;
end.
