{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov,              }
{                   Igor Chernyshov                     }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
   ,    
   
}
unit SoCtrls;

{$I SOHOLIB.INC}
{$DEFINE USE_ROUND}

interface

uses SysUtils, Windows, Messages, Classes, Graphics, Controls,
     Forms, StdCtrls, Menus, ExtCtrls, SoMultimedia, SoStrUtils
     {$IFDEF Delphi4_or_5}, ImgList {$ENDIF};

type

  TsohoGetDisplayTextEvent = procedure (Sender: TObject; var DisplayText: string) of object;
  {   OnGetDisplayText.   DisplayText,    ,
     TsohoFlatEdit }

  TsohoCustomLabel = class;

  TsohoFlatEdit = class(TCustomEdit)
  private
    { Private declarations }
    FDisplayFormat: string;
    FAlignment : TAlignment;
    FMultiLine: boolean;
    FOnGetText: TsohoGetDisplayTextEvent;
    FOnUndo: TNotifyEvent;
    FLightLabel : TsohoCustomLabel;
    FHeightAuto : boolean;

    procedure CMMouseEnter (var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave (var Message: TMessage); message CM_MOUSELEAVE;
    procedure WMSetFocus (var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus (var Message: TWMKillFocus); message WM_KILLFOCUS;
    procedure WMNCCalcSize (var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint (var Message: TMessage); message WM_NCPAINT;
    procedure WMPaint(var message: TWMPaint);message WM_PAINT;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure CMEnter(var message: TCMEnter); message CM_ENTER;
    procedure CMExit(var message: TCMExit); message CM_EXIT;
    procedure SetDisplayFormat(Value: string);
    procedure SetAlignment(Value: TAlignment);
    procedure SetHeightAuto(Value : boolean);
  protected
    { Protected declarations }
    FCanvas: TControlCanvas;
    TextRect: TRect;
    // 
    MouseInControl: Boolean;
    procedure CreateWnd; override;
    procedure RedrawBorder (const Clip: HRGN);
    function GetMinHeight: Integer;
    procedure GetTextHeight(var SysHeight, Height: Integer);
    procedure RecalcNonClient(var R: TRect); virtual;
    procedure SetMultiLine(Value: boolean); virtual;
    procedure DoUndo; virtual;
    function GetDisplayText: string; virtual;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure DoGetDisplayText(var DisplayText: string); virtual;
    function DrawAnotherStyle(DC: HDC; R: TRect): boolean; virtual;
//------------------------------------------------------------------------------
    procedure SetLightLabel(Value : TsohoCustomLabel);
//------------------------------------------------------------------------------
    procedure Notification (aComponent: TComponent; aOperation: TOperation); override;
    property Alignment : TAlignment read FAlignment write SetAlignment;
    property OnGetDisplayText: TsohoGetDisplayTextEvent read FOnGetText write FOnGetText;
    property OnUndo: TNotifyEvent read FOnUndo write FOnUndo;
    property DisplayFormat: string read FDisplayFormat write SetDisplayFormat;
    property MultiLine: boolean read FMultiLine write SetMultiLine;
//------------------------------------------------------------------------------
    property LightLabel : TsohoCustomLabel read FLightLabel write SetLightLabel;
    property HeightAuto : boolean read FHeightAuto write SetHeightAuto default True;
    {   = True,     Height , 
      }
//------------------------------------------------------------------------------

  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    procedure Undo; virtual;
  end;


  TsohoModifyEvent = procedure (Sender: TObject; OldValue, NewValue: string) of object;
  {    OnModify. OldValue -  TsohoEdit.Text  ,
    NewValue -   TsohoEdit.Text }

  TValueKind = (vkString, vkInteger, vkFloat, vkDate, vkTime, vkDateTime);
  {    TsohoEdit: , , , ,
    ,    }

  TChangeChars = string[255];
  {        ToChars, FromChars }

  TsohoEditStyle = (weNormal, weFlat);
  {  edit' -   "" }

  TsohoCanExit = procedure (Sender: TObject; var AllowExit: Boolean) of object;
  {    CanExit.  AllowExit,    
          }

  TsohoUse12Hours = (h12_None,  h12_AM_PM, h12_A_P, h12_AMPM);
  {      12-  
      :
     h12_None  -   12- 
     h12_AM_PM -  am/pm
     h12_A_P   -  a/p
     h12_AMPM  -  ampm }

  TsohoCustomEdit = class(TsohoFlatEdit)
  {   TsohoEdit -    Borland,  - Inprise }
  private
    { Private declarations }
    FOldTag: LongInt;
    FEnabled: boolean;
    FMayBeEmpty: Boolean;
    OParentCtl3D: Boolean;
    OColor: tColor;
    FEditStyle: TsohoEditStyle;
    FHighLight,
      FShadow: tColor;
    FFromChars,
      FToChars: TChangeChars;
    FShowMessage: Boolean;
    PString: string;
    FValueKind: TValueKind;
    FOnModify: TsohoModifyEvent;
    FSound: TsohoSound;
    FSoundName: TWaveFileName;
    FCanExit: TsohoCanExit;
    {$IFDEF USE_ROUND}
    FRoundValue: boolean;
    FRoundDigits: integer;
    {$ENDIF}

    FOnRightClick: TNotifyEvent;
    FButton: pointer;
    FDirectEnter: Boolean;
    FAutoFill: Boolean;
    FCenterDialog: boolean;
{------------------------------------------------------------------------------}
    FDividers  : SetOfChars;//  -.  
                            //   FMask  SetMask
                            //     Fmask,   
                            //   
    FMask      : String;    //  
    FUseMask   : Boolean;   //   
    FBlankChar : Char;      // -
    Use12Hours : TsohoUse12Hours; //   12-  
                                  // ,    Mask.
                                  //   :
                                  // h12_None  -   12- 
                                  // h12_AM_PM -  am/pm
                                  // h12_A_P   -  a/p
                                  // h12_AMPM  -  ampm }
    FFloatDigits : Integer;       // -    
{------------------------------------------------------------------------------}
  protected
    { Protected declarations }
    FRightControl: Boolean;
    {$IFDEF USE_ROUND}
    procedure SetRoundValue(Value: boolean);
    procedure SetRoundDigits(Value: integer);
    {$ENDIF}
    procedure CMVISIBLECHANGED(var message: TMessage); message CM_VISIBLECHANGED;
    procedure CMExit(var message: TCMExit); message CM_EXIT;
    procedure WMPaint(var message: TWMPaint); message WM_PAINT;
    procedure RecalcNonClient(var R: TRect); override;
    function GetDisplayText: string; override;
    procedure SetMultiLine(Value: boolean); override;
    procedure SetButtonHint(Value: string);
    function GetButtonHint: string;
    procedure SetButtonGlyph(Value: TBitmap);
    function GetButtonGlyph: TBitmap;

    procedure SetImageList(Value: TImageList);
    function GetImageList: TImageList;
    procedure SetImageIndex(Value: LongInt);
    function GetImageIndex: LongInt;

    procedure SetRightControl(Value: Boolean);
    procedure SetMayBeEmpty(Value: Boolean);
    procedure SetDate(Value: TDate);
    procedure SetTime(Value: TTime);
    procedure SetDateTime(Value: TDateTime);
    procedure SetString(Value: string);
    procedure SetInteger(Value: Longint);
    procedure SetFloat(Value: Double);
    procedure SetButtonNumGlyphs (Value : integer);
    function GetButtonNumGlyphs : integer;
    function GetDate: TDate;
    function GetTime: TTime;
    function GetDateTime: TDateTime;
    function GetString: string;
    function GetInteger: Longint;
    function GetFloat: Double;
    procedure SetEditStyle(Value: TsohoEditStyle);
    procedure SetHighLight(Value: tColor);
    procedure SetShadow(Value: tColor);
    procedure SetValueKind(Value: TValueKind);
    procedure SetSoundName(Value: TWaveFileName);
    procedure SaveAll;
    procedure RestoreAll;
    procedure SetPasswordChar (Value : char);
    function GetPasswordChar : char;

    procedure DoRightClick(Sender: TObject); virtual;
    {$IFDEF Delphi4_or_5}
    procedure SetEnabled(Value: Boolean); override;
    function GetEnabled: Boolean; override;
    {$ELSE}
    procedure SetEnabled(Value: Boolean);
    function GetEnabled: Boolean;
    {$ENDIF}
    function DrawAnotherStyle(DC: HDC; R: TRect): boolean; override;
    procedure SetRightControlPosition; virtual;
    procedure CreateRightControl; virtual;
    procedure DestroyRightControl; virtual;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure ModifyEvent;
    procedure Error(const ErrorText: string);
{------------------------------------------------------------------------------}
    //  ,    .
    function  IsDivider(C : char) : boolean;
    //  ""    Mask, BlankMask
    function  EmptyText : string;
    //   Text   Mask, BlankMask
    procedure SetEmptyText;
    procedure SetMask(Value : string);
    procedure SetUseMask(Value : boolean);
    procedure SetBlankChar(Value : char);
    procedure SetFloatDigits(Value : Integer);
    property  Mask : string read FMask write SetMask;
    property  BlankChar : Char read FBlankChar write SetBlankChar;
    property  FloatDigits : integer read FFloatDigits write SetFloatDigits default 0;
{------------------------------------------------------------------------------}
    property Images: TImageList read GetImageList write SetImageList;
    property ImageIndex: LongInt read GetImageIndex write SetImageIndex;
    property AutoFill: Boolean read FAutoFill write FAutoFill;
    property Enabled: Boolean read GetEnabled write SetEnabled;
    property EditStyle: TsohoEditStyle read FEditStyle write SetEditStyle;
    property Shadow: tColor read FShadow write SetShadow;
    property HighLight: tColor read FHighLight write SetHighLight;
    property ShowMessage: Boolean read FShowMessage write FShowMessage;
    property FromChars: TChangeChars read FFromChars write FFromChars;
    property ToChars: TChangeChars read FToChars write FToChars;
    property Sound: TsohoSound read FSound write FSound;
    property ErrorSound: TWaveFileName read FSoundName write SetSoundName;
    property MayBeEmpty: Boolean read FMayBeEmpty write SetMayBeEmpty;
    property CanExit: TsohoCanExit read FCanExit write FCanExit;
    property OnModify: TsohoModifyEvent read FOnModify write FOnModify;
    property Button: pointer read FButton;
    property BtnGlyph: TBitmap read GetButtonGlyph write SetButtonGlyph;
    property BtnNumGlyphs: integer read GetButtonNumGlyphs write SetButtonNumGlyphs;
    property BtnHint: string read GetButtonHint write SetButtonHint;
    property CenterDialog: boolean read FCenterDialog write FCenterDialog;
    property DirectEnter: Boolean read FDirectEnter write FDirectEnter;
    {$IFDEF USE_ROUND}
    property RoundValue: boolean read FRoundValue write SetRoundValue;
    property RoundDigits: integer read FRoundDigits write SetRoundDigits;
    {$ENDIF}
    property RightControl: Boolean read FRightControl write SetRightControl;
    property OnRightClick: TNotifyEvent read FOnRightClick write FOnRightClick;
    property PasswordChar: char read GetPasswordChar write SetPasswordChar;
    property HeightAuto: boolean read FHeightAuto write SetHeightAuto default True;
    property UseMask: boolean read FUsemask write SetUseMask;
  public
    { Public declarations }
{------------------------------------------------------------------------------}
    //  
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
{------------------------------------------------------------------------------}
    procedure KeyPress(var KEY: Char); override;
{------------------------------------------------------------------------------}
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
{------------------------------------------------------------------------------}

    procedure UpdateRightControl; virtual;
    procedure Loaded; override;
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Cancel; //  ,   Undo.   
    {     edit'.  ""  
          }
    property Font;
    property Color;
    property ValueKind: TValueKind read FValueKind write SetValueKind;
    property AsDate: TDate read GetDate write SetDate;
    property AsTime: TTime read GetTime write SetTime;
    property AsDateTime: TDateTime read GetDateTime write SetDateTime;
    property AsString: string read GetString write SetString;
    property AsInteger: Longint read GetInteger write SetInteger;
    property AsFloat: Double read GetFloat write SetFloat;
  end;

  TsohoEdit = class(TsohoCustomEdit)
  {     TEdit.   
    ,  ,    ValueKind, AsDate,
    AsString, AsTime, AsInteger, AsFloat, AsDateTime     
      .       ValueKind 
             
      .  RightControl = true    
     ,      Date, Time, Integer 
    Float.  ToChars  FromChars      
     .
  }
  public
    property AsDateTime;
    {   ,    TDateTime }
    property AsDate;
    {   ,    TDate }
    property AsTime;
    {   ,    TTime }
    property AsString;
    {     }
    property AsInteger;
    {   ,    LongInt }
    property AsFloat;
    {   ,    Double }
    property Button;
    {       }
  published
{$IFDEF Delphi4_or_5}
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
{$ENDIF}
    property CenterDialog default true;
    {     //  
             }
    property Images;
{   TImageList. ,       }
    property ImageIndex default -1;
{    Images    }
    property Align;
    property Alignment;
    property AutoFill default False;
    {         
      ValueKind }
    property BtnHint;
    {     }
    property BtnGlyph;
    {     }
    property BtnNumGlyphs;
    { -      }
    property DirectEnter default false;
    {  DirectEnter = true,      
      .     . 
           -  
       ,      ,
      "  ",    . ,  .
         ReadOnly.  }
    property DisplayFormat;
    {    Text.     
       ValueKind.   ,   
        :
      vkInteger, vkFloat - FormatFloat
      vkDate, vkTime, vkDateTime - FormatDateTime
      vkString - FormatMaskText
    }
    {$IFDEF USE_ROUND}
    property RoundValue default false;
    {  ,    AsFloat 
       .  ,    
       DisplayFormat,   -  
      . ,      ,
            }
    property RoundDigits default 2;
    { -       AsFloat.  RoundDigits > 0,
          ,  RoundDigits < 0, 
         .  RoundDigits = 0  
        Round }
    {$ENDIF}
    property EditStyle;
    {   }
    property Shadow;
    {   wsFlat      }
    property HighLight;
    {   wsFlat      }
    property ShowMessage;
    {     ( )     }
    property FromChars;
    {   ,        ToChars.
        ,    ,   
          ToChars,     .
        Exampe:
      FromChars: ABCD
      ToChars  : 1234
       "B"       "2" }
    property ToChars;
    {     }
    property ValueKind;
    {   TsohoValueKind }
    property Sound;
    {     }
    property ErrorSound;
    { ,      ShowMessag = true }
    property MayBeEmpty default True;
    {       }
    property MultiLine;
    {       . 
      ,       ValueKind = vkString,
       ,    DisplayFormat,  
             }
    property RightControl;
    { ,       }
    property HeightAuto default True;
    {   = True,     Height , 
      }
    property Text;
    property BorderStyle;
    property CharCase;
    property Color;
    property Font;
    property HideSelection;
    property OEMConvert;
    property AutoSelect;
    property AutoSize;
    property Visible;
    property Ctl3D default True;
    property DragCursor;
    property DragMode;
    property Enabled;
    property HelpContext;
    property MaxLength;
    property ParentColor;
    property ParentCtl3D default True;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property OnChange;

    property OnModify;
    {      , ..   ,
           }
    property OnGetDisplayText;
    {       ,  , 
        ,    .   
             }
    property OnRightClick;
    {           }
    property CanExit;
    {      .   
          }
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnUndo;
{$IFDEF Delphi5}
    property OnContextPopup;
{$ENDIF}
{$IFDEF Delphi4_or_5}
    property OnResize;
    property OnEndDock;
    property OnStartDock;
{$ENDIF}
{------------------------------------------------------------------------------}
    property  Mask;
    {  .     :
       dd          - 
       MM          - 
       yy  yyyy - 
       hh          - 
       mm          - 
       ss          - 
       zz          - 
       0           -  
       a           -  
     :
       dd.MM.yy    - ..
       MM.dd.yyyy  - ..
       hh:mm:ss.zz - ::.
       000.00      - 3.2
       00-aa-00    - 2-2-2
          12- ,   
       :
     am/pm -      am  pm
     a/p   -      a  p
     ampm  -      ,   
              TimeAMString  TimePMString
               ,
      ValueKind = vkTime, vkDate  vkDateTime
      AutoFill = True  Usemask = True,      
        .
      :   ,  ,   - MM,  - mm
     }
    property  UseMask;
    {    ? }
    property  BlankChar;
    {""      Text.   Mask = hh:mm:ss 
     BlankChar = '_', Text = __:__:__}
    property LightLabel;
    {  ,         }
    property  FloatDigits;
    {     .     ValueKind = vkFloat}
  end;

  TsohoLabelPaintEvent = procedure (Sender: TObject; Canvas: TCanvas; Rect: TRect) of object;
  {    OnBeforePaint, OnAfterPaint  TsohoLabel }

  TLightPos = (lpLeft, lpRight, lpTop, lpBottom, lpLeftTop, lpLeftBottom,
    lpRightTop, lpRightBottom);
  {  " ": , , , , -,
    -, -, - }

  TsohoLabelPosition = (wlpTop, wlpLeft, wlpRight, wlpBottom, wlpUnLinked);
  {  TsohoLabel  FocusControl: , , , ,
      }

  TsohoCustomLabel = class(TCustomLabel)
  {  TsohoLabel...   -    }
  private
    { Private declarations }
    FAutoSize: boolean;
    FAlive: Boolean;
    FFocusOffset: Integer;
    fPos: TsohoLabelPosition;
    FWordWrap: Boolean;
    FLight: TLightPos;
    F3DHeight: Integer;
    FLightColor, FShadowColor: tColor;
    FAlignment: TAlignment;
    FBevelInner, FBevelOuter: TPanelBevel;
    FBevelWidth: Integer;
    FBorderWidth: Integer;
    FBevel: Boolean;
    FActFont: tFont;
    FActColor: tColor;
    FOnMouseEnter: TNotifyEvent;
    FOnMouseLeave: TNotifyEvent;
    FOnBeforePaint,
    FOnAfterPaint : TsohoLabelPaintEvent;
    procedure SetFocusOffset(Value: Integer);
    procedure SetTrans(Value: Boolean);
    function GetTrans: Boolean;
    procedure SetFControl(Value: TWinControl);
    procedure SetLabelPos(Value: TsohoLabelPosition);
    function GetFControl: TWinControl;
    procedure SetLight(Value: TLightPos);
    procedure Set3DHeight(Value: Integer);
    procedure SetLColor(Value: tColor);
    procedure SetSColor(Value: tColor);
    procedure SetBevel(Value: Boolean);
    procedure SetBevelInner(Value: TPanelBevel);
    procedure SetBevelOuter(Value: TPanelBevel);
    procedure SetBevelWidth(Value: Integer);
    procedure SetBorderWidth(Value: Integer);
    procedure SetAlignment(Value: TAlignment);
    procedure UpdateBounds;
    procedure SetFAutoSize(Value: Boolean);
    function GetFAutoSize: Boolean;
    procedure SetAlive(Value: Boolean);
    procedure SetWrap(Value: Boolean);
    procedure SetFActiveColor(Value: tColor);
    procedure SetFActiveFont(Value: tFont);
    procedure CMParentColorChanged(var message: TMessage); message CM_PARENTCOLORCHANGED;
    procedure CMParentFontChanged(var message: TMessage); message CM_PARENTFONTCHANGED;
    procedure CMMouseEnter(var message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var message: TMessage); message CM_MOUSELEAVE;
    procedure CMTextChanged(var message: TMessage); message CM_TEXTCHANGED;
    procedure CMFontChanged(var message: TMessage); message CM_FONTCHANGED;
    procedure ActFontChanged(Sender: TObject);
    procedure CMDialogChar(var Message: TCMDialogChar); message CM_DIALOGCHAR;
  protected
    { Protected declarations }
    MouseOverLabel: Boolean;
    procedure MoveFocusControl(ALeft, ATop, AWidth, AHeight: Integer);
    procedure BeforePaint (Canvas: TCanvas; Rect: TRect); virtual;
    procedure AfterPaint (Canvas: TCanvas; Rect: TRect); virtual;
    property Transparent: Boolean read GetTrans write SetTrans;
    property Position: TsohoLabelPosition read fPos write SetLabelPos;
    property FocusControl: TWinControl read GetFControl write SetFControl;
    property AutoSize: Boolean read GetFAutoSize write SetFAutoSize default False;
    property Alive: Boolean read FAlive write SetAlive;
    property Alignment: TAlignment read FAlignment write SetAlignment default taLeftJustify;
    property WordWrap: Boolean read FWordWrap write SetWrap default True;
    property FocusOffset: Integer read FFocusOffset write SetFocusOffset;
    property ColorActive: tColor read FActColor write SetFActiveColor;
    property FontActive: tFont read FActFont write SetFActiveFont;
    property Bevel: Boolean read FBevel write SetBevel;
    property BevelInner: TPanelBevel read FBevelInner write SetBevelInner;
    property BevelOuter: TPanelBevel read FBevelOuter write SetBevelOuter;
    property BorderWidth: Integer read FBorderWidth write SetBorderWidth default 0;
    property BevelWidth: Integer read FBevelWidth write SetBevelWidth default 1;
    property LightColor: tColor read FLightColor write SetLColor default clWhite;
    property ShadowColor: tColor read FShadowColor write SetSColor default clGray;
    property Light: TLightPos read FLight write SetLight default lpTop;
    property Height3D: Integer read F3DHeight write Set3DHeight default 1;
    property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseLeave: TNotifyEvent read FOnMouseLeave write FOnMouseLeave;
    property OnBeforePaint: TsohoLabelPaintEvent read FOnBeforePaint write FOnBeforePaint;
    property OnAfterPaint : TsohoLabelPaintEvent read FOnAfterPaint write FOnAfterPaint;
    procedure Loaded; override;
    procedure Paint; override;
    procedure Click; override;
  public
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

  {  ,      FocusControl }
  TsohoLabel = class(TsohoCustomLabel)
  public
    property Canvas;
  published
    property Alive;
    {  true,      ,  
       ColorActive, FontActive  Color,Font }
    property ColorActive;
    {  ,      }
    property FontActive;
    {  ,      }
    property FocusOffset;
    {    FocusControl }
    property Position;
    { ,      FocusControl }
    property FocusControl;
    {     , TsohoLabel (  FocusControl)   
     FocusControl,     Position  FocusOffset}
    property AutoSize;
    property Alignment;
    property WordWrap;

    property Bevel;
    { ,      }
    property BevelInner;
    {    }
    property BevelOuter;
    {    }
    property BorderWidth;
    {     }
    property BevelWidth;
    {     }
    property LightColor;
    {  "" }
    property ShadowColor;
    {  "" }
    property Light;
    {  ""  }
    property Height3D;
    {  "" }
    property Align;
    property Caption;
    property Color;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    {$IFDEF Delphi4_or_5}
    property Layout default tlCenter;
    {$ENDIF}
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Transparent;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseEnter;
    {     ,      }
    property OnMouseLeave;
    {     ,     }
    property OnBeforePaint;
    {    ,  TsohoLabel    . 
 ,      }
    property OnAfterPaint;
    {    ,  TsohoLabel     }

{$IFDEF Delphi4_or_5}
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
{$ENDIF}
{$IFDEF Delphi5}
    property OnContextPopup;
{$ENDIF}
{$IFDEF Delphi4_or_5}
    property OnResize;
    property OnEndDock;
    property OnStartDock;
{$ENDIF}
  end;

  TsohoPanel = class(TCustomPanel)
  {    .    
     ,     BackImage  nil, .. 
     ,      ,   
      }
  private
    { Private declarations }
    FBackImage: TBitmap;
  protected
    { Protected declarations }
    procedure SetBackImage(Value: TBitmap);
    procedure ImageChanged(Sender: TObject);
    procedure Paint; override;
    function GetPalette: HPALETTE; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    property Canvas;
  published
    property BackImage: TBitmap read FBackImage write SetBackImage;
    { ,    .   ,  
         ,     }
    property Align;
    property Alignment;
    property BevelInner;
    property BevelOuter;
    property BevelWidth;
    property BorderWidth;
    property BorderStyle;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Caption;
    property Color;
    property Ctl3D;
    property Font;
    property Locked;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
{$IFDEF Delphi4_or_5}
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
    property ImeMode;
    property ImeName;
{$ENDIF}
{$IFDEF Delphi5}
    property OnContextPopup;
{$ENDIF}
{$IFDEF Delphi4_or_5}
    property OnResize;
    property OnEndDock;
    property OnStartDock;
{$ENDIF}
  end;

  TsohoCustomComboBox = class(TCustomComboBox)
  private
    MouseInControl: Boolean;
    FLookup: string;
//------------------------------------------------------------------------------
    FLightLabel : TsohoCustomLabel;
//------------------------------------------------------------------------------
    procedure RedrawBorder (const Clip: HRGN);
    procedure CMMouseEnter (var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave (var Message: TMessage); message CM_MOUSELEAVE;
    procedure WMNCPaint (var Message: TMessage); message WM_NCPAINT;
    procedure CMVISIBLECHANGED (var Message : TMessage); message CM_VISIBLECHANGED;
    procedure WMPaint(var message: TWMPaint); message wm_paint;
    procedure CMEnter(var message: TCMEnter); message CM_ENTER;
    procedure CMExit(var message: TCMExit); message CM_EXIT;
  protected
    procedure Lookup; virtual;
    procedure KeyPress(var Key: Char); override;
    procedure CreateParams(var Params: TCreateParams);override;
    procedure Notification(aComponent: TComponent; aOperation: TOperation); override;
//------------------------------------------------------------------------------
    procedure SetLightLabel(Value : TsohoCustomLabel);
    property LightLabel : TsohoCustomLabel read FLightLabel write SetLightLabel;
//------------------------------------------------------------------------------

  public
    constructor Create (AOwner: TComponent); override;
    property Text;
    property OnClick;
  end;

  TsohoComboBox = class(TsohoCustomComboBox)
  published
    property Style; {Must be published before Items}
{$IFDEF Delphi4_or_5}
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
{$ENDIF}
{$IFDEF Delphi5}
    property OnContextPopup;
{$ENDIF}
{$IFDEF Delphi4_or_5}
    property OnResize;
    property OnEndDock;
    property OnStartDock;
{$ENDIF}
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property DropDownCount;
    property Enabled;
    property Font;
    property ItemHeight;
    property MaxLength;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Sorted;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDrawItem;
    property OnDropDown;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMeasureItem;
    property OnStartDrag;
    property Items; { Must be published after OnMeasureItem }
    property LightLabel;
    {   ,    TsohoLabel,   ""  
      TsohoComboBox  }
  end;

procedure Draw3DText(Text: string; var Rect: TRect; Canvas: TCanvas; LightPos: TLightPos;
  Color, LightColor, ShadowColor: tColor; Height3D: Integer;
  Alignment: TAlignment; {$IFDEF Delphi4_or_5}Layout: TTextLayout; {$ENDIF}
  WordWrap, PreffixOff, Calc: Boolean);
{  ""    .    TsohoLabel }

procedure PaintEdit (Control: TCustomEdit; Canvas: TControlCanvas;
  aAlignment: TAlignment; Message: TWMPaint; aColor: TColor;
  aFont: TFont; R: TRect; const DisplayText: string);
{    }

implementation
uses SoUtils, SoAppUtils, SoDate, SohoBtns, SohoCalc,
     SoCmnCns, ComCtrls, SoGraph, SoCalendar, SoVCLUtils, Mask
     {$IFDEF Delphi3}, CalCtrls{$ENDIF}
     {$IFDEF Delphi6}, MaskUtils{$ENDIF};

{$R SOCTRLS.R32}

var
  EditImages: TImageList;

procedure Draw3DText;
const Aligns: array[TAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);
var Flags: Word;
  PText          : array[0..256] of Char;
  Leng           : Integer;
  {$IFDEF Delphi4_or_5}
  CalcRect, StartRect: TRect;
  YOffset: LongInt;
  {$ENDIF}
  LightR, ShadowR: TRect;
begin
  InflateRect(Rect, - Height3D - 2, - Height3D - 1);
  {$IFDEF Delphi4_or_5}
  StartRect := Rect;
  {$ENDIF}
  LightR := Rect;
  ShadowR := Rect;
  Flags := Aligns[Alignment] or DT_EXPANDTABS;
  if WordWrap then Flags := Flags or DT_WORDBREAK;
  if PreffixOff then Flags := Flags or DT_NOPREFIX;
  if Calc then Flags := Flags or DT_CALCRECT;
  StrPCopy(PText, Text);
  Leng := Length(Text);
  with Canvas do begin
    if Height3D > 1 then
      case LightPos of
        lpLeft: begin
          OffsetRect(LightR, - Height3D, 0);
          OffsetRect(ShadowR, Height3D, 0);
        end;
        lpRight: begin
          OffsetRect(ShadowR, - Height3D, 0);
          OffsetRect(LightR, Height3D, 0);
        end;
        lpTop: begin
          OffsetRect(LightR, 0, - Height3D);
          OffsetRect(ShadowR, 0, Height3D);
        end;
        lpBottom: begin
          OffsetRect(ShadowR, 0, - Height3D);
          OffsetRect(LightR, 0, Height3D);
        end;
        lpLeftTop: begin
          OffsetRect(LightR, - Height3D, - Height3D);
          OffsetRect(ShadowR, Height3D, Height3D);
        end;
        lpRightBottom: begin
          OffsetRect(ShadowR, - Height3D, - Height3D);
          OffsetRect(LightR, Height3D, Height3D);
        end;
        lpLeftBottom: begin
          OffsetRect(ShadowR, Height3D, - Height3D);
          OffsetRect(LightR, - Height3D, Height3D);
        end;
        lpRightTop: begin
          OffsetRect(LightR, Height3D, - Height3D);
          OffsetRect(ShadowR, - Height3D, Height3D);
        end;
      end;
    {$IFDEF Delphi4_or_5}
    if Layout <> tlTop then begin
      CalcRect := Rect;
      DrawText(Handle, PText, Leng, CalcRect, Flags or DT_CALCRECT);
      if Layout = tlBottom then
        YOffset := HeightOf(StartRect) - CalcRect.Bottom
      else
        YOffset := (HeightOf(StartRect) - CalcRect.Bottom) div 2;
      if Height3D > 1 then begin
        OffsetRect(LightR, 0, YOffset);
        OffsetRect(ShadowR, 0, YOffset);
      end;
      OffsetRect(Rect, 0, YOffset);
    end;
    {$ENDIF}
    if Height3D > 1 then begin
      SetTextColor(Handle, ColorToRGB(LightColor));
      DrawText(Handle, PText, Leng, LightR, Flags);
      SetTextColor(Handle, ColorToRGB(ShadowColor));
      DrawText(Handle, PText, Leng, ShadowR, Flags);
    end;
    SetTextColor(Handle, ColorToRGB(Color));
    DrawText(Handle, PText, Leng, Rect, Flags);
  end;
end;

procedure PaintEdit (Control: TCustomEdit; Canvas: TControlCanvas;
  aAlignment: TAlignment; Message: TWMPaint; aColor: TColor;
  aFont: TFont; R: TRect; const DisplayText: string);
var DC: HDC;
    PS: TPaintStruct;
begin
  DC := Message.DC;
  if DC = 0 then DC := BeginPaint(Control.Handle, PS);
  Canvas.Handle := DC;
  try
    Canvas.Font := aFont;
    if not Control.Enabled and NewStyleControls and not
      (csDesigning in Control.ComponentState) and
      (ColorToRGB(aColor) <> ColorToRGB(clGrayText)) then
      Canvas.Font.Color := clGrayText;
    with Canvas do begin
      R.Right := R.Right - 2;
      Brush.Color := aColor;
      TextInRect(Canvas, DisplayText, R, aAlignment);
    end;
  finally
    Canvas.Handle := 0;
    if Message.DC = 0 then EndPaint(Control.Handle, PS);
  end;
end;

{ TsohoFlatEdit }
procedure TsohoFlatEdit.Notification (aComponent: TComponent; aOperation: TOperation);
begin
  inherited;
  if (aComponent = FLightLabel) and (aOperation = opRemove) then
    FLightLabel := nil;
end;

procedure TsohoFlatEdit.CMEnter(var message: TCMEnter);
begin
  //  
  if (FLightLabel <> nil) and (FLightLabel.Alive) then begin
    FLightLabel.MouseOverLabel := True;
    FLightLabel.Invalidate;
  end;
  if not FMultiline then SelectAll
  else Invalidate;
  inherited;
end;

procedure TsohoFlatEdit.CMExit(var message: TCMExit);
begin
  if FLightLabel <> nil then begin
    FLightLabel.MouseOverLabel := False;
    FLightLabel.Invalidate;
  end;
  inherited;
  Invalidate;
end;

procedure TsohoFlatEdit.CMMouseEnter(var Message: TMessage);
begin
  inherited;
  MouseInControl := True;
  RedrawBorder (0);
end;

procedure TsohoFlatEdit.CMMouseLeave(var Message: TMessage);
begin
  inherited;
  MouseInControl := False;
  RedrawBorder (0);
end;

destructor TsohoFlatEdit.Destroy;
begin
  FCanvas.Free;
  inherited;
end;

constructor TsohoFlatEdit.Create(AOwner: TComponent);
begin
  inherited;
  FMultiLine := false;
  FAlignment := taLeftJustify;
  // 
  AutoSize := False;
  Ctl3D := False;
  BorderStyle := bsNone;
  ControlStyle := ControlStyle - [csFramed];
  FDisplayFormat := '';
  FCanvas := TControlCanvas.Create;
  FCanvas.Control := Self;
  FHeightAuto := True;
end;

procedure TsohoFlatEdit.CreateParams(var Params: TCreateParams);
const
   Alignments: array[TAlignment] of DWORD = (ES_LEFT, ES_RIGHT, ES_CENTER);
begin
   inherited CreateParams(Params);
   if PasswordChar = #0 then
     Params.Style := Params.Style or ES_MULTILINE or Alignments[FAlignment];
end;

procedure TsohoFlatEdit.DoGetDisplayText(var DisplayText: string);
begin
  if Assigned(FOnGetText) then FOnGetText(Self, DisplayText);
end;

procedure TsohoFlatEdit.DoUndo;
begin
  if Assigned(FOnUndo) then FOnUndo(Self);
end;

function TsohoFlatEdit.DrawAnotherStyle(DC: HDC; R: TRect): boolean;
begin
  Result := false;
end;

function TsohoFlatEdit.GetDisplayText: string;
begin
  if Screen.ActiveControl = Self then
    Result := Text
  else
    Result := FormatMaskText(FDisplayFormat, Text);
end;

function TsohoFlatEdit.GetMinHeight: Integer;
var I, H: Integer;
begin
  GetTextHeight(I, H);
  if I > H then I := H;
  Result := H + (GetSystemMetrics(SM_CYBORDER) * 4) + 1;
end;
//------------------------------------------------------------------------------
procedure TsohoFlatEdit.SetLightLabel(Value : TsohoCustomLabel);
begin
  If FLightLabel <> Value then begin
    FLightLabel := Value;
  End; {--- if ---}
end;

//------------------------------------------------------------------------------
procedure TsohoFlatEdit.GetTextHeight(var SysHeight, Height: Integer);
begin

  FCanvas.Font.Assign(Font);
  Height := FCanvas.TextHeight(Text);
end;

procedure TsohoFlatEdit.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if ((Key = ord('z')) or (Key = ord('Z'))) and (ssCtrl in Shift) then
    DoUndo;
  if (Key = VK_BACK) and (ssAlt in Shift) then Undo;
  inherited;
end;

procedure TsohoFlatEdit.KeyPress(var Key: Char);
begin
  if ((Key = Char(VK_RETURN)) or (Key = Char(VK_ESCAPE))) and
     (not FMultiLine) then begin
      GetParentForm(Self).Perform(CM_DIALOGKEY, Byte(Key), 0);
      if Key = Char(VK_RETURN) then begin
        inherited KeyPress(Key);
        Key := #0;
        exit;
      end;
      if Key = Char(VK_ESCAPE) then Undo;
  end;

  inherited;
end;

procedure TsohoFlatEdit.RecalcNonClient(var R: TRect);
begin
 InflateRect (R, -3, -2);
end;

procedure TsohoFlatEdit.RedrawBorder(const Clip: HRGN);
var
  DC: HDC;
  R: TRect;
  NewClipRgn: HRGN;
  BtnFaceBrush, WindowBrush: HBRUSH;

  procedure DrawNormal;
  var NeedDestroyBrush: boolean;
  begin
    NeedDestroyBrush := false;
    if ((csDesigning in ComponentState) and Enabled) or
       (not(csDesigning in ComponentState) and
        (Focused or MouseInControl)) then begin
       NeedDestroyBrush := true;
       BtnFaceBrush := CreateSolidBrush(0);
    end
    else
       BtnFaceBrush := GetSysColorBrush(COLOR_BTNFACE);
    if Enabled then
      WindowBrush := GetSysColorBrush(COLOR_WINDOW)
    else
      WindowBrush := GetSysColorBrush(COLOR_BTNFACE);
    if ((csDesigning in ComponentState) and Enabled) or
       (not(csDesigning in ComponentState) and
        (Focused or MouseInControl)) then begin
      DrawEdge (DC, R, BDR_SUNKENOUTER, BF_RECT or BF_ADJUST);
      with R do begin
        FillRect (DC, Rect(Left, Top, Left+1, Bottom-1), BtnFaceBrush);
        FillRect (DC, Rect(Left, Top, Right-1, Top+1), BtnFaceBrush);
      end;
      DrawEdge (DC, R, BDR_SUNKENINNER, BF_BOTTOMRIGHT);
      InflateRect (R, -1, -1);
      FrameRect (DC, R, WindowBrush);
    end
    else begin
        DrawEdge (DC, R, BDR_SUNKENOUTER, BF_RECT or BF_ADJUST);
        with R do begin
          FillRect (DC, Rect(Left, Top, Left+1, Bottom-1), BtnFaceBrush);
          FillRect (DC, Rect(Left, Top, Right-1, Top+1), BtnFaceBrush);
        end;
        DrawEdge (DC, R, BDR_SUNKENINNER, BF_BOTTOMRIGHT);
        InflateRect (R, -1, -1);
        FrameRect (DC, R, WindowBrush);
    end;
    if NeedDestroyBrush then DeleteObject(BtnFaceBrush);
  end;

begin
  DC := GetWindowDC(Handle);
  try
    { Use update region }
    if (Clip <> 0) and (Clip <> 1) then begin
      GetWindowRect (Handle, R);
      if SelectClipRgn(DC, Clip) = Windows.ERROR then begin
        NewClipRgn := CreateRectRgnIndirect(R);
        SelectClipRgn (DC, NewClipRgn);
        DeleteObject (NewClipRgn);
      end;
      OffsetClipRgn (DC, -R.Left, -R.Top);
    end;

    { This works around WM_NCPAINT problem described at top of source code }
    {no!  R := Rect(0, 0, Width, Height);}
    GetWindowRect (Handle, R);  OffsetRect (R, -R.Left, -R.Top);

    //        
    // 
    if not DrawAnotherStyle(DC, R) then DrawNormal;

  finally
    ReleaseDC (Handle, DC);
  end;
end;

procedure TsohoFlatEdit.SetAlignment(Value: TAlignment);
begin
  if FAlignment = Value then exit;
  FAlignment := Value;
  RecreateWnd;
end;

procedure TsohoFlatEdit.SetHeightAuto(Value : boolean);
begin
  if Value <> FHeightAuto then begin
    FHeightAuto := Value;
    SendMessage(Self.Handle,WM_SIZE,Width,Height);
  end;  { --- if --- }
end;

procedure TsohoFlatEdit.SetDisplayFormat(Value: string);
begin
  if FDisplayFormat = Value then exit;
  FDisplayFormat := Value;
  Invalidate;
end;

procedure TsohoFlatEdit.SetMultiLine(Value: boolean);
begin
  if FMultiline = Value then exit;
  FMultiline := Value;
end;

procedure TsohoFlatEdit.Undo;
begin
  SendMessage(Handle, WM_UNDO, 0, 0);
  DoUndo;
end;

procedure TsohoFlatEdit.WMKillFocus(var Message: TWMKillFocus);
begin
  inherited;
  if not(csDesigning in ComponentState) then RedrawBorder (0);
end;

procedure TsohoFlatEdit.CreateWnd;
var R: PRect;
begin
  inherited;
  New(R);
  R^ := TextRect;
  SendMessage(Handle, EM_SETRECT, 0, LongInt(R));
  Dispose(R);
end;

procedure TsohoFlatEdit.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  inherited;
  RecalcNonClient(Message.CalcSize_Params^.rgrc[0]);
end;

procedure TsohoFlatEdit.WMNCPaint(var Message: TMessage);
begin
  inherited;
  RedrawBorder (HRGN(Message.WParam));
end;

procedure TsohoFlatEdit.WMPaint(var message: TWMPaint);
var Rect: TRect;
begin
  if GetParentForm(Self).ActiveControl <> Self then begin
    Rect := TextRect;
    PaintEdit(Self, FCanvas, FAlignment, Message, Color, Font,
      Rect, GetDisplayText);
  end
  else inherited;
end;

procedure TsohoFlatEdit.WMSetFocus(var Message: TWMSetFocus);
begin
  inherited;
  if not(csDesigning in ComponentState) then begin
    Invalidate;
    RedrawBorder (0);
  end;
end;

procedure TsohoFlatEdit.WMSize(var Message: TWMSize);
var MinHeight: Integer;
begin
  inherited;
  MinHeight := GetMinHeight;
  if (FHeightAuto) AND (Height < MinHeight) then Height := MinHeight;
  TextRect := ClientRect;
end;

{ TsohoCustomEdit }
function TsohoCustomEdit.DrawAnotherStyle(DC: HDC; R: TRect): boolean;
var BtnFaceBrush: HBRUSH;
begin
  Result := false;

  if FEditStyle <> weFlat then exit;
  BtnFaceBrush := GetSysColorBrush(COLOR_BTNFACE);
  with R do begin
    FillRect (DC, Rect(R.Left-1, R.Top-1, R.Left+1, R.Bottom-1), BtnFaceBrush);
    FillRect (DC, Rect(R.Left-1, R.Top-1, R.Right-1, R.Top+2), BtnFaceBrush);

    FillRect (DC, Rect(R.Left-1, R.Bottom-1, R.Right-1, R.Bottom-1), BtnFaceBrush);
    FillRect (DC, Rect(R.Right-1, R.Top-1, R.Right+1, R.Bottom-1), BtnFaceBrush);
  end;
  R.Top := R.Bottom - 2;
  if ((csDesigning in ComponentState) and Enabled) or
     (not(csDesigning in ComponentState) and
     (Focused or MouseInControl)) then
     DCFrame3D(DC, R, FShadow, FHighLight, 1)
  else
     DCFrame3D(DC, R, FHighLight, FShadow, 1);
     
  Result := true;
end;

procedure TsohoCustomEdit.SetMultiLine(Value: boolean);
begin
  inherited;
  if FMultiline then ValueKind := vkString;
end;

{$IFDEF USE_ROUND}
procedure TsohoCustomEdit.SetRoundValue(Value: boolean);
begin
  if FRoundValue = Value then exit;
  FRoundValue := Value;
  Invalidate;
end;

procedure TsohoCustomEdit.SetRoundDigits(Value: integer);
begin
  if FRoundDigits = Value then exit;
  FRoundDigits := Value;
  Invalidate;
end;
{$ENDIF}

function TsohoCustomEdit.GetDisplayText: string;

   function FormatMultiline: string;
   var Str: TStringList;
       Index: LongInt;
       Tmp: string;
   begin
     Str := TStringList.Create;
     Str.Text := Text;
     for Index := 0 to pred(Str.Count) do begin
       Tmp := FormatMaskText(FDisplayFormat, Str[Index]);
       DoGetDisplayText(Tmp);
       Str[Index] := Tmp;
     end;
     Result := Str.Text;
   end;

begin
  if FDisplayFormat = '' then begin
    {$IFDEF USE_ROUND}
    if FRoundValue then
      case FValueKind of
        vkInteger: Result := IntToStr(trunc(WRound(AsInteger, FRoundDigits)));
        vkFloat: Result := FloatToStr(WRound(AsFloat, FRoundDigits));
        else Result := Text;
      end
    else {$ENDIF} Result := Text
  end
  else begin
    try
      case FValueKind of
        vkString: begin
          if FMultiline then begin
            Result := FormatMultiline;
            exit;
          end
          else Result := FormatMaskText(FDisplayFormat, Text);
        end;
        vkDate: Result := FormatDateTime(FDisplayFormat, StrToDate(Text));
        vkTime: Result := FormatDateTime(FDisplayFormat, StrToTime(Text));
        vkDateTime: Result := FormatDateTime(FDisplayFormat, StrToDateTime(Text));
        vkInteger: begin
          {$IFDEF USE_ROUND}
          if FRoundValue then
            Result := FormatFloat(FDisplayFormat, trunc(WRound(StrToIntDef(Text, 0), FRoundDigits)))
          else{$ENDIF}
            Result := FormatFloat(FDisplayFormat, StrToInt(Text));
        end;
        vkFloat: begin
          {$IFDEF USE_ROUND}
          if FRoundValue then
            Result := FormatFloat(FDisplayFormat, WRound(StrToFloat(Text), FRoundDigits))
          else{$ENDIF}
            Result := FormatFloat(FDisplayFormat, StrToFloat(Text));
        end;
      end;
    except
      //    -   , 
      //   ,    .
      Result := Text;
    end;
  end;
  //  ,    
  if PasswordChar <> #0 then
    Result := Chars(PasswordChar, Length(Result));
  DoGetDisplayText(Result);
end;

procedure TsohoCustomEdit.SetPasswordChar (Value : char);
begin
  if PasswordChar = Value then exit;
  inherited PasswordChar := Value;
  RecreateWnd;
end;

function TsohoCustomEdit.GetPasswordChar : char;
begin
  Result := inherited PasswordChar;
end;

procedure TsohoCustomEdit.WMPaint(var message: TWMPaint);
var R: TRect;
begin
  inherited;

  if FEditStyle = weFlat then begin
    R := ClientRect;
    try
      FCanvas.Handle := Message.DC;
      R.Top := R.Bottom - 2;
      if ((csDesigning in ComponentState) and Enabled) or
         (not(csDesigning in ComponentState) and
         (Focused or MouseInControl)) then
         DCFrame3D(FCanvas.Handle, R, FShadow, FHighLight, 1)
      else
         DCFrame3D(FCanvas.Handle, R, FHighLight, FShadow, 1);
    finally
      FCanvas.Handle := 0;
    end;
  end;

end;

procedure TsohoCustomEdit.UpdateRightControl;
begin
  if (not Assigned(Parent)) or
     (not RightControl) then exit;
  RightControl := false;
  RightControl := true;
end;

procedure TsohoCustomEdit.Loaded;
begin
  inherited Loaded;
  if FAutoFill then
    case ValueKind of
      vkDate: AsDate := Date;
      vkTime: AsTime := Time;
      vkDateTime: AsDateTime := Now;
    end;
  SetBounds(Left, Top, Width, Height);
  TsohoBitBtn(FButton).Visible := Visible;
end;

procedure TsohoCustomEdit.SetEnabled(Value: Boolean);
begin
  {$IFNDEF Delphi4_or_5}
  inherited Enabled := Value;
  FEnabled := Value;
  {$ELSE}
  inherited;
  {$ENDIF}
  TsohoBitBtn(FButton).Enabled := Value;
end;

function TsohoCustomEdit.GetEnabled: Boolean;
begin
  {$IFNDEF Delphi4_or_5}
  Result := FEnabled;
  {$ELSE}
  Result := inherited GetEnabled;
  {$ENDIF}
end;

procedure TsohoCustomEdit.SetButtonGlyph(Value: TBitmap);
begin
  TsohoBitBtn(FButton).Glyph := Value;
end;

procedure TsohoCustomEdit.SetButtonNumGlyphs (Value : integer);
begin
  TsohoBitBtn(FButton).NumGlyphs := Value;
end;

function TsohoCustomEdit.GetButtonNumGlyphs : integer;
begin
  Result := TsohoBitBtn(FButton).NumGlyphs;
end;

function TsohoCustomEdit.GetButtonGlyph: TBitmap;
begin
  Result := TsohoBitBtn(FButton).Glyph;
end;

procedure TsohoCustomEdit.SetImageList(Value: TImageList);
begin
  TsohoBitBtn(FButton).Images := Value;
end;

function TsohoCustomEdit.GetImageList: TImageList;
begin
  Result := nil;
  if (TsohoBitBtn(FButton).Images = EditImages) then exit;
  Result := TsohoBitBtn(FButton).Images;
end;

procedure TsohoCustomEdit.SetImageIndex(Value: LongInt);
begin
  TsohoBitBtn(FButton).ImageIndex := Value;
end;

function TsohoCustomEdit.GetImageIndex: LongInt;
begin
  Result := -1;
  if (TsohoBitBtn(FButton).Images = EditImages) then exit;
  Result := TsohoBitBtn(FButton).ImageIndex;
end;

procedure TsohoCustomEdit.SetButtonHint(Value: string);
begin
  TsohoBitBtn(FButton).Hint := Value;
end;

function TsohoCustomEdit.GetButtonHint: string;
begin
  Result := EmptyStr;
  Result := TsohoBitBtn(FButton).Hint;
end;

procedure TsohoCustomEdit.SetMayBeEmpty;
var Can: Boolean;
begin
  FMayBeEmpty := Value;
  Can := Value or (not Value and (Text <> ''));
  if Assigned(FCanExit) then FCanExit(self, Can);
  if not (csDesigning in ComponentState) and not (csLoading in ComponentState)
    and (not Can) then
    if Parent <> nil then begin
      Error(se_ErrorStringEmpty);
      SetFocus;
    end;
end;

procedure TsohoCustomEdit.Notification(AComponent: TComponent; Operation: TOperation);
begin
  if (AComponent = FSound) and (Operation = opRemove) then FSound := nil;
  if (AComponent = FButton) and (Operation = opRemove) then FButton := nil;
  inherited Notification(AComponent, Operation);
end;

procedure TsohoCustomEdit.SetSoundName;
begin
  FSoundName := Value;
end;
{------------------------------------------------------------------------------}
//  
procedure TsohoCustomEdit.KeyDown(var Key: Word; Shift: TShiftState);
Var
  s : String;
  i : Integer;
begin
  if UseMask then begin
    //    ,     
    //  
    if (SelLength > 1) AND (Shift = []) then begin
      s := Text;
      for i := SelStart to SelStart + SelLength do
        if not(isDivider(s[i])) then s[i] := BlankChar;
      Text := s;
    end; {--- if ---}
    if Shift = [] then
    case Key of
      vk_delete : begin
                    key := 0;
                    PostMessage(Handle,WM_CHAR,word(BlankChar),0);
                    Application.ProcessMessages;
                    PostMessage(Handle,WM_KEYDOWN,vk_left,0);
                  end;
        vk_back : begin
                    Key := 0;
                    PostMessage(Handle,WM_CHAR,word(BlankChar),0);
                    Application.ProcessMessages;
                    PostMessage(Handle,WM_KEYDOWN,vk_left,0);
                    Application.ProcessMessages;
                    PostMessage(Handle,WM_KEYDOWN,vk_left,0);
                  end;
        vk_left : begin
                     SelLength := 0;
                     if (Text <> EmptyStr) and
                        IsDivider(Text[SelStart]) then selstart := selstart - 1;
                  end;
       vk_right : begin
                    SelLength := 0;
                    if (Text <> EmptyStr) and
                       IsDivider(Text[SelStart+2]) then selstart := selstart + 1;
                  end;
           //       KeyDown   KeyUp
      else if (Text <> EmptyStr) and
              IsDivider(Text[SelStart+1]) then selstart := selstart + 1;
    end;
  end; {--- if UseMask ---}
  inherited;
end;
//  
{------------------------------------------------------------------------------}

procedure TsohoCustomEdit.KeyPress(var KEY: Char);
var index: Integer;
    ValidChars : SetOfChars;
begin
  //    :(
  //   .  :)
  if FDirectEnter then begin
    KEY := #0;
    exit;
  end;

  for Index := 1 to Length(FFromChars) do
    if (FFromChars[index] = KEY) and (index <= Length(FToChars)) then begin
      KEY := FToChars[index];
      Break;
    end;
{------------------------------------------------------------------------------}
//  
  //  -   
  if (FValueKind = vkFloat) AND (FFloatDigits > 0) AND (Key in ['0'..'9']) then begin
    index := pos(DecimalSeparator,text);
    if index > 0 then
      if length(text) - index >= FFloatDigits then Key := #0;
  end;  { --- if (FValueKind = vkFloat) AND (FFloatDigits > 0) --- }

  //  
  if UseMask then begin
  if Key = #8 Then Key := BlankChar;

 //    0 -   
 if (Mask[SelStart+1] = '0') then
   if NOT(key in ['0'..'9',BlankChar]) Then key := #0;
 //         
  if (FValueKind = vkDate) or (FValueKind = vkTime) or (FValueKind = vkDateTime) then
    //      AM/PM
    //  
    if (Use12Hours=h12_AM_PM) AND (MaxLength-SelStart<=2) then begin
      if MaxLength-SelStart=2
         then ValidChars := ['a','p','A','P',BlankChar]
         else ValidChars := ['m','M',BlankChar];
      if NOT(key in ValidChars) Then key := #0;
    end;
    //  
    if (Use12Hours=h12_A_P) AND (MaxLength-SelStart=1) then begin
        ValidChars := ['a','p','A','P',BlankChar];
      if NOT(key in ValidChars) Then key := #0;
    end;
    //     -   

    //    .   am/pm
    //  
    ValidChars := ['0','1','2','3','4','5','6','7','8','9',BlankChar];
    if (key in ValidChars) then begin

      //  
          if ((Mask[SelStart+1]) = 'h') then begin
            if ((Mask[SelStart+2]) = 'h') then begin
               if Use12Hours = h12_None
                 then ValidChars := ['0','1','2',BlankChar]
                 else ValidChars := ['0','1',BlankChar];
            end else begin
               if Use12Hours = h12_None
                 then begin
                   if (Text[SelStart] = '2') then ValidChars := ['0','1','2','3',BlankChar];
                 end
                 else if (Text[SelStart] = '1') then ValidChars := ['0','1','2',BlankChar];
            end; {--- if (UpCase(Mask[SelStart+2]) = 'H') ---}
          end;   {--- if (UpCase(Mask[SelStart+1]) = 'H') ---}

      //  
        if ((Mask[SelStart+1]) = 'm') then
          if ((Mask[SelStart+2]) = 'm') then
             ValidChars := ['0','1','2','3','4','5',BlankChar];

      //  
        if ((Mask[SelStart+1]) = 's') then
          if ((Mask[SelStart+2]) = 's') then
             ValidChars := ['0','1','2','3','4','5',BlankChar];

      //   
        if ((Mask[SelStart+1]) = 'd') then begin
          if ((Mask[SelStart+2]) = 'd') then begin
             ValidChars := ['0','1','2','3',BlankChar];
          end else begin
             if (Text[SelStart] = '3') then
               ValidChars := ['0','1',BlankChar];
          end; {--- if (UpCase(Mask[SelStart+2]) = 'D') ---}
        end ; {--- if (UpCase(Mask[SelStart+1]) = 'D') ---}

      //  
        if ((Mask[SelStart+1]) = 'M') then begin
          if ((Mask[SelStart+2]) = 'M') then begin
             ValidChars := ['0','1',BlankChar];
          end else begin
             if (Text[SelStart] = '1') then
               ValidChars := ['0','1','2',BlankChar];
          end; {--- if (UpCase(Mask[SelStart+2]) = 'M') ---}
        end ; {--- if (UpCase(Mask[SelStart+1]) = 'M') ---}

        if NOT(key in ValidChars) Then key := #0;
    end; {--- if (key in ValidChars) ---}


    SelLength := 1;
    Application.ProcessMessages;
  end; {--- if FValueKind = vkTime ---}
//  
{------------------------------------------------------------------------------}
  inherited KeyPress(Key);
end;

{------------------------------------------------------------------------------}
//  
procedure TsohoCustomEdit.KeyUp(var Key: Word; Shift: TShiftState);
begin
  if FUseMask then begin
    If Text = EmptyStr then exit;
    if Shift <> [ssShift] then begin
      if IsDivider(Text[SelStart+1]) then selstart := selstart + 1;
      if SelStart = MaxLength then selstart := selstart - 1;
      if key <> vk_Shift then SelLength := 1;
    end; {--- if ---}
    Application.ProcessMessages;
  end; {--- if FValueKind = vkTime ---}
  inherited;
end;

function  TsohoCustomEdit.EmptyText : string;
var
  s    : String;
  i    : Integer;
  lens : Integer;
begin
    s := FMask;
    lens := Length(s);
    // ,    12-  
    Use12Hours := h12_None;
    if copy(s, lens-4, lens) = 'am/pm'
      then begin
        Use12Hours := h12_AM_PM;
        s := copy(s,1,lens-5);
      end
      else
        if copy(s, lens-2, lens) = 'a/p'
          then begin
            Use12Hours := h12_a_p;
            s := copy(s,1,lens-3);
          end
          else
            if copy(s, lens-3, lens) = 'ampm'
              then begin
                Use12Hours := h12_AMPM;
                s := copy(s,1,lens-4);
              end;
    for i := 1 to Length(s) do begin
      if ((s[i]) in ['d','M','y','h','m','s','z','0','a']) then s[i] := BlankChar;
    end; {--- for ---}
    //    
    case Use12Hours of
      h12_AM_PM : s := s + BlankChar+BlankChar;
      h12_A_P : s := s + BlankChar;
      h12_AMPM : for i := 1 to Length(TimeAMString) do s := s + BlankChar;
    end; {--- case ---}
    Result := s;
end;
procedure TsohoCustomEdit.SetEmptyText;
begin
  If (FMask<>'') and (BlankChar<>'') and (UseMask) then begin

    Text := EmptyText;
    MaxLength := Length(Text);
  end; {--- if ---}
end;

procedure TsohoCustomEdit.SetMask(Value : string);
var
  i         : Integer;
  ml        : Integer;
  MaskChars : SetOfChars;
begin
  if FMask <> Value then begin
    FMask     := Value;
    FDividers := [];
    ML := Length(FMask);
    FUseMask := FMask <> '';
    SetEmptyText;

    MaskChars := ['d','M','y','h','m','s','z','0','a'];

    if Use12Hours <> h12_None then MaskChars := MaskChars + ['p'];
    if Use12Hours = h12_AMPM then begin
      for i := 1 to Length(TimeAMString) do MaskChars := MaskChars + [TimeAMString[i]];
      for i := 1 to Length(TimePMString) do MaskChars := MaskChars + [TimePMString[i]];
    end; {--- if ---}

    for i := 1 to ML do begin
      if NOT((FMask[i]) in MaskChars) then FDividers := (FDividers + [Char(FMask[i])]);
    end; {--- for ---}
  end; {--- if ---}
end;

procedure TsohoCustomEdit.SetUseMask(Value : boolean);
begin
  if FUseMask <> Value then begin
    if Value and (FMask = '') then begin
      Error(se_ErrorUseMask);
      exit;
    end; {--- if ---}
    FUseMask := Value;
    SetEmptyText;
  end; {--- if ---}
end;

procedure TsohoCustomEdit.SetBlankChar(Value : char);
begin
  if FBlankChar <> Value then begin
    FBlankChar := Value;
    SetEmptyText;
  end; {--- if ---}
end;

function  TsohoCustomEdit.IsDivider(C : char) : boolean;
begin
  Result := c in FDividers;
end;

procedure TsohoCustomEdit.SetFloatDigits(Value : Integer);
begin
  if FFloatDigits <> Value then begin
    FFloatDigits := Value;
    if FFloatDigits < 0 then FFloatDigits := 0;
  end;  { --- if --- }
end;
//  
{------------------------------------------------------------------------------}

procedure TsohoCustomEdit.Error(const ErrorText: string);
begin
  if not FShowMessage then exit;
  if FSound <> nil then begin
    if (FSoundName <> EmptyStr) then begin
      if FSoundName[1] = '#' then
        FSound.PlayResourceWave(Copy(FSoundName, 2, Length(FSoundName)))
      else FSound.PlayWave(FSoundName);
    end;
  end;
  ErrorMsg(ErrorText);
end;

procedure TsohoCustomEdit.ModifyEvent;
begin
  if Assigned(FOnModify) then FOnModify(self, PString, Text);
end;

procedure TsohoCustomEdit.SaveAll;
begin
  PString := Text;
end;

procedure TsohoCustomEdit.RestoreAll;
begin
  Text := PString;
end;

function TsohoCustomEdit.GetDateTime: TDateTime;
begin
  Result := 0;
  try
    if IsNullDate(Text) then exit
    else Result := StrToDateTime(Text);
  except
    on EConvertError do Error(se_ErrorNotDate);
  end;
end;

function TsohoCustomEdit.GetDate: TDate;
begin
  Result := 0;
  try
    Result := trunc(WStrToDate(Text));
  except
    on EConvertError do Error(se_ErrorNotDate);
  end;
end;

function TsohoCustomEdit.GetTime: TTime;
begin
  Result := 0;
  try
    if (Text = EmptyStr) or (GetNoSpacePercent(Text) = 0) then exit
    else Result := Frac(StrToTime(Text));
  except on EConvertError do Error(se_ErrorNotTime);
end;
end;

function TsohoCustomEdit.GetString: string;
begin
  Result := Text;
end;

function TsohoCustomEdit.GetInteger: Longint;
var WasError: Boolean;
begin
  Result := WStrToInt(Text, WasError);
  if WasError then Error(se_ErrorNotInteger);
end;

function TsohoCustomEdit.GetFloat: Double;
var WasError: Boolean;
begin
  Result := WStrToFloat(Text, WasError);
  if WasError then Error(se_ErrorNotFloat);
end;

procedure TsohoCustomEdit.SetDateTime(Value: TDateTime);
Var
  OldSDF,OldLTF : String;
begin
  if FValueKind <> vkDateTime then begin
    Error(se_ErrorCannotLetDateTime);
    exit;
  end;
  SaveAll;
  if Usemask then begin
    SetDivisers([' ']);
    OldSDF := ShortDateFormat;
    OldLTF := LongTimeFormat;
    ShortDateFormat := GetSomeWords(Mask,1,1);
    LongTimeFormat  := GetSomeWords(Mask,2,2);
  end; {--- if ---}

  Text := WDateTimeToStr(Value);

  if Usemask then begin
    ShortDateFormat := OldSDF;
    LongTimeFormat  := OldLTF;
  end; {--- if ---}
end;

procedure TsohoCustomEdit.SetDate(Value: TDate);
Var
  OldSDF : String;
begin
  if FValueKind <> vkDate then begin
    Error(se_ErrorCannotLetDate);
    exit;
  end;
  SaveAll;
  if UseMask then begin
    OldSDF := ShortDateFormat;
    ShortDateFormat := Mask;
  end; {--- if ---}

  Text := WDateToStr(Value);

  if UseMask then ShortDateFormat := OldSDF;
end;

procedure TsohoCustomEdit.SetTime(Value: TTime);
Var
  OldLTF : String;
begin
  if FValueKind <> vkTime then begin
    Error(se_ErrorCannotLetTime);
    exit;
  end;
  SaveAll;
  if UseMask then begin
    OldLTF := LongTimeFormat;
    LongTimeFormat := Mask;
  end; {--- if ---}

  Text := TimeToStr(Value);

  if UseMask then LongTimeFormat := OldLTF;
end;

procedure TsohoCustomEdit.SetString(Value: string);
begin
  if FValueKind <> vkString then begin
    Error(se_ErrorCannotLetString);
    exit;
  end;
  SaveAll;
  Text := Value;
end;

procedure TsohoCustomEdit.SetInteger(Value: Longint);
begin
  if FValueKind <> vkInteger then begin
    Error(se_ErrorCannotLetInteger);
    exit;
  end;
  SaveAll;
  Text := IntToStr(Value);
end;

procedure TsohoCustomEdit.SetFloat(Value: Double);
begin
  if FValueKind <> vkFloat then begin
    Error(se_ErrorCannotLetFloat);
    exit;
  end;
  SaveAll;
  Text := FloatToStr(Value);
end;

procedure TsohoCustomEdit.SetValueKind(Value: TValueKind);
var IntTmp: Longint;
    WasError: Boolean;
    FlTmp   : Double;
begin
  IntTmp := 0;
  FlTmp := 0;
  if Value = FValueKind then exit;
  SaveAll;
  FValueKind := Value;
  case Value of
    vkInteger: begin if csLoading in ComponentState then Text := '0'
                     else IntTmp := StrToIntDef(Text, 0);
                Text := IntToStr(IntTmp);
                if not (csLoading in ComponentState) then
                  Alignment := taRightJustify;
    end;
    vkFloat: begin if csLoading in ComponentState then Text := '0'
                   else FlTmp := WStrToFloat(Text, WasError);
                Text := FloatToStr(FlTmp);
                if not (csLoading in ComponentState) then
                  Alignment := taRightJustify;
    end;
    vkDateTime: begin
       if FAutoFill then AsDateTime := Now;
       if not (csLoading in ComponentState) then Alignment := taCenter;
    end;
    vkDate: begin
       if FAutoFill then AsDate := Date;
       if not (csLoading in ComponentState) then Alignment := taCenter;
    end;
    vkTime: begin
       if FAutoFill then AsTime := Time;
       if not (csLoading in ComponentState) then Alignment := taCenter;
    end;
    vkString: if not (csLoading in ComponentState) then
     Alignment := taLeftJustify;
  end;
  DestroyRightControl;
  CreateRightControl;
end;

procedure TsohoCustomEdit.CMExit;
var WasError, Can: Boolean;
    Index: Integer;
    StrTmp: string;

  procedure ConvertError (const erText: string);
  begin
    RestoreAll;
    Error(erText);
    SetFocus;
  end;

begin
  //     ,    
  if GetParentForm(Self).ActiveControl = FButton then exit;
  WasError := false;
  if ((not FMayBeEmpty) or (Text <> '')) AND (Text <> EmptyText) then begin
{------------------------------------------------------------------------------}

{   -    }
    SaveAll;
    case FValueKind of
      vkInteger: begin
        WStrToInt(self.Text, WasError);
        if WasError then ConvertError(se_ErrorMustBeInteger);
      end;
      vkFloat: begin
        WStrToFloat(self.Text, WasError);
        if WasError then ConvertError(se_ErrorMustBeFloat);
      end;
      vkDateTime: begin
        try
          if not IsNullDate(Text) then StrToDateTime(Text);
        except
          WasError := true;
          ConvertError(se_ErrorMustBeDateTime);
        end;
      end;
      vkDate: begin
        try
          if not IsNullDate(Text) then StrToDate(Text);
        except
          WasError := true;
          ConvertError(se_ErrorMustBeDate);
        end;
      end;
      vkTime: begin
        try
          StrToTime(Text);
        except
          WasError := true;
          ConvertError(se_ErrorMustBeTime);
        end;
     end;
    end;
  end;
  if WasError then exit;
  StrTmp := Text;
  for Index := 1 to Length(FFromChars) do
    if Index <= Length(FToChars) then
      StrTmp := ChangeChars(StrTmp, FFromChars[Index], FToChars[Index]);
  Text := StrTmp;
  Can := FMayBeEmpty or (not (FMayBeEmpty) and (Text <> ''));
  if Assigned(FCanExit) then FCanExit(self, Can);
  if (not Can) and not (csDesigning in ComponentState) then begin
    Error(se_ErrorStringEmpty);
    SetFocus;
    exit;
  end;
  inherited;
  if PString <> Text then ModifyEvent;
  Invalidate;
end;

procedure TsohoCustomEdit.SetHighLight(Value: tColor);
begin
  FHighLight := Value;
  Invalidate;
end;

procedure TsohoCustomEdit.SetShadow(Value: tColor);
begin
  FShadow := Value;
  Invalidate;
end;

destructor TsohoCustomEdit.Destroy;
begin
  if FButton <> nil then begin
    TsohoBitBtn(FButton).OnClick := nil;
    TsohoBitBtn(FButton).Free;
  end;  
  inherited Destroy;
end;

procedure TsohoCustomEdit.SetEditStyle;
begin
  FEditStyle := Value;
  if Value = weFlat then begin
    OColor := Color;
    if Parent <> nil then OParentCtl3D := ParentCtl3D;
    Color := GetParentColor(Self);
  end
  else Color := OColor;
  RecreateWnd;
end;

procedure TsohoCustomEdit.DoRightClick(Sender: TObject);
var NewDate: TDate;
    NewDateTime: TDateTime;
    NewTime: TTime;
    Cntr: TWinControl;
begin
  if FCenterDialog then Cntr := nil
  else Cntr := Self;

  case ValueKind of
    vkDateTime: begin
      if IsNullDate(Text) then NewDateTime := Now
      else NewDateTime := AsDateTime;
      if SelectDateTime(Cntr, NewDateTime, '', dowLocaleDefault) then
        AsDateTime := NewDateTime;
    end;
    vkDate: begin
      if IsNullDate(Text) then NewDate := Date
      else NewDate := AsDate;
      if SelectDate(Cntr, NewDate, '', dowLocaleDefault) then AsDate := NewDate;
    end;
    vkTime: begin
      if Text = '' then NewTime := Time
      else NewTime := AsTime;
      if SelectTime(Cntr, NewTime, '') then AsTime := NewTime;
    end;
    vkInteger, vkFloat:
      with TsohoCalculator.Create(Self) do begin
        Caption := sohoCalcCaption;
        Control := Cntr;
        {$IFDEF Delphi3}
        Color := clBtnFace;
        FlatButtons := false;
        {$ENDIF}
        if ValueKind = vkInteger then Value := AsInteger
        else Value := AsFloat;
        if Execute then begin
          if ValueKind = vkInteger then AsInteger := SoUtils.Round(Value)
          else AsFloat := Value;
        end;
        Free;
      end;
  end;
  SetFocus;
  if Assigned(FOnRightClick) then FOnRightClick(self);
end;

procedure TsohoCustomEdit.DestroyRightControl;
begin
  TsohoBitBtn(FButton).Visible := false;
end;

procedure TsohoCustomEdit.SetRightControlPosition;
begin
  with TsohoBitBtn(FButton) do begin
    Left := self.Left + self.Width + 2;
    Top := self.Top;
    Height := self.Height;
    Width := Height;
  end;
end;

procedure TsohoCustomEdit.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  inherited SetBounds(ALeft, ATop, AWidth, AHeight);
  if not FRightControl then exit;
  SetRightControlPosition;
end;

procedure TsohoCustomEdit.SetRightControl(Value: Boolean);
begin
  FRightControl := Value;
  if FRightControl then CreateRightControl
  else DestroyRightControl;
end;

procedure TsohoCustomEdit.CreateRightControl;
var GlyphIndex: LongInt;
begin
  if not FRightControl then exit;
  TsohoBitBtn(FButton).Parent := Parent;
  SetRightControlPosition;
  with TsohoBitBtn(FButton) do begin
    case ValueKind of
      vkString: GlyphIndex := -1;
      vkInteger,
      vkFloat: GlyphIndex := 0;
      vkDate, vkDateTime: GlyphIndex := 2;
      else GlyphIndex := 4;
    end;
    if GlyphIndex <> -1 then begin
      Images := EditImages;
      NumGlyphs := 2;
      ImageIndex := GlyphIndex;
    end
    else Images := nil;
  end;
  TsohoBitBtn(FButton).Visible := Visible;
end;

constructor TsohoCustomEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCenterDialog := true;
  FOldTag := Tag;
  FEnabled := true;
  FShowMessage := True;
  FValueKind := vkString;
  PString := Text;
  if Owner <> nil then FSound := FindSound(GetOwnerForm(self));
  FSoundName := 'SystemAsterisk';
  FHighLight := clBtnShadow;
  FShadow := clBtnHighlight;
  FDirectEnter := false;
  OColor := Color;
  FEditStyle := weNormal;
  FMayBeEmpty := True;
  FButton := nil;
  FButton := TsohoBitBtn.Create(Self);
  with TsohoBitBtn(FButton) do begin
    SetBounds(0, 0, Height, Height);
    ParentColor := true;
    NumGlyphs := 2;
    Visible := True;
    OnClick := DoRightClick;
    if csDesigning in ComponentState then
      SetComponentState(FButton, []);
    TabStop := false;
    DrawFocus := false;
  end;
  if csDesigning in ComponentState then
    SetComponentState(TsohoBitBtn(FButton),[]);
  FAutoFill := False;

  {$IFDEF USE_ROUND}
  FRoundValue := false;
  FRoundDigits := 2;
  {$ENDIF}
{------------------------------------------------------------------------------}
  FDividers    := [];
  FMask        := '';
  FUseMask     := False;
  FBlankChar   := '_';
  FLightLabel  := nil;
  FFloatDigits := 0;
{------------------------------------------------------------------------------}
end;

procedure TsohoCustomEdit.Cancel;
begin
  Undo;
end;

procedure TsohoCustomEdit.RecalcNonClient(var R: TRect);
begin
  if FEditStyle = weNormal then inherited;
end;

procedure TsohoCustomEdit.CMVISIBLECHANGED(var message: TMessage);
begin
  inherited;
  TsohoBitBtn(FButton).Visible := Visible;
end;

{ TsohoLabel }
procedure TsohoCustomLabel.BeforePaint (Canvas: TCanvas; Rect: TRect);
begin
  if Assigned(FOnBeforePaint) then FOnBeforePaint(Self, Canvas, Rect);
end;

procedure TsohoCustomLabel.AfterPaint (Canvas: TCanvas; Rect: TRect);
begin
  if Assigned(FOnAfterPaint) then FOnAfterPaint(Self, Canvas, Rect);
end;

procedure TsohoCustomLabel.CMDialogChar(var Message: TCMDialogChar);
begin
  if (FocusControl <> nil) and Enabled and ShowAccelChar and
    IsAccel(Message.CharCode, Caption) then
    with FocusControl do
      if CanFocus then begin
        SetFocus;
        Message.Result := 1;
      end;
end;

procedure TsohoCustomLabel.Loaded;
begin
  inherited Loaded;
  UpdateBounds;
  MoveFocusControl(Left, Top, Width, Height);
end;

procedure TsohoCustomLabel.Click;
begin
  if not ClickAssigned(self) and (FocusControl <> nil) and
    Alive and (FocusControl.Enabled) and (FocusControl.Visible) then FocusControl.SetFocus
  else inherited Click;
end;

procedure TsohoCustomLabel.UpdateBounds;
var Rect: TRect;
  DC: HDC;
begin
  if AutoSize then begin
    Rect := ClientRect;
    DC := GetDC(0);
    Canvas.Handle := DC;
    Canvas.Font := Font;
    Draw3DText(Caption, Rect, Canvas, Light, Color, LightColor, ShadowColor, Height3D,
      Alignment, {$IFDEF Delphi4_or_5}Layout, {$ENDIF}
      WordWrap, ShowAccelChar, True);
    Canvas.Handle := 0;
    ReleaseDC(0, DC);
    if Bevel then begin
      if BevelOuter <> bvNone then begin
        Rect.Right := Rect.Right + 2 * BevelWidth;
        Rect.Bottom := Rect.Bottom + 2 * BevelWidth;
      end;
      Rect.Right := Rect.Right + 2 * BorderWidth;
      Rect.Bottom := Rect.Bottom + 2 * BorderWidth;
      if BevelInner <> bvNone then begin
        Rect.Right := Rect.Right + 2 * BevelWidth;
        Rect.Bottom := Rect.Bottom + 2 * BevelWidth;
      end;
    end;
    Height := Rect.Bottom;
    Width := Rect.Right;
  end;
end;

procedure TsohoCustomLabel.SetTrans(Value: Boolean);
begin
  inherited Transparent := Value;
end;

function TsohoCustomLabel.GetTrans: Boolean;
begin
  Result := inherited Transparent;
end;

function TsohoCustomLabel.GetFAutoSize: Boolean;
begin
  Result := FAutoSize;
end;

procedure TsohoCustomLabel.SetFAutoSize(Value: Boolean);
begin
  if FAutoSize = Value then exit;
  FAutoSize := Value;
  if not (csLoading in ComponentState) then UpdateBounds;
  Repaint;
end;

procedure TsohoCustomLabel.SetWrap;
begin
  FWordWrap := Value;
  Repaint;
end;

procedure TsohoCustomLabel.SetFActiveColor(Value: tColor);
begin
  FActColor := Value;
  if not (csLoading in ComponentState) then ParentColor := False;
end;

procedure TsohoCustomLabel.SetFActiveFont(Value: tFont);
begin
  FActFont.Assign(Value);
  if not (csLoading in ComponentState) then ParentFont := False;
end;

procedure TsohoCustomLabel.CMParentColorChanged(var message: TMessage);
begin
  inherited;
  if ParentColor then FActColor := Color;
end;

procedure TsohoCustomLabel.CMParentFontChanged(var message: TMessage);
begin
  inherited;
  if ParentFont then FActFont.Assign(Font);
end;

procedure TsohoCustomLabel.CMMouseEnter(var message: TMessage);
begin
  MouseOverLabel := True;
  if Assigned(FOnMouseEnter) then FOnMouseEnter(self);
  if FAlive then Invalidate;
end;

procedure TsohoCustomLabel.CMMouseLeave(var message: TMessage);
begin
  MouseOverLabel := False;
  if Assigned(FOnMouseLeave) then FOnMouseLeave(self);
  if FAlive then Invalidate;
end;

destructor TsohoCustomLabel.Destroy;
begin
  FActFont.Free;
  inherited Destroy;
end;

procedure TsohoCustomLabel.SetAlive;
begin
  FAlive := Value;
  Invalidate;
end;

constructor TsohoCustomLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAlive := False;
  inherited AutoSize := False;
  FAlignment := taLeftJustify;
  Height := 21;
  FLight := lpLeftTop;
  F3DHeight := 1;
  FLightColor := clWhite;
  FShadowColor := clGray;
  FBevel := True;
  FBevelInner := bvRaised;
  FBevelOuter := bvLowered;
  FBevelWidth := 1;
  FBorderWidth := 0;
  Transparent := True;
  FWordWrap := True;
  fPos := wlpLeft;
  FFocusOffset := 2;
  MouseOverLabel := False;
  FActFont := tFont.Create;
  FActFont.OnChange := ActFontChanged;
  FActColor := Color;
  {$IFDEF Delphi4_or_5}
  Layout := tlCenter;
  {$ENDIF}
end;

procedure TsohoCustomLabel.ActFontChanged(Sender: TObject);
begin
  Invalidate;
end;

procedure TsohoCustomLabel.SetFocusOffset;
begin
  FFocusOffset := Value;
  MoveFocusControl(Left, Top, Width, Height)
end;

procedure TsohoCustomLabel.SetBounds;
var DoMove: Boolean;
begin
  DoMove := (Top <> ATop) or (Left <> ALeft) or (Height <> AHeight) or (Width <> AWidth);
  inherited SetBounds(ALeft, ATop, AWidth, AHeight);
  if DoMove then MoveFocusControl(ALeft, ATop, AWidth, AHeight);
end;

procedure TsohoCustomLabel.SetBevel(Value: Boolean);
begin
  FBevel := Value;
  Repaint;
end;

procedure TsohoCustomLabel.SetBevelInner(Value: TPanelBevel);
begin
  FBevelInner := Value;
  Repaint;
end;

procedure TsohoCustomLabel.SetBevelOuter(Value: TPanelBevel);
begin
  FBevelOuter := Value;
  Repaint;
end;

procedure TsohoCustomLabel.SetBevelWidth(Value: Integer);
begin
  FBevelWidth := Value;
  Repaint;
end;

procedure TsohoCustomLabel.SetBorderWidth(Value: Integer);
begin
  FBorderWidth := Value;
  Repaint;
end;

procedure TsohoCustomLabel.SetAlignment(Value: TAlignment);
begin
  FAlignment := Value;
  Repaint;
end;

procedure TsohoCustomLabel.SetLColor(Value: tColor);
begin
  FLightColor := Value; Repaint;
end;

procedure TsohoCustomLabel.SetFControl(Value: TWinControl);
begin
  inherited FocusControl := Value;
  MoveFocusControl(Left, Top, Width, Height);
end;

procedure TsohoCustomLabel.SetLabelPos(Value: TsohoLabelPosition);
begin
  fPos := Value;
  MoveFocusControl(Left, Top, Width, Height);
end;

procedure TsohoCustomLabel.MoveFocusControl(ALeft, ATop, AWidth, AHeight: Integer);
begin
  if (FocusControl <> nil) and (fPos <> wlpUnLinked) and
    (FocusControl.Parent = Parent) then
    with FocusControl do begin
      case fPos of
        wlpTop: begin
          Top := ATop + AHeight + FFocusOffset;
          Left := ALeft;
          if (FocusControl is TsohoCustomEdit) and
             (FocusControl as TsohoCustomEdit).RightControl then
             Width := AWidth - TsohoBitBtn((FocusControl as TsohoCustomEdit).Button).Width - 2
          else Width := AWidth;
        end;
        wlpLeft: begin
          Top := ATop;
          Left := ALeft + AWidth + FFocusOffset;
          Height := AHeight;
        end;
        wlpRight: begin
          Top := ATop;
          Left := ALeft - Width - FFocusOffset;
          Height := AHeight;
        end;
        wlpBottom: begin
          Top := ATop - Height - FFocusOffset;
          Left := ALeft;
          if (FocusControl is TsohoCustomEdit) and
             (FocusControl as TsohoCustomEdit).RightControl then
             Width := AWidth - TsohoBitBtn((FocusControl as TsohoCustomEdit).Button).Width - 2
          else Width := AWidth;
        end;
      end;
    end;
end;

function TsohoCustomLabel.GetFControl: TWinControl;
begin
  Result := inherited FocusControl;
end;

procedure TsohoCustomLabel.SetSColor(Value: tColor);
begin
  FShadowColor := Value;
  Invalidate;
end;

procedure TsohoCustomLabel.CMTextChanged(var message: TMessage);
begin
  Invalidate;
end;

procedure TsohoCustomLabel.CMFontChanged(var message: TMessage);
begin
  Invalidate;
end;

procedure TsohoCustomLabel.SetLight(Value: TLightPos);
begin
  FLight := Value;
  Invalidate;
end;

procedure TsohoCustomLabel.Set3DHeight(Value: Integer);
begin
  if Value < 0 then exit;
  F3DHeight := Value;
  // UpdateBounds;
  Repaint;
end;

procedure TsohoCustomLabel.Paint;
var TopColor,
  BottomColor: tColor;
  Rect       : TRect;
begin
  with Canvas do begin
    Rect := GetClientRect;
    if Assigned(FOnBeforePaint) then BeforePaint(Canvas, Rect)
    else begin
      if FBevel then begin
        if BevelOuter <> bvNone then begin
          AdjustColors(BevelOuter, TopColor, BottomColor, clBtnHighlight, clBtnShadow);
          Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
        end;
        Frame3D(Canvas, Rect, Color, Color, BorderWidth);
        if BevelInner <> bvNone then begin
          AdjustColors(BevelInner, TopColor, BottomColor, clBtnHighlight, clBtnShadow);
          Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
        end;
      end;
      if not Transparent then begin
        Brush.Style := bsSolid;
        if MouseOverLabel then Brush.Color := FActColor
        else Brush.Color := self.Color;
        FillRect(Rect);
      end;
      Brush.Style := bsClear;
      if MouseOverLabel then Font.Assign(FActFont)
      else Font.Assign(self.Font);
      Draw3DText(Caption, Rect, Canvas, FLight, Font.Color, FLightColor, FShadowColor,
        F3DHeight, Alignment, {$IFDEF Delphi4_or_5}Layout, {$ENDIF}
        FWordWrap, False, False);
    end;
    AfterPaint(Canvas, Rect);
  end;
end;

{ TsohoPanel }
procedure TsohoPanel.ImageChanged(Sender: TObject);
begin
  Invalidate;
end;

constructor TsohoPanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FBackImage := TBitmap.Create;
  FBackImage.Handle := LoadBitmap(hInstance, 'DEFAULTPANEL');
  FBackImage.OnChange := ImageChanged;
end;

function TsohoPanel.GetPalette: HPALETTE;
begin
  Result := FBackImage.Palette;
end;

destructor TsohoPanel.Destroy;
begin
  FBackImage.Free;
  inherited Destroy;
end;

procedure TsohoPanel.SetBackImage(Value: TBitmap);
begin
  FBackImage.Assign(Value);
  if Value = nil then FBackImage.Handle := ResBitmap('DEFAULTPANEL');
  Invalidate;
end;

procedure TsohoPanel.Paint;
var Rect, Image: TRect;
  TopColor, BottomColor: tColor;
  Text                 : array[0..255] of Char;
  TmpW, FontHeight     : Integer;
  K, k1                : Integer;
  MemBmp               : TBitmap;

const Alignments: array[TAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);
begin
  Rect := GetClientRect;
  MemBmp := TBitmap.Create;
  MemBmp.Width := Width;
  MemBmp.Height := Height;
  MemBmp.Palette := FBackImage.Palette;
  with MemBmp do begin
    if BevelOuter <> bvNone then begin
      AdjustColors(BevelOuter, TopColor, BottomColor, clBtnHighlight, clBtnShadow);
      Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
    end;
    // Frame3D(Canvas, Rect, Color, Color, BorderWidth);
    TmpW := BorderWidth;
    Dec(Rect.Bottom); Dec(Rect.Right);
    while TmpW > 0 do begin
      Dec(TmpW);
      InflateRect(Rect, -1, -1);
    end;
    Inc(Rect.Bottom); Inc(Rect.Right);
    if BevelInner <> bvNone then begin
      AdjustColors(BevelInner, TopColor, BottomColor, clBtnHighlight, clBtnShadow);
      Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
    end;
    with MemBmp.Canvas do begin
      if (FBackImage <> nil) and
         (FBackImage.Width <> 0) and
         (FBackImage.Height <> 0) then begin
        for K := 0 to Round((Rect.Right - Rect.Left) / FBackImage.Width) do
          for k1 := 0 to Round((Rect.Bottom - Rect.Top) / FBackImage.Height) do
            with IMAGE do begin
              Left := Rect.Left + K * FBackImage.Width;
              Top := Rect.Top + k1 * FBackImage.Height;
              Right := Left + FBackImage.Width;
              if Right > Rect.Right then Right := Rect.Right;
              Bottom := Top + FBackImage.Height;
              if Bottom > Rect.Bottom then Bottom := Rect.Bottom;
              CopyRect(IMAGE, FBackImage.Canvas, Bounds(0, 0, IMAGE.Right - IMAGE.Left,
                IMAGE.Bottom - IMAGE.Top));
            end;
      end
      else begin
        BRUSH.Color := Color;
        BRUSH.Style := bsSolid;
        FillRect(Rect);
      end;
      BRUSH.Style := bsClear;
      Font := self.Font;
      FontHeight := TextHeight('W');
      with Rect do begin
        Top := ((Bottom + Top) - FontHeight) shr 1;
        Bottom := Top + FontHeight;
      end;
      StrPCopy(Text, Caption);
      DrawText(Handle, Text, StrLen(Text), Rect, (DT_EXPANDTABS or
        DT_VCENTER) or Alignments[Alignment]);
    end;
  end;
  BitBlt(Canvas.Handle, 0, 0, Width, Height, MemBmp.Canvas.Handle, 0, 0, SRCCOPY);
  MemBmp.Free;
end;

{ TsohoCustomComboBox }
procedure TsohoCustomComboBox.Notification(aComponent: TComponent; aOperation: TOperation);
begin
  inherited;
  if (aComponent = FLightLabel) and (aOperation = opRemove) then
    FLightLabel := nil;
end;

procedure TsohoCustomComboBox.Lookup;
var Index: LongInt;
begin
  if not Sorted then exit;
  Index := Items.IndexOf(FLookup);
  if Index <> -1 then ItemIndex := Index;
  if FLookup = '' then ItemIndex := -1;
end;

procedure TsohoCustomComboBox.KeyPress(var Key: Char);
const
  PressCount: LongInt = 0;
begin
  inherited;
  if Style <> csDropDownList then exit;
  inc(PressCount);
  if PressCount = 2 then begin
    PressCount := 0;
    exit;
  end;
  if Key = #8 then begin
    if Length(FLookup) > 0 then Delete(FLookup, Length(FLookup), 1)
  end
  else FLookup := FLookup + Key;
  Lookup;
end;

procedure TsohoCustomComboBox.CreateParams(var Params: TCreateParams);
const
  ComboBoxStyles: array[TComboBoxStyle] of DWORD = (
    CBS_DROPDOWN, CBS_SIMPLE, CBS_DROPDOWNLIST,
    CBS_DROPDOWNLIST or CBS_OWNERDRAWFIXED,
    CBS_DROPDOWNLIST or CBS_OWNERDRAWVARIABLE);
  Sorts: array[Boolean] of DWORD = (0, CBS_SORT);
begin
  inherited CreateParams(Params);
  with Params do begin
    Style := (Style or (WS_VSCROLL or CBS_HASSTRINGS or CBS_AUTOHSCROLL) or
      ComboBoxStyles[Self.Style] or Sorts[Sorted]) and (not CBS_NOINTEGRALHEIGHT);
    ExStyle := ExStyle and not WS_EX_CLIENTEDGE;
  end;
end;

//------------------------------------------------------------------------------
procedure TsohoCustomComboBox.SetLightLabel(Value : TsohoCustomLabel);
begin
  If FLightLabel <> Value then begin
    FLightLabel := Value;
  End; {--- if ---}
end;
//------------------------------------------------------------------------------

constructor TsohoCustomComboBox.Create (AOwner: TComponent);
begin
  inherited;
  ControlStyle := ControlStyle - [csFramed, csFixedHeight]; {fixes a VCL bug with Win 3.x}
  FLookup := '';
end;

procedure TsohoCustomComboBox.CMMouseEnter (var Message: TMessage);
begin
  inherited;
  MouseInControl := True;
  RedrawBorder (0);
end;

procedure TsohoCustomComboBox.CMMouseLeave (var Message: TMessage);
begin
  inherited;
  MouseInControl := False;
  RedrawBorder (0);
end;

procedure TsohoCustomComboBox.WMNCPaint (var Message: TMessage);
begin
  inherited;
  RedrawBorder (HRGN(Message.WParam));
end;

procedure TsohoCustomComboBox.CMVISIBLECHANGED (var Message : TMessage);
begin
  inherited;
  RedrawBorder (0);
end;

procedure TsohoCustomComboBox.WMPaint(var message: TWMPaint);
begin
  inherited;
  RedrawBorder (0);
end;

procedure TsohoCustomComboBox.CMEnter(var message: TCMEnter);
begin
  inherited;
  RedrawBorder (0);
  //  
  if (FLightLabel <> nil) and (FLightLabel.Alive) then begin
    FLightLabel.MouseOverLabel := True;
    FLightLabel.Invalidate;
  end;
end;

procedure TsohoCustomComboBox.CMExit(var message: TCMExit);
begin
  inherited;
  RedrawBorder (0);
  if FLightLabel <> nil then begin
    FLightLabel.MouseOverLabel := False;
    FLightLabel.Invalidate;
  end;
end;

procedure TsohoCustomComboBox.RedrawBorder (const Clip: HRGN);
var
  DC: HDC;
  R: TRect;
  NewClipRgn: HRGN;
  BtnFaceBrush, WindowBrush: HBRUSH;
  z : boolean;
  NeedDestroyBrush: boolean;
begin
  DC := GetWindowDC(Handle);
  NeedDestroyBrush := false;
  BtnFaceBrush := 0; // for stupid delphi hints maker!
  try
    { Use update region }
    if (Clip <> 0) and (Clip <> 1) then begin
      GetWindowRect (Handle, R);
      if SelectClipRgn(DC, Clip) = ERROR then begin
        NewClipRgn := CreateRectRgnIndirect(R);
        SelectClipRgn (DC, NewClipRgn);
        DeleteObject (NewClipRgn);
      end;
      OffsetClipRgn (DC, -R.Left, -R.Top);
    end;

    { This works around WM_NCPAINT problem described at top of source code }
    {no!  R := Rect(0, 0, Width, Height);}
    GetWindowRect (Handle, R);  OffsetRect (R, -R.Left, -R.Top);
    z := Screen.ActiveControl = Self;
    if ((csDesigning in ComponentState) and Enabled) or
       (not(csDesigning in ComponentState) and
       (z or MouseInControl)) then begin
         NeedDestroyBrush := true;
         BtnFaceBrush := CreateSolidBrush(0)
       end
    else
       BtnFaceBrush := GetSysColorBrush(COLOR_BTNFACE);
    WindowBrush := GetSysColorBrush(COLOR_WINDOW);
    if ((csDesigning in ComponentState) and Enabled) or
       (not(csDesigning in ComponentState) and
        (z or MouseInControl)) then begin
      DrawEdge (DC, R, BDR_SUNKENOUTER, BF_RECT or BF_ADJUST);
      with R do begin
        FillRect (DC, Rect(Left, Top, Left+1, Bottom-1), BtnFaceBrush);
        FillRect (DC, Rect(Left, Top, Right-1, Top+1), BtnFaceBrush);
      end;
      DrawEdge (DC, R, BDR_SUNKENINNER, BF_BOTTOMRIGHT);
      InflateRect (R, -1, -1);
      FrameRect (DC, R, WindowBrush);
    end
    else begin
      if Enabled then begin
        DrawEdge (DC, R, BDR_SUNKENOUTER, BF_RECT or BF_ADJUST);
        with R do begin
          FillRect (DC, Rect(Left, Top, Left+1, Bottom-1), BtnFaceBrush);
          FillRect (DC, Rect(Left, Top, Right-1, Top+1), BtnFaceBrush);
        end;
        DrawEdge (DC, R, BDR_SUNKENINNER, BF_BOTTOMRIGHT);
        InflateRect (R, -1, -1);
        FrameRect (DC, R, WindowBrush);
      end;
    end;
  finally
    if NeedDestroyBrush then DeleteObject(BtnFaceBrush);
    ReleaseDC (Handle, DC);
  end;
end;

procedure LoadImages;
begin
  EditImages := TImageList.Create(nil);
  EditImages.Width := 14;
  EditImages.Height := 12;
  EditImages.ResourceLoad(rtBitmap, 'SOHOEDITBMPS', clAqua);
end;

initialization
  Screen.Cursors[crHandPoint] := ResCursor('POINTCURSOR');
  LoadImages;
finalization
  EditImages.Free;
end.