{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov,              }
{                   Igor Chernyshov                     }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
  06.11.2000 -     Boolean 
}

unit SoDBGrid;

{$I SOHOLIB.INC}

interface

uses
  Windows, Registry, Messages, Classes, Controls, Forms, Grids,
  Graphics, Buttons, Menus, DB, DBCtrls, DBGrids, SoClass, SoChkBox, StdCtrls;

{ TsohoCustomDBGrid }

{$IFNDEF CBUILDER}
const
  DefSohoGridOptions = [dgEditing, dgTitles, dgIndicator, dgColumnResize,
    dgColLines, dgRowLines, dgConfirmDelete, dgCancelOnExit];
{$ENDIF}

type

  TTitleClickEvent = procedure (Sender: TObject; ACol: Longint;
    Field: TField) of object;
{   OnTitleClick.        TDataSet }
  TCheckTitleBtnEvent = procedure (Sender: TObject; ACol: Longint;
    Field: TField; var Enabled: Boolean) of object;
{   OnCheckButton.       
   ACol   Field,   .   
   ,   Enabled   False. }
  TGetCellParamsEvent = procedure (Sender: TObject; Field: TField;
    AFont: TFont; var Background: TColor; Highlight: Boolean) of object;
{    OnGetCellParams.       
       - .      AFont  Background,
     }

  TSortMarker = (smNone, smDown, smUp);
{      SortMarker  -   OnGetBtnParams  
TsohoDBGrid. 
 : 
 smNone -     
 smDown -     
 smUp -     . }

  TGetBtnParamsEvent = procedure (Sender: TObject; Field: TField;
    AFont: TFont; var Background: TColor; var SortMarker: TSortMarker;
    IsDown: Boolean) of object;
{   OnGetBtnParams }
  TGetCellPropsEvent = procedure (Sender: TObject; Field: TField;
    AFont: TFont; var Background: TColor) of object; { obsolete }
{   OnGetCellProps }

  TDBEditShowEvent = procedure (Sender: TObject; Field: TField;
    var AllowEdit: Boolean) of object;
{    OnShowEditor.       Field }

  TsohoDBGridResults = class(TsohoIntegerList);
  {      TsohoDBGrid.  
    Results }

  TsohoGridOperation = (soNewRecord, soDeleteRecord, soEditRecord);
  {       TsohoDBGrid -   ,   
      }

  TsohoGridScroll = procedure (Sender: TObject; Vertical: Boolean; wScrollCode: Smallint) of object;
  {    OnScroll  TsohoDBGrid }

  TsohoOnGridOperation = function (Sender: TObject; Operation: TsohoGridOperation): Boolean of object;
  {         
    :
    1. Enter       -  
    2. Insert -   
    3. Delete -   
  }

  TsohoGridKeyOption = (dgAllowDelete, dgAllowInsert, dgEnterToTab);
  {   TsohoDBGrid.
    dgAllowDelete -  
    dgAllowInsert -    
    dgEnterToTab  -   Enter     Tab
  }

  TsohoGridKeyOptions = set of TsohoGridKeyOption;
  {     TsohoDBGrid }

  TsohoGridSelectOption = (dgsAllowMultiSelect, dgsShiftArrows,
                           dgsCtrlA_SelectAll, dgsAllowGrayKeys,
                           dgsCtrlLMouse, dgsShiftLMouse, dgsPersistSelect);
  {         :
    dgsMultiAllowSelect -    ( MultiSelect, 
                            Bookmark,   Results : TsohoIntegerList
                                .
                           - MultiSelect     
                           RX-)
    dgsShiftArrows      -   Shift- -
    dgsCtrlA_SelectAll  -      Ctrl-A
    dgsAllowGrayKeys    -      :
                           + -  
                           - -  
                           * -  
    dgsCtrlLMouse       -    Ctrl+  
    dgsShiftLMouse      -       
    dgsPersistSelect    -     ,  
                               / (- Explorer)
  }
  TsohoGridSelectOptions = set of TsohoGridSelectOption;
{ ,   ,       }

  TsohoCustomDBGrid = class(TDBGrid)
  private
{$IFDEF CBuilder}
    FGridState : TGridState;
{$ENDIF}
    FShowGlyphs: Boolean;
    FDefaultDrawing: Boolean;
    FRowHeightPercent : integer;
    FMultiSelect: Boolean;
    FSelecting: Boolean;
    FClearSelection: Boolean;
    FTitleButtons: Boolean;
    FTitleColor : TColor;

    FTitleLines : integer;
    FTitleAlignment : TAlignment;
    FCalcCellRow,
    FCalcCellCol : LongInt;
    InUpdateRowCount : boolean;
    FUpdateLock : integer;
    FResults: TsohoDBGridResults;
    FRowSelect: Boolean;
    FRowColor: tColor;
    FRowFont: tFont;
    FColReSize: TNotifyEvent;
    FOnScroll: TsohoGridScroll;
    FSpecEvent: TsohoOnGridOperation;
    FSelfChangingRowFont: Boolean;
    FAddColumn: Boolean;
    FDrawChecks: Boolean;
    FMarkedColor: tColor;
    FMarkedFont: tFont;
    FStriply : boolean;
    FStriplyColor : TColor;
    FWordWrap : boolean;
    FVCount,
      FHCount: Integer;
    FBeforeFlag : boolean;
    FBeforeColumnMoved : TNotifyEvent;
    FKeyOptions : TsohoGridKeyOptions;
    FKeyField: string;
    FEditOnDblClick : boolean;

{$IFDEF WIN32}
    FPressedCol: TColumn;
{$ELSE}
    FPressedCol: Longint;
{$ENDIF}
    FPressed: Boolean;
    FTracking: Boolean;
    FSwapButtons: Boolean;
    FDisableCount: Integer;
    FFixedCols: Integer;
    FMsIndicators: TImageList;
    FOnCheckButton: TCheckTitleBtnEvent;
    FOnGetCellProps: TGetCellPropsEvent;
    FOnGetCellParams: TGetCellParamsEvent;
    FOnGetBtnParams: TGetBtnParamsEvent;
    FOnEditChange: TNotifyEvent;
    FOnKeyPress: TKeyPressEvent;
    FOnTitleBtnClick: TTitleClickEvent;
    FOnShowEditor: TDbEditShowEvent;
    FSelectionAnchor: TBookmarkStr;
{-----------------------------------------------------------------------------}
    FSelectOptions : TsohoGridSelectOptions;
    FSelectKey     : TShortCut;
    FBoolFields    : TStringList;
    FOldACol       : Integer;   //   ,     
    FOldARow       : Integer;   //  Boolean, CheckBox   
    procedure EditBoolField;    //    CheckBox
{-----------------------------------------------------------------------------}

    procedure SetTitleLines (Value : integer);
    procedure SetTitleAlignment (Value: TAlignment);
    procedure SetMarkedColor(Value: tColor);
    procedure SetMarkedFont(Value: tFont);
    procedure SetRowSelect(Value: Boolean);
    procedure SetRowColor(Value: tColor);
    procedure SetRowFont(Value: tFont);
    procedure SetAddColumn(Value: Boolean);
    procedure SetDrawChecks(Value: Boolean);
    procedure SetColWidthByFieldIndex(index: Integer; Value: Integer);
    function GetColWidthByFieldIndex(index: Integer): Integer;
    procedure ReReadGrid(Sender: TObject);
    procedure SetStriply (Value : boolean);
    procedure SetStriplyColor (Value : TColor);
    procedure SetWordWrap (Value : boolean);
//    procedure SetRowHeightPercent (Value : integer);


    function GetImageIndex(Field: TField): Integer;
    procedure SetShowGlyphs(Value: Boolean);
    procedure SetRowsHeight(Value: Integer);
    function GetRowsHeight: Integer;
    procedure SetMultiSelect(Value: Boolean);
    procedure SetTitleButtons(Value: Boolean);
    procedure StopTracking;
    procedure TrackButton(X, Y: Integer);
    function ActiveRowSelected: Boolean;
    function GetSelCount: Longint;
    function GetOptions: TDBGridOptions;
    procedure SetOptions(Value: TDBGridOptions);
    function GetMasterColumn(ACol, ARow: Longint): TColumn;
    function GetTitleOffset: Byte;
    procedure SetFixedCols(Value: Integer);
    function GetFixedCols: Integer;
{$IFDEF Delphi4_or_5}
    function CalcLeftColumn: Integer;
{$ENDIF}
    procedure WMChar(var Msg: TWMChar); message WM_CHAR;
    procedure WMCancelMode(var Message: TMessage); message WM_CANCELMODE;
    procedure WMRButtonUp(var Message: TWMMouse); message WM_RBUTTONUP;
  protected
    procedure SetBoolFields(Value: TStrings);
    function GetBoolFields: TStrings;
    function  CalcCellRow : LongInt;
    procedure SetTitleColor (Value : TColor);
    procedure CalcRowHeight;
    procedure UpdateRowCount;
    // procedure ColWidthsChanged; override;
    // procedure LayoutChanged;override;


    {procedure DrawColumnCell(const Rect: TRect; DataCol: Integer;
      Column: TColumn; State: TGridDrawState); override;}
    procedure CMFontChanged(var message: TMessage); message CM_FONTCHANGED;
    procedure RowFontChanged(Sender: TObject);
    procedure CMParentFontChanged(var message: TMessage); message CM_PARENTFONTCHANGED;
    // procedure DblClick; override;
    // procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    // procedure KeyPress(var Key: Char); override;
    // procedure Scroll(Distance: Integer); override;
    procedure DoGridScroll(Vertical: Boolean; wScrollCode: Smallint); dynamic;
    procedure WMVScroll(var message: TWMScroll); message WM_VSCROLL;
    procedure WMHScroll(var message: TWMScroll); message WM_HSCROLL;
    // function  ActiveRowSelected: Boolean;
    procedure SetMimimumWidth(Cell : TGridCoord; ReHeight : boolean);
    function  FieldToColumnIndex (Field: TField): LongInt;


    function AcquireFocus: Boolean;
    function CanEditShow: Boolean; override;
    function CreateEditor: TInplaceEdit; override;
    procedure DoTitleClick(ACol: Longint; AField: TField); dynamic;
    procedure CheckTitleButton(ACol, ARow: Longint; var Enabled: Boolean); dynamic;
    procedure DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState); override;
    procedure EditChanged(Sender: TObject); dynamic;
    procedure GetCellProps(Field: TField; AFont: TFont; var Background: TColor;
      Highlight: Boolean); dynamic;
    function HighlightCell(DataCol, DataRow: Integer; const Value: string;
      AState: TGridDrawState): Boolean; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    procedure SetColumnAttributes; override;
    procedure WMDblClick(var Message: TMessage); message WM_LBUTTONDBLCLK;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
{$IFDEF Delphi4_or_5}
    function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;
{$ENDIF}
    procedure Scroll(Distance: Integer); override;
    procedure LayoutChanged; override;
    procedure TopLeftChanged; override;
    procedure DrawColumnCell(const Rect: TRect; DataCol: Integer;
      Column: TColumn; State: TGridDrawState); override;
    procedure ColWidthsChanged; override;
    {   }
    property TitleColor : TColor read FTitleColor write SetTitleColor;
    {   }
    property TitleAlignment : TAlignment read FTitleAlignment write SetTitleAlignment;
    { -   .   TField.DisplayLabel   "~",
              ,  
         }
    property TitleLines : integer read FTitleLines write SetTitleLines;
    {         }
    //property RowHeightPercent : integer read FRowHeightPercent write SetRowHeightPercent;
    {   -       }
    property KeyOptions : TsohoGridKeyOptions read FKeyOptions write FKeyOptions;
    property KeyField: string read FKeyField write FKeyField;
    {     Microsoft Money - .   
        StriplyColor }
    property Striply      : boolean read FStriply write SetStriply;
    {       Striply = true }
    property StriplyColor : TColor read FStriplyColor write SetStriplyColor;
    {     (Results) }
    property MarkedColor: tColor read FMarkedColor write SetMarkedColor;
    {      (Results) }
    property MarkedFont: tFont read FMarkedFont write SetMarkedFont;
    {          }
    property RowSelect: Boolean read FRowSelect write SetRowSelect;
    {      }
    property RowColor: tColor read FRowColor write SetRowColor;
    {      }
    property RowFont: tFont read FRowFont write SetRowFont;
    {       "" 
           ""  }
    property SmashColumn: Boolean read FAddColumn write SetAddColumn;
    {     ""    ftBoolean }
    property DrawChecks: Boolean read FDrawChecks write SetDrawChecks;
    {   -     }
    property WordWrap : boolean read FWordWrap write SetWordWrap;
    property EditOnDblClick : boolean read FEditOnDblClick write FEditOnDblClick default true;
    {  true,          ,
         -    }
    
    property Options: TDBGridOptions read GetOptions write SetOptions;
    property FixedCols: Integer read GetFixedCols write SetFixedCols;
    property ClearSelection: Boolean read FClearSelection write FClearSelection;
    property DefaultDrawing: Boolean read FDefaultDrawing write FDefaultDrawing;
    property MultiSelect: Boolean read FMultiSelect write SetMultiSelect;
    property ShowGlyphs: Boolean read FShowGlyphs write SetShowGlyphs;
    property TitleButtons: Boolean read FTitleButtons write SetTitleButtons;
    property RowsHeight: Integer read GetRowsHeight write SetRowsHeight;
    property OnCheckButton: TCheckTitleBtnEvent read FOnCheckButton write FOnCheckButton;
    property OnGetCellProps: TGetCellPropsEvent read FOnGetCellProps
      write FOnGetCellProps; { obsolete }
    property OnGetCellParams: TGetCellParamsEvent read FOnGetCellParams write FOnGetCellParams;
    property OnGetBtnParams: TGetBtnParamsEvent read FOnGetBtnParams write FOnGetBtnParams;
    property OnEditChange: TNotifyEvent read FOnEditChange write FOnEditChange;
    property OnShowEditor: TDBEditShowEvent read FOnShowEditor write FOnShowEditor;
    property OnTitleBtnClick: TTitleClickEvent read FOnTitleBtnClick write FOnTitleBtnClick;
    property OnKeyPress: TKeyPressEvent read FOnKeyPress write FOnKeyPress;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
{$IFDEF Delphi4_or_5}
    property OnMouseWheelDown;
    property OnMouseWheelUp;
{$ENDIF}
    {            }
    property OnScroll: TsohoGridScroll read FOnScroll write FOnScroll;
    {       : Ins, Delete, Enter }
    property OnOperation: TsohoOnGridOperation read FSpecEvent write FSpecEvent;
    {        }
    property OnColResize: TNotifyEvent read FColReSize write FColReSize;
    {    ""  }
    property OnBeforeColumnMoved : TNotifyEvent read FBeforeColumnMoved write FBeforeColumnMoved;
{-----------------------------------------------------------------------------}
    {     }
    property  SelectOptions : TsohoGridSelectOptions read FSelectOptions write FSelectOptions;
    {      }
    property  SelectKey     : TShortCut read FSelectKey write FSelectKey;
{-----------------------------------------------------------------------------}
    property BooleanFields : TStrings read GetBoolFields write SetBoolFields;
  public
    procedure DoOperation(GridOperation: TsohoGridOperation); virtual;
    procedure DrawSmashColumn; virtual;
    procedure Paint; override;

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure DefaultDataCellDraw(const Rect: TRect; Field: TField;
      State: TGridDrawState);
    procedure DisableScroll;
    procedure EnableScroll;
    function ScrollDisabled: Boolean;
    procedure MouseToCell(X, Y: Integer; var ACol, ARow: Longint);
    procedure SelectAll;
    procedure UnselectAll;
{-----------------------------------------------------------------------------}
    procedure SelectCurrent;
    {   ,      ,
        ,      }
    procedure SelectGrp(FirstID, LastID : Variant;NumRecords : Integer);
    {    }
    procedure ReverseSelection;
    {   }

{-----------------------------------------------------------------------------}
    procedure ToggleRowSelection;
    procedure GotoSelection(Index: Longint);
    function GetActiveRow : integer;
    {    .  . }
    function GetCellRect(ACol, ARow: Longint): TRect;
    {       }
    function GetCellText (aCol, aRow: LongInt): string;
    {      }

    property SelectedRows;
    property SelCount: Longint read GetSelCount;
    property Canvas;
    property Col;
    property InplaceEditor;
    property LeftCol;
    property Row;
    property VisibleRowCount;
    property VisibleColCount;
    property IndicatorOffset;
    property TitleOffset: Byte read GetTitleOffset;
    property ColWidthsByFieldIndex[index: Integer]: Integer read GetColWidthByFieldIndex write SetColWidthByFieldIndex;
    {     . Index -    TDataSet }
    property Results: TsohoDBGridResults read FResults;
    {     .     
             ,   
      KeyField  ftInteger.         
      ,  ,  , .      GetNewId.
    }
    property TopRow;
    {    .  , -  BDE   
       1.  :    ?   ... }
    property ColWidths;
    {     protected.      }
    property RowHeights;
    {     protected.      }
    property GridLineWidth;
    {     protected.     }
    property Selection;
    property ColCount;
    property GridState : TGridState read FGridState;
    property DataLink;
  end;

  TsohoDBGrid = class(TsohoCustomDBGrid)
  {     TDataSet.    TsohoCustomDBGrid.
       TDBGrid   . ,  
    ftBoolen      "",     true.
     RowFont  RowColor       
    ,   RowSelect = true.    :
    OnOperation, OnScroll, OnColResize, OnBeforeColumnMoved.  run-time  TsohoDBGrid 
       -       Results
  }
  published
    property TitleColor default clBtnFace;
    {   }
    property TitleAlignment default taLeftJustify;
    {   }
    property TitleLines default 1;
    { -   .   TField.DisplayLabel   "~",
              ,  
         }

    {         }
    //property RowHeightPercent default 100;
    property KeyOptions;
    {   -       }
    property KeyField;
{     .     .  
     }
    property Striply default false;
    {     Microsoft Money - .   
        StriplyColor }
    property StriplyColor;
    {       Striply = true }
    property MarkedColor;
    {     (Results) }
    property MarkedFont;
    {      (Results) }
    property RowSelect;
    {          }
    property RowColor;
    {      }
    property RowFont;
    {      }
    property SmashColumn default False;
    {       "" 
           ""  }
    property DrawChecks default True;
    {     ""    ftBoolean }
    property WordWrap default false;
    {   -     }
    property EditOnDblClick default true;
    {  true,          ,
         -    }

    property Options default
    {$IFNDEF CBUILDER}
        DefSohoGridOptions
    {$ELSE}
        [dgEditing, dgTitles, dgIndicator, dgColumnResize, dgColLines, dgRowLines,
         dgConfirmDelete, dgCancelOnExit]
    {$ENDIF};
    property FixedCols default 0;
    property ClearSelection default True;
    property DefaultDrawing default True;
    property MultiSelect default False;
    property ShowGlyphs default True;
    property TitleButtons default False;
    property RowsHeight stored False;

    property OnCheckButton;
    property OnGetCellProps;
    property OnGetCellParams;
    property OnGetBtnParams;
    property OnEditChange;
    property OnShowEditor;
    property OnTitleBtnClick;
    property OnKeyPress;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
{$IFDEF Delphi4_or_5}
    property OnMouseWheelDown;
    property OnMouseWheelUp;
{$ENDIF}
    property OnScroll;
    {        ,    }
    property OnOperation;
    {       : Ins, Delete, Enter }
    property OnColResize;
    {        }
    property OnBeforeColumnMoved;
    {    ""  }
    property  SelectOptions;
    {   ,          }
    property  SelectKey;
    { ,    .     ,
           -  Ctrl+Space,  Ctrl+Enter}
    property BooleanFields;
{   ,     boolean-. ,  ,  
IB Database,      boolean }
{$IFDEF Delphi4_or_5}
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
    property ImeMode;
    property ImeName;
{$ENDIF}
{$IFDEF Delphi5}
    property OnContextPopup;
{$ENDIF}
{$IFDEF Delphi4_or_5}
    property OnResize;
    property OnEndDock;
    property OnStartDock;
{$ENDIF}
  end;

var
   StringBooleanFields : TStringList;
   {        ,  
         TsohoDBGid  .  
     , ,    IB Database,    
        }

implementation
uses SysUtils, ExtCtrls, DbConsts, SoVCLUtils, {StdCtrls, }SoDBRtn,
     SoStrUtils, SoGraph, SoUtils;

{$R *.R32}

type
  TGridPicture = (gpBlob, gpMemo, gpPicture, gpOle, gpObject, gpData,
    gpNotEmpty, gpMarkDown, gpMarkUp, gpCheck, gpUnCheck);

const
  GridBmpNames: array[TGridPicture] of PChar =
    ('SOHO_DBG_BLOB', 'SOHO_DBG_MEMO', 'SOHO_DBG_PICT',
     'SOHO_DBG_OLE', 'SOHO_DBG_OBJECT', 'SOHO_DBG_DATA',
     'SOHO_DBG_NOTEMPTY', 'SOHO_DBG_SMDOWN', 'SOHO_DBG_SMUP',
     'SOHOCHECKEDCELL', 'SOHOUNCHECKEDCELL');
  GridBitmaps: array[TGridPicture] of TBitmap =
    (nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil);
  bmMultiDot = 'SOHO_DBG_MSDOT';
  bmMultiArrow = 'SOHO_DBG_MSARROW';

  NormalPad = 2;

procedure KillMessage(Wnd: HWnd; Msg: Integer);
// Delete the requested message from the queue, but throw back
// any WM_QUIT msgs that PeekMessage may also return
var
  M: TMsg;
begin
  M.Message := 0;
  if PeekMessage(M, Wnd, Msg, Msg, pm_Remove) and (M.Message = WM_QUIT) then
    PostQuitMessage(M.wparam);
end;



function GetGridBitmap(BmpType: TGridPicture): TBitmap;
begin
  if GridBitmaps[BmpType] = nil then begin
    GridBitmaps[BmpType] := TBitmap.Create;
    GridBitmaps[BmpType].Handle := LoadBitmap(HInstance, GridBmpNames[BmpType]);
  end;
  Result := GridBitmaps[BmpType];
end;

procedure DestroyLocals; far;
var
  I: TGridPicture;
begin
  for I := Low(TGridPicture) to High(TGridPicture) do GridBitmaps[I].Free;
end;

procedure GridInvalidateRow(Grid: TsohoCustomDBGrid; Row: Longint);
var
  I: Longint;
begin
  for I := 0 to Grid.ColCount - 1 do Grid.InvalidateCell(I, Row);
end;

type
  TBookmarks = class(TBookmarkList);

{ TsohoCustomDBGrid }
function TsohoCustomDBGrid.GetBoolFields: TStrings;
begin
  Result := TStrings(FBoolFields);
end;

procedure TsohoCustomDBGrid.SetBoolFields(Value: TStrings);
begin
  FBoolFields.Assign(Value);
end;

procedure TsohoCustomDBGrid.DoGridScroll(Vertical: Boolean; wScrollCode: Smallint);
begin
  if Assigned(FOnScroll) then FOnScroll(Self, Vertical, wScrollCode);
end;

procedure TsohoCustomDBGrid.WMVScroll(var message: TWMScroll);
begin
  inherited;
  { -    ,  
               }
  inc(FVCount);
  if FVCount = 2 then begin
    DoGridScroll(True, message.ScrollCode);
    FVCount := 0;
  end;
end;

procedure TsohoCustomDBGrid.WMHScroll(var message: TWMScroll);
begin
  inherited;
  { -    ,  
               }
  inc(FHCount);
  if FHCount = 2 then begin
    DoGridScroll(False, message.ScrollCode);
    FHCount := 0;
  end;
end;

procedure TsohoCustomDBGrid.SetAddColumn(Value: Boolean);
begin
  if FAddColumn = Value then exit;
  FAddColumn := Value;
  Repaint;
end;

procedure TsohoCustomDBGrid.SetStriply (Value : boolean);
begin
  if FStriply = Value then exit;
  FStriply := Value;
  Repaint;
end;

procedure TsohoCustomDBGrid.SetStriplyColor (Value : TColor);
begin
  if FStriplyColor = Value then exit;
  FStriplyColor := Value;
  Repaint;
end;

procedure TsohoCustomDBGrid.SetDrawChecks(Value: Boolean);
begin
  if FDrawChecks = Value then exit;
  FDrawChecks := Value;
  Repaint;
end;

procedure TsohoCustomDBGrid.DrawSmashColumn;
var R : TRect;
    Index : integer;
begin
  if not FAddColumn then exit;
  with Canvas do begin
  if ColCount <= 0 then exit;
  R := CellRect(ColCount - 1, 0);
  if (R.Right <> 0) and (R.Right < ClientWidth) and
     (dgTitles in Options) then begin
    Brush.Color := TitleColor;
    R := Rect(R.Right, R.Top, ClientWidth, R.Bottom);
    if dgColLines in Options then Inc(R.Left);
    FillRect(R); Dec(R.Right);
    if [dgRowLines,dgColLines] * Options = [dgRowLines, dgColLines] then begin
      DrawEdge(Canvas.Handle, R, BDR_RAISEDINNER, BF_BOTTOMRIGHT);
      DrawEdge(Canvas.Handle, R, BDR_RAISEDINNER, BF_TOPLEFT);
    end;
    if dgColLines in Options then begin
      Pen.Color := clBlack;
      PolyLine([Point(R.Right, R.Bottom - 1), Point(R.Right, R.Top - 1)]);
    end;
    if dgRowLines in Options then begin
      Pen.Color := clBlack;
      if (dgTitles in Options) then
        PolyLine([Point(R.Left, R.Bottom), Point(R.Right + 1, R.Bottom)]);
      Pen.Color := clSilver;
      if ColorToRGB(Color) = clSilver then Pen.Color := clGray;
      for Index := 0 + integer(dgTitles in Options) to
       VisibleRowCount - integer(not (dgTitles in Options)) do begin
        R := CellRect(ColCount - 1, Index);
        R.Left := R.Right;
        R.Right := ClientWidth;
        PolyLine([Point(R.Left, R.Bottom), Point(R.Right + 1, R.Bottom)]);
       end;
     end;
    end;
  end;
end;

procedure TsohoCustomDBGrid.Paint;
begin
  try
    inherited Paint;
    DrawSmashColumn;
  except
  end;
end;

procedure TsohoCustomDBGrid.CMParentFontChanged(var message: TMessage);
begin
  inherited;
  if ParentFont then begin
    FSelfChangingRowFont := True;
    try
      RowFont := Font;
    finally
      FSelfChangingRowFont := False;
    end;
    Invalidate;
  end;
end;

procedure TsohoCustomDBGrid.CMFontChanged(var message: TMessage);
begin
  if ParentFont then RowFont := Font;
  inherited;
end;

procedure TsohoCustomDBGrid.DoOperation(GridOperation: TsohoGridOperation);
var TmpCrs: TCursor;
begin
  TmpCrs := Cursor;
  if Assigned(FSpecEvent) then FSpecEvent(Self, GridOperation);
  Cursor := TmpCrs;
end;

procedure TsohoCustomDBGrid.RowFontChanged(Sender: TObject);
begin
  if (not FSelfChangingRowFont) and not (csLoading in ComponentState) then
    ParentFont := False;
  Invalidate;
end;

procedure TsohoCustomDBGrid.ReReadGrid(Sender: TObject);
begin
  Invalidate;
end;

procedure TsohoCustomDBGrid.SetRowSelect(Value: Boolean);
begin
  FRowSelect := Value;
  Invalidate;
end;

procedure TsohoCustomDBGrid.SetRowColor(Value: tColor);
begin
  FRowColor := Value;
  Invalidate;
end;

procedure TsohoCustomDBGrid.SetRowFont(Value: tFont);
begin
  FRowFont.Assign(Value);
  if not (csLoading in ComponentState)
    and (not FSelfChangingRowFont) then ParentFont := False;
  Invalidate;
end;

function TsohoCustomDBGrid.GetCellRect(ACol, ARow: Longint): TRect;
begin
  Result := CellRect(ACol, ARow);
end;

function TsohoCustomDBGrid.GetActiveRow : integer;
begin
  Result := Row;
end;

function TsohoCustomDBGrid.FieldToColumnIndex (Field: TField): LongInt;
var Index: LongInt;
begin
  Result := -1;
  for Index := 0 to pred(Columns.Count) do
    if Columns[Index].Field = Field then begin
       Result := Index;
       exit;
    end;
end;

procedure TsohoCustomDBGrid.SetColWidthByFieldIndex(index: Integer; Value: Integer);
var Offset: Integer;
begin
  if (dgIndicator in Options) then Offset := 1
  else Offset := 0;
  ColWidths[index + Offset] := Value;
end;

function TsohoCustomDBGrid.GetColWidthByFieldIndex(index: Integer): Integer;
var Offset: Integer;
begin
  if (dgIndicator in Options) then Offset := 1
  else Offset := 0;
  Result := ColWidths[index + Offset];
end;

procedure TsohoCustomDBGrid.SetMarkedColor(Value: tColor);
begin
  if FMarkedColor = Value then exit;
  FMarkedColor := Value;
  if not (csLoading in ComponentState) then Repaint;
end;

procedure TsohoCustomDBGrid.SetMarkedFont(Value: tFont);
begin
  FMarkedFont.Assign(Value);
  if not (csLoading in ComponentState) then Repaint;
end;

function TsohoCustomDBGrid.GetCellText (aCol, aRow: LongInt): string;
var OffsetX, OffsetY: byte;
    OldRecord: LongInt;
begin
  OldRecord := DataLink.ActiveRecord;
  OffsetX := 0;
  OffsetY := 0;
  try
     if dgIndicator in Options then OffsetX := 1;
     if dgTitles in Options then OffsetY := 1;
     Datalink.ActiveRecord := aRow - OffsetY;
     Result := Columns[aCol - OffsetX].Field.DisplayText;
  finally
     Datalink.ActiveRecord := OldRecord;
  end
end;

procedure TsohoCustomDBGrid.SetMimimumWidth(Cell : TGridCoord; ReHeight : boolean);
var Book : Longint;
    Col : TColumn;
    Loop, MaxW : integer;
begin
  if not DataLink.Active then exit;
  Book := DataLink.ActiveRecord;
  MaxW := Cell.X - IndicatorOffset;
  if (MaxW >= Columns.Count) or (MaxW < 0) then exit;
  Col := Columns[MaxW];
  MaxW := 0;
  if (Col <> nil) and (Col.Field <> nil) then begin
     DataLink.DataSet.DisableControls;
     try
      for Loop := 0 to pred(DataLink.BufferCount) do begin
        DataLink.ActiveRecord := Loop;
        MaxW := GetMax(MaxW, Canvas.TextWidth(Col.Field.DisplayText) + 2);
       end;
     finally
      if (ClientWidth > (Cell.X - Col.Width + MaxW)) then Col.Width := MaxW + 6;
      DataLink.ActiveRecord := Book;
      DataLink.DataSet.EnableControls;
     end;
  end;
end;

procedure TsohoCustomDBGrid.SetWordWrap (Value : boolean);
begin
  if FWordWrap = Value then exit;
  FWordWrap := Value;
  Repaint;
end;

procedure TsohoCustomDBGrid.UpdateRowCount;
var FTitleOffset : integer;
begin
  if InUpdateRowCount then exit;  { Prevent recursion }
  InUpdateRowCount:= True;

  FTitleOffset := 0;
  if dgTitles in Options then inc(FTitleOffset);

  if RowCount <= FTitleOffset then RowCount := FTitleOffset + 1;
  FixedRows := FTitleOffset;
  with DataLink do
    if not Active or (RecordCount = 0) then RowCount := 1 + FTitleOffset
    else begin
      RowCount := 1000;

      if (DataLink.Buffercount>VisibleRowCount) and
         (row >= VisibleRowCount+FTitleOffset) then
         Invalidate;

      DataLink.BufferCount := VisibleRowCount;
      RowCount := RecordCount + FTitleOffset;
    end;

  InUpdateRowCount:= False;
end;

//procedure TsohoCustomDBGrid.SetRowHeightPercent (Value : integer);
//begin
//  if Value < 100 then Value := 100;
//  if (FRowHeightPercent = Value) then exit;
//  FRowHeightPercent := Value;
//  LayoutChanged;
//end;


procedure TsohoCustomDBGrid.CalcRowHeight;
var NeedHeight : integer;
begin
  // Application.ProcessMessages;
  if (Parent <> nil) and not (csDestroying in ComponentState) then begin
    DefaultRowHeight:= Canvas.Textheight('W') + NormalPad;
    if dgRowLines in Options then DefaultRowHeight:= DefaultRowHeight + 1;
    DefaultRowHeight:= (DefaultRowHeight * FRowHeightPercent) div 100;
    NeedHeight := FTitleLines * (3+Canvas.TextHeight('W'));
    if (RowCount > 0) and (RowHeights[0] <> NeedHeight) then RowHeights[0] := NeedHeight;
  end;
end;

procedure TsohoCustomDBGrid.SetTitleColor (Value : TColor);
begin
  FTitleColor := Value;
  FixedColor := Value;
end;

procedure TsohoCustomDBGrid.SetTitleLines (Value : integer);
begin
  if (dgTitles in Options) and (Value > 0) and (Value <= 5) then begin
    FTitleLines := Value;
    CalcRowHeight;
  end;
end;

procedure TsohoCustomDBGrid.SetTitleAlignment (Value: TAlignment);
begin
  if FTitleAlignment = Value then exit;
  FTitleAlignment := Value;
  LayoutChanged;
end;

function  TsohoCustomDBGrid.CalcCellRow : LongInt;
begin
  Result := FCalcCellRow;
end;

constructor TsohoCustomDBGrid.Create(AOwner: TComponent);
var
  Bmp: TBitmap;
begin
  inherited Create(AOwner);
  inherited DefaultDrawing := False;
  //  GetDC -  
  Options :=
  {$IFNDEF CBUILDER}
    DefsohoGridOptions
  {$ELSE}
    [dgEditing, dgTitles, dgIndicator, dgColumnResize, dgColLines, dgRowLines,
     dgConfirmDelete, dgCancelOnExit]
  {$ENDIF};
  Bmp := TBitmap.Create;
  try
    Bmp.Handle := LoadBitmap(hInstance, bmMultiDot);
    FMsIndicators := TImageList.CreateSize(Bmp.Width, Bmp.Height);
    FMsIndicators.AddMasked(Bmp, clWhite);
    Bmp.Handle := LoadBitmap(hInstance, bmMultiArrow);
    FMsIndicators.AddMasked(Bmp, clWhite);
  finally
    Bmp.Free;
  end;
  FShowGlyphs := True;
  FDefaultDrawing := True;
  FClearSelection := True;

  FTitleLines := 1;
  FTitleAlignment := taLeftJustify;
  FTitleColor := clBtnFace;
  FRowHeightPercent := 100;
  FRowSelect := True;
  FRowColor := clAqua;
  FWordWrap := false;
  FAddColumn := False;
  FRowFont := tFont.Create;
  FRowFont.Color := clBlack;
  FRowFont.OnChange := RowFontChanged;
  FSelfChangingRowFont := False;
  FDrawChecks := True;
  FResults := TsohoDBGridResults.Create;
  FResults.OnChange := ReReadGrid;
  FMarkedFont := tFont.Create;
  with FMarkedFont do begin
    Assign(Font);
    Style := [];
    Color := clBlack;
  end;
  FMarkedColor := clAqua;
  FVCount := 0;
  FHCount := 0;
  FBeforeFlag := false;
  FStriply := false;
  FStriplyColor := $00DDDDDD;
  FKeyOptions := [dgAllowDelete, dgAllowInsert, dgEnterToTab];
  FKeyField := 'Id';
  InUpdateRowCount := false;
  FUpdateLock := 0;
  FEditOnDblClick := True;
{-----------------------------------------------------------------------------}
  FBoolFields := TStringList.Create;
  FSelectOptions := [];
//  FBoolFields.Add('FLAG');
{-----------------------------------------------------------------------------}

end;

destructor TsohoCustomDBGrid.Destroy;
begin
  FMsIndicators.Free;
  FRowFont.Free;
  FResults.Free;
  FMarkedFont.Free;
{-----------------------------------------------------------------------------}
  FBoolFields.Free;
{-----------------------------------------------------------------------------}
  inherited Destroy;
end;

function TsohoCustomDBGrid.GetImageIndex(Field: TField): Integer;
var
  AOnGetText: TFieldGetTextEvent;
  AOnSetText: TFieldSetTextEvent;
begin
  Result := -1;
  if FShowGlyphs and Assigned(Field) then begin
    if (not ReadOnly) and Field.CanModify then begin
      { Allow editing of memo fields if OnSetText and OnGetText
        events are assigned }
      AOnGetText := Field.OnGetText;
      AOnSetText := Field.OnSetText;
      if Assigned(AOnSetText) and Assigned(AOnGetText) then Exit;
    end;
    case Field.DataType of
      ftBytes, ftVarBytes, ftBlob: Result := Ord(gpBlob);
      ftMemo: Result := Ord(gpMemo);
      ftGraphic: Result := Ord(gpPicture);
      ftTypedBinary: Result := Ord(gpBlob);
      ftFmtMemo: Result := Ord(gpMemo);
      ftParadoxOle, ftDBaseOle: Result := Ord(gpOle);
{$IFDEF Delphi4}
      ftCursor: Result := Ord(gpData);
{$ENDIF}
{$IFDEF Delphi4_or_5}
      ftReference, ftDataSet: Result := Ord(gpData);
{$ENDIF}
    end;
  end;
end;

function TsohoCustomDBGrid.ActiveRowSelected: Boolean;
var
  Index: Integer;
begin
  Result := False;
  if MultiSelect and Datalink.Active then begin
    Result := SelectedRows.Find(Datalink.DataSet.Bookmark, Index);
  end;
end;

function TsohoCustomDBGrid.HighlightCell(DataCol, DataRow: Integer;
  const Value: string; AState: TGridDrawState): Boolean;
begin
  Result := ActiveRowSelected;
  if not Result then
    Result := inherited HighlightCell(DataCol, DataRow, Value, AState);
end;

procedure TsohoCustomDBGrid.ToggleRowSelection;
begin
  if MultiSelect and Datalink.Active then
    with SelectedRows do CurrentRowSelected := not CurrentRowSelected;
end;

function TsohoCustomDBGrid.GetSelCount: Longint;
begin
  if MultiSelect and (Datalink <> nil) and Datalink.Active then
    Result := SelectedRows.Count
  else Result := 0;
end;

procedure TsohoCustomDBGrid.SelectAll;
var
  ABookmark: TBookmark;
begin
  if (MultiSelect or (dgsAllowMultiSelect in FSelectOptions))
     and DataLink.Active
  then begin
    if (dgsAllowMultiSelect in FSelectOptions) then FResults.Clear;
    with Datalink.Dataset do begin
      if (BOF and EOF) then Exit;
      DisableControls;
      try
        ABookmark := GetBookmark;
        try
          First;
          while not EOF do begin
            if MultiSelect then SelectedRows.CurrentRowSelected := True;
            if (dgsAllowMultiSelect in FSelectOptions)
              then FResults.Add(FieldByName(FKeyField).AsInteger);
            Next;
          end;
        finally
          try
            GotoBookmark(ABookmark);
          except
          end;
          FreeBookmark(ABookmark);
        end;
      finally
        EnableControls;
      end;
    end;
  end;
end;

procedure TsohoCustomDBGrid.UnselectAll;
begin
  if MultiSelect then begin
    SelectedRows.Clear;
    FSelecting := False;
  end;
  if (dgsAllowMultiSelect in FSelectOptions) then FResults.Clear;
end;

procedure TsohoCustomDBGrid.SelectCurrent;
begin
  if Results.IndexOf(Datalink.DataSet.fieldbyname(KeyField).AsInteger) = -1
   then Results.Add(Datalink.DataSet.fieldbyname(KeyField).AsInteger)
   else Results.Remove(Datalink.DataSet.fieldbyname(KeyField).AsInteger);
end;

procedure TsohoCustomDBGrid.SelectGrp(FirstID, LastID : Variant;NumRecords : Integer);
var
  i : Integer;
begin
  BeginUpdate;
  if not (dgsPersistSelect in SelectOptions) then Results.Clear;
  for i := 0 to ABS(NumRecords) do begin
    if Results.IndexOf(Datalink.DataSet.fieldbyname(KeyField).AsInteger) = -1
       then Results.Add(Datalink.DataSet.fieldbyname(KeyField).AsInteger);
    if NumRecords < 0
       then Datalink.DataSet.Next
       else Datalink.DataSet.Prior;
  end;    { --- for --- }
  Datalink.DataSet.Locate(KeyField,FirstID,[]);
  EndUpdate;
end;

procedure TsohoCustomDBGrid.ReverseSelection;
var
  ABookmark: TBookmark;
begin
  if (dgsAllowMultiSelect in FSelectOptions) and DataLink.Active
  then begin
    with Datalink.Dataset do begin
      if (BOF and EOF) then Exit;
      DisableControls;
      try
        ABookmark := GetBookmark;
        try
          First;
          while not EOF do begin
            SelectCurrent;
            Next;
          end;
        finally
          try
            GotoBookmark(ABookmark);
          except
          end;
          FreeBookmark(ABookmark);
        end;
      finally
        EnableControls;
      end;
    end;
  end;
end;

procedure TsohoCustomDBGrid.GotoSelection(Index: Longint);
begin
  if MultiSelect and DataLink.Active and (Index < SelectedRows.Count) and
    (Index >= 0) then
    Datalink.DataSet.GotoBookmark(Pointer(SelectedRows[Index]));
end;

procedure TsohoCustomDBGrid.LayoutChanged;
var ACol: Longint;
    PrevVisibleRowCount : integer;
begin
  try
    ACol := Col;
    inherited LayoutChanged;
    if Datalink.Active and (FixedCols > 0) then
  {$IFDEF Delphi4_or_5}
      Col := GetMin(GetMax(CalcLeftColumn, ACol), ColCount - 1);
  {$ELSE}
      Col := GetMin(GetMax(inherited FixedCols, ACol), ColCount - 1);
  {$ENDIF}
  except
  end;
  if csLoading in ComponentState then Exit;
  if FUpdateLock <> 0 then Exit;
  if (Parent <> nil) and not (csDestroying in ComponentState) then begin
    Inc(FUpdateLock);
    try
      CalcRowHeight;
      UpdateRowCount;
      PrevVisibleRowCount:= VisibleRowCount;
      if VisibleRowCount<>PrevVisibleRowCount then UpdateRowCount;  {6/1/95}
      Invalidate;
    finally
      Dec(FUpdateLock);
    end;
  end;
end;

procedure TsohoCustomDBGrid.ColWidthsChanged;
var
  ACol: Longint;
begin
  ACol := Col;
  RowHeightsChanged;
  if Datalink.Active and (FixedCols > 0) then
{$IFDEF Delphi4_or_5}
    Col := GetMin(GetMax(CalcLeftColumn, ACol), ColCount - 1);
{$ELSE}
    Col := GetMin(GetMax(inherited FixedCols, ACol), ColCount - 1);
{$ENDIF}
  if Assigned(FColReSize) then FColReSize(Self);
end;

function TsohoCustomDBGrid.CreateEditor: TInplaceEdit;
begin
{------------------------------------------------------------------------------}
     Result := inherited CreateEditor;
{------------------------------------------------------------------------------}
  TEdit(Result).OnChange := EditChanged;
end;

function TsohoCustomDBGrid.GetTitleOffset: Byte;
{$IFDEF Delphi4_or_5}
var
  I, J: Integer;
{$ENDIF}
begin
  Result := 0;
  if dgTitles in Options then begin
    Result := 1;
{$IFDEF Delphi4_or_5}
    if (Datalink <> nil) and (Datalink.Dataset <> nil) and
      Datalink.Dataset.ObjectView then
    begin
      for I := 0 to Columns.Count - 1 do begin
        if Columns[I].Showing then begin
          J := Columns[I].Depth;
          if J >= Result then Result := J + 1;
        end;
      end;
    end;
{$ENDIF}
  end;
end;

procedure TsohoCustomDBGrid.SetColumnAttributes;
begin
  inherited SetColumnAttributes;
  SetFixedCols(FFixedCols);
end;

procedure TsohoCustomDBGrid.SetFixedCols(Value: Integer);
var
  FixCount, I: Integer;
begin
  FixCount := GetMax(Value, 0) + IndicatorOffset;
  if DataLink.Active and not (csLoading in ComponentState) and
    (ColCount > IndicatorOffset + 1) then
  begin
    FixCount := GetMin(FixCount, ColCount - 1);
    inherited FixedCols := FixCount;
    for I := 1 to GetMin(FixedCols, ColCount - 1) do
      TabStops[I] := False;
  end;
  FFixedCols := FixCount - IndicatorOffset;
end;

function TsohoCustomDBGrid.GetFixedCols: Integer;
begin
  if DataLink.Active then Result := inherited FixedCols - IndicatorOffset
  else Result := FFixedCols;
end;

{$IFDEF Delphi4_or_5}
function TsohoCustomDBGrid.CalcLeftColumn: Integer;
begin
  Result := FixedCols + IndicatorOffset;
  while (Result < ColCount) and (ColWidths[Result] <= 0) do
    Inc(Result);
end;
{$ENDIF}

procedure TsohoCustomDBGrid.KeyDown(var Key: Word; Shift: TShiftState);
var
  KeyDownEvent      : TKeyEvent;
  SCKey             : Word;
  SCShift           : TShiftState;
  ClearSelectedFlag : boolean;

  procedure ClearSelections;
  begin
    if FMultiSelect then begin
      if FClearSelection then SelectedRows.Clear;
      FSelecting := False;
    end;
  end;

  procedure DoSelection(Select: Boolean; Direction: Integer);
  var
    AddAfter: Boolean;
  begin
    AddAfter := False;
    BeginUpdate;
    try
      if MultiSelect and DataLink.Active then
        if Select and (ssShift in Shift) then begin
          if not FSelecting then begin
            FSelectionAnchor := TBookmarks(SelectedRows).CurrentRow;
            SelectedRows.CurrentRowSelected := True;
            FSelecting := True;
            AddAfter := True;
          end
          else with TBookmarks(SelectedRows) do begin
            AddAfter := Compare(CurrentRow, FSelectionAnchor) <> -Direction;
            if not AddAfter then CurrentRowSelected := False;
          end
        end
        else ClearSelections;
      if Direction <> 0 then Datalink.DataSet.MoveBy(Direction);
      if AddAfter then SelectedRows.CurrentRowSelected := True;
    finally
      EndUpdate;
    end;
  end;

  procedure OldNextRow(Select: Boolean);
  begin
    with Datalink.Dataset do begin
      DoSelection(Select, 1);
      if EOF and CanModify and (not ReadOnly) and (dgEditing in Options) then
        Append;
    end;
  end;

  procedure PriorRow(Select: Boolean);
  begin
    DoSelection(Select, -1);
  end;

  procedure CheckTab(GoForward: Boolean);
  var
    ACol, Original: Integer;
  begin
    ACol := Col;
    Original := ACol;
    if MultiSelect and DataLink.Active then
      while True do begin
        if GoForward then Inc(ACol) else Dec(ACol);
        if ACol >= ColCount then begin
          ClearSelections;
          ACol := IndicatorOffset;
        end
        else if ACol < IndicatorOffset then begin
          ClearSelections;
          ACol := ColCount;
        end;
        if ACol = Original then Exit;
        if TabStops[ACol] then Exit;
      end;
  end;

  function OldDeletePrompt: Boolean;
  var
    S: string;
  begin
    if (SelectedRows.Count > 1) then
      S := SDeleteMultipleRecordsQuestion
    else S := SDeleteRecordQuestion;
    Result := not (dgConfirmDelete in Options) or YesNoMsg(S);
  end;

  procedure NextRow;
  begin
    with Datalink.Dataset do begin
      if (State = dsInsert) and (not Modified)  then
	if EOF then Exit
        else Cancel
      else begin
	 if Eof and (DataLink.ActiveRecord>=0) and
            (DataLink.ActiveRecord<DataLink.RecordCount-1) and
            not (State=dsInsert) then
	    DataLink.ActiveRecord:= DataLink.ActiveRecord + 1
	 else begin
           Next;
         end;  { --- if --- }
      end;
      if EOF and CanModify and (dgEditing in Options)
          and (dgAllowInsert in KeyOptions) then Append;
    end;
    FOldACol := Col;
    FOldARow := Row;
  end;

  function DeletePrompt: Boolean;
  begin
    Result := (dgConfirmDelete in Options) and
               YesNoMsg(SDeleteRecordQuestion);
    if not (dgConfirmDelete in Options) then Result := true;
  end;
begin

  if not Datalink.Active or not CanGridAcceptKey(Key, Shift) then Exit;
  ClearSelectedFlag := (Key in [VK_UP, VK_DOWN, VK_LEFT, VK_RIGHT, VK_HOME, VK_END, VK_PRIOR, VK_NEXT])
                       AND (Shift=[]);
  with Datalink.DataSet do
    case Key of
      VK_DOWN: begin
{------------------------------------------------------------------------------}
                 if (Shift = [ssShift]) AND (dgsShiftArrows in FSelectOptions)
                 then begin
                   SelectCurrent;
                 end; {--- if ---}
{------------------------------------------------------------------------------}
                 Key := 0;
                 NextRow;
               end;
{------------------------------------------------------------------------------}
      VK_UP  : begin
                if (Shift = [ssShift]) AND (dgsShiftArrows in FSelectOptions)
                 then begin
                   SelectCurrent;
                 end; {--- if ---}
                FOldACol := Col;
                FOldARow := Row;
               end; {--- VK_UP ---}
      {Ctrl+A}
      $41   : if (dgsCtrlA_SelectAll in FSelectOptions) AND (Shift = [ssCtrl])
              then begin
                 SelectAll;
               end; {--- if ---}

      VK_ADD : if (dgsAllowGrayKeys in FSelectOptions) then begin
                 SelectAll;
               end; {--- if ---}

  VK_SUBTRACT : if (dgsAllowGrayKeys in FSelectOptions) then begin
                 UnselectAll;
               end; {--- if ---}

  VK_MULTIPLY : if (dgsAllowGrayKeys in FSelectOptions) then begin
                 ReverseSelection;
               end; {--- if ---}
{------------------------------------------------------------------------------}
      VK_INSERT: if not ReadOnly and (dgEditing in Options) and
                   (dgAllowInsert in KeyOptions) then begin
                   Insert;
                   Key := 0;
                 end
                 else begin
                   DoOperation(soNewRecord);
                   if not (dgAllowInsert in KeyOptions) then Key := 0;
                 end;
      VK_RETURN: DoOperation(soEditRecord);
      VK_DELETE: if (dgAllowDelete in KeyOptions) and (not ReadOnly) and
                    CanModify and (dgEditing in Options) and DeletePrompt then begin
                   Delete;
                   Key := 0;
                 end
                 else begin
                   DoOperation(soDeleteRecord);
                   if not (dgAllowDelete in KeyOptions) then Key := 0;
                   // Key := 0;
                 end;
      VK_TAB: if ssCtrl in Shift then begin
                SendMessage(GetOwnerForm(Self).Handle, WM_NEXTDLGCTL, 0, 0);
                KEY := 0;
                exit;
              end
              else
                if (Col >= ColCount - 1) and (not (dgAllowInsert in FKeyOptions)) and (Datalink.DataSet.Eof) then
                begin
                  exit;
                end;
      VK_SPACE :
{$IFDEF Delphi4_or_5}
                   if FBoolFields.IndexOf(SelectedField.FullName) <> -1 then begin
{$ELSE}
                   if FBoolFields.IndexOf(SelectedField.Name) <> -1 then begin
{$ENDIF}
                   Application.ProcessMessages;
                   EditBoolField;
                   Key := 0;
                 end; {--- if ---}
      end; {--- case ---}

{------------------------------------------------------------------------------}
  //  
  if (dgsAllowMultiSelect in FSelectOptions) then begin
    ShortCutToKey(FSelectKey, SCKey, SCShift);
    if (SCKey = Key) AND (SCShift = Shift) AND (Key <> 0)
      then SelectCurrent;
    if (not (dgsPersistSelect in SelectOptions)) AND (ClearSelectedFlag) then UnselectAll;
  end; {--- if ---}
{------------------------------------------------------------------------------}

  //    . , !
  KeyDownEvent := OnKeyDown;
  if Assigned(KeyDownEvent) then KeyDownEvent(Self, Key, Shift);
  with Datalink.DataSet do
    if ssCtrl in Shift then begin
      if (Key in [VK_UP, VK_PRIOR, VK_DOWN, VK_NEXT, VK_HOME, VK_END]) then
        ClearSelections;
      case Key of
        VK_LEFT:
          if FixedCols > 0 then begin
{$IFDEF Delphi4_or_5}
            SelectedIndex := CalcLeftColumn - IndicatorOffset;
{$ELSE}
            SelectedIndex := FixedCols;
{$ENDIF}
            Exit;
          end;
        VK_DELETE:
          if not ReadOnly and CanModify and not
            IsDataSetEmpty(Datalink.DataSet) then
          begin
            if OldDeletePrompt then begin
              if SelectedRows.Count > 0 then SelectedRows.Delete
              else Delete;
            end;
            Exit;
          end;
      end
    end
    else begin
      case Key of
        VK_LEFT:
          if (FixedCols > 0) and not (dgRowSelect in Options) then begin
{$IFDEF Delphi4_or_5}
            if SelectedIndex <= CalcLeftColumn - IndicatorOffset then
              Exit;
{$ELSE}
            if SelectedIndex <= FFixedCols then Exit;
{$ENDIF}
          end;
        VK_HOME:
          if (FixedCols > 0) and (ColCount <> IndicatorOffset + 1) and
            not (dgRowSelect in Options) then
          begin
{$IFDEF Delphi4_or_5}
            SelectedIndex := CalcLeftColumn - IndicatorOffset;
{$ELSE}
            SelectedIndex := FixedCols;
{$ENDIF}
            Exit;
          end;
      end;
      if (Datalink.DataSet.State = dsBrowse) then begin
        case Key of
          VK_UP:
            begin
              PriorRow(True); Exit;
            end;
          VK_DOWN:
            begin
              OldNextRow(True); Exit;
            end;
        end;
      end;
      if ((Key in [VK_LEFT, VK_RIGHT]) and (dgRowSelect in Options)) or
        ((Key in [VK_HOME, VK_END]) and ((ColCount = IndicatorOffset + 1)
          or (dgRowSelect in Options))) or (Key in [VK_ESCAPE, VK_NEXT,
          VK_PRIOR]) or ((Key = VK_INSERT) and (CanModify and
          (not ReadOnly) and (dgEditing in Options))) then
        ClearSelections
      else if ((Key = VK_TAB) and not (ssAlt in Shift)) then
        CheckTab(not (ssShift in Shift));
    end;
  OnKeyDown := nil;
  try
    inherited KeyDown(Key, Shift);
  finally
    OnKeyDown := KeyDownEvent;
  end;
end;

procedure TsohoCustomDBGrid.SetShowGlyphs(Value: Boolean);
begin
  if FShowGlyphs <> Value then begin
    FShowGlyphs := Value;
    Invalidate;
  end;
end;

procedure TsohoCustomDBGrid.SetRowsHeight(Value: Integer);
begin
  if not (csDesigning in ComponentState) and (DefaultRowHeight <> Value) then
  begin
    DefaultRowHeight := Value;
    if dgTitles in Options then RowHeights[0] := Value + 2;
    if HandleAllocated then
      Perform(WM_SIZE, SIZE_RESTORED, MakeLong(ClientWidth, ClientHeight));
  end;
end;

function TsohoCustomDBGrid.GetRowsHeight: Integer;
begin
  Result := DefaultRowHeight;
end;

function TsohoCustomDBGrid.GetOptions: TDBGridOptions;
begin
  Result := inherited Options;
  if FMultiSelect then Result := Result + [dgMultiSelect]
  else Result := Result - [dgMultiSelect];
end;

procedure TsohoCustomDBGrid.SetOptions(Value: TDBGridOptions);
var
  NewOptions: TGridOptions;
begin
  inherited Options := Value - [dgMultiSelect];
  NewOptions := TDrawGrid(Self).Options;
  if FTitleButtons then begin
    TDrawGrid(Self).Options := NewOptions + [goFixedHorzLine, goFixedVertLine];
  end
  else begin
    if not (dgColLines in Value) then
      NewOptions := NewOptions - [goFixedVertLine];
    if not (dgRowLines in Value) then
      NewOptions := NewOptions - [goFixedHorzLine];
    TDrawGrid(Self).Options := NewOptions;
  end;
  SetMultiSelect(dgMultiSelect in Value);
end;

procedure TsohoCustomDBGrid.SetTitleButtons(Value: Boolean);
begin
  if FTitleButtons <> Value then begin
    FTitleButtons := Value;
    Invalidate;
    SetOptions(Options);
  end;
end;

procedure TsohoCustomDBGrid.SetMultiSelect(Value: Boolean);
begin
  if FMultiSelect <> Value then begin
    FMultiSelect := Value;
    if not Value then SelectedRows.Clear;
  end;
end;

function TsohoCustomDBGrid.AcquireFocus: Boolean;
begin
  Result := True;
  if FAcquireFocus and CanFocus and not (csDesigning in ComponentState) then
  begin
    SetFocus;
    Result := Focused or (InplaceEditor <> nil) and InplaceEditor.Focused;
  end;
end;

function TsohoCustomDBGrid.CanEditShow: Boolean;
var
  F: TField;
begin
  Result := inherited CanEditShow;
  F := nil;
  if Result and (Datalink <> nil) and Datalink.Active and (FieldCount > 0) and
    (SelectedIndex < FieldCount) and (SelectedIndex >= 0) and
    (FieldCount <= DataSource.DataSet.FieldCount) then
  begin
    F := Fields[SelectedIndex];
    if F <> nil then Result := GetImageIndex(F) < 0;
  end;
  if F <> nil then
{$IFDEF Delphi4_or_5}
    Result := (Result AND (FBoolFields.IndexOf(F.FullName) = -1));
{$ELSE}
    Result := (Result AND (FBoolFields.IndexOf(F.Name) = -1));
{$ENDIF}
  if Result and Assigned(FOnShowEditor) then
    FOnShowEditor(Self, F, Result);
end;

procedure TsohoCustomDBGrid.GetCellProps(Field: TField; AFont: TFont;
  var Background: TColor; Highlight: Boolean);
var AColor, ABack: TColor;

  procedure DrawMarkedLines;
  var Id_Field: TField;
  begin
    if not DataLink.Active then exit;
    if FKeyField = '' then exit;
    Id_Field := DataSource.DataSet.FindField(FKeyField);
    if (Id_Field = nil) or (Id_Field.DataType <> ftInteger) then exit;
    if FResults.IndexOf(Id_Field.AsInteger) <> -1 then begin
      AFont.Assign(FMarkedFont);
      Background := FMarkedColor;
    end;
  end;

begin
  if csDestroying in ComponentState then exit;
  if Assigned(FOnGetCellParams) then
    FOnGetCellParams(Self, Field, AFont, Background, Highlight)
  else if Assigned(FOnGetCellProps) then begin
    if Highlight then begin
      AColor := AFont.Color;
      FOnGetCellProps(Self, Field, AFont, ABack);
      AFont.Color := AColor;
    end
    else FOnGetCellProps(Self, Field, AFont, Background);
  end;
  if DataLink.Active then begin
    if FStriply then
      if (DataSource.DataSet.RecNo mod 2) = 0 then Background := FStriplyColor;
    if Highlight or (CalcCellRow = GetActiveRow) and
       (FieldToColumnIndex(Field) >= FixedCols) then begin
      Background := FRowColor;
      AFont.Assign(FRowFont);
    end;
    DrawMarkedLines;
  end;
end;

procedure TsohoCustomDBGrid.DoTitleClick(ACol: Longint; AField: TField);
begin
  if Assigned(FOnTitleBtnClick) then FOnTitleBtnClick(Self, ACol, AField);
end;

procedure TsohoCustomDBGrid.CheckTitleButton(ACol, ARow: Longint; var Enabled: Boolean);
var
  Field: TField;
begin
  if (ACol >= 0) and (ACol < Columns.Count) then
  begin
    if Assigned(FOnCheckButton) then begin
      Field := Columns[ACol].Field;
  {$IFDEF Delphi4_or_5}
      if ColumnAtDepth(Columns[ACol], ARow) <> nil then
        Field := ColumnAtDepth(Columns[ACol], ARow).Field;
  {$ENDIF}
      FOnCheckButton(Self, ACol, Field, Enabled);
    end;
  end
  else Enabled := False;
end;

procedure TsohoCustomDBGrid.DisableScroll;
begin
  Inc(FDisableCount);
end;

type
  THackLink = class(TGridDataLink);

procedure TsohoCustomDBGrid.EnableScroll;
begin
  if FDisableCount <> 0 then begin
    Dec(FDisableCount);
    if FDisableCount = 0 then
      THackLink(DataLink).DataSetScrolled(0);
  end;
end;

function TsohoCustomDBGrid.ScrollDisabled: Boolean;
begin
  Result := FDisableCount <> 0;
end;

procedure TsohoCustomDBGrid.Scroll(Distance: Integer);
{$IFNDEF Delphi3}
var
  IndicatorRect: TRect;
{$ENDIF}
begin
  if FDisableCount = 0 then begin
    inherited Scroll(Distance);
{$IFNDEF Delphi3}
    if (dgIndicator in Options) and HandleAllocated and MultiSelect then
    begin
      IndicatorRect := BoxRect(0, 0, 0, RowCount - 1);
      InvalidateRect(Handle, @IndicatorRect, False);
    end;
{$ENDIF}
  end;
  DrawSmashColumn;
end;

{$IFDEF Delphi4_or_5}

function TsohoCustomDBGrid.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := False;
  if Assigned(OnMouseWheelDown) then
    OnMouseWheelDown(Self, Shift, MousePos, Result);
  if not Result then begin
    if not AcquireFocus then Exit;
    if Datalink.Active then begin
      Result := Datalink.DataSet.MoveBy(1) <> 0;
    end;
  end;
end;

function TsohoCustomDBGrid.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := False;
  if Assigned(OnMouseWheelUp) then
    OnMouseWheelUp(Self, Shift, MousePos, Result);
  if not Result then begin
    if not AcquireFocus then Exit;
    if Datalink.Active then begin
      Result := Datalink.DataSet.MoveBy(-1) <> 0;
    end;
  end;
end;

{$ENDIF Delphi4_or_5}

procedure TsohoCustomDBGrid.EditChanged(Sender: TObject);
begin
  if Assigned(FOnEditChange) then FOnEditChange(Self);
end;

procedure TsohoCustomDBGrid.TopLeftChanged;
begin
  if (dgRowSelect in Options) and DefaultDrawing then
    GridInvalidateRow(Self, Self.Row);
  inherited TopLeftChanged;
  if FTracking then StopTracking;
end;

procedure TsohoCustomDBGrid.StopTracking;
begin
  if FTracking then begin
    TrackButton(-1, -1);
    FTracking := False;
    MouseCapture := False;
  end;
end;

procedure TsohoCustomDBGrid.TrackButton(X, Y: Integer);
var
  Cell: TGridCoord;
  NewPressed: Boolean;
  I, Offset: Integer;
begin
  Cell := MouseCoord(X, Y);
  Offset := TitleOffset;
  NewPressed := PtInRect(Rect(0, 0, ClientWidth, ClientHeight), Point(X, Y)) and
    (FPressedCol = GetMasterColumn(Cell.X, Cell.Y)) and (Cell.Y < Offset);
  if FPressed <> NewPressed then begin
    FPressed := NewPressed;
    for I := 0 to Offset - 1 do
      GridInvalidateRow(Self, I);
  end;
end;

// ,  DblClick     
// TitleButtons    OnDblClick.
procedure TsohoCustomDBGrid.WMDblClick(var Message: TMessage);
var Tmp: TGridCoord;
begin
  Tmp := MouseCoord(Loword(Message.LParam), Hiword(Message.LParam));
  if (Tmp.Y = 0) and (dgTitles in Options) and
     TitleButtons then exit;
  if FEditOnDblClick then DoOperation(soEditRecord);
  inherited;
end;

procedure TsohoCustomDBGrid.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var Cell           : TGridCoord;
    MouseDownEvent : TMouseEvent;
    EnableClick    : Boolean;
    OldID          : Variant;
    OldRecNo       : Integer;
    IdField: TField;
begin
  if not AcquireFocus then Exit;
  IdField := nil;
  OldRecNo := -1;
  if (dgsShiftLMouse in SelectOptions) AND (ssShift in Shift) then begin
    IdField := Datalink.Dataset.FindField(KeyField);
    if IdField <> nil then
      OldID    := Datalink.Dataset.FieldByName(KeyField).Value
    else
      OldID    := -1;
    OldRecNo := Datalink.Dataset.RecNo
  end;  { --- if --- }
  Cell := MouseCoord(X, Y);
  if Sizing(X, Y) and (ssDouble in Shift) then begin
    SetMimimumWidth(MouseCoord(X - 4, Y), True);
    Exit;
  end;

  if (ssDouble in Shift) and (Button = mbLeft) then begin
    DblClick;
    Exit;
  end;
  if Sizing(X, Y) then
    inherited MouseDown(Button, Shift, X, Y)
  else begin
    Cell := MouseCoord(X, Y);
{$IFDEF Delphi4_or_5}
    if (DragKind = dkDock) and (Cell.X < IndicatorOffset) and
      (Cell.Y < TitleOffset) and (not (csDesigning in ComponentState)) then
    begin
      BeginDrag(False);
      Exit;
    end;
{$ENDIF}
    if FTitleButtons and (Datalink <> nil) and Datalink.Active and
      (Cell.Y < TitleOffset) and (Cell.X >= IndicatorOffset) and
      not (csDesigning in ComponentState) then
    begin
      if (dgColumnResize in Options) and (Button = mbRight) then begin
        Button := mbLeft;
        FSwapButtons := True;
        MouseCapture := True;
      end
      else if Button = mbLeft then begin
        EnableClick := True;
        CheckTitleButton(Cell.X - IndicatorOffset, Cell.Y, EnableClick);
        if EnableClick then begin
          MouseCapture := True;
          FTracking := True;
          FPressedCol := GetMasterColumn(Cell.X, Cell.Y);
          TrackButton(X, Y);
        end else Beep;
        Exit;
      end;
    end;
    if (Cell.X < FixedCols + IndicatorOffset) and Datalink.Active then begin
      if (dgIndicator in Options) then
        inherited MouseDown(Button, Shift, 1, Y)
      else if Cell.Y >= TitleOffset then
        if Cell.Y - Row <> 0 then Datalink.Dataset.MoveBy(Cell.Y - Row);
    end
    else inherited MouseDown(Button, Shift, X, Y);
    MouseDownEvent := OnMouseDown;
    if Assigned(MouseDownEvent) then MouseDownEvent(Self, Button, Shift, X, Y);
    if not (((csDesigning in ComponentState) or (dgColumnResize in Options)) and
      (Cell.Y < TitleOffset)) and (Button = mbLeft) then
    begin
      // Selected rows if Multiselect := true
      if MultiSelect and Datalink.Active then
        with SelectedRows do begin
          FSelecting := False;
          if ssCtrl in Shift then
            CurrentRowSelected := not CurrentRowSelected
          else begin
            Clear;
            if FClearSelection then CurrentRowSelected := True;
          end;
        end;

      if (not (dgsPersistSelect in SelectOptions))
         AND (not (ssCtrl in Shift))
         AND (not (ssShift in Shift)) then UnselectAll;
      // Selected row if dgsCtrlLMouse in SelectOptions
      if (dgsCtrlLMouse in SelectOptions) AND (ssCtrl in Shift) then begin
        SelectCurrent;
      end; { --- if --- }

      // Selected rows if dgsShiftLMouse in SelectOptions
      if (dgsShiftLMouse in SelectOptions) AND
         (ssShift in Shift) and (IdField <> nil) then begin
        SelectGrp(IdField.Value, OldID,
                  (Datalink.Dataset.RecNo - OldRecNo));
      end; { --- if --- }
{------------------------------------------------------------------------------}
{$IFDEF Delphi4_or_5}
    if FBoolFields.IndexOf(SelectedField.FullName) <> -1 then begin
{$ELSE}
    if FBoolFields.IndexOf(SelectedField.Name) <> -1 then begin
{$ENDIF}
       If (FOldACol = Col) AND (FOldARow = Row) then EditBoolField;
     end; {--- if ---}
    FOldACol := Col;
    FOldARow := Row;
{------------------------------------------------------------------------------}
    end;
  end;
end;

procedure TsohoCustomDBGrid.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  if FTracking then TrackButton(X, Y);
  inherited MouseMove(Shift, X, Y);
end;

procedure TsohoCustomDBGrid.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var
  Cell: TGridCoord;
  ACol: Longint;
  DoClick: Boolean;
begin
  if GridState = gsColMoving then
    if Assigned(FBeforeColumnMoved) then FBeforeColumnMoved(Self);

  if FTracking and (FPressedCol <> nil) then
  begin
    Cell := MouseCoord(X, Y);
    DoClick := PtInRect(Rect(0, 0, ClientWidth, ClientHeight), Point(X, Y))
      and (Cell.Y < TitleOffset) and
      (FPressedCol = GetMasterColumn(Cell.X, Cell.Y));
    StopTracking;
    if DoClick then begin
      ACol := Cell.X;
      if (dgIndicator in Options) then Dec(ACol);
      if (DataLink <> nil) and DataLink.Active and (ACol >= 0) and
        (ACol < Columns.Count) then
      begin
        DoTitleClick(FPressedCol.Index, FPressedCol.Field);
      end;
    end;
  end
  else if FSwapButtons then begin
    FSwapButtons := False;
    MouseCapture := False;
    if Button = mbRight then Button := mbLeft;
  end;
  inherited MouseUp(Button, Shift, X, Y);
end;

procedure TsohoCustomDBGrid.WMRButtonUp(var Message: TWMMouse);
begin
  if not (FGridState in [gsColMoving, gsRowMoving]) then
    inherited
  else if not (csNoStdEvents in ControlStyle) then
    with Message do MouseUp(mbRight, KeysToShiftState(Keys), XPos, YPos);
end;

procedure TsohoCustomDBGrid.WMCancelMode(var Message: TMessage);
begin
  StopTracking;
  inherited;
end;

type
  THack = class(TWinControl);

procedure TsohoCustomDBGrid.WMChar(var Msg: TWMChar);

  function DoKeyPress(var Msg: TWMChar): Boolean;
  var
    Form: TCustomForm;
    Ch: Char;
  begin
    Result := True;
    Form := GetParentForm(Self);
    if (Form <> nil) and TForm(Form).KeyPreview and
      THack(Form).DoKeyPress(Msg) then Exit;
    with Msg do begin
      if Assigned(FOnKeyPress) then begin
        Ch := Char(CharCode);
        FOnKeyPress(Self, Ch);
        CharCode := Word(Ch);
      end;
      if Char(CharCode) = #0 then Exit;
    end;
    Result := False;
  end;

begin
  if EditorMode or not DoKeyPress(Msg) then inherited;
end;

procedure TsohoCustomDBGrid.KeyPress(var Key: Char);
var K : Word;
    Old_key : Char;

    procedure OldKeyPress;
    begin
      if EditorMode then inherited OnKeyPress := FOnKeyPress;
      try
        inherited KeyPress(Key);
      finally
        inherited OnKeyPress := nil;
      end;
    end;

begin
  try
    Old_Key := Key;
    if (dgEnterToTab in FKeyOptions) then begin
      if (EditorMode) and (Key = EnterStr) then Key := TabStr;
      inherited KeyPress(Key);
      if (EditorMode) and (Old_Key = EnterStr) then begin
        k := vk_Tab;
        KeyDown(k,[]);
      end;{--- If ---}
    end {--- If ---}
    else inherited KeyPress(Key);
  finally
  end;
end;

procedure TsohoCustomDBGrid.DefaultDataCellDraw(const Rect: TRect; Field: TField;
  State: TGridDrawState);
begin
  DefaultDrawDataCell(Rect, Field, State);
end;

function TsohoCustomDBGrid.GetMasterColumn(ACol, ARow: Longint): TColumn;
begin
  if (dgIndicator in Options) then Dec(ACol, IndicatorOffset);
  if (Datalink <> nil) and Datalink.Active and (ACol >= 0) and
    (ACol < Columns.Count) then
  begin
    Result := Columns[ACol];
{$IFDEF Delphi4_or_5}
    Result := ColumnAtDepth(Result, ARow);
{$ENDIF}
  end
  else Result := nil;
end;

procedure TsohoCustomDBGrid.DrawCell(ACol, ARow: Longint; ARect: TRect;
  AState: TGridDrawState);

{$IFDEF Delphi4_or_5}
  function CalcTitleRect(Col: TColumn; ARow: Integer; var MasterCol: TColumn): TRect;
    { copied from Inprise's DbGrids.pas }
  var
    I,J: Integer;
    InBiDiMode: Boolean;
    DrawInfo: TGridDrawInfo;
  begin
    MasterCol := ColumnAtDepth(Col, ARow);
    if MasterCol = nil then Exit;
    I := DataToRawColumn(MasterCol.Index);
    if I >= LeftCol then J := MasterCol.Depth
    else begin
      if (FixedCols > 0) and (MasterCol.Index < FixedCols) then begin
        J := MasterCol.Depth;
      end
      else begin
        I := LeftCol;
        if Col.Depth > ARow then J := ARow
        else J := Col.Depth;
      end;
    end;
    Result := CellRect(I, J);
    InBiDiMode := UseRightToLeftAlignment and (Canvas.CanvasOrientation = coLeftToRight);
    for I := Col.Index to Columns.Count - 1 do begin
      if ColumnAtDepth(Columns[I], ARow) <> MasterCol then Break;
      if not InBiDiMode then begin
        J := CellRect(DataToRawColumn(I), ARow).Right;
        if J = 0 then Break;
        Result.Right := GetMax(Result.Right, J);
      end
      else begin
        J := CellRect(DataToRawColumn(I), ARow).Left;
        if J >= ClientWidth then Break;
        Result.Left := J;
      end;
    end;
    J := Col.Depth;
    if (J <= ARow) and (J < FixedRows - 1) then begin
      CalcFixedInfo(DrawInfo);
      Result.Bottom := DrawInfo.Vert.FixedBoundary -
        DrawInfo.Vert.EffectiveLineWidth;
    end;
  end;

  procedure DrawExpandBtn(var TitleRect, TextRect: TRect; InBiDiMode: Boolean;
    Expanded: Boolean); { copied from Inprise's DbGrids.pas }
  const
    ScrollArrows: array [Boolean, Boolean] of Integer =
      ((DFCS_SCROLLRIGHT, DFCS_SCROLLLEFT), (DFCS_SCROLLLEFT, DFCS_SCROLLRIGHT));
  var
    ButtonRect: TRect;
    I: Integer;
  begin
    I := GetSystemMetrics(SM_CXHSCROLL);
    if ((TextRect.Right - TextRect.Left) > I) then begin
      Dec(TextRect.Right, I);
      ButtonRect := TitleRect;
      ButtonRect.Left := TextRect.Right;
      I := SaveDC(Canvas.Handle);
      try
        Canvas.FillRect(ButtonRect);
        InflateRect(ButtonRect, -1, -1);
        with ButtonRect do
          IntersectClipRect(Canvas.Handle, Left, Top, Right, Bottom);
        InflateRect(ButtonRect, 1, 1);
        { DrawFrameControl doesn't draw properly when orienatation has changed.
          It draws as ExtTextOut does. }
        if InBiDiMode then { stretch the arrows box }
          Inc(ButtonRect.Right, GetSystemMetrics(SM_CXHSCROLL) + 4);
        DrawFrameControl(Canvas.Handle, ButtonRect, DFC_SCROLL,
          ScrollArrows[InBiDiMode, Expanded] or DFCS_FLAT);
      finally
        RestoreDC(Canvas.Handle, I);
      end;
      TitleRect.Right := ButtonRect.Left;
    end;
  end;
{$ENDIF Delphi4_or_5}

var
  FrameOffs: Byte;
  BackColor: TColor;
  SortMarker: TSortMarker;
  Indicator, ALeft: Integer;
  TmpTitle: string;
  Down: Boolean;
  Bmp: TBitmap;
  SavePen: TColor;
  OldActive: Longint;
  MultiSelected: Boolean;
  FixRect: TRect;
  TitleRect, TextRect: TRect;
  AField: TField;
{$IFDEF Delphi4_or_5}
  MasterCol: TColumn;
  InBiDiMode: Boolean;
{$ENDIF}
  DrawColumn: TColumn;
const
  EdgeFlag: array[Boolean] of UINT = (BDR_RAISEDINNER, BDR_SUNKENINNER);
begin
  FCalcCellRow := aRow;
  FCalcCellCol := aCol;
  inherited DrawCell(ACol, ARow, ARect, AState);
{$IFDEF Delphi4_or_5}
  InBiDiMode := Canvas.CanvasOrientation = coRightToLeft;
{$ENDIF}
  if (dgIndicator in Options) and (ACol = 0) and (ARow - TitleOffset >= 0)
    and MultiSelect and (DataLink <> nil) and DataLink.Active and
    (Datalink.DataSet.State = dsBrowse) then
  begin { draw multiselect indicators if needed }
    FixRect := ARect;
    if ([dgRowLines, dgColLines] * Options = [dgRowLines, dgColLines]) then
    begin
      InflateRect(FixRect, -1, -1);
      FrameOffs := 1;
    end
    else FrameOffs := 2;
    OldActive := DataLink.ActiveRecord;
    try
      Datalink.ActiveRecord := ARow - TitleOffset;
      MultiSelected := ActiveRowSelected;
    finally
      Datalink.ActiveRecord := OldActive;
    end;
    if MultiSelected then begin
      if (ARow - TitleOffset <> Datalink.ActiveRecord) then Indicator := 0
      else Indicator := 1;  { multiselected and current row }
      FMsIndicators.BkColor := FixedColor;
      ALeft := FixRect.Right - FMsIndicators.Width - FrameOffs;
{$IFDEF Delphi4_or_5}
      if InBiDiMode then Inc(ALeft);
{$ENDIF}
      FMsIndicators.Draw(Self.Canvas, ALeft, (FixRect.Top +
        FixRect.Bottom - FMsIndicators.Height) shr 1, Indicator);
    end;
  end
  else if not (csLoading in ComponentState) and
    (*(FTitleButtons {$IFDEF Delphi4_or_5} or (FixedCols > 0) {$ENDIF}) and*)
    (gdFixed in AState) and (dgTitles in Options) and (ARow < TitleOffset) then
  begin
    SavePen := Canvas.Pen.Color;
    try
      Canvas.Pen.Color := clWindowFrame;
      if (dgIndicator in Options) then Dec(ACol, IndicatorOffset);
      AField := nil;
      SortMarker := smNone;
{$IFDEF WIN32}
      if (Datalink <> nil) and Datalink.Active and (ACol >= 0) and
        (ACol < Columns.Count) then
      begin
        DrawColumn := Columns[ACol];
        AField := DrawColumn.Field;
      end
      else DrawColumn := nil;
{$IFDEF Delphi4_or_5}
      if Assigned(DrawColumn) and not DrawColumn.Showing then Exit;
      TitleRect := CalcTitleRect(DrawColumn, ARow, MasterCol);
      if TitleRect.Right < ARect.Right then
        TitleRect.Right := ARect.Right;
      if MasterCol = nil then
        Exit
      else if MasterCol <> DrawColumn then
        AField := MasterCol.Field;
      DrawColumn := MasterCol;
      if ((dgColLines in Options) or FTitleButtons) and (ACol = FixedCols - 1) then
      begin
        if (ACol < Columns.Count - 1) and not (Columns[ACol + 1].Showing) then
        begin
          Canvas.MoveTo(TitleRect.Right, TitleRect.Top);
          Canvas.LineTo(TitleRect.Right, TitleRect.Bottom);
        end;
      end;
      if ((dgRowLines in Options) or FTitleButtons) and not MasterCol.Showing then
      begin
        Canvas.MoveTo(TitleRect.Left, TitleRect.Bottom);
        Canvas.LineTo(TitleRect.Right, TitleRect.Bottom);
      end;
{$ELSE}
      TitleRect := ARect;
{$ENDIF Delphi4_or_5}
      Down := FPressed and FTitleButtons and (FPressedCol = DrawColumn);
      if FTitleButtons or ([dgRowLines, dgColLines] * Options =
        [dgRowLines, dgColLines]) then
      begin
        DrawEdge(Canvas.Handle, TitleRect, EdgeFlag[Down], BF_BOTTOMRIGHT);
        DrawEdge(Canvas.Handle, TitleRect, EdgeFlag[Down], BF_TOPLEFT);
        InflateRect(TitleRect, -1, -1);
      end;
      Canvas.Font := TitleFont;
      Canvas.Brush.Color := FixedColor;
      if (DrawColumn <> nil) then begin
        Canvas.Font := DrawColumn.Title.Font;
        Canvas.Brush.Color := DrawColumn.Title.Color;
      end;
      if FTitleButtons and (AField <> nil) and Assigned(FOnGetBtnParams) then
      begin
        BackColor := Canvas.Brush.Color;
        FOnGetBtnParams(Self, AField, Canvas.Font, BackColor, SortMarker, Down);
        Canvas.Brush.Color := BackColor;
      end;
      if Down then begin
        Inc(TitleRect.Left); Inc(TitleRect.Top);
      end;
      ARect := TitleRect;
      if (DataLink = nil) or not DataLink.Active then
        Canvas.FillRect(TitleRect)
      else if (DrawColumn <> nil) then begin
        case SortMarker of
          smDown: Bmp := GetGridBitmap(gpMarkDown);
          smUp: Bmp := GetGridBitmap(gpMarkUp);
          else Bmp := nil;
        end;
        TextRect := TitleRect;
{$IFDEF Delphi4_or_5}
        if DrawColumn.Expandable then
          DrawExpandBtn(TitleRect, TextRect, InBiDiMode, DrawColumn.Expanded);
{$ENDIF}
        {with DrawColumn.Title do
          DrawCellText(Self, ACol, ARow, Caption, TextRect,
            Alignment, vaCenter);}
        with DrawColumn.Title do begin
          TmpTitle := ChangeChars(Caption, '~', EnterStr);
          DrawCellText(Self, ACol, ARow, TmpTitle, TextRect,
            FTitleAlignment, vaTopJustify);
        end;
          {WriteText(Canvas, aRect, 0, 0, TmpTitle,
             FTitleAlignment, FTitleLines>1);}
        if Bmp <> nil then begin
          ALeft := TitleRect.Right - Bmp.Width - 3;
          if Down then Inc(ALeft);
{$IFDEF Delphi4_or_5}
          if IsRightToLeft then ALeft := TitleRect.Left + 3;
{$ENDIF}
          if (ALeft > TitleRect.Left) and (ALeft + Bmp.Width < TitleRect.Right) then
            DrawBitmapTransparent(Canvas, ALeft, (TitleRect.Bottom +
              TitleRect.Top - Bmp.Height) div 2, Bmp, clFuchsia);
        end;
      end
{$ELSE WIN32}
      if not (dgColLines in Options) then begin
        Canvas.MoveTo(ARect.Right - 1, ARect.Top);
        Canvas.LineTo(ARect.Right - 1, ARect.Bottom);
        Dec(ARect.Right);
      end;
      if not (dgRowLines in Options) then begin
        Canvas.MoveTo(ARect.Left, ARect.Bottom - 1);
        Canvas.LineTo(ARect.Right, ARect.Bottom - 1);
        Dec(ARect.Bottom);
      end;
      Down := FPressed and FTitleButtons and (FPressedCol = ACol);
      if (Datalink <> nil) and Datalink.Active and (ACol >= 0) and
        (ACol < FieldCount) then
      begin
        AField := Fields[ACol];
      end;
      if Down then begin
        with ARect do begin
          Canvas.Pen.Color := clBtnShadow;
          Canvas.PolyLine([Point(Left, Bottom - 1), Point(Left, Top),
            Point(Right, Top)]);
          Inc(Left, 2); Inc(Top, 2);
        end;
      end
      else Frame3D(Canvas, ARect, clBtnHighlight, clBtnShadow, 1);
      Canvas.Font := TitleFont;
      Canvas.Brush.Color := TitleColor;
      if FTitleButtons and (AField <> nil) and Assigned(FOnGetBtnParams) then
      begin
        BackColor := Canvas.Brush.Color;
        FOnGetBtnParams(Self, AField, Canvas.Font, BackColor, SortMarker, Down);
        Canvas.Brush.Color := BackColor;
      end;
      if (DataLink = nil) or not DataLink.Active then
        Canvas.FillRect(ARect)
      else if (AField <> nil) then begin
        case SortMarker of
          smDown: Bmp := GetGridBitmap(gpMarkDown);
          smUp: Bmp := GetGridBitmap(gpMarkUp);
          else Bmp := nil;
        end;
        if Bmp <> nil then Indicator := Bmp.Width + 8
        else Indicator := 1;
        DrawCellText(Self, ACol, ARow, AField.DisplayLabel, ARect,
          taLeftJustify, vaCenter);
        if Bmp <> nil then begin
          ALeft := ARect.Right - Bmp.Width - 4;
          if Down then Inc(ALeft);
          DrawBitmapTransparent(Canvas, ALeft,
            (ARect.Bottom + ARect.Top - Bmp.Height) div 2, Bmp, clFuchsia);
        end;
      end
{$ENDIF WIN32}
      else DrawCellText(Self, ACol, ARow, '', ARect, taLeftJustify, vaCenter);
    finally
      Canvas.Pen.Color := SavePen;
    end;
  end
  else begin
{$IFDEF Delphi4_or_5}
    Canvas.Font := Self.Font;
    if (DataLink <> nil) and DataLink.Active and (ACol >= 0) and
      (ACol < Columns.Count) then
    begin
      DrawColumn := Columns[ACol];
      if DrawColumn <> nil then Canvas.Font := DrawColumn.Font;
    end;
{$ENDIF}
  end;
end;

procedure TsohoCustomDBGrid.DrawColumnCell(const Rect: TRect; DataCol: Integer;
  Column: TColumn; State: TGridDrawState);
var
  I: Integer;
  NewBackgrnd: TColor;
  Highlight: Boolean;
  Bmp: TBitmap;
  Field: TField;
  R    : TRect;
  Flags: Integer;
  // TextH : Integer;
    procedure DrawFocusedColumnCell;
    begin
       if Highlight
         and not (csDesigning in ComponentState)
         and not (dgRowSelect in Options)
         and (ValidParentForm(Self).ActiveControl = Self) then
         Canvas.DrawFocusRect(Rect);
    end;

    {      }
    procedure OldDrawColumnCell;
    begin
      if gdFixed in State then Canvas.Brush.Color := FixedColor;
      NewBackgrnd := Canvas.Brush.Color;
      Highlight := (gdSelected in State) and ((dgAlwaysShowSelection in Options) or
        Focused);
      GetCellProps(Field, Canvas.Font, NewBackgrnd, Highlight or ActiveRowSelected);
      Canvas.Brush.Color := NewBackgrnd;
      if FDefaultDrawing then begin
        I := GetImageIndex(Field);
        if I >= 0 then begin
          Bmp := GetGridBitmap(TGridPicture(I));
          Canvas.FillRect(Rect);
          DrawBitmapTransparent(Canvas, (Rect.Left + Rect.Right - Bmp.Width) div 2,
            (Rect.Top + Rect.Bottom - Bmp.Height) div 2, Bmp, clOlive);
        end
        else DefaultDrawColumnCell(Rect, DataCol, Column, State);
      end;
      if Columns.State = csDefault then
        inherited DrawDataCell(Rect, Field, State);
      inherited DrawColumnCell(Rect, DataCol, Column, State);
      if FDefaultDrawing and Highlight and not (csDesigning in ComponentState)
        and not (dgRowSelect in Options)
        and (ValidParentForm(Self).ActiveControl = Self) then
        Canvas.DrawFocusRect(Rect);
    end;

begin
  Field := Column.Field;

  if DefaultDrawing then begin

    if Assigned(Field) and FDrawChecks and
       (
       (Field.DataType = ftBoolean) or
       (StringBooleanFields.IndexOf(AnsiUpperCase(Field.FieldName)) <> -1 ) or
       (FBoolFields.IndexOf(AnsiUpperCase(Field.FieldName)) <> -1)
       )
    then begin
      NewBackgrnd := Canvas.Brush.Color;
      Highlight := (gdSelected in State) and ((dgAlwaysShowSelection in Options) or
         Focused);
      GetCellProps(Field, Canvas.Font, NewBackgrnd, Highlight or ActiveRowSelected);
      Canvas.Brush.Color := NewBackgrnd;
      Canvas.FillRect(Rect);
//------------------------------------------------------------------------------
      if ((Field.DataType = ftBoolean) and TBooleanField(Field).AsBoolean) or
          StrToBool(Field.AsString)
         then Flags := DFCS_CHECKED or DFCS_BUTTONCHECK //Bmp := GetGridBitmap(gpCheck)
         else Flags := DFCS_BUTTONCHECK;                //Bmp := GetGridBitmap(gpUnCheck);
//     CheckBox
          SetRect(R,(Rect.Left + Rect.Right  - 13) div 2,
                    (Rect.Top  + Rect.Bottom - 13) div 2 + 1,
                    (Rect.Left + Rect.Right  + 13) div 2,
                    (Rect.Top  + Rect.Bottom + 13) div 2 + 1);
          DrawFrameControl(Canvas.Handle, R, DFC_BUTTON, Flags);
          //DrawBitmapTransparent(Canvas, (Rect.Left + Rect.Right - Bmp.Width) div 2,
          //  (Rect.Top + Rect.Bottom - Bmp.Height) div 2, Bmp, Bmp.Canvas.Pixels[0, Bmp.Height - 1]);
          // DrawResBitmapInRect(Canvas, Rect, 'SOHOCHECKEDCELL');
//------------------------------------------------------------------------------
      DrawFocusedColumnCell;
    end

    else
      if Assigned(Field) and (Field is TStringField) and FWordWrap then begin
         inherited DrawColumnCell(Rect, Datacol, Column, State);
         NewBackgrnd := Canvas.Brush.Color;
         Highlight := (gdSelected in State) and ((dgAlwaysShowSelection in Options) or
            Focused);
         GetCellProps(Field, Canvas.Font, NewBackgrnd, Highlight or ActiveRowSelected);
         Canvas.Brush.Color := NewBackgrnd;
         Canvas.FillRect(Rect);
         WrapTextInRect(Canvas, Field.AsString, Rect, Column.Alignment);
         DrawFocusedColumnCell;

      end
      else OldDrawColumnCell;
  end
  else OldDrawColumnCell;
end;

procedure TsohoCustomDBGrid.MouseToCell(X, Y: Integer; var ACol, ARow: Longint);
var
  Coord: TGridCoord;
begin
  Coord := MouseCoord(X, Y);
  ACol := Coord.X;
  ARow := Coord.Y;
end;

procedure TsohoCustomDBGrid.EditBoolField;
Var
  R : TRect;
  Flags: Integer;
begin
  if ReadOnly then Exit;
  SelectedField.AsBoolean := not SelectedField.AsBoolean;
  if SelectedField.AsBoolean
    then Flags := DFCS_CHECKED or DFCS_BUTTONCHECK
    else Flags := DFCS_BUTTONCHECK;
  R := GetCellRect(Col, Row);
  SetRect(R,R.Left+1,R.Top+2,R.Right-1,R.Bottom-1);
  DrawFrameControl(Canvas.Handle, R, DFC_BUTTON, Flags);
end; {--- EditBoolField ---}

initialization
  StringBooleanFields := TStringList.Create;
finalization
  StringBooleanFields.Free;
  DestroyLocals;
end.