{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{              Written by Igor Chernyshov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoDBGridAddon;

interface

uses
  Windows, SysUtils, Classes, soDBGrid, soCtmDBGridAddon;

type

  TsohoDBGridAddon = class(TsohoCustomDBGridAddon)
  {        TsohoDBGrid,  , 
     .    
sql- "ORDER BY"
}

  private
    { Private declarations }
  protected
    function  ValidDataSet : boolean; override;
    procedure ChangeOrderBy(FieldNo : integer; const FieldName : string; AscSortOrder : Boolean); override;
    procedure NoSort; override;
  public
    { Public declarations }
  published
    property  AllowSorting;
    {   }
    property AllowFiltering;
    {       }
    property Active;
    {   Active,    }

    property  SortByFieldNo;
    {       (TField.FieldName)  
     (TField.FieldNo).     FieldNames.  , 
    select    ,       .
    ,    :
    ---
    SELECT MAIN_PROV.NAME, SPR_PCH.NAME, MEROPR_GRP.NAME
    FROM   MAIN_PROV, SPR_PCH, MEROPR_GRP
    WHERE  MAIN_PROV.KOD_PCH     = SPR_PCH.ID AND
           MAIN_PROV.IDMEROPRGRP = MEROPR_GRP.ID
    ---
          ,  SortByFieldNo = true
      FieldNames       :
    MAIN_PROV.NAME
    SPR_PCH.NAME
    MEROPR_GRP.NAME
    }
    property  FieldNames;
    {    .   . SortByFieldNo}
    property TurnOffFilter;
    {  -        TurnOffFilter = true
        Filtering  DataSet    false }
    property BeforeOperation;
    {        }
    property AfterOperation;
    {         }
  end;

implementation
Uses DBTables;
//------------------------------------------------------------------------------
// PROTECTED
//------------------------------------------------------------------------------
function  TsohoDBGridAddon.ValidDataSet : boolean;
begin
  Result := (Grid.DataSource.DataSet is TQuery);
end;

procedure TsohoDBGridAddon.ChangeOrderBy(FieldNo : integer; const FieldName : string; AscSortOrder : Boolean);
Var
  i : integer;
  s : string;
begin
  Grid.DataSource.DataSet.Close;
  s := (Grid.DataSource.DataSet as TQuery).SQL.Text;
  i := pos('ORDER BY', UpperCase(S));
  if i <> 0 then S := Copy(S, 1, i - 1);
  S := S + ' ORDER BY ' + FieldName;
  If NOT AscSortOrder then S := S + ' DESC ';
  (Grid.DataSource.DataSet as TQuery).SQL.Text := S;
  Grid.DataSource.DataSet.Open;
end;

procedure TsohoDBGridAddon.NoSort;
Var
  i : integer;
  s : string;
begin
  inherited;
  Grid.DataSource.DataSet.Close;
  s := (Grid.DataSource.DataSet as TQuery).SQL.Text;
  i := pos('ORDER BY', UpperCase(S));
  if i <> 0 then S := Copy(S, 1, i - 1);
  (Grid.DataSource.DataSet as TQuery).SQL.Text := S;
  Grid.DataSource.DataSet.Open;
end;

end.
