{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoExRepD;

{$I SOHOLIB.INC}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, SohoBtns, SoExlRep, SoChkBox, SohoSpin, SoCtrls;

type
  TsohoExlRepPrintDialog = class(TForm)
    PringG: TGroupBox;
    PrintToFileC: TsohoCheckBox;
    CopiesL: TLabel;
    CopiesE: TsohoSpinEdit;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    PrintActionG: TGroupBox;
    PreviewC: TsohoCheckBox;
    AutoPrintC: TsohoCheckBox;
    OpenExcelC: TsohoCheckBox;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    function Execute (var PrintAction : TsohoExcelPrintAction;
       var PrintToFile : boolean; var Copies : integer) : boolean;
  public
    { Public declarations }
  end;

var sohoExlRepPrintDialog: TsohoExlRepPrintDialog;

function GetExcelReportOptions (var PrintAction : TsohoExcelPrintAction;
   var PrintToFile : boolean; var Copies : integer) : boolean;

implementation
uses SoCmnCns, SoDBCns;

{$R *.DFM}

function GetExcelReportOptions (var PrintAction : TsohoExcelPrintAction;
   var PrintToFile : boolean; var Copies : integer) : boolean;
begin
  try
    sohoExlRepPrintDialog := TsohoExlRepPrintDialog.Create(Application);
    Result := sohoExlRepPrintDialog.Execute(PrintAction, PrintToFile, Copies);
  finally
    sohoExlRepPrintDialog.Free;
  end;
end;

procedure TsohoExlRepPrintDialog.FormCreate(Sender: TObject);
begin
  Icon.Handle := LoadIcon(hInstance, 'MAINICON');

  Caption := sohoExcelRepDialogTitle;
  PrintActionG.Caption := sohoExcelRepDialogPrintKind;
  PreviewC.Caption := sohoExcelRepDialogPreview;
  AutoPrintC.Caption := sohoExcelRepDialogAutoPrint;
  OpenExcelC.Caption := sohoExcelRepDialogOpenExcel;
  PringG.Caption := sohoExcelRepDialogPrint;
  PrintToFileC.Caption := sohoExcelRepDialogPrintToFile;
  CopiesL.Caption := sohoExcelRepDialogCopies;

  OkB.Caption := SOKButton;
  CancelB.Caption := SCancelButton;
end;

function TsohoExlRepPrintDialog.Execute (var PrintAction : TsohoExcelPrintAction;
       var PrintToFile : boolean; var Copies : integer) : boolean;
begin
  if PrintAction = paNone then SetGroupIndex(PrintActionG, 2)
  else SetGroupIndex(PrintActionG, ord(PrintAction));

  PrintToFileC.Checked := PrintToFile;
  CopiesE.Value := Copies;

  Result := ShowModal = mrOk;
  if not Result then exit;

  PrintAction := TsohoExcelPrintAction(GetGroupIndex(PrintActionG));

  PrintToFile := PrintToFileC.Checked;
  Copies := trunc(CopiesE.Value);
end;

end.
