{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoFldMnF;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Graphics, Controls,
     Forms, SoTools, StdCtrls, SohoBtns, SoUnit, SoChkBox;

type
  
  TItemsBounds = 0..11;
  
  TFolderMenusForm = class(TForm)
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    sohoEnterTab1: TsohoEnterTab;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FItems: array[TItemsBounds] of TsohoCheckBox;
    function GetNewEnabledMenus(OldMenus: string; var NewMenus: string): boolean;
  public
    { Public declarations }
  end;
  
var FolderMenusForm: TFolderMenusForm;

function GetNewEnabledMenus(OldMenus: string; var NewMenus: string): boolean;

implementation
uses SoCtmFld, SoCmnCns, SoDBCns;

{$R *.DFM}


const MenusIndexes: array[TItemsBounds] of Integer =
   (mDisplaylabel, mDisplayWidth, mDisplayFormat,
    mFieldAlign,   mHideField,    mChangeVisible,
    mSaveFolder,   mLoadFolder,   mTitleLines,
    mTitleAlign,   mCreateRField, mDeleteRField);
  
function GetNewEnabledMenus(OldMenus: string; var NewMenus: string): boolean;
begin
  FolderMenusForm := TFolderMenusForm.Create(Application);
  try
    Result := FolderMenusForm.GetNewEnabledMenus(OldMenus, NewMenus);
  finally
    FolderMenusForm.Free;
  end;
end;

function TFolderMenusForm.GetNewEnabledMenus(OldMenus: string; var NewMenus: string): boolean;
var index: Longint;
  ResSet: SetOfByte;
begin
  ResSet := StrToSet(OldMenus);
  for index := Low(FItems) to High(FItems) do begin
    FItems[index] := TsohoCheckBox.Create(Self);
    FItems[index].Parent := Self;
    FItems[index].Top := 10 + index * 20;
    FItems[index].Width := 260;
    FItems[index].Left := 10;
    FItems[index].Caption := GetMenuCaption(MenusIndexes[index]);
    FItems[index].Checked := (MenusIndexes[index] + 1) in ResSet;
  end;
  Result := ShowModal = mrOk;
  if Result then begin
    ResSet := [];
    for index := Low(FItems) to High(FItems) do
      if FItems[index].Checked then ResSet := ResSet + [MenusIndexes[index] + 1];
    NewMenus := SetToStr(ResSet);
  end;
  for index := Low(FItems) to High(FItems) do FItems[index].Free;
end;

procedure TFolderMenusForm.FormCreate(Sender: TObject);
begin
  Caption := sohoFolderOptionsTitle;

  OkB.Caption := SOKButton;
  CancelB.Caption := SCancelButton;
end;

end.

