{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{           Partial copyright (c) AllexSoft             }
{              Written by Serg Vostrikov,               }
{                Alexander Govyadinov,                  }
{                   Victor Mylcin                       }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
     TsohoFolder.    
    TsohoDBGrid  run-time 
}
unit SoFolder;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Controls, SoCtmFld;

type

  TsohoFolder = class(TsohoCustomFolder)
  {        TsohoDBGrid 
    run-time .      
       TsohoDBGrid,     
      .    "" TsohoDBGrid ( Grid),
     ini- (FolderName  FolderDir  ).  Auto = true
    ,        DataSet,
      .    DisplayLabel, DisplayFormat 
     , TsohoCustomFolder      
    Calculated-,       .  DataSet
     TsohoDBGrid   ,     
        ,     TableName
  }
  private
    FDataBaseName : string;
  protected
    procedure CreateRealField; override;
    procedure DeleteRealField; override;
    procedure ChangeVisible; override;
  public  
    procedure SetEvents;override;
  published
    property ProtectView default true;
    {   ""   DataSet.   true
    TsohoFolder      
            "Protect".
      ,     false  
      }
    property DataBaseName : string read FDataBaseName write FDataBaseName;
    {     }
    property Grid;
    {   ,      }
    property Auto;
    {      DataSet',  
      Grid  DataSource }
    property FolderName;
    {   - }
    property FolderDir;
    { ,      }
    property TableName;
    {    .   ,    
          }
    property EnabledMenus;
    {     }
    property OnSaveDataSet;
    {      DataSet }
    property OnLoadDataSet;
    {      DataSet }
    property OnChange;
    {       Grid }
  end;

implementation
uses SoAppUtils, DBTables, SoDBRtn, SoCrFldF, SoRghtsF, SoCtmRgs,
     SoUnit, SoDBCns, SoVCLUtils;

procedure TsohoFolder.CreateRealField;
var SQLCommand: string;
    TmpQuery: TQuery;
begin
  if not CreateNewField(SQLCommand) then exit;
  TmpQuery := nil;
  try
    TmpQuery := TQuery.Create(Self);
    with TmpQuery, SQL do begin
      if ExtractFileExt(TableName) = '' then
        Add('ALTER TABLE ' + TableName + ' ADD ' + SQLCommand)
      else
        Add('ALTER TABLE "' + TableName + '" ADD ' + SQLCommand);
      try
        DataSet.Close;
        PushCursor(crHourGlass);
        DataBaseName := FDataBaseName;
        ExecSQL;
      except ErrorMsg(Format(sohoFolderColumnCreateError, [Self.Name]));
      end;
    end;
  finally
    if TmpQuery <> nil then TmpQuery.Free;
    ReOpen;
    RestoreCursor;
  end;
end;

procedure TsohoFolder.DeleteRealField;
var TmpQuery: TQuery;
begin
  if not YesNoMsg(Format(sohoFolderBeforeColumnDelete,
    [Grid.SelectedField.FieldName])) then exit;
  TmpQuery := nil;
  try
    TmpQuery := TQuery.Create(Self);
    with TmpQuery, SQL do begin
      if ExtractFileExt(TableName) = '' then
        Add('ALTER TABLE ' + TableName + ' DROP ' + Grid.SelectedField.FieldName)
      else
        Add('ALTER TABLE "' + TableName + '" DROP ' + Grid.SelectedField.FieldName);
      try
        DataSet.Close;
        PushCursor(crHourGlass);
        DataBaseName := FDataBaseName;
        ExecSQL;
      except ErrorMsg(Format(sohoFolderColumnDeleteError, [Self.Name]));
      end;
    end;
  finally
    if TmpQuery <> nil then TmpQuery.Free;
    ReOpen;
    RestoreCursor;
  end;
end;

procedure TsohoFolder.ChangeVisible;
var FieldRights, aOld, RecordRights : byte;
    IsRightsField : boolean;
begin
  {     ,     }
  if SingleRegister = nil then exit;
  IsRightsField := DataSet.FindField('Protect')<>nil;
  aOld := 0;
  if IsRightsField then
    aOld := DataSet.FieldByName('Protect').AsInteger;
  RecordRights := aOld;
  if not SetDataRights(FieldRights, RecordRights, IsRightsField) then exit;
  if (FieldRights in DataReadRights) or
    (FieldRights in DataWriteRights) then
    Grid.SelectedField.Tag := FieldRights
  else InfoMsg(Format(sohoFolderYouCanUse, [SetToStr(DataReadRights + DataWriteRights)]));

  FIni.WriteInteger(Grid.SelectedField.FieldName, 'Tag', Grid.SelectedField.Tag);
  if (aOld<>RecordRights) and (DataSet.FindField('Protect')<>nil) then
    if (RecordRights in DataReadRights) or
       (RecordRights in DataWriteRights) then begin
       with TQuery.Create(nil) do begin
         DataBaseName := FDataBaseName;
         if ExtractFileExt(TableName) <> '' then
           SQL.Add('update "'+TableName+'" set Protect='+IntToStr(RecordRights)+
              ' where '+KeyField+'='+DataSet.FieldByName(KeyField).AsString)
         else
           SQL.Add('update '+TableName+' set Protect='+IntToStr(RecordRights)+
              ' where '+KeyField+'='+DataSet.FieldByName(KeyField).AsString);
         try
           ExecSQL;
         except
           on E: Exception do ErrorMsg(Name+': '+E.Message);
         end;
         Free;
       end;
       RefreshDataSetWithId(DataSet, KeyField);
    end
    else InfoMsg(Format(sohoFolderYouCanUse, [SetToStr(DataReadRights + DataWriteRights)]));
  Changed;
end;

procedure TsohoFolder.SetEvents;
begin
  if FDataBaseName='' then
    if SingleRegister <> nil then FDataBaseName := SingleRegister.PathToData;
  inherited SetEvents;
end;

end.
