{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
    TsohoFormActive
}
unit SoFrmAct;

{$I SOHOLIB.INC}

interface

uses Windows, Messages, Classes, SoTools;

const
  {      }
  WM_REALACTIVATE = WM_USER + 11111;

type

  TsohoFormActive = class(TsohoMsgGrabber)
  {      "" 
    ,  TForm.OnActivate     .
         OnRealActivate
  }
  private
    { Private declarations }
    FOnActivate: TNotifyEvent;
    FOnCreate: TNotifyEvent;
  protected
    { Protected declarations }
    procedure DoFormCreate(Sender: TObject);
    procedure RealActivate(var message: TMessage); message WM_REALACTIVATE;
  public
    procedure Loaded; override;
    destructor Destroy; override;
  published
    property OnRealActivate: TNotifyEvent read FOnActivate write FOnActivate;
    {       }
  end;

implementation
uses SoVCLUtils, Forms;

procedure TsohoFormActive.DoFormCreate(Sender: TObject);
var Form: TForm;
begin
  Form := GetOwnerForm(Self);
  {   ,  , . , 
               . -
          ! }
  if Form <> nil then PostMessage(Form.Handle, WM_REALACTIVATE, 0, 0);
  if Assigned(FOnCreate) then FOnCreate(Sender);
end;

procedure TsohoFormActive.RealActivate(var message: TMessage);
begin
  if Assigned(FOnActivate) then FOnActivate(Self);
end;

procedure TsohoFormActive.Loaded;
var Form: TForm;
begin
  inherited Loaded;
  if csDesigning in ComponentState then exit;
  Form := GetOwnerForm(Self);
  if Form <> nil then begin
    FOnCreate := Form.OnCreate;
    Form.OnCreate := DoFormCreate;
  end;
end;

destructor TsohoFormActive.Destroy;
var Form: TForm;
begin
  if not (csDesigning in ComponentState) then begin
    Form := GetOwnerForm(Self);
    if Form <> nil then Form.OnCreate := FOnCreate;
  end;
  inherited Destroy;
end;

end.

