{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{           Partial copyright (c) AllexSoft             }
{              Written by Serg Vostrikov,               }
{                 Alexander Govyadinov                  }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
     TsohoBitmapGraphic,
     .
      , 
   Marat Sadykov (msadykov@mail.zarech.ru)
    RU.DELPHI.  ,  
     ,    
    Delphi (   SoUtils)
}
unit SoGraph;

{$I SOHOLIB.INC}
{$R-}

interface
uses Windows, Graphics, Classes, ExtCtrls, Controls;

type

     TVertAlignment = (vaTopJustify, vaCenter, vaBottomJustify);

     PArray = ^TArray;
     TArray = array [0..0] of LongInt;

     PsohoBitmapArray = ^TsohoBitmapArray;
     TsohoBitmapArray = record
       Left, Top, Width, Height : LongInt;
       Size : LongInt;
       Buffer : PArray;
     end;

     TsohoBitmapGraphic = class(TBitmap)
{    TBitmap,     .
      SetCurrentArea,    ,   .
 CurrentArea     ,    
   ,   UpdateBitmap.  ,   
QuickPixels        }
     private
       FCurrent : TsohoBitmapArray;
       FUpdating : boolean;
       // FParentHandle : HDC;
       FBitsInfo : TBitmapInfo;
     protected
       procedure SetQuickPixel (X,Y: integer; aColor : TColor);
       function  GetQuickPixel (X,Y: integer) : TColor;
     public
       constructor Create;override;
       destructor Destroy;override;

       procedure UpdateBitmap;
       {     }
       procedure UpdateArea;
       {     }
       procedure BeginUpdate;
       {    "" }
       procedure EndUpdate;
       {  }
       function SetCurrentArea (aLeft, aTop, aWidth, aHeight : integer) : boolean;
       {    }
       procedure Assign(Source : TPersistent);override;
       {      }
       property QuickPixels  [X, Y: integer]: TColor read GetQuickPixel write SetQuickPixel;
       {    }
       property CurrentArea : TsohoBitmapArray read FCurrent write FCurrent;
       {      ""  }
       // property ParentHandle : HDC read FParentHandle write FParentHandle;
     end;

     TRGBRecord = packed record
     {       TColor  .
       ,      ,   
             unit' }
       Blue: byte;
       Green: byte;
       Red: byte;
       Reserved: byte;
     end;

     TInterpolateFunction = function (var BitmapArray: TsohoBitmapArray;
         X,Y: Double): TColor;
     {          }

var

     DefaultInterpolator: TInterpolateFunction;


{--------------------------------------------------------}
{       .    }
{     TsohoBitmapGraphic           }
{--------------------------------------------------------}

procedure InternalGetDIBits(ParentDC : HDC; Bitmap: TBitmap; var BitsInfo : TBitmapInfo;
          var Area : TsohoBitmapArray);
{    Bitmap   }
function  InternalSetDIBits(ParentDC : HDC; Bitmap: TBitmap;
          var BitsInfo : TBitmapInfo; Area: TsohoBitmapArray): integer;
{      Bitmap }
procedure ShiftImage(Source, Destination: TsohoBitmapArray;
  ShiftX, ShiftY: Double; InterPolator: TInterpolateFunction);
{   }
procedure ResizeImage(Source, Destination: TsohoBitmapArray;
  ResizeX, ResizeY: Double; InterPolator: TInterpolateFunction);
{    }
procedure RotateImage(Source, Destination: TsohoBitmapArray;
  CenterX, CenterY, Angle: Double; InterPolator: TInterpolateFunction);
{   }
procedure ConvertToGrayScale(Source, Destination: TsohoBitmapArray);
{    }
procedure ChangeRGB(Source, Destination: TsohoBitmapArray;
  DeltaR, DeltaG, DeltaB: Integer);
{   R,G,B  }

{--------------------------------------------------------}
{                    }
{--------------------------------------------------------}

procedure DoHorRect(Canvas: TCanvas; AlignTop: Boolean; Rect: TRect;
  TopColor, BottomColor: TColor);
{    : ,   . 
   "" ,       TopColor 
    BottomColor }
procedure DoVertRect(Canvas: TCanvas; AlignLeft: Boolean; Rect: TRect;
  TopColor, BottomColor: TColor);
{    : ,   . 
   "" ,       TopColor 
    BottomColor }
function VertCenter(Rect: TRect; Height: Integer): Integer;
{    Height   Rect. 
   "",     ,     
   Rect }
function HorCenter(Rect: TRect; Width: Integer): Integer;
{    Width   Rect. 
   "x",     ,     
   Rect }
procedure AdjustColors(Bevel: TPanelBevel; var TopColor, BottomColor: tColor;
  HighLightColor, ShadowColor: tColor);
{      }

procedure DCFrame3D(DC: HDC; var Rect: TRect; TopColor, BottomColor: TColor;
  Width: Integer);

procedure WriteText(ACanvas: TCanvas; ARect: TRect; DX, DY: Integer;
  const Text: string; Alignment: TAlignment; WordWrap: Boolean
  {$IFDEF Delphi4_or_5}; ARightToLeft: Boolean = False {$ENDIF});

procedure DrawCellTextEx(Control: TCustomControl; ACol, ARow: Longint;
  const S: string; const ARect: TRect; Align: TAlignment;
  VertAlign: TVertAlignment; WordWrap: Boolean);
procedure DrawCellText(Control: TCustomControl; ACol, ARow: Longint;
  const S: string; const ARect: TRect; Align: TAlignment;
  VertAlign: TVertAlignment);
procedure DrawCellBitmap(Control: TCustomControl; ACol, ARow: Longint;
  Bmp: TGraphic; Rect: TRect);

function MinimizeText(const Text: string; Canvas: TCanvas;
  MaxWidth: Integer): string;
{  Text,     Canvas     MaxWidth  }

function WidthOf(R: TRect): Integer;
{    R}
function HeightOf(R: TRect): Integer;
{    R}
procedure DrawBitmapTransparent(Dest: TCanvas; DstX, DstY: Integer;
  Bitmap: TBitmap; TransparentColor: TColor);
{   Bitmap,   TransparentColor  "" }
procedure TextInRect(Canvas: TCanvas; const Text: string; Rect: TRect;
  TextAlign: TAlignment);
{    Rect  API }
procedure WrapTextInRect(Canvas: TCanvas; const Text: string; Rect: TRect;
  TextAlign: TAlignment);
{    Rect  API   }

procedure AngleTextInRect(Canvas: TCanvas; const Text: string; Rect: TRect;
  X, Y: Integer; Angle: Integer);
{    . ,    TTF! }
function GetStrWidth(DC: HDC; const Value: string): Integer;
{     ,     }
function GetStrHeight(DC: HDC; const Value: string): Integer;
{     ,     }

procedure DrawBitmapInRect(Canvas: TCanvas; Rect: TRect; Bitmap: TBitmap);
{  bitmap    }
procedure DrawResBitmapInRect(Canvas: TCanvas; Rect: TRect; const BitMapName: string);
{  bitmap,       }
function CreateBitmapFromIcon(Icon: TIcon; BackColor: TColor): TBitmap;
{  TBitmap  TIcon }

implementation
uses SysUtils, SoUtils, SoCmnCns, SoVCLUtils;

procedure InternalGetDIBits(ParentDC : HDC; Bitmap: TBitmap; var BitsInfo : TBitmapInfo;
          var Area : TsohoBitmapArray);

  function WidthBytes(I: Longint): Longint;
  begin
     Result := ((I + 31) div 32) * 4; //+31etc=  
  end;

begin
  with BitsInfo.bmiHeader do begin
    biWidth  := Bitmap.Width;
    biHeight := Bitmap.Height;
    biSize   :=  SizeOf(TBITMAPINFOHEADER);
    biCompression := BI_RGB;
    biBitCount  := 32;
    biPlanes := 1;
    biSizeImage := WidthBytes(biWidth * biBitCount) * biHeight;
    // Area.Buffer := AllocMem(biSizeImage);
  end;
  with Bitmap do begin
     GetDIBits(ParentDC, Handle, 0, Height, Area.Buffer , BitsInfo,
       DIB_RGB_COLORS);
  end;
end;

function InternalSetDIBits(ParentDC : HDC; Bitmap: TBitmap;
         var BitsInfo : TBitmapInfo; Area: TsohoBitmapArray): integer;
begin
  with Bitmap do begin
    Height := BitsInfo.bmiHeader.biHeight;
    Width  := BitsInfo.bmiHeader.biWidth;
    Result := SetDIBits(ParentDC, Handle, 0, Height, Area.Buffer,
              BitsInfo, DIB_RGB_COLORS);
  end;
end;

{ TsohoBitmapGraphic }
procedure TsohoBitmapGraphic.UpdateBitmap;
var TmpArea : TsohoBitmapArray;
    Index: LongInt;
    DC : HDC;
begin
  if not Assigned(FCurrent.Buffer) then exit;
  DC := GetDC(0);
  if   (FCurrent.Left = 0) and (FCurrent.Top = 0)
   and (FCurrent.Height = Height) and (FCurrent.Width = Width) then
     InternalSetDIBits(DC{ParentHandle}, Self, FBitsInfo, FCurrent)
  else begin
    TmpArea.Left := 0;
    TmpArea.Top := 0;
    TmpArea.Height := Height;
    TmpArea.Width := Width;
    TmpArea.Size := Height * Width * 4;
    TmpArea.Buffer := AllocMem(TmpArea.Size);
    InternalGetDIBits(DC{ParentHandle}, Self, FBitsInfo, TmpArea);
    for Index := 0 to pred(FCurrent.Height) do
      Move( FCurrent.Buffer^[Index*FCurrent.Width],
            TmpArea.Buffer^[(Index+FCurrent.Top)*Width+FCurrent.Left],
            FCurrent.Width * 4);
    InternalSetDIBits(DC{ParentHandle}, Self, FBitsInfo, TmpArea);
    FreeMem(TmpArea.Buffer, TmpArea.Size);
  end;
  ReleaseDC(0, DC);
end;

procedure TsohoBitmapGraphic.UpdateArea;
var TmpArea : TsohoBitmapArray;
    Index: LongInt;
    DC : HDC;
begin
  if Handle = 0 then exit;
  if not Assigned(FCurrent.Buffer) then exit;
  DC := GetDC(0);
  if   (FCurrent.Left = 0) and (FCurrent.Top = 0)
   and (FCurrent.Height = Height) and (FCurrent.Width = Width) then
     InternalGetDIBits(DC{ParentHandle}, Self, FBitsInfo, FCurrent)
  else begin
    TmpArea.Left := 0;
    TmpArea.Top := 0;
    TmpArea.Height := Height;
    TmpArea.Width := Width;
    TmpArea.Size := Height * Width * 4;
    TmpArea.Buffer := AllocMem(TmpArea.Size);
    InternalGetDIBits(DC{ParentHandle}, Self, FBitsInfo, TmpArea);
    for Index := 0 to pred(FCurrent.Height) do
      Move( TmpArea.Buffer^[(Index+FCurrent.Top)*Width+FCurrent.Left],
            FCurrent.Buffer^[Index*FCurrent.Width],
            FCurrent.Width * 4);
    FreeMem(TmpArea.Buffer, TmpArea.Size);
  end;
  ReleaseDC(0, DC);
end;

procedure TsohoBitmapGraphic.SetQuickPixel (X,Y: integer; aColor : TColor);
begin
  if not Assigned(FCurrent.Buffer) then exit;
  if (X < 0) or (X >= Width) or (Y < 0)  or (Y >= Height) then exit;
  with FCurrent do begin
   Y := Height - Y - 1;
   Buffer^[Y*Width + X] := aColor//ColorToRGB(aColor);
  end;
  if not FUpdating then UpdateBitmap;
end;

function  TsohoBitmapGraphic.GetQuickPixel (X,Y: integer) : TColor;
begin
  Result := clBlack;
  if not Assigned(FCurrent.Buffer) then exit;
  if (X < 0) or (X >= Width) or (Y < 0)  or (Y >= Height) then exit;
  with FCurrent do begin
   Y := Height - Y - 1;
   Result := Buffer^[Y*Width + X];
  end;
end;

constructor TsohoBitmapGraphic.Create;
begin
  inherited Create;
  FCurrent.Buffer  := nil;
  FUpdating := false;
end;

destructor TsohoBitmapGraphic.Destroy;
begin
  if Assigned(FCurrent.Buffer) then FreeMem(FCurrent.Buffer, FCurrent.Size);
  inherited Destroy;
end;

procedure TsohoBitmapGraphic.BeginUpdate;
begin
  FUpdating := true;
end;

procedure TsohoBitmapGraphic.EndUpdate;
begin
  FUpdating := false;
  UpdateBitmap;
end;

function TsohoBitmapGraphic.SetCurrentArea (aLeft, aTop, aWidth, aHeight : integer) : boolean;
begin
  Result := false;
  if Handle = 0 then exit;
  if Assigned(FCurrent.Buffer) then FreeMem(FCurrent.Buffer, FCurrent.Size);
  with FCurrent do begin
    Width  := aWidth;
    Height := aHeight;
    Left   := aLeft;
    Top    := aTop;
    Size   := Width * Height * 4;
    try
      Buffer := AllocMem(Size);
      Result := true;
    except
      exit;
    end;
  end;
  UpdateArea;
end;

procedure TsohoBitmapGraphic.Assign(Source : TPersistent);
begin
  inherited Assign(Source);
  if not (Source is TsohoBitmapGraphic) then
    raise Exception.Create(sohoGraphNotSohoBitmap);
  if Assigned(FCurrent.Buffer) then FreeMem(FCurrent.Buffer, FCurrent.Size);
  FCurrent.Buffer := nil;
  if TsohoBitmapGraphic(Source).FCurrent.Buffer = nil then exit;
  FCurrent := TsohoBitmapGraphic(Source).FCurrent;
  FCurrent.Buffer := AllocMem(FCurrent.Size);
  Move(TsohoBitmapGraphic(Source).FCurrent.Buffer^,
    FCurrent.Buffer^, FCurrent.Size);
end;

function Index(var BitmapArray: TsohoBitmapArray; X, Y: LongInt): LongInt;
begin
   with BitmapArray do
     Result := (Y-Top)*Width+X-Left;
end;

{--------------------------------------------------------}
{       .    }
{     TsohoBitmapGraphic           }
{--------------------------------------------------------}

//  ""

//          "" 
function TruncInterpolator(var BitmapArray:TsohoBitmapArray;X,Y:Double):TColor;
var XI,YI,XI1,YI1:LongInt;
begin
  XI:=Trunc(X);
  YI:=Trunc(Y);
  XI1:=XI+1;
  YI1:=YI+1;
  with BitMapArray do
  IF (XI<Left) or (XI1>Left+Width) or (YI<Top) or (YI1>Top+Height) then begin
    Result:=clBlack; Exit;
  end;
  Result:=BitmapArray.Buffer^[Index(BitmapArray,Round(X),Round(Y))];
end;

Function SimpleInterPolator(var BitmapArray:TsohoBitmapArray;X,Y:Double):TColor;
var XI,YI,XI1,YI1:LongInt;
    hx,hy:Double;
    CXIYI,CXI1YI,CXIYI1,CXI1YI1:TRGBRecord;
begin
 //        
 //  
  XI:=Trunc(X);
  YI:=Trunc(Y);
  XI1:=XI+1;
  YI1:=YI+1;
  with BitMapArray do
  IF (XI<Left) or (XI1>Left+Width) or (YI<Top) or (YI1>Top+Height) then begin
    Result:=clBlack; Exit;
  end;
  hx:=(X-XI);
  hy:=(Y-YI);
  CXIYI:=TRGBRecord(BitMapArray.Buffer^[Index(BitmapArray,XI,YI)]);
  CXIYI1:=TRGBRecord(BitMapArray.Buffer^[Index(BitmapArray,XI,YI1)]);
  CXI1YI:=TRGBRecord(BitMapArray.Buffer^[Index(BitmapArray,XI1,YI)]);
  CXI1YI1:=TRGBRecord(BitMapArray.Buffer^[Index(BitmapArray,XI1,YI1)]);
  with TRGBRecord(Result) do begin
    Red:=Round(( CXIYI.Red*(1-hx+1-hy)+
                 CXIYI1.Red*(1-hx+hy)+
                 CXI1YI.Red*(hx+1-hy)+
                 CXI1YI1.Red*(hx+hy)
                 )/4
                );

    Green:=Round(( CXIYI.Green*(1-hx+1-hy)+
                 CXIYI1.Green*(1-hx+hy)+
                 CXI1YI.Green*(hx+1-hy)+
                 CXI1YI1.Green*(hx+hy)
                 )/4
                );


    Blue:=Round(( CXIYI.Blue*(1-hx+1-hy)+
                 CXIYI1.Blue*(1-hx+hy)+
                 CXI1YI.Blue*(hx+1-hy)+
                 CXI1YI1.Blue*(hx+hy)
                 )/4
                );
  end;
end;

{$HINTS OFF}
function EuclideInterpolator(var BitmapArray:TsohoBitmapArray;X,Y:Double):TColor;
 var XI,YI,XI1,YI1:LongInt;
 var R00,R01,R10,R11,SR:Double;
 var P00,P01,P10,P11:Double;
begin
   Result := clBlack;
   XI:=Trunc(X);
   YI:=Trunc(Y);
   XI1:=XI+1;
   YI1:=YI+1;
   with BitMapArray do
   IF (XI<Left) or (XI1>Left+Width) or (YI<Top) or (YI1>Top+Height) then begin
     Result:=clBlack; Exit;
   end;
   R00:=SQRT(SQR(X-XI )+SQR(Y-YI ));
   R01:=SQRT(SQR(X-XI )+SQR(Y-YI1));
   R10:=SQRT(SQR(X-XI1)+SQR(Y-YI ));
   R11:=SQRT(SQR(X-XI1)+SQR(Y-YI1));
   SR:=R00+R01+R10+R11;
   if R00<0.001 then begin
    P00:=1; P01:=0;P10:=0;P11:=0;
   end else
   if R01<0.001 then begin
    P00:=0; P01:=1;P10:=0;P11:=0;
   end else
   if R10<0.001 then begin
    P00:=0; P01:=0;P10:=1;P11:=0;
   end else
   if R11<0.001 then begin
    P00:=0; P01:=0;P10:=0;P11:=1;
   end else
   begin
     //    -    ?
   end;
end;
{$HINTS ON}


function LinearInterpolator(var BitmapArray:TsohoBitmapArray;X,Y:Double):TColor;
var XI,YI,XI1,YI1:LongInt;
begin
  XI:=Trunc(X);
  YI:=Trunc(Y);
  XI1:=XI+1;
  YI1:=YI+1;
  with BitMapArray do
  IF (XI<Left) or (XI1>Left+Width) or (YI<Top) or (YI1>Top+Height) then begin
    Result:=clBlack; Exit;
  end;
 //    -  ""  
 //    .     4  
 // ,   3 .    
 // "".
 with TRGBRecord(Result) do begin
  // ,   .   .
 end;
end;

function Intencivity(Color:TColor):LongInt;
begin
 with TRGBRecord(Color) do
 Result:=(Word(Red)+Word(Green)+Word(Blue)) div 3;
end;

procedure ShiftImage(Source,Destination:TsohoBitmapArray;ShiftX,ShiftY:Double;InterPolator:TInterpolateFunction);
var x,y: LongInt;
    i: LongInt;
begin
//   
  with Destination do
   for x := Left to Left+Width-1 do
    for y := Top to Top+Height-1 do
    begin
     if Assigned(Interpolator)
      then I:=InterPolator(Source,X-ShiftX,Y-ShiftY)
      else I:=DefaultInterpolator(Source,X-ShiftX,Y-ShiftY);
     Destination.Buffer^[Index(Destination,X,Y)] := I;
    end;
end;

procedure ResizeImage;
var x,y: LongInt;
    i: LongInt;
    ScaleX,ScaleY:Double;
begin
  ScaleX:=Exp(-ResizeX/100);
  ScaleY:=Exp(-ResizeY/100);;
  with Destination do
   for x := Left to Left+Width-1 do
    for y := Top to Top+Height-1 do
    begin
     if Assigned(Interpolator)
      then I:=InterPolator(Source,X*ScaleX,Y*ScaleY)
      else I:=DefaultInterpolator(Source,X*ScaleX,Y*ScaleY);
     Destination.Buffer^[Index(Destination,X,Y)] := I;
    end;
end;

procedure RotateImage(Source,Destination:TsohoBitmapArray;CenterX,CenterY,Angle:Double;InterPolator:TInterpolateFunction);
var x,y: LongInt;
    i: LongInt;
    DeltaX,DeltaY,CosFi,SinFi:Double;
    NewX,NewY:Double;
begin
   SinFi:=Sin(-Angle);CosFi:=Cos(-Angle);
  with Destination do
   for x := Left to Left+Width-1 do
    for y := Top to Top+Height-1 do
    begin
     //    
     //X1:=(X-X0)*Cos(Fi)+(Y-Y0)*Sin(Fi)+X0
     //Y1:=-(Y-Y0)*Sin(Fi)+(X-X0)*Cos(Fi)
     //,     
     //  , ..  -Fi
     DeltaY:=Y-CenterY; DeltaX:=X-CenterX;
     NewX:=CenterX+DeltaX*CosFi+DeltaY*SinFi;
     NewY:=CenterY-DeltaX*SinFi+DeltaY*CosFi;
     if Assigned(Interpolator)
      then I:=InterPolator(Source,NewX,NewY)
      else I:=DefaultInterpolator(Source,NewX,NewY);
     Destination.Buffer^[Index(Destination,X,Y)] := I;
    end;
end;

procedure ConvertToGrayScale(Source,Destination: TsohoBitmapArray);
var x,y: LongInt;
    i: LongInt;
begin
  with Source do
   for x := Left to Left+Width-1 do
    for y := Top to Top+Height-1 do
    begin
     I := Intencivity(Buffer^[Index(Source,X,Y)]);
     Destination.Buffer^[Index(Destination,X,Y)] := RGB(i,i,i);
    end;
end;

procedure ChangeRGB(Source,Destination:TsohoBitmapArray;DeltaR,DeltaG,DeltaB:Integer);
 var x,y: LongInt;
     I,SRC: TRGBRecord;
     w:LongInt;
begin
   with Source do
    for x := Left to Left+Width-1 do
     for y := Top to Top+Height-1 do
     begin
      SRC:=TRGBRecord(Buffer^[Index(Source,X,Y)]);
      I.Reserved:=0;
      W:=SRC.Red+DeltaR;
      if W>255 then W:=255;
      if W<0 then W:=0;
      I.Red:=W;
      W:=SRC.Green+DeltaG;
      if W>255 then W:=255;
      if W<0 then W:=0;
      I.Green:=W;
      W:=SRC.Blue+DeltaB;
      if W>255 then W:=255;
      if W<0 then W:=0;
      I.Blue:=W;
      TRGBRecord(Destination.Buffer^[Index(Destination,X,Y)]) := I;
     end;
end;

{--------------------------------------------------------}
{                    }
{--------------------------------------------------------}

{         TsohoTabSet }
procedure DoHorRect(Canvas: TCanvas; AlignTop: Boolean; Rect: TRect; TopColor, BottomColor: TColor);
var TopRight, BOTTOMLEFT: TPoint;
begin
  with Canvas, Rect do begin
    TopRight.X := Right;
    TopRight.Y := Top;
    BOTTOMLEFT.X := Left;
    BOTTOMLEFT.Y := Bottom;
    Pen.Color := TopColor;
    if AlignTop then Polyline([BOTTOMLEFT, TopLeft, TopRight])
    else Polyline([BOTTOMLEFT, TopLeft]);
    Pen.Color := BottomColor;
    dec(BOTTOMLEFT.X);
    if AlignTop then Polyline([TopRight, BottomRight])
    else Polyline([TopRight, BottomRight, BOTTOMLEFT]);
  end;
end;

{         TsohoTabSet }
procedure DoVertRect(Canvas: TCanvas; AlignLeft: Boolean; Rect: TRect;
    TopColor, BottomColor: TColor);
var TopRight, BOTTOMLEFT: TPoint;
begin
  with Canvas, Rect do begin
    TopRight.X := Right;
    TopRight.Y := Top;
    BOTTOMLEFT.X := Left;
    BOTTOMLEFT.Y := Bottom;
    Pen.Color := TopColor;
    if AlignLeft then Polyline([BOTTOMLEFT, TopLeft, TopRight])
    else Polyline([TopLeft, TopRight]);
    Pen.Color := BottomColor;
    dec(BOTTOMLEFT.X);
    if AlignLeft then Polyline([BOTTOMLEFT, BottomRight])
    else Polyline([BOTTOMLEFT, BottomRight, TopRight]);
  end;
end;

function VertCenter(Rect: TRect; Height: Integer): Integer;
begin
  Result := Rect.Top + trunc((Rect.Bottom - Rect.Top - Height) / 2);
end;

function HorCenter(Rect: TRect; Width: Integer): Integer;
begin
  Result := Rect.Left + trunc((Rect.Right - Rect.Left - Width) / 2);
end;

procedure AdjustColors(Bevel: TPanelBevel; var TopColor, BottomColor: tColor;
    HighLightColor, ShadowColor: tColor);
begin
  TopColor := HighLightColor;
  if Bevel = bvLowered then TopColor := ShadowColor;
  BottomColor := ShadowColor;
  if Bevel = bvLowered then BottomColor := HighLightColor;
end;

type
  THack = class(TCustomControl);

const
  DrawBitmap: TBitmap = nil;

procedure UsesBitmap;
begin
  if DrawBitmap = nil then DrawBitmap := TBitmap.Create;
end;

procedure ReleaseBitmap; far;
begin
  if DrawBitmap <> nil then DrawBitmap.Free;
  DrawBitmap := nil;
end;

procedure WriteText(ACanvas: TCanvas; ARect: TRect; DX, DY: Integer;
  const Text: string; Alignment: TAlignment; WordWrap: Boolean
  {$IFDEF Delphi4_or_5}; ARightToLeft: Boolean = False {$ENDIF});
const
  AlignFlags: array [TAlignment] of Integer =
    (DT_LEFT or DT_EXPANDTABS or DT_NOPREFIX,
     DT_RIGHT or DT_EXPANDTABS or DT_NOPREFIX,
     DT_CENTER or DT_EXPANDTABS or DT_NOPREFIX);
  WrapFlags: array[Boolean] of Integer = (0, DT_WORDBREAK);
{$IFDEF Delphi4_or_5}
  RTL: array [Boolean] of Integer = (0, DT_RTLREADING);
{$ENDIF}
var
{$IFNDEF WIN32}
  S: array[0..255] of Char;
{$ENDIF}
  B, R: TRect;
  I, Left: Integer;
begin
  UsesBitmap;
  I := ColorToRGB(ACanvas.Brush.Color);
  if not WordWrap and (Integer(GetNearestColor(ACanvas.Handle, I)) = I) and
    (Pos(#13, Text) = 0) then
  begin { Use ExtTextOut for solid colors }
{$IFDEF Delphi4_or_5}
    { In BiDi, because we changed the window origin, the text that does not
      change alignment, actually gets its alignment changed. }
    if (ACanvas.CanvasOrientation = coRightToLeft) and (not ARightToLeft) then
      ChangeBiDiModeAlignment(Alignment);
{$ENDIF}
    case Alignment of
      taLeftJustify: Left := ARect.Left + DX;
      taRightJustify: Left := ARect.Right - ACanvas.TextWidth(Text) - 3;
      else { taCenter }
        Left := ARect.Left + (ARect.Right - ARect.Left) shr 1
          - (ACanvas.TextWidth(Text) shr 1);
    end;
{$IFDEF Delphi4_or_5}
    ACanvas.TextRect(ARect, Left, ARect.Top + DY, Text);
{$ELSE}
  {$IFDEF WIN32}
    ExtTextOut(ACanvas.Handle, Left, ARect.Top + DY, ETO_OPAQUE or
      ETO_CLIPPED, @ARect, PChar(Text), Length(Text), nil);
  {$ELSE}
    ExtTextOut(ACanvas.Handle, Left, ARect.Top + DY, ETO_OPAQUE or
      ETO_CLIPPED, @ARect, StrPCopy(S, Text), Length(Text), nil);
  {$ENDIF}
{$ENDIF}
  end
  else begin { Use FillRect and DrawText for dithered colors }
{$IFDEF Delphi3}
    DrawBitmap.Canvas.Lock;
    try
{$ENDIF}
      with DrawBitmap, ARect do { Use offscreen bitmap to eliminate flicker and }
      begin                     { brush origin tics in painting / scrolling.    }
        Width := GetMax(Width, Right - Left);
        Height := GetMax(Height, Bottom - Top);
        R := Rect(DX, DY, Right - Left - {$IFDEF WIN32} 1 {$ELSE} 2 {$ENDIF},
          Bottom - Top - 1);
        B := Rect(0, 0, Right - Left, Bottom - Top);
      end;
      with DrawBitmap.Canvas do begin
        Font := ACanvas.Font;
        Font.Color := ACanvas.Font.Color;
        Brush := ACanvas.Brush;
        Brush.Style := bsSolid;
        FillRect(B);
        SetBkMode(Handle, TRANSPARENT);
{$IFDEF Delphi4_or_5}
        if (ACanvas.CanvasOrientation = coRightToLeft) then
          ChangeBiDiModeAlignment(Alignment);
        DrawText(Handle, PChar(Text), Length(Text), R, AlignFlags[Alignment]
          or RTL[ARightToLeft] or WrapFlags[WordWrap]);
{$ELSE}
  {$IFDEF WIN32}
        DrawText(Handle, PChar(Text), Length(Text), R,
          AlignFlags[Alignment] or WrapFlags[WordWrap]);
  {$ELSE}
        DrawText(Handle, StrPCopy(S, Text), Length(Text), R,
          AlignFlags[Alignment] or WrapFlags[WordWrap]);
  {$ENDIF}
{$ENDIF}
      end;
      ACanvas.CopyRect(ARect, DrawBitmap.Canvas, B);
{$IFDEF Delphi3}
    finally
      DrawBitmap.Canvas.Unlock;
    end;
{$ENDIF}
  end;
end;

procedure DrawCellTextEx(Control: TCustomControl; ACol, ARow: Longint;
  const S: string; const ARect: TRect; Align: TAlignment;
  VertAlign: TVertAlignment; WordWrap: Boolean);
const
  MinOffs = 2;
var
  H: Integer;
begin
  case VertAlign of
    vaTopJustify: H := MinOffs;
    vaCenter:
      with THack(Control) do
        H := GetMax(1, (ARect.Bottom - ARect.Top -
          Canvas.TextHeight('W')) div 2);
    else {vaBottomJustify} begin
      with THack(Control) do
        H := GetMax(MinOffs, ARect.Bottom - ARect.Top -
          Canvas.TextHeight('W'));
    end;
  end;
  WriteText(THack(Control).Canvas, ARect, MinOffs, H, S, Align, WordWrap);
end;

procedure DrawCellText(Control: TCustomControl; ACol, ARow: Longint;
  const S: string; const ARect: TRect; Align: TAlignment;
  VertAlign: TVertAlignment);
begin
  DrawCellTextEx(Control, ACol, ARow, S, ARect, Align, VertAlign,
    Align = taCenter);
end;

{procedure DrawCellText(Control: TCustomControl; ACol, ARow: Longint;
  const S: string; const ARect: TRect; Align: TAlignment;
  VertAlign: TVertAlignment); overload;
begin
  DrawCellTextEx(Control, ACol, ARow, S, ARect, Align, VertAlign,
    Align = taCenter);
end;}

procedure DrawCellBitmap(Control: TCustomControl; ACol, ARow: Longint;
  Bmp: TGraphic; Rect: TRect);
begin
  Rect.Top := (Rect.Bottom + Rect.Top - Bmp.Height) div 2;
  Rect.Left := (Rect.Right + Rect.Left - Bmp.Width) div 2;
  THack(Control).Canvas.Draw(Rect.Left, Rect.Top, Bmp);
end;

function MinimizeText(const Text: string; Canvas: TCanvas;
  MaxWidth: Integer): string;
var
  I: Integer;
begin
  Result := Text;
  I := 1;
  while (I <= Length(Text)) and (Canvas.TextWidth(Result) > MaxWidth) do begin
    Inc(I);
    Result := Copy(Text, 1, GetMax(0, Length(Text) - I)) + '...';
  end;
end;

function WidthOf(R: TRect): Integer;
begin
  Result := R.Right - R.Left;
end;

function HeightOf(R: TRect): Integer;
begin
  Result := R.Bottom - R.Top;
end;

const

  PaletteMask = $02000000;

function PaletteColor(Color: TColor): Longint;
begin
  Result := ColorToRGB(Color) or PaletteMask;
end;

procedure StretchBltTransparent(DstDC: HDC; DstX, DstY, DstW, DstH: Integer;
  SrcDC: HDC; SrcX, SrcY, SrcW, SrcH: Integer; Palette: HPalette;
  TransparentColor: TColorRef);
var
  Color: TColorRef;
  bmAndBack, bmAndObject, bmAndMem, bmSave: HBitmap;
  bmBackOld, bmObjectOld, bmMemOld, bmSaveOld: HBitmap;
  MemDC, BackDC, ObjectDC, SaveDC: HDC;
  palDst, palMem, palSave, palObj: HPalette;
begin
  { Create some DCs to hold temporary data }
  BackDC := CreateCompatibleDC(DstDC);
  ObjectDC := CreateCompatibleDC(DstDC);
  MemDC := CreateCompatibleDC(DstDC);
  SaveDC := CreateCompatibleDC(DstDC);
  { Create a bitmap for each DC }
  bmAndObject := CreateBitmap(SrcW, SrcH, 1, 1, nil);
  bmAndBack := CreateBitmap(SrcW, SrcH, 1, 1, nil);
  bmAndMem := CreateCompatibleBitmap(DstDC, DstW, DstH);
  bmSave := CreateCompatibleBitmap(DstDC, SrcW, SrcH);
  { Each DC must select a bitmap object to store pixel data }
  bmBackOld := SelectObject(BackDC, bmAndBack);
  bmObjectOld := SelectObject(ObjectDC, bmAndObject);
  bmMemOld := SelectObject(MemDC, bmAndMem);
  bmSaveOld := SelectObject(SaveDC, bmSave);
  { Select palette }
  palDst := 0; palMem := 0; palSave := 0; palObj := 0;
  if Palette <> 0 then begin
    palDst := SelectPalette(DstDC, Palette, True);
    RealizePalette(DstDC);
    palSave := SelectPalette(SaveDC, Palette, False);
    RealizePalette(SaveDC);
    palObj := SelectPalette(ObjectDC, Palette, False);
    RealizePalette(ObjectDC);
    palMem := SelectPalette(MemDC, Palette, True);
    RealizePalette(MemDC);
  end;
  { Set proper mapping mode }
  SetMapMode(SrcDC, GetMapMode(DstDC));
  SetMapMode(SaveDC, GetMapMode(DstDC));
  { Save the bitmap sent here }
  BitBlt(SaveDC, 0, 0, SrcW, SrcH, SrcDC, SrcX, SrcY, SRCCOPY);
  { Set the background color of the source DC to the color,         }
  { contained in the parts of the bitmap that should be transparent }
  Color := SetBkColor(SaveDC, PaletteColor(TransparentColor));
  { Create the object mask for the bitmap by performing a BitBlt()  }
  { from the source bitmap to a monochrome bitmap                   }
  BitBlt(ObjectDC, 0, 0, SrcW, SrcH, SaveDC, 0, 0, SRCCOPY);
  { Set the background color of the source DC back to the original  }
  SetBkColor(SaveDC, Color);
  { Create the inverse of the object mask }
  BitBlt(BackDC, 0, 0, SrcW, SrcH, ObjectDC, 0, 0, NOTSRCCOPY);
  { Copy the background of the main DC to the destination }
  BitBlt(MemDC, 0, 0, DstW, DstH, DstDC, DstX, DstY, SRCCOPY);
  { Mask out the places where the bitmap will be placed }
  StretchBlt(MemDC, 0, 0, DstW, DstH, ObjectDC, 0, 0, SrcW, SrcH, SRCAND);
  { Mask out the transparent colored pixels on the bitmap }
  BitBlt(SaveDC, 0, 0, SrcW, SrcH, BackDC, 0, 0, SRCAND);
  { XOR the bitmap with the background on the destination DC }
  StretchBlt(MemDC, 0, 0, DstW, DstH, SaveDC, 0, 0, SrcW, SrcH, SRCPAINT);
  { Copy the destination to the screen }
  BitBlt(DstDC, DstX, DstY, DstW, DstH, MemDC, 0, 0,
    SRCCOPY);
  { Restore palette }
  if Palette <> 0 then begin
    SelectPalette(MemDC, palMem, False);
    SelectPalette(ObjectDC, palObj, False);
    SelectPalette(SaveDC, palSave, False);
    SelectPalette(DstDC, palDst, True);
  end;
  { Delete the memory bitmaps }
  DeleteObject(SelectObject(BackDC, bmBackOld));
  DeleteObject(SelectObject(ObjectDC, bmObjectOld));
  DeleteObject(SelectObject(MemDC, bmMemOld));
  DeleteObject(SelectObject(SaveDC, bmSaveOld));
  { Delete the memory DCs }
  DeleteDC(MemDC);
  DeleteDC(BackDC);
  DeleteDC(ObjectDC);
  DeleteDC(SaveDC);
end;

procedure StretchBitmapTransparent(Dest: TCanvas; Bitmap: TBitmap;
  TransparentColor: TColor; DstX, DstY, DstW, DstH, SrcX, SrcY,
  SrcW, SrcH: Integer);
var
  CanvasChanging: TNotifyEvent;
begin
  if DstW <= 0 then DstW := Bitmap.Width;
  if DstH <= 0 then DstH := Bitmap.Height;
  if (SrcW <= 0) or (SrcH <= 0) then begin
    SrcX := 0; SrcY := 0;
    SrcW := Bitmap.Width;
    SrcH := Bitmap.Height;
  end;
  if not Bitmap.Monochrome then
    SetStretchBltMode(Dest.Handle, STRETCH_DELETESCANS);
  CanvasChanging := Bitmap.Canvas.OnChanging;
{$IFDEF RX_D3}
  Bitmap.Canvas.Lock;
{$ENDIF}
  try
    Bitmap.Canvas.OnChanging := nil;
    if TransparentColor = clNone then begin
      StretchBlt(Dest.Handle, DstX, DstY, DstW, DstH, Bitmap.Canvas.Handle,
        SrcX, SrcY, SrcW, SrcH, Dest.CopyMode);
    end
    else begin
{$IFDEF RX_D3}
      if TransparentColor = clDefault then
        TransparentColor := Bitmap.Canvas.Pixels[0, Bitmap.Height - 1];
{$ENDIF}
      if Bitmap.Monochrome then TransparentColor := clWhite
      else TransparentColor := ColorToRGB(TransparentColor);
      StretchBltTransparent(Dest.Handle, DstX, DstY, DstW, DstH,
        Bitmap.Canvas.Handle, SrcX, SrcY, SrcW, SrcH, Bitmap.Palette,
        TransparentColor);
    end;
  finally
    Bitmap.Canvas.OnChanging := CanvasChanging;
{$IFDEF RX_D3}
    Bitmap.Canvas.Unlock;
{$ENDIF}
  end;
end;

procedure StretchBitmapRectTransparent(Dest: TCanvas; DstX, DstY,
  DstW, DstH: Integer; SrcRect: TRect; Bitmap: TBitmap;
  TransparentColor: TColor);
begin
  with SrcRect do
    StretchBitmapTransparent(Dest, Bitmap, TransparentColor,
    DstX, DstY, DstW, DstH, Left, Top, Right - Left, Bottom - Top);
end;

procedure DrawBitmapRectTransparent(Dest: TCanvas; DstX, DstY: Integer;
  SrcRect: TRect; Bitmap: TBitmap; TransparentColor: TColor);
begin
  with SrcRect do
    StretchBitmapTransparent(Dest, Bitmap, TransparentColor,
    DstX, DstY, Right - Left, Bottom - Top, Left, Top, Right - Left,
    Bottom - Top);
end;

procedure DrawBitmapTransparent(Dest: TCanvas; DstX, DstY: Integer;
  Bitmap: TBitmap; TransparentColor: TColor);
begin
  StretchBitmapTransparent(Dest, Bitmap, TransparentColor, DstX, DstY,
    Bitmap.Width, Bitmap.Height, 0, 0, Bitmap.Width, Bitmap.Height);
end;

procedure DCFrame3D(DC: HDC; var Rect: TRect; TopColor, BottomColor: TColor;
  Width: Integer);

type
  PPoints = ^TPoints;
  TPoints = array[0..0] of TPoint;


var OldPen, Pen : HPen;

  procedure DrawPolyLine (DC : HDC; const Points: array of TPoint);
  begin
    Windows.Polyline(DC, PPoints(@Points)^, High(Points) + 1);
  end;

  procedure DoRect;
  var
    TopRight, BottomLeft: TPoint;
  begin
    with {Canvas, }Rect do
    begin
      TopRight.X := Right;
      TopRight.Y := Top;
      BottomLeft.X := Left;
      BottomLeft.Y := Bottom;
      Pen := CreatePen(PS_SOLID, 1, ColorToRGB(TopColor)) ;
      OldPen := SelectObject(DC, Pen);
      // Pen.Color := TopColor;
      DrawPolyLine(DC, [BottomLeft, TopLeft, TopRight]);
      DeleteObject(Pen);
      // Pen.Color := BottomColor;
      Pen := CreatePen(PS_SOLID, 1, ColorToRGB(BottomColor)) ;
      SelectObject(DC, Pen);
      Dec(BottomLeft.X);
      DrawPolyLine(DC, [TopRight, BottomRight, BottomLeft]);
      DeleteObject(Pen);
      SelectObject(DC, OldPen);
    end;
  end;

begin
  // Canvas.Pen.Width := 1;
  Dec(Rect.Bottom); Dec(Rect.Right);
  while Width > 0 do begin
    Dec(Width);
    DoRect;
    InflateRect(Rect, -1, -1);
  end;
  Inc(Rect.Bottom); Inc(Rect.Right);
end;

procedure WrapTextInRect(Canvas: TCanvas; const Text: string; Rect: TRect;
  TextAlign: TAlignment);
const Aligns: array[TAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);
var PText: array[0..256] of Char;
  Flags: Word;
  Leng : Integer;
begin
  Flags := Aligns[TextAlign];
  StrPCopy(PText, Text);
  Leng := Length(Text);
  DrawText(Canvas.Handle, PText, Leng, Rect, Flags or DT_WORDBREAK);
end;

procedure TextInRect;
const Aligns: array[TAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);
var PText: PChar;
  Flags: Word;
  Leng : Integer;
begin
  Flags := Aligns[TextAlign];
  GetMem(PText, length(Text) + 1);
  StrPCopy(PText, Text);
  Leng := Length(Text);
  DrawText(Canvas.Handle, PText, Leng, Rect, Flags);
  FreeMem(PText);
end;

procedure AngleTextInRect;
var PText: PChar;
  {Flags     : word;                 }
  Leng       : Integer;
  VertFont,
    OldFont  : HFONT;
  FontName   : array[0..256] of Char;
  lf         : TLogFont;
begin
  {Flags := DT_LEFT;}
  GetMem(PText, length(Text) + 1);
  StrPCopy(PText, Text);
  Leng := Length(Text);
  StrPCopy(FontName, Canvas.Font.name);
  with lf, Canvas do begin
    {  ,  }
    lfHeight := Font.Height;
    lfWidth := 0;
    lfEscapement := Angle * 10; {    0.1 }
    lfOrientation := 0 {90*10}; {    }
    if fsBold in Font.Style then lfWeight := FW_BOLD
    else lfWeight := FW_NORMAL;
    lfItalic := Byte(fsItalic in Font.Style);
    lfUnderline := Byte(fsUnderline in Font.Style);
    lfStrikeOut := Byte(fsStrikeOut in Font.Style);
    lfCharSet := DEFAULT_CHARSET;
    StrPCopy(lfFaceName, Font.name);
    lfQuality := PROOF_QUALITY{DEFAULT_QUALITY};
    lfOutPrecision := OUT_DEFAULT_PRECIS;
    lfClipPrecision := CLIP_DEFAULT_PRECIS;
    lfPitchAndFamily := DEFAULT_PITCH;
  end;
  VertFont := CreateFontIndirect(lf);
  OldFont := SelectObject(Canvas.Handle, VertFont);
  ExtTextOut(Canvas.Handle, X, Y, ETO_CLIPPED, @Rect,
    PText, Leng, nil);
  SelectObject(Canvas.Handle, OldFont);
  DeleteObject(VertFont);
  FreeMem(PText);
end;

{     ,     }
function GetStrWidth(DC: HDC; const Value: string): Integer;
var tmp: string;
  {$IFDEF Win32}
  aSize : TSize;
  {$ELSE}
  TmpInt: Longint;
  {$ENDIF}
begin
  Result := 0;
  tmp := Value + #0;
  {$IFNDEF Win32}
  TmpInt := GetTextExtent(DC, @tmp[0], Length(tmp));
  Result := LongRec(TmpInt).Lo;
  {$ELSE}
  if not GetTextExtentPoint32(DC, @tmp, Length(tmp) - 1, aSize) then exit;
  Result := aSize.cx;
  {$ENDIF}
end;

{     ,     }
function GetStrHeight(DC: HDC; const Value: string): Integer;
var tmp: string;
  {$IFDEF Win32}
  aSize : TSize;
  {$ELSE}
  TmpInt: Longint;
  {$ENDIF}
begin
  Result := 0;
  tmp := Value + #0;
  {$IFNDEF Win32}
  TmpInt := GetTextExtent(DC, @tmp[0], Length(tmp));
  Result := LongRec(TmpInt).Hi;
  {$ELSE}
  if not GetTextExtentPoint32(DC, @tmp, Length(tmp) - 1, aSize) then exit;
  Result := aSize.cy;
  {$ENDIF}
end;

procedure DrawBitmapInRect(Canvas: TCanvas; Rect: TRect; Bitmap: TBitmap);
var X, Y: Integer;
begin
  with Canvas do begin
    X := (Rect.Right - Rect.Left - Bitmap.Width) div 2 + Rect.Left;
    Y := (Rect.Bottom - Rect.Top - Bitmap.Height) div 2 + Rect.Top;
    BrushCopy(Classes.Rect(X, Y, X + Bitmap.Width, Y + Bitmap.Height), Bitmap,
      Classes.Rect(0, 0, Bitmap.Width, Bitmap.Height), clBlack);
  end;
end;

procedure DrawResBitmapInRect(Canvas: TCanvas; Rect: TRect; const BitMapName: string);
var X, Y: Integer;
  Bitmap: TBitmap;
begin
  with Canvas do begin
    Bitmap := TBitmap.Create;
    Bitmap.Handle := ResBitmap(BitMapName);
    X := (Rect.Right - Rect.Left - Bitmap.Width) div 2 + Rect.Left;
    Y := (Rect.Bottom - Rect.Top - Bitmap.Height) div 2 + Rect.Top;
    BrushCopy(Classes.Rect(X, Y, X + Bitmap.Width, Y + Bitmap.Height), Bitmap,
      Classes.Rect(0, 0, Bitmap.Width, Bitmap.Height),
      Bitmap.Canvas.Pixels[0, Bitmap.Height - 1]);
    Bitmap.Free;
  end;
end;

function CreateBitmapFromIcon(Icon: TIcon; BackColor: TColor): TBitmap;
var
  IWidth, IHeight: Integer;
begin
  IWidth := Icon.Width;
  IHeight := Icon.Height;
  Result := TBitmap.Create;
  try
    Result.Width := IWidth;
    Result.Height := IHeight;
    with Result.Canvas do begin
      Brush.Color := BackColor;
      FillRect(Rect(0, 0, IWidth, IHeight));
      Draw(0, 0, Icon);
    end;
{$IFDEF Delphi3}
    Result.TransparentColor := BackColor;
    Result.Transparent := True;
{$ENDIF}
  except
    Result.Free;
    raise;
  end;
end;

initialization
  try
    RegisterClasses([TsohoBitmapGraphic]);
    TPicture.RegisterFileFormat('qbmp', 'Quick Bitmap', TsohoBitmapGraphic);
  except
  end;
    {      }
  DefaultInterpolator := SimpleInterPolator;
finalization
  ReleaseBitmap;
  try
    TPicture.UnRegisterGraphicClass(TsohoBitmapGraphic);
  except
  end;
end.
