{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoImgIndF;

{$I SOHOLIB.INC}

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
     StdCtrls, SohoBtns, ComCtrls;

type
  TSoImgIndexForm = class(TForm)
    PreviewL: TListView;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    procedure PreviewLDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure CreatePreviewItems;
  public
    { Public declarations }
  end;

var SoImgIndexForm: TSoImgIndexForm;

function GetImageIndex(aComponent: TComponent; aImageIndex: LongInt): LongInt;

implementation
uses SoRTTI, SoDesCns, SoCmnCns;

{$R *.DFM}

function GetImageIndex(aComponent: TComponent; aImageIndex: LongInt): LongInt;
var
  Images: TImageList;
begin
    Result := aImageIndex;
    if not IsProperty(aComponent, 'Images') then exit;
    Images := GetClassProperty(aComponent, 'Images');
    if Assigned(Images) and (Images is TImageList) then
     try
       SoImgIndexForm := TSoImgIndexForm.Create(Application);
       SoImgIndexForm.PreviewL.LargeImages := Images;
       SoImgIndexForm.CreatePreviewItems;
       if aImageIndex <> -1 then
         SoImgIndexForm.PreviewL.Selected := SoImgIndexForm.PreviewL.Items[aImageIndex]; 

       if SoImgIndexForm.ShowModal = mrOk then
         Result := SoImgIndexForm.PreviewL.Selected.Index;
     finally
       SoImgIndexForm.Free;
     end;
end;

procedure TSoImgIndexForm.CreatePreviewItems;
var
  Index : LongInt;
  Item: TListItem;
begin
  for Index := 0 to pred(SoImgIndexForm.PreviewL.LargeImages.Count) do begin    // Iterate
    Item := SoImgIndexForm.PreviewL.Items.Add;
    Item.Caption := IntToStr(Index);
    Item.ImageIndex := Index;
  end;    // for
end;

procedure TSoImgIndexForm.PreviewLDblClick(Sender: TObject);
begin
  if Assigned(PreviewL.Selected) then ModalResult := mrOk;
end;

procedure TSoImgIndexForm.FormCreate(Sender: TObject);
begin
  Caption := sohoImageListEditorTitle;
  OkB.Caption := SOKButton;
  CancelB.Caption := SCancelButton;
end;

end.
