{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov,              }
{                   Igor Chernyshov                     }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
     TsohoModalForm
}
unit SoMdlFrm;

{$I SOHOLIB.INC}

interface

uses Windows, Classes, Forms, Messages, Controls;

type

  TsohoModalConfirm = (mcOk, mcCancel);
  TsohoModalConfirms = set of TsohoModalConfirm;

  TsohoModalForm = class(TForm)
  private
    procedure WMSize( var message: TWMSize ); message WM_SIZE;
  public
    function BeforeModalResultOk : boolean; virtual;
    procedure KeyPress(var Key: Char);override;
    function GetOkConfirm: string;
    function GetCancelConfirm: string;
    constructor Create(AOwner : TComponent);override;
    function IfOkConfirm: boolean;
    function IfCancelConfirm: boolean;
  end;

const
  EnableConfirms : TsohoModalConfirms = [];

implementation
uses SoVCLUtils, SoCmnCns;

{ TsohoModalForm }
function TsohoModalForm.GetOkConfirm: string;
begin
  Result := sohoMFSaveChanges;
end;

function TsohoModalForm.GetCancelConfirm: string;
begin
  Result := sohoMFDonotSaveChanges;
end;

function TsohoModalForm.IfOkConfirm: boolean;
begin
  if mcOk in EnableConfirms then
    Result := YesNoMsg(GetOkConfirm)
  else
    Result := true;
end;

function TsohoModalForm.IfCancelConfirm: boolean;
begin
  if mcCancel in EnableConfirms then
    Result := YesNoMsg(GetCancelConfirm)
  else
    Result := true;
end;

function TsohoModalForm.BeforeModalResultOk : boolean;
begin
  Result := IfOkConfirm;
end;

procedure TsohoModalForm.KeyPress(var Key: Char);
begin
  if (Key = #27) and IfCancelConfirm then ModalResult := mrCancel;
  if (Key = #13) and BeforeModalResultOk then ModalResult := mrOk;
  inherited KeyPress(Key);
end;

constructor TsohoModalForm.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  KeyPreview := true;
end;

procedure TsohoModalForm.WMSize(var message: TWMSize);
begin
  inherited;
  case message.SizeType of
    SIZE_MINIMIZED: Application.Minimize;
    SIZE_RESTORED: Application.Restore;
  end;
end;

end.
