{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoPrdF;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Graphics, StdCtrls,
     SoCtrls, SoFrmStorage, SoTools, Controls, SohoBtns, Forms;

type
  TsohoGetPeriodForm = class(TForm)
    WizEnterTab1: TsohoEnterTab;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    Ini: TsohoFormStorage;
    PeriodL: TsohoLabel;
    FromL: TsohoLabel;
    TillB: TsohoLabel;
    FromDateE: TsohoEdit;
    ToDateE: TsohoEdit;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function Execute (var FromDate,ToDate : TDateTime) : boolean;
    function MaxDate (var ToDate : TDateTime) : boolean;
  end;

var sohoGetPeriodForm : TsohoGetPeriodForm;

implementation
uses SoCmnCns;

{$R *.DFM}
function TsohoGetPeriodForm.MaxDate (var ToDate : TDateTime) : boolean;
begin
     ToDateE.AsDate := Date;
     FromDateE.Enabled := false;
     Result := ShowModal=mrOk;
     if Result then ToDate   := ToDateE.AsDate;
     FromDateE.Enabled := true;
end;

function TsohoGetPeriodForm.Execute;
begin
     ToDateE.AsDate := Date;
     Result := ShowModal=mrOk;
     if Result then begin
        FromDate := FromDateE.AsDate;
        ToDate   := ToDateE.AsDate;
     end;
end;

procedure TsohoGetPeriodForm.FormCreate(Sender: TObject);
begin
  Caption := sohoTimePeriodFormTitle;
  PeriodL.Caption := sohoTimePeriodFormPeriod;
  FromL.Caption := sohoTimePeriodFormFrom;
  TillB.Caption := sohoTimePeriodFormTill;
  OkB.Caption := SOKButton;
  CancelB.Caption := SCancelButton;
end;

end.
