{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoRepPrg;

{$I SOHOLIB.INC}

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
     StdCtrls, SohoBtns, SoGauges;

type
  TsohoReportProgressForm = class(TForm)
    Gauge: TsohoGauge;
    StopB: TsohoBitBtn;
    MessageL: TLabel;
    procedure StopBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Stopped : boolean;
    procedure SetMessage(Value : string);
  end;

var sohoReportProgressForm: TsohoReportProgressForm;

function CreateProgressDialog (const aCaption,
         aStartMessage : string) : TsohoReportProgressForm;

implementation
uses SoDBCns, SoCmnCns;

{$R *.DFM}

function CreateProgressDialog (const aCaption,
         aStartMessage : string) : TsohoReportProgressForm;
begin
  try
    Result := TsohoReportProgressForm.Create(Application);
    Result.Caption := aCaption;
    Result.Stopped := false;
    Result.Show;
    Result.Update;
  except
    Result := nil;
  end;
end;

procedure TsohoReportProgressForm.SetMessage(Value : string);
begin
  MessageL.Caption := Value;
  Update;
end;

procedure TsohoReportProgressForm.StopBClick(Sender: TObject);
begin
  Stopped := true;
  Close;
end;

procedure TsohoReportProgressForm.FormCreate(Sender: TObject);
begin
  Caption := sohoPrintTitle + '...';
  MessageL.Caption := sohoPrintTitle;
  StopB.Caption := SCancelButton;
end;

end.
