{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
        Registry
}
unit SoRgstry;

{$I SOHOLIB.INC}

interface
uses Windows, Registry;

function RegGetStringValue  (aRootKey : HKey; const Key, Name, DefaultValue : string) : string;
{      }
function RegGetIntegerValue (aRootKey : HKey; const Key, Name : string; DefaultValue : LongInt) : LongInt;
{      }

implementation

function RegGetStringValue  (aRootKey : HKey; const Key, Name, DefaultValue : string) : string;
var Reg : TRegistry;
begin
  Reg := TRegistry.Create;
  with Reg do begin
    RootKey := aRootKey;
    if OpenKey(Key, false) then
      Result := ReadString(Name)
    else Result := DefaultValue;
    Free;
  end;
end;

function RegGetIntegerValue (aRootKey : HKey; const Key, Name : string; DefaultValue : LongInt) : LongInt;
var Reg : TRegistry;
begin
  Reg := TRegistry.Create;
  with Reg do begin
    RootKey := aRootKey;
    if OpenKey(Key, false) then
      Result := ReadInteger(Name)
    else Result := DefaultValue;
    Free;
  end;
end;

end.
