{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
        

           >>> Dmitry Shikhman, 2:468/13.32 <<<

        .
}
unit SoSingle;

{$I SOHOLIB.INC}

interface

function AlreadyRunning (const AppId: string; Activate, TerminateSelf: boolean): boolean;
(*      ,  Active = true,
    .   AppId  
     .  TerminateSelf ,
          
  .    TsohoApplication   
    ,    SearchPrev

Example:
uses
  SoSingle, {        }
  Forms,
  main in 'main.pas' {MainForm},
  GrpCard in 'GrpCard.pas' {EditGroupForm};

{$R *.RES}

begin
  AlreadyRunning('Test.Application.Already.Running', true, true);
  Application.Initialize;
  Application.CreateForm(TMainForm, MainForm);
  Application.Run;
end.
*)

implementation
uses Windows, Messages, Forms, SoVCLUtils, SysUtils, SoCmnCns;

var HFile: THandle;

procedure ErrorMsg (TerminateSelf: boolean);
begin
  SoVCLUtils.ErrorMsg(sohoSingleMapFileCreatingError);
  if TerminateSelf then Halt(255);
end;

function AlreadyRunning;
var lpvMem: Pointer;
    AppHandle, TopWindow: HWnd;
    pAppId: array[0..255] of char;
begin
  Result := true;
  StrPCopy(pAppId, AppId);
  HFile := CreateFileMapping(THandle($FFFFFFFF), nil, PAGE_READWRITE, 0,
           4096, pAppId);
  if HFile = 0 then begin
    ErrorMsg(TerminateSelf);
    Exit;
  end;
  Result := GetLastError() = ERROR_ALREADY_EXISTS;
  lpvMem := MapViewOfFile(HFile, FILE_MAP_WRITE, 0, 0, 0);
  if lpvMem = nil then begin
    ErrorMsg(TerminateSelf);
    Exit;
  end
  else begin
    if Result then begin
      if Activate then begin
        Move(lpvMem^, AppHandle, SizeOf(AppHandle));
        if AppHandle <> 0 then begin
          if IsIconic(AppHandle) then
             SendMessage(AppHandle, WM_SYSCOMMAND, SC_RESTORE, 0);
          TopWindow := GetLastActivePopup(AppHandle);
          if (TopWindow <> 0) and (TopWindow <> AppHandle) and
            IsWindowVisible(TopWindow) and IsWindowEnabled(TopWindow) then
            SetForegroundWindow(TopWindow);
        end;
      end;
      if TerminateSelf then Halt(255);
    end
    else begin
      AppHandle := Application.Handle;
      Move(AppHandle, lpvMem^, SizeOf(AppHandle));
    end;
    UnmapViewOfFile(lpvMem);
  end;
end;

initialization
  HFile := 0;
finalization
  if HFile <> 0 then CloseHandle(HFile);
end.

