{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoSizeF;

{$I SOHOLIB.INC}

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, StdCtrls, Buttons, ExtCtrls, SoTools, SohoBtns, SoCtrls,
  SoRadGrp;

type
  TsohoSizeForm = class(TForm)
    HorizontalSize: TsohoRadioGroup;
    VerticalSize: TsohoRadioGroup;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    SizeG: TGroupBox;
    SizeWidth: TsohoEdit;
    SizeHeight: TsohoEdit;
    WidthL: TLabel;
    FormWidthE: TsohoEdit;
    HeightL: TLabel;
    FormHeightE: TsohoEdit;
    procedure FormShow(Sender: TObject);
    procedure SizeWidthChange(Sender: TObject);
    procedure SizeWidthEnter(Sender: TObject);
    procedure SizeHeightEnter(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
     function GetSize (var aWidth,aHeight : integer;
                       var aWidthValue, aHeightValue : integer;
                       FirstControl : TControl) : boolean;
  public
    { Public declarations }
  end;

var SizeForm: TsohoSizeForm;

function GetControlsSize (var aWidth,aHeight : integer;
                          var aWidthValue, aHeightValue : integer;
                          FirstControl : TControl) : boolean;

implementation
uses SoCmnCns;

{$R *.DFM}
function GetControlsSize (var aWidth,aHeight : integer;
                          var aWidthValue, aHeightValue : integer;
                          FirstControl : TControl) : boolean;
begin
   try
     SizeForm := TsohoSizeForm.Create(Application);
     Result := SizeForm.GetSize(aWidth,aHeight,aWidthValue, aHeightValue,FirstControl);
   finally
     SizeForm.Free;
   end;
end;

function TsohoSizeForm.GetSize (var aWidth,aHeight : integer;
                  var aWidthValue, aHeightValue : integer;
                  FirstControl : TControl) : boolean;
begin
    if FirstControl<>nil then begin
      SizeWidth.AsInteger := FirstControl.Width;
      SizeHeight.AsInteger := FirstControl.Height;
    end;
    Result := ShowModal = mrOk;
    if not Result then exit;
    aWidth  := HorizontalSize.ItemIndex;
    aHeight := VerticalSize.ItemIndex;
    aWidthValue := SizeWidth.AsInteger;
    aHeightValue := SizeHeight.AsInteger;
end;

procedure TsohoSizeForm.FormShow(Sender: TObject);
begin
    HorizontalSize.ItemIndex := 0;
    VerticalSize.ItemIndex   := 0;
end;

procedure TsohoSizeForm.SizeWidthChange(Sender: TObject);
begin
   with (Sender as TsohoEdit) do
    if Text<>'' then
     if AsInteger<0 then AsInteger := 0;
end;

procedure TsohoSizeForm.SizeWidthEnter(Sender: TObject);
begin
    HorizontalSize.ItemIndex := 3;
end;

procedure TsohoSizeForm.SizeHeightEnter(Sender: TObject);
begin
    VerticalSize.ItemIndex   := 3;
end;

procedure TsohoSizeForm.FormCreate(Sender: TObject);
begin
  Caption := sohoSizeFormTitle;

  HorizontalSize.Caption := sohoSizeFormHorizontalSize;
  with HorizontalSize, Items do begin
    Add(sohoAlignFormNoChanges);
    Add(sohoSizeFormShrink);
    Add(sohoSizeFormGrow);
    Add(sohoSizeFormWidth);
  end;
  VerticalSize.Caption := sohoSizeFormVerticalSize;
  with VerticalSize, Items do begin
    Add(sohoAlignFormNoChanges);
    Add(sohoSizeFormShrink);
    Add(sohoSizeFormGrow);
    Add(sohoSizeFormHeight);
  end;
  SizeG.Caption := sohoSizeFormSize;
  WidthL.Caption := sohoSizeFormWidth;
  HeightL.Caption := sohoSizeFormHeight;

  OkB.Caption := SOKButton;
  CancelB.Caption := SCancelButton;
end;

end.
