{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoSqlFrm;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, StdCtrls, ExtCtrls, SohoBtns, SoCtrls, SoFrmStorage,
  SoTools, Dialogs;

type
  TsohoGetSQLForm = class(TForm)
    SQLFileE: TsohoEdit;
    FileL: TsohoLabel;
    SaveB: TsohoBitBtn;
    OpenB: TsohoBitBtn;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    Bevel1: TBevel;
    SQLMemo: TMemo;
    SQLL: TsohoLabel;
    Ini: TsohoFormStorage;
    OpenD: TOpenDialog;
    procedure SQLFileEChange(Sender: TObject);
    procedure OpenBClick(Sender: TObject);
    procedure SaveBClick(Sender: TObject);
    procedure SQLFileERightClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    SQLDir: string;
  end;
  
var sohoGetSQLForm: TsohoGetSQLForm;
  
function SQLFormExecute(var SQLFile: string): boolean;

implementation
uses SoVCLUtils, SoDesCns, SoCmnCns;

{$R *.DFM}

function SQLFormExecute(var SQLFile: string): boolean;
var Tmp: string;
begin
  sohoGetSQLForm := TsohoGetSQLForm.Create(Application);
  try
    try
      with sohoGetSQLForm do begin
        SQLDir := Ini.ReadString(Ini.IniSection, 'DefaultSQLDir', '');
        if ExtractFilePath(SQLFile) <> '' then SQLDir := ExtractFilePath(SQLFile);
        if (SQLDir <> '') and (SQLDir[Length(SQLDir)] <> '\') then SQLDir := SQLDir + '\';
        Ini.WriteString(Ini.IniSection, 'DefaultSQLDir', SQLDir);
        Tmp := SQLDir + ExtractFileName(SQLFile);
        SQLFileE.Text := Tmp;
        if FileExists(SQLFileE.Text) then SQLMemo.Lines.LoadFromFile(SQLFileE.Text);
        if (Tmp = '') or (Tmp[Length(Tmp)] = '\') then SQLFileE.Text := SQLFileE.Text + '*.SQL';
        Result := ShowModal = mrOk;
        if Result then SQLFile := ExtractFileName(SQLFileE.Text);
      end;
    except
      on E: Exception do begin
        Result := false;
        ErrorMsg(E.message);
      end;
    end;
  finally
    sohoGetSQLForm.Free;
  end
end;

procedure TsohoGetSQLForm.SQLFileEChange(Sender: TObject);
begin
  SaveB.Enabled := SQLFileE.Text <> '';
  OpenB.Enabled := SQLFileE.Text <> '';
  OkB.Enabled := SQLFileE.Text <> '';
end;

procedure TsohoGetSQLForm.OpenBClick(Sender: TObject);
begin
  if FileExists(SQLFileE.Text) then begin
    SQLMemo.Lines.Clear;
    SQLMemo.Lines.LoadFromFile(SQLFileE.Text);
    if ExtractFilePath(SQLFileE.Text) <> '' then
      SQLDir := ExtractFilePath(SQLFileE.Text);
    Ini.WriteString(Ini.IniSection, 'DefaultSQLDir', SQLDir);
  end;
end;

procedure TsohoGetSQLForm.SaveBClick(Sender: TObject);
begin
  try
    SQLMemo.Lines.SaveToFile(SQLFileE.Text);
  except ErrorMsg(sohoSQLFormWriteError);
  end;
end;

procedure TsohoGetSQLForm.SQLFileERightClick(Sender: TObject);
begin
  if not OpenD.Execute then exit;
  SQLFileE.AsString := OpenD.FileName;
end;

procedure TsohoGetSQLForm.FormCreate(Sender: TObject);
begin
  Caption := sohoSQLEditorTitle;

  FileL.Caption := sohoSQLEditorFile;
  SaveB.Caption := sohoSQLEditorSave;
  OpenB.Caption := sohoSQLEditorOpen;
  SQLL.Caption := sohoSQLEditorSQL;

  OkB.Caption := SOKButton;
  CancelB.Caption := SCancelButton;
end;

end.

