{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{           Partial copyright (c) AllexSoft             }
{              Written by Serg Vostrikov,               }
{                 Alexander Govyadinov                  }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{ 03.11.2000 -   SplitString
}
unit SoStrUtils;

interface
uses Classes;

type

  TWordInfo = record
    StartIndex: LongInt;
    EndIndex: LongInt;
    WordLength: LongInt;
    Text: string;
  end;
  {        }

  SetOfChars = set of Char;
  {   }

  TsohoCharCase = (csNormal, csLower, csUpper);
  {   PCopyToStr }

const

  Space = ' ';
  {    }
  EmptyStr = '';
  {   }
  EnterStr = #13;
  {  Enter }
  SoftEnterStr = #10;
  { "" enter }
  TabStr = #9;
  {  Tab }
  sDot = '.';
  {  }
  sComma = ',';
  {  }
  sColon = ':';
  {  }
  sSemicolon = ';';
  {    }
  sSingleQuote = '''';
  {   }
  sDoubleQuote = '"';
  {   }
  {   WIN -> KOI8R}
  Win2KOI8Table : Array[0..255] of byte =
  (
  $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,
  $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
  $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,
  $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F,
  $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,
  $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$5F,
  $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,
  $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,$7C,$7D,$7E,$7F,

  $5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,
  $5F,$5F,$5F,$5F,$5F,$95,$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,$5F,
  $5F,$9F,$97,$5F,$9D,$5F,$7C,$15,$B3,$63,$99,$11,$2D,$2D,$72,$93,
  $9C,$5F,$49,$69,$5F,$5F,$14,$9E,$A3,$BF,$98,$10,$5F,$5F,$5F,$9B,
  $E1,$E2,$F7,$E7,$E4,$E5,$F6,$FA,$E9,$EA,$EB,$EC,$ED,$EE,$EF,$F0,
  $F2,$F3,$F4,$F5,$E6,$E8,$E3,$FE,$FB,$FD,$FF,$F9,$F8,$FC,$E0,$F1,
  $C1,$C2,$D7,$C7,$C4,$C5,$D6,$DA,$C9,$CA,$CB,$CC,$CD,$CE,$CF,$D0,
  $D2,$D3,$D4,$D5,$C6,$C8,$C3,$DE,$DB,$DD,$DF,$D9,$D8,$DC,$C0,$D1
  );

  KOI82WinTable : Array[0..255] of byte =
  (
  $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,
  $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
  $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,
  $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F,
  $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,
  $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$5F,
  $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,
  $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$7B,$7C,$7D,$7E,$7F,

  $2D,$A6,$2B,$2B,$2B,$2B,$2B,$A6,$2D,$2D,$2B,$5F,$5F,$5F,$5F,$5F,
  $5F,$5F,$5F,$AF,$5F,$95,$5F,$A2,$BA,$AA,$5F,$BF,$B0,$A4,$B7,$A1,
  $2D,$A6,$2B,$B8,$2B,$2B,$2B,$2B,$2B,$2B,$2B,$2B,$2B,$2B,$2B,$A6,
  $A6,$A6,$A6,$A8,$A6,$A6,$2D,$2D,$2D,$2D,$2D,$2D,$2B,$2B,$2B,$B9,
  $FE,$E0,$E1,$F6,$E4,$E5,$F4,$E3,$F5,$E8,$E9,$EA,$EB,$EC,$ED,$EE,
  $EF,$FF,$F0,$F1,$F2,$F3,$E6,$E2,$FC,$FB,$E7,$F8,$FD,$F9,$F7,$FA,
  $DE,$C0,$C1,$D6,$C4,$C5,$D4,$C3,$D5,$C8,$C9,$CA,$CB,$CC,$CD,$CE,
  $CF,$DF,$D0,$D1,$D2,$D3,$C6,$C2,$DC,$DB,$C7,$D8,$DD,$D9,$D7,$DA
  );

procedure SetDivisers(NewDivisers: SetOfChars);
{    .    
    ,      . ,
      SetDivisers,   
      }
function GetWordInfo(var Str: string; WordIndex: LongInt): TWordInfo;
{     .  SetDivisers }
function PointEndWord(Str: string; WordIndex: LongInt): LongInt;
{    .  SetDivisers }
function PointStartWord(Str: string; WordIndex: LongInt): LongInt;
{    .  SetDivisers }
function WordsInstring(Str: string): LongInt;
{    .  SetDivisers }
function GetSomeWords(Str: string; FromIndex, ToIndex: LongInt): string;
{     .  SetDivisers }
function CutStringOnLines(Str: string; MaxLen: LongInt): string;
{     ,   . 
        "|".  
  ,      "|".   
    MaxLen,   ,     
  ,   ,  MaxLen.  SetDivisers }
procedure DeleteWord(var Str: string; WordIndex: LongInt);
{  .  SetDivisers }
function  WordPosition(Str, Word: string): LongInt;
{   .  SetDivisers }
procedure ChangeWord(var Str: string; const OldWord, NewWord: string);
{     .  SetDivisers }
function UpCase(C: Char): Char;
{  ,    ,  UNICODE}
function LowCase(C: Char): Char;
{  ,     }
function StrUpper(const Str: string): string;
{     }
function StrLower(const Str: string): string;
{     }
function FirstCapital(const Str: string): string;
{       }
function GetNoSpacePercent(const Str: string): real;
{   -  .  
       ,  
   .
example:
   GetNoSpacePercent('    ') = 0
   GetNoSpacePercent('1111') = 100
}
function ChangeChars(const Str: string; OldChar, NewChar: Char): string;
{     }
function ChangeStr(const Str, OldText, NewText: string) : string;
{     .       }
function ReplaceStr(const Str, OldText, NewText: string) : string;
{        .}
function Chars(C: Char; Count: Integer): string;
{        Count  }
function DeleteChars(const Value: string; Chars: SetOfChars): string;
{      }
function AlignStr(const Value: string; Alignment: TAlignment;
                  AlignChar: Char; Len: LongInt): string;
{  .  Value   AlignChar 
        Alignment    Len }
function DecLength(const Value: string; Count: Integer): string;
{       .  
     string,     }
function IndexOfStr(const Value: string; const Values: array of string): Integer;
{     .   
         }
function PCopyToStr (Source: PChar; MaxLen: LongInt; CharCase: TsohoCharCase): string;
{    PChar  string }
function StripQuote(const Value: string): string;
{         }
function SingleQuotes(const Value: string): string;
{         }
function DoubleQuotes(const Value: string): string;
{         }

procedure SplitString(const S : string; Divider : Char; var Words : TStringList);
{    S  ,  Divider. 
    StringList Words. Words    !
      Words,      }

function Win2KOI8(const s : string) : string;
{    WIN1251  KOI8-R }

function KOI82Win(const s : string) : string;
{    KOI8-R  WIN1251 }

implementation
uses SysUtils;

var Divisers: SetOfChars;

function GetNoSpacePercent(const Str: string): real;
var Count, Index: LongInt;
begin
  if Length(Str) = 0 then begin
    GetNoSpacePercent := 0;
    exit;
  end;
  Count := 0;
  for Index := 1 to Length(Str) do
    if Str[Index] = Space then inc(Count);
  GetNoSpacePercent := 100 - Count * 100 / Length(Str);
end;

function ChangeChars(const Str: string; OldChar, NewChar: Char): string;
var Index: LongInt;
begin
  Result := Str;
  for Index := 1 to Length(Result) do
    if Result[Index] = OldChar then Result[Index] := NewChar;
end;

function ChangeStr(const Str, OldText, NewText: string) : string;
var Index : LongInt;
begin
  Result := Str;
  Index := pos(StrUpper(OldText), StrUpper(Str));
  if Index = 0 then exit;
  Result := copy(Str, 1, Index-1) + NewText + copy(Str, Index+length(OldText),
    length(Str));
end;

function ReplaceStr(const Str, OldText, NewText: string) : string;
var Index : LongInt;
    BeginStr: string;
begin
  Result := '';
  BeginStr := Str;
  Index := pos(AnsiUpperCase(OldText), AnsiUpperCase(BeginStr));
  while Index <> 0 do begin
    Result := Result + copy(BeginStr, 1, Index - 1) + NewText;
    BeginStr := copy(BeginStr, Index + length(OldText), length(BeginStr));
    Index := pos(AnsiUpperCase(OldText), AnsiUpperCase(BeginStr));
  end; {--- while ---}
  Result := Result + BeginStr;
end;

function Chars(C: Char; Count: Integer): string;
var Index: LongInt;
begin
  Result := EmptyStr;
  for Index := 1 to Count do Result := Result + C;
end;

procedure SetDivisers(NewDivisers: SetOfChars);
begin
  Divisers := NewDivisers;
end;

{  ,   ,  Letters = True 
     }
procedure Skip(var CurrentPos: LongInt; var S: string; Letters: boolean);
begin
  while ( CurrentPos <= Length(S)) and
        ( (S[CurrentPos] in Divisers) xor Letters) do Inc(CurrentPos);
end;


function GetWordInfo(var Str: string; WordIndex: LongInt): TWordInfo;
var CurrentWord: LongInt;
    CurrentPos: LongInt;
begin
  CurrentPos := 1;
  CurrentWord := 1;
  Skip(CurrentPos, Str, false); //   
  while (CurrentWord <= WordIndex) do begin
    Result.StartIndex := CurrentPos;
    Skip(CurrentPos, Str, true);
    Result.EndIndex := CurrentPos - 1;
    Skip(CurrentPos, Str, false);
    Inc(CurrentWord);
  end;

  with Result do
    if (EndIndex >= StartIndex) and (WordIndex > 0) then begin
      WordLength := EndIndex - StartIndex + 1;
      Text := Copy(Str, StartIndex, WordLength);
    end
    else begin
      WordLength := 0;
      StartIndex := 0;
      EndIndex := 0;
      Text := EmptyStr;
    end;
end;

function PointStartWord(Str: string; WordIndex: LongInt): LongInt;
begin
  Result := GetWordInfo(Str, WordIndex).StartIndex;
end;

function PointEndWord(Str: string; WordIndex: LongInt): LongInt;
begin
  Result := GetWordInfo(Str, WordIndex).EndIndex;
end;

function WordsInString(Str: string): LongInt;
var CurrentPos: LongInt;
begin
  CurrentPos := 1;
  Result := 0;
  while CurrentPos <= Length(Str) do begin
    Skip(CurrentPos, Str, false);
    if CurrentPos > Length(Str) then exit;
    Skip(CurrentPos, Str, true);
    Inc(Result);
  end;
end;

function GetSomeWords(Str: string; FromIndex, ToIndex: LongInt): string;
var Index: LongInt;
begin
  Result := EmptyStr;
  if FromIndex > ToIndex then exit; // 1 -  ,     
 (*  asm    // 2 -  ,  
   Push _From
   Push _To
   Pop  _From
   Pop  _To
  end;
 *)
 //*)
  if FromIndex < 1 then exit;
  if ToIndex > WordsInString(Str) then exit;

  Result := GetWordInfo(Str, FromIndex).Text;
  for Index :=FromIndex + 1 to ToIndex do
    Result := Result + Space + GetWordInfo(Str, Index).Text;
end;


function CutStringOnLines(Str: string; MaxLen: LongInt): string;
var Index: LongInt;
    TotalWords: LongInt;
    WordInfo: TWordInfo;
begin
  Result := EmptyStr;         //
  if Str = EmptyStr then exit;
  repeat
    TotalWords := WordsInString(Str); //    
    Index := 1; //  
    repeat
      WordInfo := GetWordInfo(Str, Index); //   
      if WordInfo.EndIndex > MaxLen then Break; //     - 
      Inc(Index); //  -    
    until (Index>TotalWords); //  ,   
    //
     //    "" (Index>1 & Index<=TotalWords)
     //     (Index=1)
     //      (Index>TotalWords)

    //,  Index     
    if Index > TotalWords then begin
      Result := Result + Str + '|';
      Break;
    end;

    if Index>1 then begin
      Dec(Index); //   
      WordInfo := GetWordInfo(Str, Index);
    end;
    Result := Result + Copy(Str, 1, WordInfo.EndIndex) + '|';
    Delete(Str, 1, WordInfo.EndIndex);
    while (Str<>EmptyStr) and (Str[1] in Divisers) do Delete(Str, 1, 1);
  until Str = EmptyStr;
end;

function WordPosition(Str: string; Word: string): LongInt;
var Index: LongInt;
begin
  Result := 0;
  for Index := 1 to WordsInString(Str) do
   if GetWordInfo(Str, Index).Text = Word then begin
     Result := Index;
     exit;
   end;
end;

procedure ChangeWord(var Str: string; const OldWord, NewWord: string);
var WordPos: LongInt;
    WordInfo: TWordInfo;
begin
  WordPos := WordPosition(Str, OldWord);
  if WordPos = 0 then exit;
  WordInfo := GetWordInfo(Str,WordPos);
  with WordInfo do
   Str := Copy(Str, 1, StartIndex - 1) + NewWord +
          Copy(Str, EndIndex + 1, Length(Str));
end;

procedure DeleteWord(var Str: string; WordIndex: LongInt);
begin
  with GetWordInfo(Str, WordIndex) do
    Str := Copy(Str, 1, StartIndex - 1) +
           Copy(Str, EndIndex + 1, Length(Str));
end;

function UpCase(C: Char): Char;
begin
  if C in ['a'..'z', ''..''] then C := Chr(Ord(C) - 32);
  Result := C;
end;

function StrUpper(const Str: string): string;
var Index: Integer;
begin
  Result := Str;
  for Index := 1 to Length(Str) do Result[Index] := UpCase(Result[Index]);
end;

function LowCase(C: Char): Char;
begin
  if C in ['A'..'Z', ''..''] then C := Chr(Ord(C) + 32);
  Result := C;
end;

function StrLower(const Str: string): string;
var Index: Integer;
begin
  Result := Str;
  for Index := 1 to Length(Str) do Result[Index] := LowCase(Result[Index]);
end;

function FirstCapital(const Str: string): string;
begin
  Result := Str;
  if Result = EmptyStr then exit;
  Result := UpCase(Result[1]) + copy(Result, 2, length(Result));
end;

function DeleteChars(const Value: string; Chars: SetOfChars): string;
var Index: LongInt;
begin
  Result := EmptyStr;
  for Index := 1 to Length(Value) do
    if not (Value[Index] in Chars) then Result := Result + Value[Index];
end;

function AlignStr(const Value: string; Alignment: TAlignment;
         AlignChar: Char; Len: LongInt): string;
var Fill: string;
    DeltaLength: LongInt;
begin
  Result := Copy(Value, 1, Len); //    
  DeltaLength := Len - Length(Result);
  if DeltaLength = 0 then exit;
  case Alignment of
    taLeftJustify: Result := Result + Chars(AlignChar, DeltaLength);
    taRightJustify : Result := Chars(AlignChar, DeltaLength) + Result;
    taCenter: begin
      Fill := Chars(AlignChar, DeltaLength div 2);
      Result := Fill + Result + Fill;
      if Odd(DeltaLength) then Result := Result + AlignChar;
    end;
  end;
end;

function DecLength(const Value: string; Count: Integer): string;
begin
  // Result := Copy(Value, 1, Length(Value) - Count);
  Result := Value;
  Delete(Result, Length(Value), 1);
end;

function IndexOfStr(const Value: string; const Values: array of string): Integer;
var index: Integer;
begin
  Result := -1;
  for index := Low(Values) to High(Values) do
    if CompareText(Value, Values[index]) = 0 then begin
      Result := index;
      exit;
    end;
end;

function PCopyToStr (Source: PChar; MaxLen: LongInt; CharCase: TsohoCharCase): string;
var Tmp: PChar;
begin
  GetMem(Tmp, MaxLen + 1);
  FillChar(Tmp^, MaxLen, 0);
  StrLCopy(Tmp, Source, MaxLen);
  case CharCase of
    csLower: SysUtils.StrLower(Tmp);
    csUpper: SysUtils.StrUpper(Tmp);
    else ;
  end;
  Result := StrPas(Tmp);
  FreeMem(Tmp, MaxLen + 1);
end;

function StripQuote(const Value: string): string;
begin
  if (Value <> EmptyStr) and
     (Value[1] in ['"', '''']) then Result := Copy(Value, 2,
      length(Value) - 2)
  else Result := Value;
end;

function SingleQuotes(const Value: string): string;
begin
  Result := sSingleQuote + Value + sSingleQuote;
end;

function DoubleQuotes(const Value: string): string;
begin
  Result := sDoubleQuote + Value + sDoubleQuote;
end;

procedure SplitString(const S : string; Divider : Char; var Words : TStringList);
var
  s1 : string;
  s2 : string;
  i  : Integer;
begin
  if Words = nil then Exit;
  s1 := s;
  s2 := '';
  while length(s1) > 0 do begin
    i := pos(Divider,s1);
    if i = 0 then i := length(s1)+1;
    s2 := copy(s1,1,i-1);
    Words.Add(s2);
    delete(s1,1,i);
  end;  { --- while --- }
end;

function Win2KOI8(const s : string) : string;
var
  i : Integer;
begin
  result := '';
  for i := 1 to Length(s) do begin
    result := result + chr(Win2Koi8Table[ord(s[i])]);
  end;    { --- for --- }
end;

function KOI82Win(const s : string) : string;
var
  i : Integer;
begin
  result := '';
  for i := 1 to Length(s) do begin
    result := result + chr(Koi82WinTable[ord(s[i])]);
  end;    { --- for --- }
end;
end.
