{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoTimeF;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Controls,
     Forms, StdCtrls, SohoBtns, ComCtrls;

type
  TsohoTimeFormDialog = class(TForm)
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    TimeE: TDateTimePicker;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    function Execute (var Time : TDateTime; const aCaption : string) : boolean;
  public
    { Public declarations }
  end;

var sohoTimeFormDialog: TsohoTimeFormDialog;

function GetTimeDialog (var Time : TDateTime; const aCaption : string) : boolean;
function GetTimeDialogStr (var Time : string; const aCaption : string) : boolean;

implementation
uses SoCmnCns;

{$R *.DFM}

function GetTimeDialog (var Time : TDateTime; const aCaption : string) : boolean;
begin
  try
    sohoTimeFormDialog := TsohoTimeFormDialog.Create(Application);
    Result := sohoTimeFormDialog.Execute(Time,aCaption);
  finally
    sohoTimeFormDialog.Free;
  end;
end;

function GetTimeDialogStr (var Time : string; const aCaption : string) : boolean;
var NewTime : TDateTime;
begin
  NewTime := StrToTime(Time);
  Result := GetTimeDialog (NewTime,aCaption);
  if Result then Time := TimeToStr(NewTime);
end;

function TsohoTimeFormDialog.Execute(var Time : TDateTime; const aCaption : string) : boolean;
begin
  TimeE.Time := Time;
  Caption      := aCaption;
  Result := ShowModal=mrOk;
  if not Result then exit;
  Time := TimeE.Time;
end;

procedure TsohoTimeFormDialog.FormCreate(Sender: TObject);
begin
  Caption := sohoTimeDialogTitle;

  OkB.Caption := SOKButton;
  CancelB.Caption := SCancelButton;
end;

end.
