{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoTreeF;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Graphics, Controls,
     Forms, SoCtrls, StdCtrls, SohoBtns, DB, DBTables,
     SoTools, SoChkBox, SoSDlgs, CheckLst;

type
  TNewTreeGuideForm = class(TForm)
    PathL: TsohoLabel;
    DirE: TsohoEdit;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    GroupsGr: TGroupBox;
    CreateGroupsC: TsohoCheckBox;
    GroupsNameL: TsohoLabel;
    GroupsNameE: TsohoEdit;
    GroupFieldsL: TsohoLabel;
    ItemsGr: TGroupBox;
    ItemsFieldsL: TsohoLabel;
    CreateItemsC: TsohoCheckBox;
    ItemsTableL: TsohoLabel;
    ItemsNameE: TsohoEdit;
    CreateQ: TQuery;
    DirD: TsohoDirectoryDialog;
    GroupsFields: TCheckListBox;
    ItemsFields: TCheckListBox;
    procedure CreateGroupsCClick(Sender: TObject);
    procedure CreateItemsCClick(Sender: TObject);
    procedure DirERightClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    function FormCreateTreeGuide : boolean;
  public
    { Public declarations }
  end;

var NewTreeGuideForm: TNewTreeGuideForm;
    aGroupsTableName : string;
    aItemsTableName  : string;

function CreateTreeGuide : boolean;

implementation
uses SoDesCns, SoVClUtils, SoCmnCns;

{$R *.DFM}

function CreateTreeGuide : boolean;
begin
   try
     Result := false;
     NewTreeGuideForm := TNewTreeGuideForm.Create(Application);
     Result := NewTreeGuideForm.FormCreateTreeGuide;
   finally
     NewTreeGuideForm.Free;
   end;
end;

function TNewTreeGuideForm.FormCreateTreeGuide : boolean;
var Index : integer;
begin
     aGroupsTableName := '';
     aItemsTableName  := '';
     Result := ShowModal = mrOk;
     if not Result then exit;
     CreateQ.DataBaseName := DirE.Text;
     { Create groups? }
     if CreateGroupsC.Checked and (GroupsNameE.AsString<>'') then begin
        with CreateQ,SQL do begin
            Clear;
            aGroupsTableName := GroupsNameE.AsString;
            if Pos('.DB', AnsiUpperCase(GroupsNameE.AsString)) = 0 then
              Add('create table '+GroupsNameE.AsString)
            else
              Add('create table "'+GroupsNameE.AsString+'"');
            Add('(');
            for Index := 0 to pred(GroupsFields.Items.Count) do
              if GroupsFields.Checked[Index] then Add(GroupsFields.Items[Index]+',');
            Add(' Primary Key (Id)');
            Add(')');
            try
              ExecSQL;
            except ErrorMsg(sohoGroupTableCreateError+
                   DataBaseName+'\'+GroupsNameE.AsString);
                   exit;
            end;
        end;
     end;
     { Create items? }
     if CreateItemsC.Checked and (ItemsNameE.AsString<>'') then begin
        with CreateQ,SQL do begin
            Clear;
            aItemsTableName  := ItemsNameE.AsString;
            if Pos('.DB', AnsiUpperCase(ItemsNameE.AsString)) = 0 then
              Add('create table '+ItemsNameE.AsString)
            else
              Add('create table "'+ItemsNameE.AsString+'"');
            Add('(');
            for Index := 0 to pred(ItemsFields.Items.Count) do
              if ItemsFields.Checked[Index] then Add(ItemsFields.Items[Index]+',');
            Add(' Primary Key (Id)');
            Add(')');
            try
              ExecSQL;
            except ErrorMsg(sohoItemsTableCreateError+
                   DataBaseName+'\'+ItemsNameE.AsString);
                   exit;
            end;
        end;
     end;
end;

procedure TNewTreeGuideForm.CreateGroupsCClick(Sender: TObject);
begin
     GroupsNameE.Enabled := CreateGroupsC.Checked;
     OkB.Enabled := CreateGroupsC.Checked or CreateItemsC.Checked;
end;

procedure TNewTreeGuideForm.CreateItemsCClick(Sender: TObject);
begin
     ItemsNameE.Enabled := CreateItemsC.Checked;
     OkB.Enabled := CreateGroupsC.Checked or CreateItemsC.Checked;
end;

procedure TNewTreeGuideForm.DirERightClick(Sender: TObject);
begin
  if not DirD.Execute then exit;
  DirE.AsString := DirD.Directory;
end;

procedure TNewTreeGuideForm.FormCreate(Sender: TObject);
var Index: LongInt;
begin
  for Index := 0 to pred(GroupsFields.Items.Count) do begin
    GroupsFields.Checked[Index] := true;
    {$IFDEF Delphi5}
    if Index <= 3 then GroupsFields.ItemEnabled[Index] := false;
    {$ENDIF}
  end;
  for Index := 0 to pred(ItemsFields.Items.Count) do begin
    ItemsFields.Checked[Index] := true;
    {$IFDEF Delphi5}
    if Index <= 3 then ItemsFields.ItemEnabled[Index] := false;
    {$ENDIF}
  end;

  Caption := sohoTreeViewCreatorTitle;
  PathL.Caption := sohoTreeViewCreatorPath;
  GroupsGr.Caption := sohoTreeViewCreatorGroups;
  GroupsNameL.Caption := sohoTreeViewCreatorGroupsName;
  GroupFieldsL.Caption := sohoTreeViewCreatorGroupFields;
  ItemsGr.Caption := sohoTreeViewCreatorItems;
  ItemsFieldsL.Caption := sohoTreeViewCreatorItemsFields;
  ItemsTableL.Caption := sohoTreeViewCreatorItemsTable;

  OkB.Caption := SOKButton;
  CancelB.Caption := SCancelButton;
end;

end.