{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{           Partial copyright (c) AllexSoft             }
{           Written by Alexander Govyadinov,            }
{                   Victor Mylcin,                      }
{                   Serg Vostrikov                      }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoUsCard;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, SoFrmStorage, SoTools,
         SoSDlgs, Db, DBTables, StdCtrls, SohoBtns, Controls, SoCtrls, SohoSpin, Forms;

type

  TUserCardF = class(TForm)
    Query1: TQuery;
    DirDialog: TsohoDirectoryDialog;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    sohoEnterTab1: TsohoEnterTab;
    CommentE: TsohoEdit;
    CommentsL: TsohoLabel;
    UserIni: TsohoFormStorage;
    CommonGr: TGroupBox;
    NameL: TsohoLabel;
    ShortNameL: TsohoLabel;
    PasswordL: TsohoLabel;
    ShortNameE: TsohoEdit;
    UserNameE: TsohoEdit;
    PasswordE: TsohoEdit;
    UserGr: TGroupBox;
    ActionsL: TsohoLabel;
    ActionE: TsohoEdit;
    WritingL: TsohoLabel;
    WriteE: TsohoEdit;
    ReadingL: TsohoLabel;
    ReadE: TsohoEdit;
    ProtectL: TsohoLabel;
    DataLevelE: TsohoSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ActionEExit(Sender: TObject);
    procedure ReadEExit(Sender: TObject);
    procedure WriteEExit(Sender: TObject);
    procedure UserNameEExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var UserCardF: TUserCardF;

implementation
uses SoUsers, SohoPswU, SoCtmRgs, SoUnit, SoDBCns, SoCmnCns;

{$R *.DFM}

procedure TUserCardF.FormCreate(Sender: TObject);
begin
  Caption := sohoUserCardTitle;
  CommentE.AsString := sohoUserCardNoComments;
  CommentsL.Caption := sohoUserCardComments;
  CommonGr.Caption := sohoUserCardCommon;
  NameL.Caption := sohoUserCardName;
  ShortNameL.Caption := sohoUserCardShortName;
  PasswordL.Caption := sohoUserCardPassword;
  UserGr.Caption := sohoUserCardRights;
  ActionsL.Caption := sohoUserCardActions;
  WritingL.Caption := sohoUserCardWriting;
  ReadingL.Caption := sohoUserCardReading;
  ProtectL.Caption := sohoUserCardProtect;

  OkB.Caption := SOKButton;
  CancelB.Caption := SCancelButton;

  with UserF.PasswordQ do begin
    UserNameE.Text := FieldByName('UserName').AsString;
    ActionE.Text   := FieldByName('Action').AsString;
    ReadE.Text := FieldByName('ReadR').AsString;
    WriteE.Text := FieldByName('WriteR').AsString;
    CommentE.Text := FieldByName('Comment').AsString;
    ShortNameE.Text := FieldByName('ShortName').AsString;
    DataLevelE.AsInteger := FieldByName('DataLevel').AsInteger;
    PasswordE.Text := '';
  end;

  if SingleRegister = nil then Close;
  with SingleRegister, OkB do begin
     Visible := True;
     Visible := Visible and (StrToSet(ActionE.Text) <= ActionRights);
     Visible := Visible and (StrToSet(ReadE.Text) <= DataReadRights);
     Visible := Visible and (StrToSet(WriteE.Text) <= DataWriteRights);
  end;
end;

procedure TUserCardF.BitBtn1Click(Sender: TObject);
var ID:Longint;
begin
 with Query1,SQL do begin
  DataBaseName := UserF.PasswordQ.DataBaseName;
  Clear;
  Add('Update "sopswrd.db" ');
  Add('Set ');
  Add('PasswordR=0,');
  Add('UserName="'+UserNameE.Text+'",');
  Add('Action="'+ActionE.Text+'",');
  Add('ReadR="'+ReadE.Text+'",');
  Add('WriteR="'+WriteE.Text+'",');
  Add('Comment="'+CommentE.Text+'",');
  Add('DataLevel='+IntToStr(DataLevelE.AsInteger)+',');
  Add('ShortName="'+ShortNameE.Text+'"');
  Add('Where ID='+UserF.PasswordQ.FieldByName('ID').AsString);
  ID := UserF.PasswordQ.FieldByName('ID').AsInteger;
  UserF.PasswordQ.Close;
  ExecSql;
  UserF.PasswordQ.Open;
  while UserF.PasswordQ.FieldByName('ID').AsInteger<>ID do UserF.PasswordQ.Next;
  Clear;
  Add('Update "sopswrd.db" ');
  Add('Set ');
  Add('PasswordR='+IntToStr(CalculatePassword(UserF.PasswordQ,
     PassWordE.Text)));
  Add('Where ID='+UserF.PasswordQ.FieldByName('ID').AsString);
  ExecSQL;
 end;
end;

procedure TUserCardF.ActionEExit(Sender: TObject);
begin
 {  }
 with ActionE do
   Text := SetToStr(StrToSet(Text) * SingleRegister.ActionRights);
end;

procedure TUserCardF.ReadEExit(Sender: TObject);
begin
 with  ReadE do
  Text:=SetToStr(StrToSet(Text) * SingleRegister.DataReadRights);
end;

procedure TUserCardF.WriteEExit(Sender: TObject);
begin
 with  WriteE do
  Text:=SetToStr(StrToSet(Text) * SingleRegister.DataWriteRights);
end;

procedure TUserCardF.UserNameEExit(Sender: TObject);
begin
  if ShortNameE.Text = '' then
      ShortNameE.Text := copy(UserNameE.Text,1,8);
end;

end.
