{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{           Partial copyright (c) AllexSoft             }
{           Written by Alexander Govyadinov,            }
{                   Victor Mylcin,                      }
{                   Serg Vostrikov                      }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoUsers;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, DB, DBTables, Grids, SoUnit, SoUsCard, SoSDlgs, IniFiles,
  SoFolder, Menus, SohoBtns, DBGrids, StdCtrls, ExtCtrls, SoCtmFld, 
  SoDBGrid;

type

  TUserF = class(TForm)
    Panel1: TPanel;
    DeleteQ: TQuery;
    InsertQ: TQuery;
    DirDialog: TsohoDirectoryDialog;
    MainMenu: TMainMenu;
    UserM: TMenuItem;
    AddM: TMenuItem;
    DeleteM: TMenuItem;
    EditM: TMenuItem;
    N5: TMenuItem;
    CloseM: TMenuItem;
    Folder: TsohoFolder;
    EditB: TsohoBitBtn;
    AddB: TsohoBitBtn;
    DeleteB: TsohoBitBtn;
    CloseB: TsohoBitBtn;
    PasswordQ: TQuery;
    DataSource: TDataSource;
    Grid: TsohoDBGrid;
    procedure DeleteBClick(Sender: TObject);
    procedure AddBClick(Sender: TObject);
    procedure EditBClick(Sender: TObject);
    procedure CloseBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    function GridOperation(Sender: TObject;
      Operation: TsohoGridOperation): Boolean;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  UserF: TUserF;

implementation
uses SoVCLUtils, SoCtmRgs, SoDBCns;

{$R *.DFM}

procedure TUserF.DeleteBClick(Sender: TObject);
var Well: boolean;
begin
  DeleteQ.DataBaseName := PasswordQ.DataBaseName;
  DeleteQ.Prepare;
  DeleteQ.Params[0].AsInteger := PasswordQ.FieldByName('ID').AsInteger;
  with PasswordQ do begin
    Well := True;
    Well := Well and (StrToSet(FieldByName('Action').AsString) <= SingleRegister.ActionRights);
    Well := Well and (StrToSet(FieldByName('ReadR').AsString) <= SingleRegister.DataReadRights);
    Well := Well and (StrToSet(FieldByName('WriteR').AsString) <= SingleRegister.DataWriteRights);
  end;
  if Well then begin
    PasswordQ.Close;
    DeleteQ.ExecSql;
    PasswordQ.Open;
  end
  else InfoMsg(sohoUsersRightsError);
end;

procedure TUserF.AddBClick(Sender: TObject);
var ID: Longint;
begin
  ID := GetNewID('USER');
  with InsertQ do begin
    DataBaseName := PasswordQ.DataBaseName;
    Prepare;
    Params[0].AsInteger := ID;
    // Params[1].AsDateTime := Now;
    Params[1].AsInteger := SingleRegister.UserID;
    PasswordQ.Close;
    ExecSql;
    PasswordQ.Open;
    while (PasswordQ.FieldByName('ID').AsInteger <> ID) do
      PasswordQ.Next;
  end;
  EditBClick(Sender);
end;

procedure TUserF.EditBClick(Sender: TObject);
begin
  PasswordQ.DisableControls;
  try
    UserCardF := TUserCardF.Create(Self);
    UserCardF.ShowModal;
  finally
    UserCardF.Free;
  end;
  PasswordQ.EnableControls;
end;

procedure TUserF.CloseBClick(Sender: TObject);
begin
  Close;
end;

procedure TUserF.FormCreate(Sender: TObject);
var Ini: TIniFile;
  // TempForm: TForm;
begin
  Caption := sohoUsersFormTitle;
  UserM.Caption := sohoUsersFormUser;
  AddM.Caption := sohoUsersFormAdd;
  DeleteM.Caption := sohoUsersFormDelete;
  EditM.Caption := sohoUsersFormEdit;
  CloseM.Caption := sohoUsersFormClose;
  EditB.Caption := sohoUsersFormEdit;
  AddB.Caption := sohoUsersFormAdd;
  DeleteB.Caption := sohoUsersFormDelete;
  CloseB.Caption := sohoUsersFormClose;

  Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'Soho.ini');
  DirDialog.Directory := Ini.ReadString
    ('Password', 'Directory', ExtractFilePath(ParamStr(0)));
  Ini.Free;
  with PasswordQ do
    repeat
      try
        DataBaseName := DirDialog.Directory;
        Folder.FolderDir := DirDialog.Directory;
        Open;
      except
        if not DirDialog.Execute then begin
          Self.Close;
          Exit;
        end;
      end;
    until Active;
  PasswordQ.Close;
  PasswordQ.Open;
end; {proc}

procedure TUserF.FormDestroy(Sender: TObject);
begin
  PasswordQ.Close;
end;

function TUserF.GridOperation(Sender: TObject;
  Operation: TsohoGridOperation): Boolean;
begin
  Result := true;
  case Operation of
    soNewRecord: AddBClick(Sender);
    soEditRecord: EditBClick(Sender);
    else DeleteBClick(Sender);
  end;
end;

end.

