{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{           Partial copyright (c) AllexSoft             }
{              Written by Serg Vostrikov,               }
{                 Alexander Govyadinov                  }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
      .  
   .
}
unit SoUtils;

{$I SOHOLIB.INC}

interface
uses Classes, Controls, Graphics, Windows;

function IsFloat(const Value: string): Boolean;
{      ? }
function IsInteger(const Value: string): Boolean;
{      ? }
function HexToInt(const Value: string): LongInt;
{  16-    }
function BoolToStr(Value: LongBool): string;
{  boolean  string }
function StrToBool(const Value: string): Boolean;
{  string  boolean }
function AlignmentToStr(Value: TAlignment): string;
{  TAlignment  string }
function StrToAlignment(const Value: string): TAlignment;
{  string  TAlignment }
function AlignToStr(Value: tAlign): string;
{  TAlign  string }
function StrToAlign(const Value: string): tAlign;
{  string  TAlign }
function FontStyleToStr(Value: TFontStyles): string;
{  TFontStyles  string }
function StrToFontStyle(const Value: string): TFontStyles;
{  string  TFontStyles }
function FontToStr(Value: TFont): string;
{  TFont  string }
procedure StrToFont(const Value: string; Font : TFont);
{  string  TFont }
function IntToStrF(Value: Longint; Width: Integer): string;
{        (Width) }
{$IFDEF Delphi4_or_5}
function FloatToStrF(Value: Extended; Width: Integer;
  Decimals: Integer; WithDotSeparator: boolean = true): string;
{$ELSE}
function FloatToStrF(Value: Extended; Width: Integer;
  Decimals: Integer): string;
{$ENDIF}
{        (Width)  
      (Decimal) }
function FloatToSQLFloat(Value: Extended): string;
{           SQL-,
          '.'}
function WStrToInt(const Value: string; var Error: Boolean): Longint;
{     .      except,
    0 }
function WStrToFloat(const Value: string; var Error: Boolean): Extended;
{     .      except,
    0 }
procedure SwapLongInt(var A, B: Longint);
{    a  b }
procedure SwapInteger(var A, B: Integer);
{    a  b }
procedure SwapDouble(var A, B: Double);
{    a  b }
procedure Swap(var A,B; Size: LongInt);
{     a  b }
function SmallToPoint(Point: TSmallPoint): TPoint;
{    TSmallPoint  TPoint, c
   Win32 API    "",  
  TPoint  Win16 }
function GetMax(X, Y: Integer): Integer;
{    }
function GetMin(X, Y: Integer): Integer;
{    }
function Round(Value: Extended): Longint;
{ ,    round.  
      -   
   ,     
    .     ,
       .  
  round    , 
   }
function WRound(Value: Double; Digits: Integer): Double;
{       
   Digits > 0,
   Round  Digits = 0,
           Digits < 0
}

const

 DefSQLFloatWidth    : integer = 15;
 DefSQLFloatDecimals : integer = 3;
 {      FloatToSQlFloat.
   DefSQLFloatWidth -  -   ,
   DefSQLFloatDecimals - -    }

implementation
uses SysUtils, SoCmnCns, SoStrUtils, Math;

function IsFloat(const Value: string): Boolean;
var index: Integer;
  OneFound: Boolean;
  ExpFound: Boolean;
  Tmp: string;
begin
  Result := False;
  OneFound := False; {-  float     }
  ExpFound := False;
// Weitek 20.01.2000
  Tmp := DeleteChars(Value,[' ']);
  Tmp := ChangeChars(Tmp, '.', DecimalSeparator);
  if Tmp <> EmptyStr then begin
    for Index := 1 to Length(Tmp) do begin
      if Tmp[Index] in ['E','e'] then {-  float      E}
        if not ExpFound then ExpFound := True
        else Exit;
      if Tmp[Index] = DecimalSeparator then begin
        if ExpFound then Exit { ????} else
        if not OneFound then OneFound := True
        else exit;
      end;
      if not (Tmp[Index] in [Space, DecimalSeparator, '0'..'9', '-','E','e']) then exit;
    end;
    Result := not ((ExpFound) and (Tmp[Length(Tmp)] in ['e','E']));
  end;
end;

function IsInteger(const Value: string): Boolean;
type IntegerState = (isSpaced, isMinused, isDigit, isTailSpaced);
var Index: Integer;
    State: IntegerState;
    C: char;
begin
  // ,    -       
  //    
  Result := false;
  Index := 1;
  State := isSpaced;
  while Index <= Length(Value) do begin
     C := Value[Index];
     if not (C in [Space, '-', '0'..'9']) then exit; //,  - 
     if C = '-' then //    
     case State of
       isSpaced: State := isMinused;
       isMinused, isDigit, isTailSpaced: exit; // -     
     end;

     if C = Space then
      case State of
       isSpaced, isTailSpaced : ;//  -    
       isMinused: exit; // -   
       isDigit: State := isTailSpaced; //  
      end;

//     if C in ['0'..'9'] then ,    = 
     case State of
      isSpaced, isMinused: State := isDigit; //  
//       isDigit  :state:=isDigit; //  
      isTailSpaced: exit; // -     
     end;
     inc(Index); //  
   end;
   Result := true;//  
end;

function HexToInt(const Value: string): LongInt;
var Tmp: string;
begin
  if Pos('$', Value) = 0 then Tmp := '$' + Value
  else Tmp := Value;
  Result := StrToIntDef(Tmp, 0);
end;

function WStrToInt(const Value: string; var Error: Boolean): Longint;
begin
  Result := 0;
  Error := not IsInteger(Value);
  if Error then exit;
  try
    Result := StrToInt(DeleteChars(Value,[Space]));
  except
    Error := True;
  end;
end;

function WStrToFloat(const Value: string; var Error: Boolean): Extended;
var tmp: string;
begin
// Weitek 20.02.2000
//  Tmp := DeleteChars(Value,[' ']);
//  Tmp := ChangeChars(Value, '.', DecimalSeparator);
  Tmp := DeleteChars(Value,[' ']);
  Tmp := ChangeChars(Tmp, '.', DecimalSeparator);
  Result := 0;
  Error := not IsFloat(Tmp);
  if Error then exit;
  try
    Result := StrToFloat(tmp);
  except
    Error := true;
  end;
end;

function BoolToStr(Value: LongBool): string;
const BooleanToStr : array [boolean] of string = ('0', '1');
begin
  Result := BooleanToStr[Value];
end;

function StrToBool(const Value: string): Boolean;
var V: string;
begin
  V := AnsiUpperCase(Value);
  Result := (V = 'TRUE') or (V = 'T') or (V = '1') or
    (V = 'YES') or (V = 'Y');
end;

function AlignmentToStr(Value: TAlignment): string;
begin
  if Value = taLeftJustify then Result := 'taLeftJustify';
  if Value = taRightJustify then Result := 'taRightJustify';
  if Value = taCenter then Result := 'taCenter';
end;

function StrToAlignment(const Value: string): TAlignment;
begin
  case IndexOfStr(AnsiUpperCase(Value),
    ['TALEFTJUSTIFY', 'TARIGHTJUSTIFY', 'TACENTER']) of
      0: Result := taLeftJustify;
      1: Result := taRightJustify;
      else Result := taCenter;
   end;
end;

function AlignToStr(Value: tAlign): string;
begin
  if Value = alLeft then Result := 'alLeft';
  if Value = alRight then Result := 'alRight';
  if Value = alClient then Result := 'alClient';
  if Value = alNone then Result := 'alNone';
  if Value = alTop then Result := 'alTop';
  if Value = alBottom then Result := 'alBottom';
end;

function StrToAlign(const Value: string): tAlign;
begin
  case IndexOfStr(StrUpper(Value),
    ['ALCLIENT', 'ALRIGHT', 'ALNONE', 'ALTOP', 'ALBOTTOM', 'ALLEFT']) of
      0: Result := alClient;
      1: Result := alRight;
      2: Result := alNone;
      3: Result := alTop;
      4: Result := alBottom;
      else Result := alLeft;
  end;
end;

function IntToStrF(Value: Longint; Width: Integer): string;
begin
  Str(Value: Width, Result);
end;

{$IFDEF Delphi4_or_5}
function FloatToStrF(Value: Extended; Width: Integer;
  Decimals: Integer; WithDotSeparator: boolean = true): string;
{$ELSE}
function FloatToStrF(Value: Extended; Width: Integer;
  Decimals: Integer): string;
{$ENDIF}
begin
  Str(Value: Width: Decimals, Result);
  Result := DeleteChars(Result, [Space]);
{$IFDEF Delphi4_or_5}
  if not WithDotSeparator then
    Result := ChangeChars(Result, '.', DecimalSeparator);
{$ELSE}
  Result := ChangeChars(Result, '.', DecimalSeparator);
{$ENDIF}
end;

function FloatToSQLFloat(Value: Extended): string;
begin
  Str(Value: DefSQLFloatWidth: DefSQLFloatDecimals, Result);
  Result := DeleteChars(Result, [#32]);
  // Result := FloatToStrF(Value, 15, 3);
end;

function FontStyleToStr(Value: TFontStyles): string;
begin
//  Result := '';
  if Value = [] then Result := 'N' else Result := EmptyStr;
  if fsBold in Value then Result := Result + 'B';
  if fsItalic in Value then Result := Result + 'I';
  if fsUnderline in Value then Result := Result + 'U';
  if fsStrikeOut in Value then Result := Result + 'S';
end;

function StrToFontStyle(const Value: string): TFontStyles;
var index: Integer;
begin
  Result := [];
  for index := 1 to Length(Value) do
    case Value[index] of
      'B': Result := Result + [fsBold];
      'I': Result := Result + [fsItalic];
      'U': Result := Result + [fsUnderline];
      'S': Result := Result + [fsStrikeOut];
    end;
end;

function FontToStr(Value: TFont): string;
begin
  Result := Value.name + ',' + ColorToString(Value.Color) + ',' +
    FontStyleToStr(Value.Style) + ',' + IntToStr(Value.Size);
end;

procedure StrToFont(const Value: string; Font : TFont);
var Error: Boolean;
begin
  if Font = nil then exit;
  {   -  }
  SetDivisers([',']);
  with Font do begin
    Name := GetSomeWords(Value, 1, 1);
    Color := StringToColor(GetSomeWords(Value, 2, 2));
    Style := StrToFontStyle(GetSomeWords(Value, 3, 3));
    Size := WStrToInt(GetSomeWords(Value, 4, 4), Error);
  end;
end;

procedure SwapInteger(var A, B: Integer);
var tmp: Integer;
begin
  tmp := A;
  A := B;
  B := tmp;
end;

procedure SwapLongInt(var A, B: Longint);
var tmp: Longint;
begin
  tmp := A;
  A := B;
  B := tmp;
end;

procedure SwapDouble(var A, B: Double);
var tmp: double;
begin
  tmp := A;
  A := B;
  B := tmp;
end;

procedure Swap(var A,B; Size: LongInt);
var P: pointer;
begin
  GetMem(P, Size);
  Move(A, P^, Size);
  Move(B, A, Size);
  Move(P^, B, Size);
  FreeMem(P);
end;

function GetMax(X, Y: Integer): Integer;
begin
  if X > Y then Result := X else Result := Y;
end;

function GetMin(X, Y: Integer): Integer;
begin
  if X < Y then Result := X else Result := Y;
end;

function SmallToPoint(Point: TSmallPoint): TPoint;
begin
  Result.X := Point.X;
  Result.Y := Point.Y;
end;

function Round(Value: Extended): Longint;
begin
  if Value > 0 then Result := trunc(Value + 0.5)
  else Result := trunc(Value - 0.5);
end;

// Weitek 23.01.2000
function WRound(Value: Double; Digits: Integer): Double;
var Exp : Extended;
begin
  if Digits = 0 then Result := Round(Value)
  else begin
    Exp := IntPower(10, Abs(Digits));
    if Digits > 0 then Result := Round(Value * Exp) / Exp
    else Result := Round(Value / Exp) * Exp;
  end;
end;

end.
