{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{           Partial copyright (c) AllexSoft             }
{              Written by Serg Vostrikov,               }
{                 Alexander Govyadinov                  }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoVCLUtils;

{$I SOHOLIB.INC}

interface
uses Windows, Forms, Classes, Controls, Graphics, FileCtrl, Menus,
     StdCtrls, ComCtrls;

type

  TCompare = (cmpLike, cmpCaseSensitive);
  TSetOfCompare = set of TCompare;

procedure ErrorMsg(const MsgText: string);
{    }
procedure InfoMsg(const MsgText: string);
{    }
function YesNoMsg(const MsgText: string): Boolean;
{    ""  "".   true,     "" }
function YesNoCancel (const MsgText: string) : TModalResult;
{    "", "", "".      }
function OkCancelMsg(const MsgText: string): Boolean;
{    "Ok"  ""    true,     "Ok" }
procedure ErrorResFrm(ResID: Word; Args: array of const);
{   ,        }
procedure ErrorRes(ResID: Word);
{   ,      }
procedure Delay(Pause: DWORD; ProcessMessages: Boolean);
{  .  ProcessMessages = true,     
     .      }
function GetControlColor(AControl: TControl): TColor;
{    TControl }
function GetControlFont(AControl: TControl): tFont;
{    aControl }
procedure SetControlFont(AControl: TControl; AFont: tFont);
{    aControl }
procedure SetControlColor(AControl: TControl; aColor: TColor);
{    aControl }
function GetParentColor(AControl: TControl): TColor;
{    aControl.Parent }
function GetParentFont(AControl: TControl): tFont;
{    aControl.Parent }
procedure SetComponentState(AComponent: TComponent; State: TComponentState);
{    }
function GetOwnerForm(AComponent: TComponent): TForm;
{  - }
function FormExists (CheckForm : TForm) : boolean;
{    ,        ? }
function FindForm(Pos: TPoint): TForm;
{     }
function FindComponentOnForm(Pos: TPoint; Form: TForm; CanBeForm: Boolean): TComponent;
{       }
function ClickAssigned(AControl: TControl): Boolean;
{  true,   OnClick  aControl  }
function IsCDROM(DriveNum: Integer): Boolean;
{   CD-ROM   ? }
function IsRAMDrive(DriveNum: Integer): Boolean;
{   RAM-drive   ? }
function FindDriveType(DriveNum: Integer): TDriveType;
{   }
function VolumeID(DriveChar: Char): string;
{    }
function NetworkVolume(DriveChar: Char): string;
{    }
function Substituted(DriveChar: Char): string;
{     ,       subst}


function ResString(StrId: Word): string;
{     }
function ResBitmap(const BitMapName: string): HBITMAP;
{     }
function ResCursor(const CursorName: string): HCURSOR;
{     }
function CopyMenuItem(Owner: TComponent; FromItem: TMenuItem): TMenuItem;
{   ,     FromMenu. 
  Owner      }
function FindComponentByProperty(aOwner: TComponent;
   const PropertyName: string; var PropertyValue;
   const Compare: TSetOfCompare): TComponent;
{        .
         
  = ,    False=0, True=1.    
   Boolean      }
function FindMenuItemByTag (Menu : TComponent; FindTag : LongInt) : TMenuItem;
{      Tag }
function FindMenuItemByHotChar (Menu : TComponent; HotChar : char) : TMenuItem;
{      " " }
procedure MenuItemRightAlign (Menu : TMainMenu; Item : TMenuItem);
{       }
procedure SetCursorPos(Memo : TMemo; XPos, YPos : integer);
{     Memo.     1- }
function GetPageIndex (PageControl : TPageControl) : integer;
{     }
procedure SetPageIndex (PageControl : TPageControl; Index : integer);
{     }

implementation
uses SysUtils, SoUtils, SoRTTI, TypInfo, SoDialogs;

type

  {$HINTS OFF}
  THackComponent = class(TPersistent)
  private
    FOwner: TComponent;
    FName: TComponentName;
    FTag: Longint;
    FComponents: TList;
    FFreeNotifies: TList;
    FDesignInfo: Longint;
    FVCLComObject: Pointer;
    FComponentState: TComponentState;
  end;

  {$IFDEF Delphi3}
  THackControl = class(TComponent)
  private
    FParent: TWinControl;
    FWindowProc: TWndMethod;
    FLeft: Integer;
    FTop: Integer;
    FWidth: Integer;
    FHeight: Integer;
    FControlStyle: TControlStyle;
    FControlState: TControlState;
    FDesktopFont: Boolean;
    FVisible: Boolean;
    FEnabled: Boolean;
    FParentFont: Boolean;
    FParentColor: Boolean;
    FAlign: tAlign;
    FDragMode: TDragMode;
    FIsControl: Boolean;
    FText: PChar;
    FFont: tFont;
    FColor: TColor;
    FCursor: tCursor;
    FDragCursor: tCursor;
    FPopupMenu: TPopupMenu;
    FHint: string;
    FFontHeight: Integer;
    FScalingFlags: TScalingFlags;
    FShowHint: Boolean;
    FParentShowHint: Boolean;
    FOnMouseDown: TMouseEvent;
    FOnMouseMove: TMouseMoveEvent;
    FOnMouseUp: TMouseEvent;
    FOnDragDrop: TDragDropEvent;
    FOnDragOver: TDragOverEvent;
    FOnStartDrag: TStartDragEvent;
    FOnEndDrag: TEndDragEvent;
    FOnClick: TNotifyEvent;
    FOnDblClick: TNotifyEvent;
  end;
  {$ENDIF}

  {$IFDEF Delphi4}
  THackControl = class(TComponent)
  private
    FParent: TWinControl;
    FWindowProc: TWndMethod;
    FLeft: Integer;
    FTop: Integer;
    FWidth: Integer;
    FHeight: Integer;
    FControlStyle: TControlStyle;
    FControlState: TControlState;
    FDesktopFont: Boolean;
    FVisible: Boolean;
    FEnabled: Boolean;
    FParentFont: Boolean;
    FParentColor: Boolean;
    FAlign: TAlign;
    FAutoSize: Boolean;
    FDragMode: TDragMode;
    FIsControl: Boolean;
    FBiDiMode: TBiDiMode;
    FParentBiDiMode: Boolean;
    FText: PChar;
    FFont: TFont;
    FActionLink: TControlActionLink;
    FAnchors: TAnchors;
    FColor: TColor;
    FConstraints: TSizeConstraints;
    FCursor: TCursor;
    FDragCursor: TCursor;
    FPopupMenu: TPopupMenu;
    FHint: string;
    FFontHeight: Integer;
    FLastHeight: Integer;
    FLastWidth: Integer;
    FScalingFlags: TScalingFlags;
    FShowHint: Boolean;
    FParentShowHint: Boolean;
    FDragKind: TDragKind;
    FDockOrientation: TDockOrientation;
    FHostDockSite: TWinControl;
    FUndockWidth: Integer;
    FUndockHeight: Integer;
    FLRDockWidth: Integer;
    FTBDockHeight: Integer;
    FFloatingDockSiteClass: TWinControlClass;
    FOnCanResize: TCanResizeEvent;
    FOnConstrainedResize: TConstrainedResizeEvent;
    FOnMouseDown: TMouseEvent;
    FOnMouseMove: TMouseMoveEvent;
    FOnMouseUp: TMouseEvent;
    FOnDragDrop: TDragDropEvent;
    FOnDragOver: TDragOverEvent;
    FOnResize: TNotifyEvent;
    FOnStartDock: TStartDockEvent;
    FOnEndDock: TEndDragEvent;
    FOnStartDrag: TStartDragEvent;
    FOnEndDrag: TEndDragEvent;
    FOnClick: TNotifyEvent;
    FOnDblClick: TNotifyEvent;
  end;
  {$ENDIF}

  {$IFDEF Delphi5}
  THackControl = class(TComponent)
  private
    FParent: TWinControl;
    FWindowProc: TWndMethod;
    FLeft: Integer;
    FTop: Integer;
    FWidth: Integer;
    FHeight: Integer;
    FControlStyle: TControlStyle;
    FControlState: TControlState;
    FDesktopFont: Boolean;
    FVisible: Boolean;
    FEnabled: Boolean;
    FParentFont: Boolean;
    FParentColor: Boolean;
    FAlign: TAlign;
    FAutoSize: Boolean;
    FDragMode: TDragMode;
    FIsControl: Boolean;
    FBiDiMode: TBiDiMode;
    FParentBiDiMode: Boolean;
    FAnchors: TAnchors;
    FAnchorMove: Boolean;
    FText: PChar;
    FFont: TFont;
    FActionLink: TControlActionLink;
    FColor: TColor;
    FConstraints: TSizeConstraints;
    FCursor: TCursor;
    FDragCursor: TCursor;
    FPopupMenu: TPopupMenu;
    FHint: string;
    FFontHeight: Integer;
    FAnchorRules: TPoint;
    FOriginalParentSize: TPoint;
    FScalingFlags: TScalingFlags;
    FShowHint: Boolean;
    FParentShowHint: Boolean;
    FDragKind: TDragKind;
    FDockOrientation: TDockOrientation;
    FHostDockSite: TWinControl;
    FUndockWidth: Integer;
    FUndockHeight: Integer;
    FLRDockWidth: Integer;
    FTBDockHeight: Integer;
    FFloatingDockSiteClass: TWinControlClass;
    FOnCanResize: TCanResizeEvent;
    FOnConstrainedResize: TConstrainedResizeEvent;
    FOnMouseDown: TMouseEvent;
    FOnMouseMove: TMouseMoveEvent;
    FOnMouseUp: TMouseEvent;
    FOnDragDrop: TDragDropEvent;
    FOnDragOver: TDragOverEvent;
    FOnResize: TNotifyEvent;
    FOnStartDock: TStartDockEvent;
    FOnEndDock: TEndDragEvent;
    FOnStartDrag: TStartDragEvent;
    FOnEndDrag: TEndDragEvent;
    FOnClick: TNotifyEvent;
    FOnDblClick: TNotifyEvent;
    FOnContextPopup: TContextPopupEvent;
  end;
  {$ENDIF}
  {$HINTS ON}

procedure ErrorMsg(const MsgText: string);
begin
  Screen.Cursor := crDefault;
  MessageBeep(MB_ICONHAND);
  {Application.MessageBox(PChar(MsgText), '', MB_ICONERROR or
     MB_OK or MB_TASKMODAL);}
  MessageDlg(MsgText, mtError, [mbOk], 0);
end;

procedure InfoMsg(const MsgText: string);
begin
  {Application.MessageBox(PChar(MsgText), '', MB_ICONINFORMATION
     or MB_OK or MB_TASKMODAL);}
  MessageBeep(MB_OK);
  MessageDlg(MsgText, mtInformation, [mbOk], 0);
end;

function YesNoMsg(const MsgText: string): Boolean;
begin
  {Result := Application.MessageBox(PChar(MsgText), '',
    MB_ICONQUESTION or MB_YESNO or MB_TASKMODAL) = IDYES;}
  MessageBeep(MB_ICONQUESTION);
  Result := MessageDlg(MsgText, mtConfirmation, [mbYes, mbNo], 0) = mrYes;
end;

function YesNoCancel (const MsgText: string) : TModalResult;
// var Tmp : integer;
begin
  {Tmp := Application.MessageBox(PChar(MsgText), '',
    MB_ICONQUESTION or MB_YESNOCANCEL or MB_TASKMODAL);
  case Tmp of
    IDYES    : Result := mrYes;
    IDNO     : Result := mrNo;
    else Result := mrCancel;
  end;}
  MessageBeep(MB_ICONQUESTION);
  Result := MessageDlg(MsgText, mtConfirmation, [mbYes, mbNo, mbCancel], 0);
end;

function OkCancelMsg(const MsgText: string): Boolean;
begin
  {Result := Application.MessageBox(PChar(MsgText), '',
    MB_ICONQUESTION or MB_OKCANCEL or MB_TASKMODAL) = IDOK;}
  MessageBeep(MB_ICONQUESTION);
  Result := MessageDlg(MsgText, mtConfirmation, [mbOk, mbCancel], 0) = mrOk;
end;

procedure ErrorRes(ResID: Word);
begin
  ErrorMsg(LoadStr(ResID));
end;

procedure ErrorResFrm(ResID: Word; Args: array of const);
begin
  ErrorMsg(FmtLoadStr(ResID, Args));
end;

procedure Delay(Pause: DWORD; ProcessMessages: Boolean);
var FirstTick: DWORD;
begin
  if not ProcessMessages then SleepEx(Pause, true)
  else begin
    FirstTick := GetTickCount;
    repeat
      Application.ProcessMessages
    until GetTickCount - FirstTick >= Pause;
  end;
end;

{$IFNDEF WIN32}
function IsCDROM(DriveNum: Integer): Boolean; assembler;
asm
  MOV   AX,1500h { look for MSCDEX }
  XOR   BX,BX
  INT   2fh
  OR    BX,BX
  JZ    @Finish
  MOV   AX,150Bh { check for using CD driver }
  MOV   CX,DriveNum
  INT   2fh
  OR    AX,AX
  @Finish:
end;
{$ELSE}
function IsCDROM(DriveNum: Integer): Boolean;
begin
  Result := FindDriveType(DriveNum) = dtCDROM;
end;
{$ENDIF}

{$IFNDEF WIN32}
function IsRAMDrive(DriveNum: Integer): Boolean; assembler;
var
  TempResult: Boolean;
asm
  MOV   TempResult,False
  PUSH  DS
  MOV   BX,SS
  MOV   DS,BX
  SUB   SP,0200h
  MOV   BX,SP
  MOV   AX,DriveNum
  MOV   CX,1
  XOR   DX,DX
  INT   25h  { read boot sector }
  ADD   SP,2
  JC    @ItsNot
  MOV   BX,SP
  CMP   BYTE PTR SS:[BX+15h],0F8h  { reverify fixed disk }
  JNE   @ItsNot
  CMP   BYTE PTR SS:[BX+10h],1  { check for single FAT }
  JNE   @ItsNot
  MOV   TempResult,True
  @ItsNot:
  ADD   SP,0200h
  POP   DS
  MOV   AL, TempResult
end;
{$ELSE}
function IsRAMDrive(DriveNum: Integer): Boolean;
begin
  Result := FindDriveType(DriveNum) = dtRAM;
end;
{$ENDIF}

function FindDriveType(DriveNum: Integer): TDriveType;
{$IFDEF WIN32}
var DriveChar : char;
{$ENDIF}
begin
  {$IFNDEF WIN32}
  Result := TDriveType(GetDriveType(DriveNum));
  if (Result = dtFixed) or (Result = dtNetwork) then begin
    if IsCDROM(DriveNum) then Result := dtCDROM
    else if (Result = dtFixed) then begin
      { do not check for RAMDrive under Windows NT }
      if ((GetWinFlags and $4000) = 0) and IsRAMDrive(DriveNum) then
        Result := dtRAM;
    end;
  end;
  {$ELSE}
  DriveChar := Char(DriveNum + Ord('a'));
  Result := TDriveType(GetDriveType(PChar(DriveChar + ':\')));
  {$ENDIF}
end;

function VolumeID(DriveChar: Char): string;
{$IFNDEF WIN32}
var
  SearchMask  : string[7];
  SearchRec   : TSearchRec;
  DotPos      : Byte;
  OldErrorMode: Word;
begin
  OldErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    SearchMask := 'c:\*.*';
    SearchMask[1] := DriveChar;
    if FindFirst(SearchMask, faVolumeID, SearchRec) = 0 then begin
      Result := SearchRec.name;
      DotPos := Pos('.', Result);
      if DotPos <> 0 then
        System.Delete(Result, DotPos, 1);
      if DriveChar < 'a' then
        Result := ': [' + AnsiUpperCase(Result) + ']'
      else
        Result := ': [' + AnsiLowerCase(Result) + ']'
    end
    else Result := '';
    {    !}
  finally
    SetErrorMode(OldErrorMode);
  end;
end;
{$ELSE}
var
  {
  OldErrorMode: Integer;
  NotUsed, VolFlags: Integer;
  }
  OldErrorMode: DWORD; {D4}
  NotUsed, VolFlags: DWORD; {D4}
  Buf: array [0..MAX_PATH] of Char;
begin
  OldErrorMode := SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    Buf[0] := #$00;
    if GetVolumeInformation(PChar(DriveChar + ':\'), Buf, sizeof(Buf),
      nil, NotUsed, VolFlags, nil, 0) then
      SetString(Result, Buf, StrLen(Buf))
    else Result := '';
    if DriveChar < 'a' then
      Result := AnsiUpperCaseFileName(Result)
    else
      Result := AnsiLowerCaseFileName(Result);
    Result := Format('[%s]',[Result]);
  finally
    SetErrorMode(OldErrorMode);
  end;
end;
{$ENDIF}

function NetworkVolume(DriveChar: Char): string;
{$IFNDEF WIN32}
const
  LocalName: array[0..2] of Char = 'D:'#0;
var
  {BufferSize: Integer;}
  BufferSize: DWORD; {D4}
  TempName  : array[0..128] of Char;
begin
  LocalName[0] := DriveChar;
  BufferSize := SizeOf(TempName) - 1;
  if WNetGetConnection(LocalName, TempName, @BufferSize) = WN_SUCCESS then begin
    if DriveChar < 'a' then
      Result := ': ' + AnsiUpperCase(StrPas(TempName))
    else
      Result := ': ' + AnsiLowerCase(StrPas(TempName));
  end
  else
    Result := VolumeID(DriveChar);
end;
{$ELSE}
var
  Buf: Array [0..MAX_PATH] of Char;
  DriveStr: array [0..3] of Char;
  {$IFDEF Delphi3}
  BufferSize: Integer;
  {$ELSE}
  BufferSize: DWORD;
  {$ENDIF}
begin
  BufferSize := sizeof(Buf);
  DriveStr[0] := UpCase(DriveChar);
  DriveStr[1] := ':';
  DriveStr[2] := #0;
  if WNetGetConnection(DriveStr, Buf, BufferSize) = WN_SUCCESS then
  begin
    SetString(Result, Buf, BufferSize);
    if DriveChar < 'a' then
      Result := AnsiUpperCaseFileName(Result)
    else
      Result := AnsiLowerCaseFileName(Result);
  end
  else
    Result := VolumeID(DriveChar);
end;
{$ENDIF}

function Substituted(DriveChar: Char): string;
var DosDevice: array[0..255] of char;
begin
 Result := '';
 if QueryDosDevice(PChar(DriveChar+':'#0), @DosDevice, SizeOf(DosDevice)) = 0 then exit;
 if DosDevice[1] <> '?' then exit;
 Result := DosDevice;
 Result := Copy(Result, 5, 255);
end;

function ResString(StrId: Word): string;
begin
  Result := LoadStr(StrId);
end;

function ResBitmap;
begin
  Result := LoadBitmap(HInstance, PChar(BitMapName));
end;

function ResCursor;
var tmp: string;
begin
  tmp := CursorName + #0;
  Result := LoadCursor(HInstance, @tmp[1]);
end;

function GetControlColor(AControl: TControl): TColor;
begin
  Result := clBtnFace;
  if (AControl <> nil) then Result := THackControl(AControl).FColor;
end;

function GetControlFont(AControl: TControl): tFont;
begin
  Result := nil;
  if AControl <> nil then Result := THackControl(AControl).FFont;
end;

function GetParentColor(AControl: TControl): TColor;
begin
  if AControl.Parent = nil then Result := GetControlColor(AControl)
  else Result := GetControlColor(AControl.Parent);
end;

function GetParentFont(AControl: TControl): tFont;
begin
  if AControl.Parent = nil then Result := GetControlFont(AControl)
  else Result := GetControlFont(AControl.Parent);
end;

procedure SetControlFont(AControl: TControl; AFont: tFont);
begin
  if (AControl <> nil) and (AFont <> nil) then begin
    THackControl(AControl).FFont.Assign(AFont);
    AControl.Repaint;
  end;
end;

procedure SetControlColor(AControl: TControl; aColor: TColor);
begin
  if AControl <> nil then begin
    THackControl(AControl).FColor := aColor;
    AControl.Repaint;
  end;
end;

procedure SetComponentState(AComponent: TComponent; State: TComponentState);
begin
  THackComponent(AComponent).FComponentState := State;
end;

function FindComponentOnForm(Pos: TPoint; Form: TForm; CanBeForm: Boolean): TComponent;
var index: Integer;
  Component: TComponent;
  Rect     : TRect;
  DesInfo  : Longint;
  CompPos  : TPoint;
begin
  with Form do begin
    for index := 0 to ComponentCount - 1 do begin
      Component := Components[index];
      if (Component is TControl) or (Component.DesignInfo = 0) then Continue;
      DesInfo := Component.DesignInfo;
      {$IFNDEF Win32}
      CompPos := TPoint(DesInfo);
      {$ELSE}
      CompPos := SmallToPoint(TSmallPoint(DesInfo));
      {$ENDIF}
      CompPos := ClientToScreen(CompPos);
      with CompPos do Rect := Bounds(X, Y, 26, 26);
      if PtInRect(Rect, Pos) then begin
        Result := Component;
        exit;
      end;
    end;
    Result := FindDragTarget(Pos, True);
    if (Result = Form) and not (CanBeForm) then begin
      Result := nil;
      exit;
    end;
  end;
end;

function ClickAssigned(AControl: TControl): Boolean;
begin
  Result := Assigned(THackControl(AControl).FOnClick);
end;

{ Menus }
function CopyMenuItem(Owner: TComponent; FromItem: TMenuItem): TMenuItem;
var SubItem : TMenuItem;
    Index : LongInt;
begin
  Result := TMenuItem.Create(Owner);
  with Result do begin
    break := FromItem.break;
    Caption := FromItem.Caption;
    checked := FromItem.checked;
    {$IFDEF Win32}
    Default := FromItem.Default;
    MenuIndex := FromItem.MenuIndex;
    RadioItem := FromItem.RadioItem;
    {$ENDIF}
    Enabled := FromItem.Enabled;
    GroupIndex := FromItem.GroupIndex;
    HelpContext := FromItem.HelpContext;
    Hint := FromItem.Hint;
    ShortCut := FromItem.ShortCut;
    Visible := FromItem.Visible;
    {$IFDEF Delphi4_or_5}
    ImageIndex := FromItem.ImageIndex;
    {$ENDIF}
    OnClick := FromItem.OnClick;
    Tag     := FromItem.Tag;
    if FromItem.Count>0 then
      for Index := 0 to pred(FromItem.Count) do begin
          SubItem := CopyMenuItem(Owner, FromItem.Items[Index]);
          Result.Add(SubItem);
      end;
  end;
end;

function FindComponentByProperty(aOwner: TComponent;
         const PropertyName: string; var PropertyValue;
         const Compare: TSetOfCompare): TComponent;
var Index: LongInt;

  function CheckObject(Obj: TPersistent): boolean;
  var PropInfo: PPropInfo;
      TypeInfo: PTypeInfo;
      Str1,Str2: string;
   // TypeList:
   // 0 tkUnknown, *1 tkInteger, 2 tkChar, 3 tkEnumeration, *4 tkFloat, *5 tkString,
   // 6 tkSet, 7 tkClass, 8 tkMethod, 9 tkWChar, *10 tkLString, *11 tkWString,
   // 12 tkVariant, 13 tkArray, 14 tkRecord, 15 tkInterface
  begin
    Result := false;
    TypeInfo := Obj.ClassInfo;
    if TypeInfo = nil then exit; // 
    PropInfo := GetPropInfo(TypeInfo, PropertyName);
    if PropInfo = nil then exit; // 

    case PropInfo^.PropType^^.Kind of //   
      tkInteger, tkEnumeration:
         Result := GetOrdProp(Obj,PropInfo) = LongInt(PropertyValue);
      tkFloat:
         Result := GetFloatProp(Obj,PropInfo) = Extended(PropertyValue);
      tkString, tkClass, tkLString, tkWString: begin
         if cmpCaseSensitive in Compare then begin
           Str1 := GetStrProp(Obj, PropInfo);
           Str2 := string(PropertyValue);
         end
         else begin
           Str1 := AnsiUpperCase(GetStrProp(Obj,PropInfo));
           Str2 := AnsiUpperCase(string(PropertyValue));
         end;
         if cmpLike in Compare then Result := Pos(Str2, Str1) <> 0
         else Result := Str1 = Str2;
      end;
      else Result := false; //   
    end;
  end;

begin
  Result := nil; //  
  if CheckObject(aOwner) then begin
    Result := aOwner;
    exit;
  end;
  for Index := 0 to pred(aOwner.ComponentCount) do
   if CheckObject(aOwner.Components[Index]) then begin
     Result := aOwner.Components[Index];
     exit;
   end;
end;

(*
function FindMenuItemByTag (Menu : TComponent; FindTag : LongInt) : TMenuItem;

  function CheckItem (Item : TMenuItem) : TMenuItem;
  var Index : LongInt;
  begin
    Result := nil;
    if Item.Tag = FindTag then Result := Item
    else
      if Item.Count>0 then
        for Index := 0 to pred(Item.Count) do begin
          Result := CheckItem(Item.Items[Index]);
          if Result <> nil then exit;
        end;
  end;

var aIndex : LongInt;

begin
  Result := nil;
  if Menu is TMainMenu then
    with (Menu as TMainMenu) do begin
      for aIndex := 0 to pred(Items.Count) do begin
        Result := CheckItem(Items[aIndex]);
        if Result <> nil then exit;
      end;
    end
  else
    if Menu is TPopupMenu then
      with (Menu as TPopupMenu) do begin
        for aIndex := 0 to pred(Items.Count) do begin
          Result := CheckItem(Items[aIndex]);
          if Result <> nil then exit;
        end;
      end
    else
      if Menu is TMenuItem then
        with (Menu as TMenuItem) do begin
          for aIndex := 0 to pred(Count) do begin
            Result := CheckItem(Items[aIndex]);
            if Result <> nil then exit;
          end;
        end
end;
*)

function FindMenuItemByTag (Menu : TComponent; FindTag : LongInt) : TMenuItem;
begin
  Result := TMenuItem(FindComponentByProperty( GetOwnerForm(Menu),
    'Tag', FindTag, []));
end;

(*
function FindMenuItemByHotChar (Menu : TComponent; HotChar : char) : TMenuItem;

  function CheckItem (Item : TMenuItem) : TMenuItem;
  var Index : LongInt;
  begin
    Result := nil;
    if LowerCase(Item.Caption[Pos('&', Item.Caption) + 1]) = HotChar then Result := Item
    else
      if Item.Count>0 then
        for Index := 0 to pred(Item.Count) do begin
          Result := CheckItem(Item.Items[Index]);
          if Result <> nil then exit;
        end;
  end;

var aIndex : LongInt;

begin
  Result := nil;
  if Menu is TMainMenu then
    with (Menu as TMainMenu) do begin
      for aIndex := 0 to pred(Items.Count) do begin
        Result := CheckItem(Items[aIndex]);
        if Result <> nil then exit;
      end;
    end
  else
    if Menu is TPopupMenu then
      with (Menu as TPopupMenu) do begin
        for aIndex := 0 to pred(Items.Count) do begin
          Result := CheckItem(Items[aIndex]);
          if Result <> nil then exit;
        end;
      end
    else
      if Menu is TMenuItem then
        with (Menu as TMenuItem) do begin
          for aIndex := 0 to pred(Count) do begin
            Result := CheckItem(Items[aIndex]);
            if Result <> nil then exit;
          end;
        end
end;
*)

function FindMenuItemByHotChar (Menu : TComponent; HotChar : char) : TMenuItem;
var Tmp: string;
begin
  Tmp := '&' + HotChar;
  Result := TMenuItem(FindComponentByProperty(GetOwnerForm(Menu),
    'Caption', Tmp, [cmpLike]));
end;

procedure MenuItemRightAlign (Menu : TMainMenu; Item : TMenuItem);
var MenuInfo : TMENUITEMINFO;
begin
  with MenuInfo do begin
   cbSize := SizeOf(MenuInfo);
   fMask  := MIIM_TYPE;
   fType  := MFT_RIGHTJUSTIFY;
   wId    := Item.Command;
   hSubMenu   := 0;
   dwTypeData :=  PChar(Item.Caption);
   cch := length(Item.Caption);
  end;
  SetMenuItemInfo(Menu.Handle, Item.Command, FALSE, MenuInfo);
end;


procedure SetCursorPos(Memo : TMemo; XPos, YPos : integer);
var Index, Selection : integer;
begin
  if (XPos <= 0) or (XPos > 300) or
     (YPos <= 0) or (YPos > Memo.Lines.Count) then exit;
  Selection := 0;
  with Memo do begin
    for Index := 1 to YPos - 1 do
      Selection := Selection + length(Lines[Index-1]) + 2;
    Selection := Selection + XPos - 1;
    SetFocus;
    SelStart := Selection;
    SelLength := 0;
  end;
end;

procedure SetPageIndex (PageControl : TPageControl; Index : integer);
var PageChanged : TNotifyEvent;
begin
  PageControl.ActivePage := PageControl.Pages[Index];
  PageChanged := PageControl.OnChange;
  if Assigned(PageChanged) then PageChanged(PageControl);
end;

function GetPageIndex (PageControl : TPageControl) : integer;
var Index : integer;
begin
  Result := -1;
  for Index := 0 to pred(PageControl.PageCount) do begin    // Iterate
    if PageControl.ActivePage = PageControl.Pages[Index] then begin
      Result := Index;
      exit;
    end;
  end;    // for
end;

function GetOwnerForm(AComponent: TComponent): TForm;
var tmp: TComponent;
begin
  tmp := AComponent;
  while (not (tmp.Owner is TForm))
    and (tmp.Owner <> nil) do tmp := tmp.Owner;
  Result := Pointer(tmp.Owner);
end;

function FormExists (CheckForm : TForm) : boolean;
var Index : integer;
begin
  Result := (CheckForm <> nil);
  if not Result then exit;
  for Index := 0 to pred(Screen.FormCount) do
    if Screen.Forms[Index] = CheckForm then exit;
  Result := false;
end;

function FindForm(Pos: TPoint): TForm;
var index: Integer;
  Rect: TRect;
begin
  Result := nil;
  with Screen do
    for index := 0 to FormCount - 1 do begin
      Result := Forms[index];
      Rect := Result.BoundsRect;
      if PtInRect(Rect, Pos) then exit;
    end;
end;



end.
