{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
      ,  
  "Version Info"  
}
unit SoVrsInf;

{$I SOHOLIB.INC}

interface
uses Windows;

function GetVersionInfoSection (Section : string): string;
{    Section   }
function GetCompanyName: string;
{    }
function GetFileDescription: string;
{    }
function GetFileVersion: string;
{     (build) }
function GetInternalName: string;
{     }
function GetLegalCopyright: string;
{      }
function GetLegalTrademarks: string;
{      }
function GetOriginalFilename: string;
{     }
function GetProductName: string;
{     }
function GetProductVersion: string;
{     }
function GetComments: string;
{      }

implementation
uses SysUtils, Forms;

var VerBuf  : PChar;
    VerText : PChar;
    VerSize : DWORD;
    Temp : DWORD;
    SectionSize : DWORD;

procedure GetVersionInfo;
begin
  VerSize := GetFileVersionInfoSize(PChar(Application.ExeName),Temp);
  if (VerSize<>0) then begin
    GetMem(VerBuf, VerSize);
    GetFileVersionInfo(PChar(Application.ExeName),Temp, VerSize, VerBuf);
  end;
end;

{ >> Added by Serhiy Lakas <filia@uaservice.uzhgorod.ua> }
function GetTranslation: Pointer;
var Len: UINT;
begin
  Result := nil;
  if VerSize <> 0 then
   VerQueryValue(VerBuf, '\VarFileInfo\Translation', Result, Len);
end;

function GetTranslationString: string;
var P: Pointer;
begin
  Result := '';
  P := GetTranslation;
  if P <> nil then
    Result := IntToHex(MakeLong(HiWord(Longint(P^)),
                                LoWord(Longint(P^))), 8);
end;
{ << Added by Serhiy Lakas <filia@uaservice.uzhgorod.ua> }

function GetVersionInfoSection (Section : string): string;
var Tmp : array [0..254] of char;
begin
  Result := '';
  if VerSize = 0 then exit;
  StrPCopy(Tmp,'\StringFileInfo\' + GetTranslationString + '\' +Section);
  VerQueryValue(VerBuf,Tmp,pointer(VerText),SectionSize);
  Result := StrPas(VerText);
end;

function GetCompanyName: string;
begin
  Result := GetVersionInfoSection('CompanyName');
end;

function GetFileDescription: string;
begin
  Result := GetVersionInfoSection('FileDescription');
end;

function GetFileVersion: string;
begin
  Result := GetVersionInfoSection('FileVersion');
end;

function GetInternalName: string;
begin
  Result := GetVersionInfoSection('InternalName');
end;

function GetLegalCopyright: string;
begin
  Result := GetVersionInfoSection('LegalCopyright');
end;

function GetLegalTrademarks: string;
begin
  Result := GetVersionInfoSection('LegalTrademarks');
end;

function GetOriginalFileName: string;
begin
  Result := GetVersionInfoSection('OriginalFilename');
end;

function GetProductName: string;
begin
  Result := GetVersionInfoSection('ProductName');
end;

function GetProductVersion: string;
begin
  Result := GetVersionInfoSection('ProductVersion');
end;

function GetComments: string;
begin
  Result := GetVersionInfoSection('Comments');
end;

initialization
  GetVersionInfo;
finalization
  if VerSize<>0 then FreeMem(VerBuf, VerSize);
end.

