{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
unit SoDBReg;

{$I SOHOLIB.INC}

interface

procedure Register;

implementation

uses SysUtils, Classes,  SoDBGrid, SohoTree, SoCtmTre, SoDbPrp,
     SoTools, SoDBOle, SoDBNav, SoExlRep, SoDBCtrls, 
     SoCtmRgs, SohoRgst, SoDBGuide, SoTVCont, SoUnit, SoSDlgs,
     {$IFDEF Delphi6}DesignEditors, DesignIntf{$ELSE}DsgnIntf{$ENDIF}, SohoComb, SoQSrch,  SohoRec,  SoCtmFld, SoFolder, 
     SoDBGridAddon, SoEnhTreeView;

{$R SODBREG.D32}

procedure Register;
begin
  RegisterComponents ('SOHO-Controls', [
                             TsohoDBComboBox,
                             TsohoDBEdit,
                             TsohoDBGrid,
                             TsohoTreeView,
                             TsohoQuickSearch,
                             TsohoDBOleContainer,
                             TsohoDBNavigator
                             ]);

  RegisterComponents ('SOHO-Tools', [
                             TsohoFolder,
                             TsohoRegister,
                             TsohoSubRegister,
                             TsohoExcelReporter,
                             TsohoDBGridAddon
                             ]);

  RegisterComponents ('SOHO-Dialogs', [
                             TsohoRecordForm,
                             TsohoDBGuide,
                             TsohoTVContainer,
                             TsohoDirectoryDialog]);

  RegisterComponentEditor (TsohoTreeView, TsohoTreeViewEditor);
  RegisterComponentEditor (TsohoTVContainer, TsohoTreeViewEditor);

  RegisterPropertyEditor  (TypeInfo(TsohoDBGrid) , TsohoCustomTreeView,    '', TsohoSubProperty);
  RegisterPropertyEditor  (TypeInfo(TsohoEnhTreeView), TsohoCustomTreeView,    '', TsohoSubProperty);

  RegisterPropertyEditor  (TypeInfo(TSQLFileName), TsohoDBComboBox,    'SQLFile', TsohoSQLFileNameProperty);
  RegisterPropertyEditor  (TypeInfo(TSQLFileName), TsohoTVContainer, '', TsohoSQLFileNameProperty);
  RegisterPropertyEditor  (TypeInfo(TSQLFileName), TsohoDBGuide,     'SQLFile', TsohoSQLFileNameProperty);

  RegisterPropertyEditor  (TypeInfo(string)      , TComponent, 'EnabledMenus', TsohoFolderEnabledMenusProperty);

  RegisterPropertyEditor  (TypeInfo(string)      , TsohoDBComboBox, 'DataBaseName', TsohoDBNameProperty);
  RegisterPropertyEditor  (TypeInfo(string)      , TsohoRecordForm, 'DataBaseName', TsohoDBNameProperty);
  RegisterPropertyEditor  (TypeInfo(string)      , TsohoFolder, 'DataBaseName', TsohoDBNameProperty);
  RegisterPropertyEditor  (TypeInfo(string)      , TsohoDBGuide, 'DataBaseName', TsohoDBNameProperty);
  RegisterPropertyEditor  (TypeInfo(string)      , TsohoTVContainer, 'DataBaseName', TsohoDBNameProperty);
end;

end.
