{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
    TsohoDBComboBox -   
   .      
}
unit SohoComb;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Graphics, Controls,
     Forms, StdCtrls, Menus, SoUnit, SoTools, DB, SoCtmCmb;

type

  TsohoDBComboBox = class(TsohoCustomDBComboBox)
  {         .  
      (SQLFile),  ,   
         (TextField),     
     (KeyField),         IdItems.
        DataBaseName  TableName -    
        SQLFile   .   
         ItemId
  }
  private
    { Private declarations }
    FDataBaseName: string;
  protected
    { Protected declarations }
    function  ActivateSelection (SQLText : TStringList) : TDataSet;override;
    procedure DoInsertSQL (SQLText : TStringList);override;
    procedure PrepareList;override;
  published
    property DataBaseName: string read FDataBaseName write FDataBaseName;
    {     }
  end;

implementation
uses SoAppUtils, DBTables, SoCtmRgs, SoVCLUtils;

function  TsohoDBComboBox.ActivateSelection (SQLText : TStringList) : TDataSet;
var Tmp : TQuery;
begin
  PushCursor(crHourGlass);
  try
    Tmp := TQuery.Create(self);
    Tmp.SQL.Assign(SQLText);
    Tmp.DataBaseName := FDataBaseName;
    DoBeforeOpen(Tmp);
    Tmp.Open;
    Result := Tmp;
    RestoreCursor;
  except
    on E: Exception do begin
      RestoreCursor;
      ErrorMsg(Name+': '+E.Message);
      Result := nil;
    end;
  end;
end;

procedure TsohoDBComboBox.DoInsertSQL (SQLText : TStringList);
var Tmp : TQuery;
begin
  PushCursor(crHourGlass);
  try
    Tmp := TQuery.Create(self);
    Tmp.DataBaseName := FDataBaseName;
    with Tmp do begin
      SQL.Assign(SQLText);
      ExecSQL;
    end;
    RestoreCursor;
  except
    on E: Exception do begin
      RestoreCursor;
      ErrorMsg(Name+': '+E.Message);
    end;
  end;
end;

procedure TsohoDBComboBox.PrepareList;
begin
  if (FDataBaseName = '') and (SingleRegister<>nil) then
    FDataBaseName := SingleRegister.PathToData;
  inherited PrepareList;
end;

end.

