{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Igor Chernyshov              }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{$I SOHOLIB.INC}
unit SohoMultiLNG_Editor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, SoCtrls, SoGrids, SohoBtns, SoSplit, grids,
  soClass, sohoMultiLng, {$IFDEF Delphi6}DesignEditors, DesignIntf{$ELSE}DsgnIntf{$ENDIF}, SohoMultiLNGCns, 
  SoChkBox;

type
{$IFNDEF Delphi4_or_5}
  IDesigner = TDesigner;
{$ENDIF}

{        SohoMultiLNGCns -
    
}

//------------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------
  TSohoMultiLNG_Editor = class(TForm)
    MainMenu1: TMainMenu;
    MM_File: TMenuItem;
    MM_Open: TMenuItem;
    MM_Save: TMenuItem;
    MM_Saveas: TMenuItem;
    MM_Separator1: TMenuItem;
    MM_Exit: TMenuItem;
    MM_Language: TMenuItem;
    MM_Addlanguage: TMenuItem;
    MM_Separator2: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    TopPanel: TPanel;
    l_Language: TsohoLabel;
    l_LangComment: TsohoLabel;
    e_Language: TsohoEdit;
    e_LangComment: TsohoEdit;
    MM_Deletelanguage: TMenuItem;
    l_Form: TsohoLabel;
    l_Component: TsohoLabel;
    l_Property: TsohoLabel;
    cb_Form: TsohoComboBox;
    cb_Component: TsohoComboBox;
    cb_Property: TsohoComboBox;
    ClientPanel: TPanel;
    sg_Values: TsohoStringGrid;
    Btn_Add: TsohoBitBtn;
    m_Value: TMemo;
    sohoSplitter1: TsohoSplitter;
    RightPanel: TPanel;
    Btn_AddVariable: TsohoBitBtn;
    Btn_Rename: TsohoBitBtn;
    Btn_Delete: TsohoBitBtn;
    MM_Variables: TMenuItem;
    MM_Addvariable: TMenuItem;
    MM_Rename: TMenuItem;
    MM_Delete: TMenuItem;
    MM_Options: TMenuItem;
    MM_Shortpropertynames: TMenuItem;
    MM_Filter: TMenuItem;
    MM_Viewall: TMenuItem;
    MM_ViewComponents: TMenuItem;
    MM_Viewvariables: TMenuItem;
    MM_Separator3: TMenuItem;
    MM_ViewParent: TMenuItem;
    l_Filter: TsohoLabel;
    e_Filter: TsohoEdit;
    cb_UseFilter: TsohoCheckBox;
    MM_ViewNotFounded: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure MM_ExitClick(Sender: TObject);
    procedure MM_OpenClick(Sender: TObject);
    procedure MM_SaveClick(Sender: TObject);
    procedure MM_SaveasClick(Sender: TObject);
    procedure MM_AddlanguageClick(Sender: TObject);
    procedure LanguageClick(Sender: TObject);
    procedure MM_DeletelanguageClick(Sender: TObject);
    procedure cb_FormChange(Sender: TObject);
    procedure cb_ComponentChange(Sender: TObject);
    procedure cb_PropertyChange(Sender: TObject);
    procedure Btn_AddClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sg_ValuesSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure e_LanguageChange(Sender: TObject);
    procedure e_LangCommentChange(Sender: TObject);
    procedure m_ValueExit(Sender: TObject);
    procedure sg_ValuesAfterCellEdit(Sender: TObject; Col, Row: Integer);
    procedure sg_ValuesCalcCellColors(Sender: TObject; Col, Row: Integer;
      aFont: TFont; var aColor: TColor; State: TGridDrawState);
    procedure sg_ValuesCanEdit(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Btn_AddVariableClick(Sender: TObject);
    procedure Btn_RenameClick(Sender: TObject);
    procedure Btn_DeleteClick(Sender: TObject);
    procedure MM_AddvariableClick(Sender: TObject);
    procedure MM_RenameClick(Sender: TObject);
    procedure MM_DeleteClick(Sender: TObject);
    procedure MM_ShortpropertynamesClick(Sender: TObject);
    procedure MM_ViewClick(Sender: TObject);
    procedure cb_FormEnter(Sender: TObject);
    procedure MM_ViewParentClick(Sender: TObject);
    procedure cb_UseFilterChange(Sender: TObject);
    procedure e_FilterExit(Sender: TObject);
    procedure e_FilterKeyPress(Sender: TObject; var Key: Char);
    procedure m_ValueKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MM_ViewNotFoundedClick(Sender: TObject);
  private
    FCompOwner   : TComponent;
	{$IFDEF Delphi6}
    FFrmDesigner : IDesigner;
	{$ELSE}
    FFrmDesigner : IFormDesigner;
	{$ENDIF}
    FileName     : string;    //  
    OldMenuItem  : TMenuItem; //    ,    
    MenuItemTag  : Integer;   //  Tag       
    Changed      : boolean;   //     ?   ,   
    LangID       : Integer;   //  .    
    LNGHeaders   : TLNGHeaderList;
    LNGData      : TLNGDataList;
    ColWidth     : TsohoIntegerList; //   
    //MLNG        : TsohoMultiLNG;   //  - 
    Hash         : TsohoIntegerList; //   -    LNGData
                                     //    sg_Value : TsohoStringGrid
                                     //  :  Hash[1] = 4,   ,
                                     //   2-   (  
                                     // )  , 
                                     //  LNGData[4]
    //   ,      
    ShowShortNames : boolean;       //  "" (  )
                                    //  
    ViewFilter     : Integer;       //   .   :
                                    // -1 -  
                                    //  0 -  property
                                    //  1 -  
    ViewParentComp : boolean;       //     ,
                                    //  - ,   
    ViewNotFounded : boolean;       //  ,   
                                    //   
    UseNameFilter  : boolean;       //                                     
    //    
    procedure ClearData;
    //   S : String   fs : TFileStream.
    //     (word),   
    //     
    function StringToStream(const s : string; fs : TFileStream) : boolean;
    //     fs : TFileStream.
    //     (word),    > 0  
    //     
    function StringFromStream(fs : TFileStream) : string;
    //     Name      
    //     ,  -1
    // function GetVariableIndex(const Name : string) : Integer;
    //   /  
    // procedure SetVariable(const Name, Value : string; LangID : Integer);
    //   
    procedure OpenFile(const FName : string);
    //  
    procedure SaveFile(const FName : string);
    //   
    procedure AddLanguage(const LName,Comment : string);
    //  
    procedure DeleteLanguage(Num : Integer);
    //   -  ComboBox
    procedure CreateFormList;
    //   -  ComboBox.
    // .  -   
    procedure CreateComponentList(const FormName : string);
    //   -  ComboBox
    // .  -   , 
    procedure CreatePropertyList(const FormName, CompName : string);
    //     
    // .  -   , , 
    //  DataType <> 0,     FormName  CompName 
    // 
    procedure AddProperty(const FormName, CompName, PropName : string; DataID, DataType : byte);
    //  /. Num -    
    procedure DeleteProperty(Num : Integer);
    //  StringGrid     
    procedure FillGrid;
    //    CreateFormList     
    //    
    procedure GetModuleProc(const FileName, UnitName, FormName, DesignClass: string; CoClasses: TStrings);
  public
    { Public declarations }

  end;

  TsohoMultiLNGEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

  TsohoMultiLNGNameProperty = class(TStringProperty)
  public
    procedure GetValues(Proc: TGetStrProc); override;
    function GetAttributes: TPropertyAttributes; override;
  end;

var
  SohoMultiLNG__Editor: TSohoMultiLNG_Editor;

procedure ShowMultiLNGEditor(MLNG : TsohoMultiLNG; ACompOwner: TComponent; ADesigner: IDesigner;
  var File_Name : TFileName; var Lang_ID : Integer);

implementation
uses SoRTTI, SoProps, TypInfo, SoVCLUtils, SoSTRUtils, SoAppUtils,
     SoWldStr, SoDesCns;
{$R *.DFM}
//-----------------------------------------------------------------------------
// TsohoMultiLNGEditor
//-----------------------------------------------------------------------------
procedure TsohoMultiLNGEditor.ExecuteVerb(Index: Integer);
var
  FName : TFileName;
  LID   : Integer;
  ml    : TSohoMultiLNG;
begin
  ml := (Component as TSohoMultiLNG);
  if Index = 0 then begin
    FName := ml.LangFile;
    LID   := ml.LangID;
    ShowMultiLNGEditor(ml,TComponent(ml.Owner),Designer,FName, LID);
    if (Component as TSohoMultiLNG).LangFile <> FName then begin
      (Component as TSohoMultiLNG).LangFile := FName;
      Designer.Modified;
    end; {--- if ---}
    if (Component as TSohoMultiLNG).LangID <> LID then begin
      (Component as TSohoMultiLNG).LangID := LID;
      Designer.Modified;
    end; {--- if ---}
  end;
end;

function TsohoMultiLNGEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := '&MultiLanguage Editor';
    else Result := '';
  end;
end;

function TsohoMultiLNGEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ Show component editor }
procedure ShowMultiLNGEditor(MLNG : TsohoMultiLNG; ACompOwner: TComponent; ADesigner: IDesigner;
  var File_Name : TFileName; var Lang_ID : Integer);
begin
  with TSohoMultiLNG_Editor.Create(Application) do
  try
    FileName      := File_Name;
    FCompOwner    := ACompOwner;
	{$IFDEF Delphi6}
    FFrmDesigner  := ADesigner;
	{$ELSE}
    FFrmDesigner  := ADesigner as IFormDesigner;
	{$ENDIF}
    if File_Name <> '' then OpenFile(File_Name);
    Application.ProcessMessages;
    if Lang_ID <> -1 then LanguageClick(MM_Language.Items[3+Lang_ID]);
    ShowModal;
    File_Name := FileName;
    Lang_ID   := LangID;
    Application.ProcessMessages;
  finally
    Free;
  end;
end;

//-----------------------------------------------------------------------------
// TsohoMultiLNGNameProperty
//-----------------------------------------------------------------------------

function TsohoMultiLNGNameProperty.GetAttributes : TPropertyAttributes;
begin
  Result := [paValueList];
end;

procedure TsohoMultiLNGNameProperty.GetValues(Proc : TGetStrProc);
var
  i : Integer;
Begin
  for i := 0 to pred((GetComponent(0) as TsohoMultiLNG).LanguageCount) do begin
    Proc((GetComponent(0) as TsohoMultiLNG).GetLanguageName(i));
  end; {--- for ---}
end;

//------------------------------------------------------------------------------
// PRIVATE
//------------------------------------------------------------------------------

//   
procedure TSohoMultiLNG_Editor.ClearData;
begin
  while LNGHeaders.Count >0 do begin
    Dispose(PLNGHeader(LNGHeaders[0]));
    LNGHeaders.Delete(0);
  end; {--- while ---}
  while LNGData.Count > 0 do begin
    PLNGData(LNGData[0]).LNG_Value.Free;
    Dispose(PLNGData(LNGData[0]));
    LNGData.Delete(0);
  end; {--- while ---}
  OldMenuItem := nil;
  MenuItemTag := 1;
  //  
  while MM_Language.Count > 3 do  MM_Language.Delete(3);
end;

//    
function TSohoMultiLNG_Editor.StringToStream(const s : string; fs : TFileStream) : boolean;
var
  W : word;
begin
  Result := True;
  try
    w := Length(S);
    fs.WriteBuffer(w, SizeOf(W));
    if w > 0 then fs.WriteBuffer(PChar(S)^,W+1);
  except
    raise;
    Result := False;
  end; {--- try/except ---}
end;

function TSohoMultiLNG_Editor.StringFromStream(fs : TFileStream) : string;
var
  w : word;
  p : PChar;
begin
  Result := '';
  //   
  fs.Read(w, SizeOf(W));
  if w > 0 then begin
    GetMem(P,W+1);
    FillChar(P^,W,#0);
    fs.read(P^,W+1);
    //SetLength(Result,W);
    Result := String(P);
    FreeMem(P);
  end; {--- IF ---}
end;

//     Name      
//     ,  -1
{function TSohoMultiLNG_Editor.GetVariableIndex(const Name : string) : Integer;
var
  i : Integer;
begin
  Result := -1;
  i := 0;
  while (i < LNGData.Count) AND (PLNGData(LNGData[i]).LNG_FieldName <> Name)
    do inc(i);
  if i < LNGData.Count then Result := i;
end;}

//   /  
{procedure TSohoMultiLNG_Editor.SetVariable(const Name, Value : string; LangID : Integer);
var
  i : Integer;
begin
  i := GetVariableIndex(Name);
  if i <> -1 then PLNGData(LNGData[i]).LNG_Value[LangID] := Value;
end;}

//   
procedure TSohoMultiLNG_Editor.OpenFile(const FName : string);
var
  fs       : TFileStream;
  s        : string;
  LngCount : word;
  i        : Integer;
  j        : Integer;
  tsl      : TStringList;
  DataID   : byte;
  DataType : byte;
  VarCount : Integer;
  ColCount : Integer;
begin
  ClearData;
  //  
  try
    fs := TFileStream.Create(FName, fmOpenRead);
  except
    raise;
  end; {--- try/except---}

  // ---   
  try
    tsl := TStringList.Create;
    //     -  - 
    s := StringFromStream(fs);
    if s <> 'SohoMultiLNG' then begin
      ErrorMsg( Format(sohoMultiLNG_NotLngFile,[FName]));
      Exit;
    end; {--- if ---}
    //   
    fs.Read(LngCount, SizeOF(LngCount));
    for i := 0 to pred(LngCount) do begin
      // 
      S := '';
      S := StringFromStream(fs);
      AddLanguage(S,StringFromStream(fs));
      // . 
      fs.ReadBuffer(PLNGHeader(LNGHeaders[i])^.LNG_RESERVED, SizeOf(PLNGHeader(LNGHeaders[i])^.LNG_RESERVED));
    end; {--- for ---}
    //  - 
    fs.Read(VarCount, SizeOf(VarCount));
    //   
    i := 0;
    while (i < VarCount) do begin
      //  
      fs.Read(DataID, SizeOf(DataID));
      fs.Read(DataType, SizeOf(DataType));
      S := StringFromStream(fs);
      tsl.Clear;
      SplitString(S,'.',tsl);
      case DataID of
        0: AddProperty(tsl[0],tsl[1],tsl[2],DataID,DataType);
        1: AddProperty('','',tsl[0],DataID,DataType);
      end; {--- case ---}

      PLNGData(LNGData[i]).LNG_Value.Text := StringFromStream(fs);
      inc(i);
    end; {--- while ---}

    //  ViewParentComp
    fs.Read(ViewParentComp,SizeOf(ViewParentComp));
    MM_ViewParent.Checked := ViewParentComp;

    FillGrid;
    //     
    fs.Read(ColCount, SizeOf(ColCount));
    //   
    for i := 0 to pred(colcount) do begin
      fs.Read(j, SizeOf(j));
      sg_Values.ColWidths[i]:= j;
    end; {--- for ---}

  finally
    fs.Free;
    tsl.Free;
  end; {--- try/finally---}
  Caption  := FName;
  FileName := FName;
  Changed := False;
end;

//  
procedure TSohoMultiLNG_Editor.SaveFile(const FName : string);
var
  fs : TFileStream;
  s  : string;
  i  : Integer;
  j  : Integer;
begin
  // ---  
  try
    fs := TFileStream.Create(FName, fmCreate);
  except
    raise;
    Exit;
  end; {--- try/except ---}
  // ---   
  try
    //  
    s := 'SohoMultiLNG';
    StringToStream(s,fs);
    //    
    fs.WriteBuffer(LNGHeaders.count,SizeOf(Word));
    for i := 0 to pred(LNGHeaders.Count) do begin
      StringToStream(PLNGHeader(LNGHeaders[i]).LNG_Name,fs);
      StringToStream(PLNGHeader(LNGHeaders[i]).LNG_Comment,fs);
      fs.WriteBuffer(PLNGHeader(LNGHeaders[i])^.LNG_RESERVED, SizeOf(PLNGHeader(LNGHeaders[i])^.LNG_RESERVED));
    end; {--- for ---}
    //   
      fs.Write(LNGData.Count, SizeOf(LNGData.Count));
    //   
    for i := 0 to pred(LNGData.Count) do begin
      fs.Write(PLNGData(LNGData[i]).LNG_DataID, SizeOf(PLNGData(LNGData[i]).LNG_DataID));
      fs.Write(PLNGData(LNGData[i]).LNG_DataType, SizeOf(PLNGData(LNGData[i]).LNG_DataType));
      StringToStream(PLNGData(LNGData[i]).LNG_FieldName, fs);
      StringToStream(PLNGData(LNGData[i]).LNG_Value.Text, fs);
    end; {--- for ---}

    // ---    
    //  ViewParentComp
    fs.Write(ViewParentComp,SizeOf(ViewParentComp));
    //     
    j := sg_Values.colcount;
    fs.Write(j, SizeOf(j));
    //   
    for i := 0 to pred(sg_Values.colcount) do begin
      j := sg_Values.ColWidths[i];
      fs.Write(j, SizeOf(j));
    end; {--- for ---}
  finally
    fs.Free;
  end; {--- try/finally ---}
  Caption  := FName;
  FileName := FName;
  Changed := False;
end;

//  
procedure TSohoMultiLNG_Editor.AddLanguage(const LName, Comment : string);
var
  mi : TMenuItem;
  P  : PLNGHeader;
  i  : Integer;
begin
  //    
  mi := TMenuItem.Create(MM_Language);
  mi.Caption   := LName;
  mi.OnClick   := LanguageClick;
  mi.Tag       := MenuItemTag;
  inc(MenuItemTag);
  MM_Language.Add(mi);
  //    " "
  MM_Deletelanguage.Enabled := True;
  //    
  New(P);
  P.LNG_Name    := LName;
  P.LNG_Comment := Comment;
  FillChar(P.LNG_RESERVED,64,0);
  LNGHeaders.Add(P);
  for i := 0 to pred(LNGData.Count) do begin
    TStringList(PLNGData(LNGData[i]).LNG_Value).Add('');
  end; {--- for ---}

  LanguageClick(mi);
end;

//  
procedure TSohoMultiLNG_Editor.DeleteLanguage(Num : Integer);
var
  i : Integer;
begin
  //   
  MM_Language.Delete(2+Num);
  //     Tag  -1
  for i := 2+Num to pred(MM_Language.Count) do begin
    MM_Language.Items[i].Tag := MM_Language.Items[i].Tag -1;
  end;
  // ,     " "
  MM_Deletelanguage.Enabled := MM_Language.Count > 3;
  //    StringGrid
  sg_Values.DeleteColumn(Num+1);
  //    
  Dispose(PLNGHeader(LNGHeaders[Num-1]));
  LNGHeaders.Delete(Num-1);
  //   ,    
  for i := 0 to pred(LNGData.Count) do begin
    PLNGData(LNGData[i])^.LNG_Value.Delete(Num);
  end; {--- for ---}
end;

//   
procedure TSohoMultiLNG_Editor.CreateFormList;
begin
  cb_Form.Items.Clear;
  //cb_Form.Items.Add('SohoMultiLNG_Editor');
  if FFrmDesigner <> nil then begin
    FFrmDesigner.GetProjectModules(GetModuleProc);
  end; {--- if ---}
end;

//   -  ComboBox
procedure TSohoMultiLNG_Editor.CreateComponentList(const FormName : string);
var
  i : Integer;
  BaseForm : TComponent;
begin
  cb_Component.Items.Clear;
  BaseForm := GetScreenFormByName(FormName);
  if BaseForm = nil then Exit;
  //       
  for i := 0 to pred(BaseForm.ComponentCount) do begin
    if BaseForm.Components[i].Name <> ''
      then cb_Component.Items.Add(BaseForm.Components[i].Name);
  end; {--- for ---}
  cb_Component.Sorted := True;
end;

// .  -   
procedure TSohoMultiLNG_Editor.CreatePropertyList(const FormName, CompName : string);
var
  i        : Integer;
  BaseForm : TComponent;
  BaseComp : TComponent;
  Props    : TsohoPropInfoList;
  Prs      : TPersistent;
begin
  cb_Property.Items.Clear;
  //    
  BaseForm := GetScreenFormByName(FormName);
  if BaseForm = nil then Exit;
  //    
  BaseComp := BaseForm.FindComponent(CompName);
  if BaseComp = nil then Exit;
  //   
  Props := TsohoPropInfoList.Create(BaseComp, tkProperties);
  for i := 0 to pred(Props.Count) do begin
    // ,    
    if Props.Items[i].PropType^.Kind = tkLString
      then cb_Property.Items.Add(Props.Items[i].Name);
    // ,    TStrings
    if Props.Items[i].PropType^.Kind = tkClass then begin
        Prs := GetClassProperty(BaseComp, Props.Items[i].Name);
        if (Prs is TStrings) then cb_Property.Items.Add(Props.Items[i].Name);
    end; {--- if ---}
  end; {--- for ---}
  Props.Free;
end;

//     
procedure TSohoMultiLNG_Editor.AddProperty(const FormName, CompName, PropName : string; DataID, DataType : byte);
var
  i        : Integer;
  P        : PLNGData;
  FullName : string;
begin
  //     
  case DataID of
    0 : FullName := FormName+'.'+CompName+'.'+PropName;
    1 : FullName := PropName;
  end; {--- case ---}
  //    
  New(P);
  P.LNG_DataID    := DataID;
  P.LNG_DataType  := DataType;
  P.LNG_FieldName := FullName;
  LNGData.Add(P);
  PLNGData(LNGData[LNGData.Count-1]).LNG_Value     := TStringList.Create;
  for i := 0 to pred(LNGHeaders.Count) do begin
    TStringList(PLNGData(LNGData[LNGData.Count-1]).LNG_Value).Add('');
  end; {--- for ---}
  //     
  Btn_Rename.Enabled := True;
  Btn_Delete.Enabled := True;
  MM_Rename.Enabled := True;
  MM_Delete.Enabled := True;
end;

//  / Num -    
procedure TSohoMultiLNG_Editor.DeleteProperty(Num : Integer);
begin
  //  
  PLNGData(LNGData[Hash[Num-1]]).LNG_Value.Free;
  Dispose(PLNGData(LNGData[Hash[Num-1]]));
  LNGData.Delete(Hash[Num-1]);
  //   Hash
  Hash.Delete(Num-1);

  //   
  if sg_Values.RowCount = 2
    then begin
           sg_Values.Rows[1].Text := '';
           Btn_Rename.Enabled     := False;
           Btn_Delete.Enabled     := False;
           MM_Rename.Enabled      := False;
           MM_Delete.Enabled      := False;
    end;
  FillGrid;
  //  
  if Num >= sg_Values.RowCount
    then sg_Values.Row := Num-1
    else sg_Values.Row := Num;
end;

procedure TSohoMultiLNG_Editor.FillGrid;
var
  i        : Integer;
  j        : Integer;
  BaseForm : TComponent;
  BaseComp : TComponent;
  DataID   : byte;
  tsl      : TStringList;
  ViewData : boolean;
  PropComp : TPersistent;
begin
  tsl := TStringList.Create;
  //  
  sg_Values.RowCount := 2;
  for i := 0 to pred(sg_Values.ColCount) do begin
    sg_Values.Cells[i,1] := '';
  end; {--- for ---}
  Hash.Clear;

  //     - 
  sg_Values.ColCount := 2 + LNGHeaders.Count;
  for i := 0 to pred(LNGHeaders.Count) do begin
    sg_Values.Cells[i + 2,0] := PLNGHeader(LNGHeaders[i]).LNG_Name;
  end; {--- for ---}

  // ---   
  for i := 0 to pred(LNGData.Count) do begin
    DataID := PLNGData(LNGData[i]).LNG_DataID;
    //    -     
    ViewData := ((DataID = ViewFilter) OR (ViewFilter = -1));
    // ,     
    tsl.Clear;
    SplitString(PLNGData(LNGData[i]).LNG_FieldName,'.',tsl);
    if ViewParentComp then begin
       if (DataID = 0) AND (FCompOwner <> nil)
         then ViewData := (ViewData AND (tsl[0] = FCompOwner.Name));
    end; {--- if ---}
    // ,   ,    
    if (ViewNotFounded) AND (DataID = 0) then begin
      BaseForm := GetScreenFormByName(tsl[0]);
      if BaseForm <> nil
        then ViewData := (ViewData) AND (BaseForm.FindComponent(tsl[1]) = nil);
    end;   {--- if ---}
    if UseNameFilter then begin
      ViewData := (ViewData AND
                   (WildStringCompare(PLNGData(LNGData[i]).LNG_FieldName,
                                      e_Filter.Text
                                      )
                   ));
    end; {--- if ---}
    if ViewData then begin
      //    
      if sg_Values.Cells[0,1] <> '' then sg_Values.RowCount := sg_Values.RowCount+1;
      //         Hash
      //   
      if not ShowShortNames
        then sg_Values.Cells[0,sg_Values.RowCount-1] := PLNGData(LNGData[i]).LNG_FieldName
        else sg_Values.Cells[0,sg_Values.RowCount-1] := Copy (PLNGData(LNGData[i]).LNG_FieldName,pos('.',PLNGData(LNGData[i]).LNG_FieldName)+1,255);

      //   .      
      //         
      //    
      sg_Values.Cells[1,sg_Values.RowCount-1] := '';
      if DataID = 0 then begin
        tsl.Clear;
        SplitString(PLNGData(LNGData[i]).LNG_FieldName,'.',tsl);
        //    
        BaseForm := GetScreenFormByName(tsl[0]);
        if BaseForm <> nil then begin
          //    
          BaseComp := BaseForm.FindComponent(tsl[1]);

          //   "" 
          if BaseComp <> nil then begin
            PLNGData(LNGData[i]).LNG_NotFound := 0;
            case PLNGData(LNGData[i]).LNG_DataType of
              //   : String
              0: sg_Values.Cells[1,sg_Values.RowCount-1] := GetStringProperty(BaseComp, tsl[2]);
              //   : TStrings
              1: begin
                   PropComp := GetClassProperty(BaseComp, tsl[2]);
                   if (PropComp is TStrings)
                     then sg_Values.Cells[1,sg_Values.RowCount-1] :=
                            ReplaceSTR((PropComp as TStrings).Text,
                                       sohoMultiLNG_CRLF,
                                       sohoMultiLNG_ReplaceCRLF);
                 end; {--- 1 ---}
            end; {--- case ---}
          end else begin
            PLNGData(LNGData[i]).LNG_NotFound := 1;
          end; {--- if BaseComp ---}

        end; {--- if ---}
      end; {--- if ---}
      //   /   
      for j := 0 to pred(PLNGData(LNGData[i]).LNG_Value.Count) do begin
        sg_Values.Cells[j+2,sg_Values.RowCount-1] := PLNGData(LNGData[i]).LNG_Value[j];
      end; {--- for ---}
      Hash.Add(i);
    end; {--- if ViewData  ---}
  end; {--- for ---}
  tsl.Free;
end;

procedure TSohoMultiLNG_Editor.GetModuleProc(const FileName, UnitName, FormName, DesignClass: string; CoClasses: TStrings);
begin
  if FormName <> '' then
    if GetScreenFormByName(FormName) <> nil then cb_Form.Items.Add(FormName);
end;
//------------------------------------------------------------------------------
// PUBLIC
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
// Events
//------------------------------------------------------------------------------
//  
procedure TSohoMultiLNG_Editor.FormCreate(Sender: TObject);
begin
  FileName        := '';
  Caption         := '';
  OldMenuItem     := nil;
  MenuItemTag     := 1;
  LangID          := -1;
  ShowShortNames  := False;
  ViewFilter      := -1;
  ViewParentComp  := False;
  UseNameFilter   := False;
  Changed         := False;
  Hash            := TsohoIntegerList.Create;
  ColWidth        := TsohoIntegerList.Create;
  LNGHeaders      := TLNGHeaderList.Create;
  LNGData         := TLNGDataList.Create;
  FCompOwner      := nil;
  FFrmDesigner    := nil;

  MM_File.Caption := sohoMLEditorFile;
  MM_Open.Caption := sohoMLEditorOpen;
  MM_Save.Caption := sohoMLEditorSave;
  MM_Saveas.Caption := sohoMLEditorSaveAs;
  MM_Exit.Caption := sohoMLEditorExit;
  MM_Language.Caption := sohoMLEditorLanguage;
  MM_Addlanguage.Caption := sohoMLEditorAddLanguage;
  MM_Deletelanguage.Caption := sohoMLEditorDeleteLanguage;
  l_Language.Caption := sohoMLEditorLanguageLabel;
  l_LangComment.Caption := sohoMLEditorLangComment;
  l_Form.Caption := sohoMLEditorForm;
  l_Component.Caption := sohoMLEditorComponent;
  l_Property.Caption := sohoMLEditorProperty;
  Btn_Add.Caption := sohoMLEditorBtnAdd;
  Btn_AddVariable.Caption := sohoMLEditorBtnAddVariable;
  Btn_Rename.Caption := sohoMLEditorBtnRename;
  Btn_Delete.Caption := sohoMLEditorBtnDelete;
  MM_Variables.Caption := sohoMLEditorVariables;
  MM_Addvariable.Caption := sohoMLEditorAddVariable;
  MM_Rename.Caption := sohoMLEditorRename;
  MM_Delete.Caption := sohoMLEditorDelete;
  MM_Options.Caption := sohoMLEditorOptions;
  MM_Shortpropertynames.Caption := sohoMLEditorShortPropertyNames;
  MM_Filter.Caption := sohoMLEditorFilter;
  MM_Viewall.Caption := sohoMLEditorViewAll;
  MM_ViewComponents.Caption := sohoMLEditorViewComponents;
  MM_Viewvariables.Caption := sohoMLEditorViewVariables;
  MM_ViewParent.Caption := sohoMLEditorViewParent;
  l_Filter.Caption := sohoMLEditorFilterLabel;
  cb_UseFilter.Caption := sohoMLEditorUseFilter;
  MM_ViewNotFounded.Caption := sohoMLEditorViewNotFound;

  sg_Values.Cells[0, 0] := sohoMLEditorProperty;
  sg_Values.Cells[0, 1] := sohoMLEditorOrogonalValue;

  OpenDialog1.Filter := sohoMLEditorFileMask;
  SaveDialog1.Filter := sohoMLEditorFileMask;
end;

//  
procedure TSohoMultiLNG_Editor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if Changed then begin
    case YesNoCancel(sohoMultiLNG_DataChanged) of
      mrYes    : begin
                   MM_SaveClick(MM_Save);
                   Application.ProcessMessages;
                 end;  
      mrCancel : Action := caNone;
    end; {--- case ---}
  end; {--- if ---}
  ClearData;
  Hash.Free;
  ColWidth.Free;
  LNGHeaders.Free;
  LNGData.Free;
  //MLNG.Free;
end;

//  
procedure TSohoMultiLNG_Editor.cb_FormChange(Sender: TObject);
begin
  if cb_Form.ItemIndex = -1 then Exit;
  CreateComponentList(cb_Form.Items[cb_Form.ItemIndex]);
end;

//  
procedure TSohoMultiLNG_Editor.cb_ComponentChange(Sender: TObject);
begin
  if cb_Component.ItemIndex = -1 then Exit;
  CreatePropertyList(cb_Form.Items[cb_Form.ItemIndex], cb_Component.Items[cb_Component.ItemIndex]);
  Btn_Add.Enabled := False;
end;

//  
procedure TSohoMultiLNG_Editor.cb_PropertyChange(Sender: TObject);
begin
  Btn_Add.Enabled := cb_Property.ItemIndex <> -1;
end;

//  ""
procedure TSohoMultiLNG_Editor.Btn_AddClick(Sender: TObject);
var
  BaseForm : TComponent;
  BaseComp : TComponent;
  Prs      : TPersistent;
  DataType : Integer;
begin
  DataType := 0;
  //   
  //    
  BaseForm := GetScreenFormByName(cb_Form.Items[cb_Form.ItemIndex]);
  if BaseForm = nil then Exit;
  //    
  BaseComp := BaseForm.FindComponent(cb_Component.Items[cb_Component.ItemIndex]);
  if BaseComp = nil then Exit;
{$IFNDEF DELPHI5}
  case PropType(BaseComp, cb_Property.Items[cb_Property.ItemIndex])^.Kind of
{$ELSE}
  case PropType(BaseComp, cb_Property.Items[cb_Property.ItemIndex]) of
{$ENDIF}
    tkLString : DataType := 0;
    tkClass   : begin
                  Prs := GetClassProperty(BaseComp,
                                          cb_Property.Items[cb_Property.ItemIndex]);
                  if (Prs is TStrings) then DataType := 1
                end;
  end; {--- case ---}

  AddProperty(cb_Form.Items[cb_Form.ItemIndex],
              cb_Component.Items[cb_Component.ItemIndex],
              cb_Property.Items[cb_Property.ItemIndex],
              0,DataType
              );
  FillGrid;
  Changed := True;
  sg_Values.Row := sg_Values.RowCount -1;
end;

//   
procedure TSohoMultiLNG_Editor.e_LanguageChange(Sender: TObject);
begin
  PLNGHeader(LNGHeaders[OldMenuItem.Tag-1]).LNG_Name := e_Language.Text;
end;

//  
procedure TSohoMultiLNG_Editor.e_LangCommentChange(Sender: TObject);
begin
  if PLNGHeader(LNGHeaders[OldMenuItem.Tag-1]).LNG_Comment <> e_LangComment.Text
  then begin
    Changed := True;
    PLNGHeader(LNGHeaders[OldMenuItem.Tag-1]).LNG_Comment := e_LangComment.Text;
  end; {--- if ---}
end;

// ,       
procedure TSohoMultiLNG_Editor.sg_ValuesCanEdit(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  CanSelect := (ACol > 1) AND (Hash.Count > 0);
end;

//     Memo
procedure TSohoMultiLNG_Editor.sg_ValuesSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  m_Value.ReadOnly := (ACol < 2) OR (ARow <1);
  m_Value.Lines.Text := ReplaceSTR(sg_Values.Cells[ACol, ARow],
                                   sohoMultiLNG_ReplaceCRLF,
                                   sohoMultiLNG_CRLF);
end;

//     -        
procedure TSohoMultiLNG_Editor.m_ValueExit(Sender: TObject);
begin
  if (sg_Values.Col < 2) OR (sg_Values.Row <1) then begin
    m_Value.ReadOnly := True;
  end else begin
    sg_Values.Cells[sg_Values.Col, sg_Values.Row] :=
      ReplaceSTR(m_Value.Lines.Text,sohoMultiLNG_CRLF,sohoMultiLNG_ReplaceCRLF);
    PLNGData(LngData[Hash[sg_Values.Row-1]]).LNG_Value[sg_Values.Col-2] :=
      ReplaceSTR(m_Value.Lines.Text,sohoMultiLNG_CRLF,sohoMultiLNG_ReplaceCRLF);
    Changed := True;
  end; {--- if ---}
end;

//      -        
procedure TSohoMultiLNG_Editor.sg_ValuesAfterCellEdit(Sender: TObject; Col,
  Row: Integer);
begin
  PLNGData(LngData[Hash[Row-1]]).LNG_Value[Col-2] := sg_Values.Cells[Col, Row];
  Changed := True;
end;

//     
procedure TSohoMultiLNG_Editor.sg_ValuesCalcCellColors(Sender: TObject;
  Col, Row: Integer; aFont: TFont; var aColor: TColor;
  State: TGridDrawState);
begin
  if Col = 0 then begin
    if Row <= Hash.Count then
    case PLNGData(LNGData[Hash[Row-1]]).LNG_DataID of
      0 : aFont.Color := clNavy;
      1 : aFont.Color := clGreen;
    end; {--- CASE ---}
    if PLNGData(LNGData[Hash[Row-1]]).LNG_NotFound = 1
      then aFont.Color := clMaroon;
  end; {--- if ---}

end;

//   
procedure TSohoMultiLNG_Editor.Btn_AddVariableClick(Sender: TObject);
var
  s : string;
begin
  If InputQuery(sohoMultiLNG_NewVar,sohoMultiLNG_EnterNewVar,S) then
    if s <> '' then begin
      AddProperty('','',s,1,0);
      FillGrid;
      sg_Values.row := sg_Values.RowCount-1;
      if sg_Values.ColCount > 2
        then sg_Values.Col := 2
        else sg_Values.Col := 0;
      sg_Values.SetFocus;
      Changed := True;
    end; {--- if ---}
end;

//  
procedure TSohoMultiLNG_Editor.Btn_RenameClick(Sender: TObject);
var
  s : string;
begin
  s := PLNGData(LNGData[Hash[sg_Values.Row-1]]).LNG_FieldName;
  if InputQuery(sohoMultiLNG_RenVar,sohoMultiLNG_EnterRenVar,S) then
    if s <> '' then begin
      PLNGData(LNGData[Hash[sg_Values.Row-1]]).LNG_FieldName := S;
      sg_Values.Cells[0, sg_Values.Row] := s;
      Changed := True;
    end; {--- if ---}
end;

//  
procedure TSohoMultiLNG_Editor.Btn_DeleteClick(Sender: TObject);
begin
 if YesNoMsg(sohoMultiLNG_DeleteVar) then begin
   DeleteProperty(sg_Values.Row);
   Application.ProcessMessages;
   Changed := True;
 end; {--- if ---}
end;

procedure TSohoMultiLNG_Editor.cb_FormEnter(Sender: TObject);
begin
  CreateFormList;
end;

//  " "
procedure TSohoMultiLNG_Editor.cb_UseFilterChange(Sender: TObject);
begin
  UseNameFilter := cb_UseFilter.Checked;
  FillGrid;
end;

//   
procedure TSohoMultiLNG_Editor.e_FilterExit(Sender: TObject);
begin
  FillGrid;
end;

//   ,    Enter
procedure TSohoMultiLNG_Editor.e_FilterKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = #13 then FillGrid;
end;

//          Memo
procedure TSohoMultiLNG_Editor.m_ValueKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Shift <> [ssCTRL] then Exit;
  if not (Key in [VK_DOWN, VK_UP, VK_LEFT, VK_RIGHT]) then exit;
  m_ValueExit(m_Value);
  case Key of
    VK_DOWN : if sg_Values.Row < sg_Values.RowCount-1
                then sg_Values.Row := sg_Values.Row + 1;
    VK_UP   : if sg_Values.Row > 1
                then sg_Values.Row := sg_Values.Row - 1;
    VK_LEFT : if sg_Values.Col > 0
                then sg_Values.Col := sg_Values.Col - 1;
    VK_RIGHT: if sg_Values.Col < sg_Values.ColCount-1
                then sg_Values.Col := sg_Values.Col + 1;
  end; {--- case ---}
end;

//------------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------
// 
procedure TSohoMultiLNG_Editor.MM_ExitClick(Sender: TObject);
begin
  Close;
end;

//  
procedure TSohoMultiLNG_Editor.MM_OpenClick(Sender: TObject);
begin
  if OpenDialog1.Execute then OpenFile(OpenDialog1.FileName);
end;

//  
procedure TSohoMultiLNG_Editor.MM_SaveClick(Sender: TObject);
begin
  if FileName = ''
    then MM_SaveasClick(MM_Saveas)
    else SaveFile(FileName);
end;

//  
procedure TSohoMultiLNG_Editor.MM_SaveasClick(Sender: TObject);
begin
  if SaveDialog1.Execute then SaveFile(SaveDialog1.FileName);
end;

//   
procedure TSohoMultiLNG_Editor.MM_AddlanguageClick(Sender: TObject);
var
  s : string;
begin
  if InputQuery(sohoMultiLNG_EnterNewLang,sohoMultiLNG_NewLang,s) then
    if s <> '' then begin
      AddLanguage(S,'');
      FillGrid;
      Changed := True;
    end; {--- if ---}
end;

//  
procedure TSohoMultiLNG_Editor.MM_DeletelanguageClick(Sender: TObject);
begin
  if OldMenuItem <> nil then
    if YesNoMsg(sohoMultiLNG_DeleteLang)
     then begin
       DeleteLanguage(OldMenuItem.Tag);
       FillGrid;
       Changed := True;
     end; {--- if ---}
end;

//    
procedure TSohoMultiLNG_Editor.LanguageClick(Sender: TObject);
begin
 if OldMenuItem <> nil then OldMenuItem.Checked := False;
 (Sender as TMenuItem).Checked := True;
 OldMenuItem := (Sender as TMenuItem);
 LangID := (Sender as TMenuItem).Tag-1;
 e_Language.Text    := PLNGHeader(LNGHeaders[LangID]).LNG_Name;
 e_LangComment.Text := PLNGHeader(LNGHeaders[LangID]).LNG_Comment;
end;

//  
procedure TSohoMultiLNG_Editor.MM_AddvariableClick(Sender: TObject);
begin
  Btn_AddClick(Btn_Add);
end;

//  
procedure TSohoMultiLNG_Editor.MM_RenameClick(Sender: TObject);
begin
  Btn_RenameClick(Btn_Rename);
end;

//  
procedure TSohoMultiLNG_Editor.MM_DeleteClick(Sender: TObject);
begin
  Btn_DeleteClick(Btn_Delete);
end;

//   
procedure TSohoMultiLNG_Editor.MM_ShortpropertynamesClick(Sender: TObject);
begin
  MM_Shortpropertynames.Checked := not MM_Shortpropertynames.Checked;
  ShowShortNames := MM_Shortpropertynames.Checked;
  FillGrid;
end;

//   
procedure TSohoMultiLNG_Editor.MM_ViewClick(Sender: TObject);
begin
  MM_Filter.Items[ViewFilter+1].Checked := False;
  ViewFilter := (Sender as TMenuItem).Tag;
  MM_Filter.Items[ViewFilter+1].Checked := True;
  FillGrid;
end;

//    ,      SohoMultiLNG
procedure TSohoMultiLNG_Editor.MM_ViewParentClick(Sender: TObject);
begin
  ViewParentComp := not ViewParentComp;
  MM_ViewParent.Checked := ViewParentComp;
  FillGrid;
end;

//    ,     
procedure TSohoMultiLNG_Editor.MM_ViewNotFoundedClick(Sender: TObject);
begin
  ViewNotFounded := not ViewNotFounded;
  MM_ViewNotFounded.Checked := ViewNotFounded;
  FillGrid;
end;

end.
