{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{     TsohoRecordForm - ,  
       
}
unit SohoRec;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Controls, SoCtmRec, DBTables;

type

  TsohoRecordForm = class(TsohoCustomRecordForm)
  { TsohoRecordForm - ,       
     .   TDataSet,    SQL
       .      ,
        SQL-    
    
  }
  private
    FDataBaseName: TFileName;
    Query : TQuery;
  protected
    function  RunUpdateSQL (SQLText : TStringList) : boolean;override;
    function  RunInsertSQL (SQLText : TStringList) : boolean;override;
    procedure PrepareCard; override;
    procedure SetMemoFields;
  published
    property DataBaseName: TFileName read FDataBaseName write FDataBaseName;
    {     }
  end;

implementation
uses SoVCLUtils, SoCtmRgs, SoDBCns, StdCtrls, DB, SoAppUtils;

procedure TsohoRecordForm.PrepareCard;
begin
  if (FDataBaseName = '') and (SingleRegister<>nil) then
    FDataBaseName := SingleRegister.PathToData;
  inherited PrepareCard;
end;

procedure TsohoRecordForm.SetMemoFields;
var I, Index : LongInt;
    Strm : TMemoryStream;
    FieldControl : TWinControl;
begin
  I := 0;
  for Index := 0 to pred(Folder.DataSet.FieldCount) do
    if Folder.DataSet.Fields[Index] is TMemoField then begin
      Strm := TMemoryStream.Create;
      FieldControl := DialogForm.GetControlByIndex(index);
      TMemo(FieldControl).Lines.SaveToStream(Strm);
      Strm.Position := 0;
      Query.Params[I].LoadFromStream(Strm, ftMemo);
      inc(I);
      Strm.Free;
    end;
end;

function TsohoRecordForm.RunUpdateSQL (SQLText : TStringList) : boolean;
begin
  try
    Query := TQuery.Create(Self);
    Query.DataBaseName := DataBaseName;
    with Query do begin
     PushCursor(crHourGlass);
     SQL.Assign(SQLText);
     SetMemoFields;
     ExecSQL;
     Result := True;
     DoAfterSQLExecute;
    end;
  except
   on E: Exception do begin
     Result := false;
     ErrorMsg(Format(sohoRecFormUpdateError, [Self.name, E.Message]));
   end;  
  end;
  Query.Free;
end;

function TsohoRecordForm.RunInsertSQL (SQLText : TStringList) : boolean;
begin
  try
    Query := TQuery.Create(Self);
    Query.DataBaseName := DataBaseName;
    with Query do begin
     PushCursor(crHourGlass);
     SQL.Assign(SQLText);
     SetMemoFields;
     ExecSQL;
     Result := True;
     DoAfterSQLExecute;
    end;
  except
    on E:Exception do begin
     Result := false;
     ErrorMsg(Format(sohoRecFormInsertError, [Self.name, E.Message]));
    end;
  end;
  Query.Free;
end;

end.

