{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{           Partial copyright (c) AllexSoft             }
{           Written by Alexander Govyadinov,            }
{                   Serg Vostrikov                      }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
     TsohoRegister.    
  SohoLib,     ,
    ,     
 .
}
unit SohoRgst;

{$I SOHOLIB.INC}

interface

uses SysUtils, Windows, Messages, Classes, Controls, SoCtmRgs,
     Forms, SohoPswU;

type

  TsohoRegister = class(TsohoCustomRegister)
  {    ,    
       .       ,
        -    ,    ,
          .     
         ( PasswordRequired = true).  
              
      .    TsohoRegister  
     .         
    TsohoRegister.      TsohoSubRegister
  }
  private
    PasswordF: TPasswordF;
  protected
    procedure DefineDataPath; override;
    procedure GetUserRights; override;
  public
    procedure ShowUserList; override;
    {    }
    function ShowPasswordDialog: boolean; override;
    {         }
    procedure ChangePassword;override;
    {    }
    property WindowHandle;
    {    ,   TsohoCustomRegister    }
  published
    property UserActionRights;
    {       }
    property UserDataReadRights;
    {         }
    property UserDataWriteRights;
    {         }
    property HideSecret default true;
    {    AppplyRights,     
              
         .      
        ,    . 
      HideSecret       ""
      :  Visible = false,  Enabled = false }
    property ApplyRights;
    {        }
    property PasswordRequired default False;
    {         ? }
    property ActivateOn;
    {  :   ,     }
    property OnActivate;
    {     TsohoCustomRegister }
    property OnBeforeActivate;
    {     TsohoCustomRegister }
    property OnNewUserBox;
    {         }
  end;

implementation
uses SoAppUtils, SoUsers, SoUsCard, FileCtrl, SoBDERtn,
     SoDBCns, SoVClUtils;

procedure TsohoRegister.DefineDataPath;
var Info: TsohoAliasInfo;
    AliasExists: boolean;
begin
  inherited; //      
  DataName := DefaultName;

  //    ,  ,      //, 
  if PathToData = '' then begin
    PathToData := PathToProgram;
    Exit; // Goto EXITLABEL,      
  end;

  //   , -   ?    ?
  if FileExists(PathToData) then begin
    DataName := ExtractFileName(PathToData);
    PathToData := ExtractFilePath(PathToData);
    Exit;
  end;

  if DirectoryExists(PathToData) then begin //   ?
   PathToData := NormalDir(PathToData);
   Exit;
  end;

   RoutinesQuiet := True;
   AliasExists:=GetAliasInfo(PathToData, Info);//       ...?
   RoutinesQuiet := False;
   if AliasExists then Exit;

   // !   ,  ,   -  ,   !
   ErrorMsg(Format(sohoRegisterPathOrAliasDontExists,[Name, PathToData]));
end;

procedure TsohoRegister.ShowUserList;
begin
  UserF := TUserF.Create(Application);
  with UserF do begin
    ShowModal;
    Free;
  end;
end;

function TsohoRegister.ShowPasswordDialog: boolean;
begin
  Result := False;
  if (csDesigning in ComponentState) then exit;
  PasswordF := TPasswordF.Create(Application);
  Result := PasswordF.ShowModal = mrOk;
  if not Result then begin
    PasswordF.Free;
    PasswordF := nil;
  end;
end;

procedure TsohoRegister.ChangePassword;
begin
  if UserID = 0 then exit;
  UserF := TUserF.Create(Self);
  with UserF do begin
    PasswordQ.SQL.Delete(1);
    PasswordQ.SQL.Add('where ID=' + IntToStr(UserID));
    PasswordQ.Close;
    try
      PasswordQ.Open;
    except ErrorMsg(Format(sohoRegisterChangePasswordError, [name]));
    end;
    AddB.Visible := False;
    DeleteB.Visible := False;
    ShowModal;
    Free;
  end;
end;

procedure TsohoRegister.GetUserRights;
begin
  if PasswordF <> nil then begin
    DataReadRights := PasswordF.ReadRight;
    DataWriteRights := PasswordF.WriteRight;
    ActionRights := PasswordF.ActionRight;
    UserID := PasswordF.UserID;
    DataLevel := PasswordF.DataLevel;
    UserName := PasswordF.NameC.Text;
    ShortName := PasswordF.ShortName;
    PasswordF.Free;
    PasswordF := nil;
  end;
end;

end.
