{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Igor Chernyshov              }
{                                                       }
{             Devrace SohoLib Pro Components            }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: soholib@devrace.com               }
{                                                       }
{*******************************************************}
{
           win32
}

unit SohoWin32;

interface
Uses Windows,graphics;

{  ErrorStr -         -
   win32     SetLastError(0) }
function w32_GetLastError(var ErrorStr : string) : Cardinal;

{     .
    :
    FileName      -  
    RequestedInfo -   :
      OWNER_SECURITY_INFORMATION -    
      GROUP_SECURITY_INFORMATION -   
      DACL_SECURITY_INFORMATION  -   discretionary ACL (Access Control List)
      SACL_SECURITY_INFORMATION  -   system ACL (   
                                   ,     )
    :
    SecurityDescriptor - ,   .   
                                !
    DescriptorSize     - - ,   .  
                          = 0
     True,    ,  False   .
           w32_GetLastError}
function w32_GetFileSecurity(const FileName : string; RequestedInfo : SECURITY_INFORMATION; var SecurityDescriptor : pSecurityDescriptor; var DescriptorSize : Cardinal) : boolean;

{     
    :
    FileName      -  
    RequestedInfo -  .   . w32_GetFileSecurity
    SecurityDescriptor -      
    :
     True,    ,  False   .
           w32_GetLastError }
function w32_SetFileSecurity(const FileName : string; RequestedInfo : SECURITY_INFORMATION; SecurityDescriptor : pSecurityDescriptor) : boolean;

{   ,   
    :
    FileName      -  
    BigIcon, SmallIcon -  TIcon.   nil
    :
    BigIcon       -  
    SmallIcon     -  
     True,    ,  False   .
}
function w32_ExtractAssociatedIcon(const FileName : string; var BigIcon, SmallIcon : TIcon) : boolean;

implementation
Uses
  ShellAPI, Registry, SysUtils;
function w32_GetLastError(var ErrorStr : string) : Cardinal;
var
  p : PChar;
begin
  result := GetLastError;
  SetLastError(0);
  GetMem(p,512);
  try
    FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil, result,SUBLANG_NEUTRAL,
                  p,512,nil);
  finally
    ErrorStr := string(P);
    FreeMem(P,512);
  end;  { --- try --- }
end;

function w32_GetFileSecurity(const FileName : string; RequestedInfo : SECURITY_INFORMATION; var SecurityDescriptor : pSecurityDescriptor; var DescriptorSize : Cardinal) : boolean;
var
  NeedMem : cardinal;
begin
  NeedMem := 1;
  GetMem(SecurityDescriptor,NeedMem);
  //New(SecurityDescriptor);
  GetFileSecurity(PChar(FileName),RequestedInfo,SecurityDescriptor,Needmem,Needmem);
  //       1     .  NeedMem -  - 
  FreeMem(SecurityDescriptor,1);
  GetMem(SecurityDescriptor,NeedMem);
  result := GetFileSecurity(PChar(FileName),RequestedInfo,SecurityDescriptor,Needmem,Needmem);
  if result then DescriptorSize := NeedMem else DescriptorSize := 0;
end;

function w32_SetFileSecurity(const FileName : string; RequestedInfo : SECURITY_INFORMATION; SecurityDescriptor : pSecurityDescriptor) : boolean;
begin
  result := SetFileSecurity(PChar(FileName),RequestedInfo,SecurityDescriptor);
end;

function w32_ExtractAssociatedIcon(const FileName : string; var BigIcon, SmallIcon : TIcon) : boolean;
var
  Reg        : TRegistry;
  App        : string;
  exe        : string;
  ex         : string;
  comma      : Integer;
  NumberIcon : Integer;
  w          : cardinal;
  bic,sic    : HICON;
begin
  Result := False;
  ex := ExtractFileExt(FileName);
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CLASSES_ROOT;
    if Reg.OpenKey(ex, False) then begin
      App := Reg.ReadString('');
      if App <> '' then begin
        if Reg.OpenKey('\'+App+'\DefaultIcon', False) then begin
          exe := Reg.ReadString('');
          comma := pos(',',exe);
          if comma > 0 then begin
            NumberIcon := StrToInt(copy(exe,comma+1,Length(exe)));
            exe := copy(exe,1,comma-1);
            w   := 1;
            ExtractIconEx(pchar(exe),NumberIcon,bic,sic,w);
            if (bic <> 0) AND (BigIcon <> nil)   then begin
              BigIcon.Handle   := bic;
              Result           := True;
            end;  { --- if --- }
            if (sic <> 0) AND (SmallIcon <> nil) then begin
              SmallIcon.Handle := sic;
              Result           := True;
            end;  { --- if --- }  
          end;  { --- if --- }
        end;  { --- if --- }
      end;  { --- if --- }
    end;  { --- if --- }
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
end;
end.
